/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],d=0,M=re.length;d<M;d++)e[d]=be[re[d]];return e};define(be[42],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(be[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const b=[];for(let n in t)d.call(t,n)&&b.push(t[n]);return b}e.values=M;function E(t,b){for(let n in t)if(d.call(t,n)&&b({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,b){const n=Object.create(null);for(const h of t){const o=b(h);let l=n[o];l||(l=n[o]=[]),l.push(h)}return n}e.groupBy=A;function R(t){const b=Object.create(null);return t&&t.forEach((n,h)=>{b[h]=n}),b}e.fromMap=R;function k(t,b){const n=[],h=[];for(let o of t)b.has(o)||n.push(o);for(let o of b)t.has(o)||h.push(o);return{removed:n,added:h}}e.diffSets=k;function D(t,b){const n=[],h=[];for(let[o,l]of t)b.has(o)||n.push(l);for(let[o,l]of b)t.has(o)||h.push(l);return{removed:n,added:h}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(b,n){let h=this.map.get(b);h||(h=new Set,this.map.set(b,h)),h.add(n)}delete(b,n){const h=this.map.get(b);!h||(h.delete(n),h.size===0&&this.map.delete(b))}forEach(b,n){const h=this.map.get(b);!h||h.forEach(n)}}e.SetMap=T}),define(be[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(R){return(k,D,T)=>{let t=null,b=null;if(typeof T.value=="function"?(t="value",b=T.value):typeof T.get=="function"&&(t="get",b=T.get),!b)throw new Error("not supported");T[t]=R(b,D)}}e.createDecorator=d;function M(R,k,D){let T=null,t=null;if(typeof D.value=="function"?(T="value",t=D.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",t=D.get),!t)throw new Error("not supported");const b=`$memoize$${k}`;D[T]=function(...n){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[b]}}e.memoize=M;function E(R,k,D){return d((T,t)=>{const b=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...h){this[n]||(this[n]=D?D():void 0),clearTimeout(this[b]),k&&(this[n]=k(this[n],...h),h=[this[n]]),this[b]=setTimeout(()=>{T.apply(this,h),this[n]=D?D():void 0},R)}})}e.debounce=E;function A(R,k,D){return d((T,t)=>{const b=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,h=`$throttle$lastRun$${t}`,o=`$throttle$pending$${t}`;return function(...l){if(this[n]||(this[n]=D?D():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[n]=k(this[n],...l)),this[o])return;const v=this[h]+R;v<=Date.now()?(this[h]=Date.now(),T.apply(this,[this[n]]),this[n]=D?D():void 0):(this[o]=!0,this[b]=setTimeout(()=>{this[o]=!1,this[h]=Date.now(),T.apply(this,[this[n]]),this[n]=D?D():void 0},v-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(Z,oe=0){return Z[Z.length-(1+oe)]}e.tail=M;function E(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=E;function A(Z,oe,ve=(Ae,Se)=>Ae===Se){if(Z===oe)return!0;if(!Z||!oe||Z.length!==oe.length)return!1;for(let Ae=0,Se=Z.length;Ae<Se;Ae++)if(!ve(Z[Ae],oe[Ae]))return!1;return!0}e.equals=A;function R(Z,oe,ve){let Ae=0,Se=Z.length-1;for(;Ae<=Se;){const Ne=(Ae+Se)/2|0,We=ve(Z[Ne],oe);if(We<0)Ae=Ne+1;else if(We>0)Se=Ne-1;else return Ne}return-(Ae+1)}e.binarySearch=R;function k(Z,oe){let ve=0,Ae=Z.length;if(Ae===0)return 0;for(;ve<Ae;){const Se=Math.floor((ve+Ae)/2);oe(Z[Se])?Ae=Se:ve=Se+1}return ve}e.findFirstInSorted=k;function D(Z,oe,ve){if(Z=Z|0,Z>=oe.length)throw new TypeError("invalid index");let Ae=oe[Math.floor(oe.length*Math.random())],Se=[],Ne=[],We=[];for(let je of oe){const qe=ve(je,Ae);qe<0?Se.push(je):qe>0?Ne.push(je):We.push(je)}return Z<Se.length?D(Z,Se,ve):Z<Se.length+We.length?We[0]:D(Z-(Se.length+We.length),Ne,ve)}e.quickSelect=D;function T(Z,oe){const ve=[];let Ae;for(const Se of Z.slice(0).sort(oe))!Ae||oe(Ae[0],Se)!==0?(Ae=[Se],ve.push(Ae)):Ae.push(Se);return ve}e.groupBy=T;function t(Z,oe,ve){const Ae=[];function Se(je,qe,$){if(qe===0&&$.length===0)return;const K=Ae[Ae.length-1];K&&K.start+K.deleteCount===je?(K.deleteCount+=qe,K.toInsert.push(...$)):Ae.push({start:je,deleteCount:qe,toInsert:$})}let Ne=0,We=0;for(;;){if(Ne===Z.length){Se(Ne,0,oe.slice(We));break}if(We===oe.length){Se(Ne,Z.length-Ne,[]);break}const je=Z[Ne],qe=oe[We],$=ve(je,qe);$===0?(Ne+=1,We+=1):$<0?(Se(Ne,1,[]),Ne+=1):$>0&&(Se(Ne,0,[qe]),We+=1)}return Ae}e.sortedDiff=t;function b(Z,oe,ve){const Ae=t(Z,oe,ve),Se=[],Ne=[];for(const We of Ae)Se.push(...Z.slice(We.start,We.start+We.deleteCount)),Ne.push(...We.toInsert);return{removed:Se,added:Ne}}e.delta=b;function n(Z,oe,ve){if(ve===0)return[];const Ae=Z.slice(0,ve).sort(oe);return o(Z,oe,Ae,ve,Z.length),Ae}e.top=n;function h(Z,oe,ve,Ae,Se){return ve===0?Promise.resolve([]):new Promise((Ne,We)=>{(async()=>{const je=Z.length,qe=Z.slice(0,ve).sort(oe);for(let $=ve,K=Math.min(ve+Ae,je);$<je;$=K,K=Math.min(K+Ae,je)){if($>ve&&await new Promise(ee=>setTimeout(ee)),Se&&Se.isCancellationRequested)throw(0,d.canceled)();o(Z,oe,qe,$,K)}return qe})().then(Ne,We)})}e.topAsync=h;function o(Z,oe,ve,Ae,Se){for(const Ne=ve.length;Ae<Se;Ae++){const We=Z[Ae];if(oe(We,ve[Ne-1])<0){ve.pop();const je=k(ve,qe=>oe(We,qe)<0);ve.splice(je,0,We)}}}function l(Z){return Z.filter(oe=>!!oe)}e.coalesce=l;function v(Z){let oe=0;for(let ve=0;ve<Z.length;ve++)Z[ve]&&(Z[oe]=Z[ve],oe+=1);Z.length=oe}e.coalesceInPlace=v;function S(Z,oe,ve){Z.splice(ve,0,Z.splice(oe,1)[0])}e.move=S;function _(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=_;function a(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=a;function c(Z,oe){if(!oe)return Z.filter((Ae,Se)=>Z.indexOf(Ae)===Se);const ve=Object.create(null);return Z.filter(Ae=>{const Se=oe(Ae);return ve[Se]?!1:(ve[Se]=!0,!0)})}e.distinct=c;function y(Z){const oe=new Set;return Z.filter(ve=>oe.has(ve)?!1:(oe.add(ve),!0))}e.distinctES6=y;function i(Z){const oe=Object.create(null);return ve=>{const Ae=Z(ve);return oe[Ae]?!1:(oe[Ae]=!0,!0)}}e.uniqueFilter=i;function g(Z,oe){const ve=r(Z,oe);if(ve!==-1)return Z[ve]}e.findLast=g;function r(Z,oe){for(let ve=Z.length-1;ve>=0;ve--){const Ae=Z[ve];if(oe(Ae))return ve}return-1}e.lastIndex=r;function s(Z,oe){return Z.length>0?Z[0]:oe}e.firstOrDefault=s;function u(Z,oe,ve=(Ae,Se)=>Ae===Se){let Ae=0;for(let Se=0,Ne=Math.min(Z.length,oe.length);Se<Ne&&ve(Z[Se],oe[Se]);Se++)Ae++;return Ae}e.commonPrefixLength=u;function f(Z){return[].concat(...Z)}e.flatten=f;function p(Z,oe){let ve=typeof oe=="number"?Z:0;typeof oe=="number"?ve=Z:(ve=0,oe=Z);const Ae=[];if(ve<=oe)for(let Se=ve;Se<oe;Se++)Ae.push(Se);else for(let Se=ve;Se>oe;Se--)Ae.push(Se);return Ae}e.range=p;function C(Z,oe,ve){return Z.reduce((Ae,Se)=>(Ae[oe(Se)]=ve?ve(Se):Se,Ae),Object.create(null))}e.index=C;function P(Z,oe){return Z.push(oe),()=>m(Z,oe)}e.insert=P;function m(Z,oe){const ve=Z.indexOf(oe);if(ve>-1)return Z.splice(ve,1),oe}e.remove=m;function I(Z,oe,ve){const Ae=Z.slice(0,oe),Se=Z.slice(oe);return Ae.concat(ve,Se)}e.arrayInsert=I;function F(Z,oe){let ve;if(typeof oe=="number"){let Ae=oe;ve=()=>{const Se=Math.sin(Ae++)*179426549;return Se-Math.floor(Se)}}else ve=Math.random;for(let Ae=Z.length-1;Ae>0;Ae-=1){const Se=Math.floor(ve()*(Ae+1)),Ne=Z[Ae];Z[Ae]=Z[Se],Z[Se]=Ne}}e.shuffle=F;function L(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.unshift(oe))}e.pushToStart=L;function w(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.push(oe))}e.pushToEnd=w;function x(Z,oe){return Array.isArray(Z)?Z.map(oe):oe(Z)}e.mapArrayOrNot=x;function W(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=W;function B(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=B;function G(Z,oe){for(const ve of Z){const Ae=oe(ve);if(Ae!==void 0)return Ae}}e.mapFind=G;function H(Z,oe,ve){const Ae=V(Z,oe),Se=Z.length,Ne=ve.length;Z.length=Se+Ne;for(let We=Se-1;We>=Ae;We--)Z[We+Ne]=Z[We];for(let We=0;We<Ne;We++)Z[We+Ae]=ve[We]}e.insertInto=H;function U(Z,oe,ve,Ae){const Se=V(Z,oe),Ne=Z.splice(Se,ve);return H(Z,Se,Ae),Ne}e.splice=U;function V(Z,oe){return oe<0?Math.max(oe+Z.length,0):Math.min(oe,Z.length)}function Q(Z,oe){let ve=Number.MAX_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We<ve&&(ve=We,Ae=Ne)}),Ae}e.minIndex=Q;function ne(Z,oe){let ve=Number.MIN_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We>ve&&(ve=We,Ae=Ne)}),Ae}e.maxIndex=ne;class ce{constructor(oe){this.items=oe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(oe){let ve=this.firstIdx;for(;ve<this.items.length&&oe(this.items[ve]);)ve++;const Ae=ve===this.firstIdx?null:this.items.slice(this.firstIdx,ve);return this.firstIdx=ve,Ae}takeFromEndWhile(oe){let ve=this.lastIdx;for(;ve>=0&&oe(this.items[ve]);)ve--;const Ae=ve===this.lastIdx?null:this.items.slice(ve+1,this.lastIdx+1);return this.lastIdx=ve,Ae}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=ce}),define(be[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,g=!1){let r=0,s=i.length,u="",f=0,p=16,C=0;function P(W){let B=0,G=0;for(;B<W;){const H=i.charCodeAt(r);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;r++,B++}return B<W&&(G=-1),G}function m(W){r=W,u="",f=0,p=16,C=0}function I(){const W=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&T(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&T(i.charCodeAt(r)))for(r++;r<i.length&&T(i.charCodeAt(r));)r++;else return C=3,i.substring(W,r);let B=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&T(i.charCodeAt(r))){for(r++;r<i.length&&T(i.charCodeAt(r));)r++;B=r}else C=3;return i.substring(W,B)}function F(){let W="",B=r;for(;;){if(r>=s){W+=i.substring(B,r),C=2;break}const G=i.charCodeAt(r);if(G===34){W+=i.substring(B,r),r++;break}if(G===92){if(W+=i.substring(B,r),r++,r>=s){C=2;break}switch(i.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const U=P(4);U>=0?W+=String.fromCharCode(U):C=4;break;default:C=5}B=r;continue}if(G>=0&&G<=31)if(D(G)){W+=i.substring(B,r),C=2;break}else C=6;r++}return W}function L(){if(u="",C=0,f=r,r>=s)return f=s,p=17;let W=i.charCodeAt(r);if(k(W)){do r++,u+=String.fromCharCode(W),W=i.charCodeAt(r);while(k(W));return p=15}if(D(W))return r++,u+=String.fromCharCode(W),W===13&&i.charCodeAt(r)===10&&(r++,u+=`
`),p=14;switch(W){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,u=F(),p=10;case 47:const B=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!D(i.charCodeAt(r));)r++;return u=i.substring(B,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const G=s-1;let H=!1;for(;r<G;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,C=1),u=i.substring(B,r),p=13}return u+=String.fromCharCode(W),r++,p=16;case 45:if(u+=String.fromCharCode(W),r++,r===s||!T(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=I(),p=11;default:for(;r<s&&w(W);)r++,W=i.charCodeAt(r);if(f!==r){switch(u=i.substring(f,r),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(W),r++,p=16}}function w(W){if(k(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let W;do W=L();while(W>=12&&W<=15);return W}return{setPosition:m,getPosition:()=>r,scan:g?x:L,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>C}}e.createScanner=R;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function b(i,g){const r=[],s=new Object;let u;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function C(P,m,I,F){f.value=P,f.offset=m,f.length=I,f.type=F,f.colonOffset=void 0,u=f}try{a(i,{onObjectBegin:(P,m)=>{if(g<=P)throw s;u=void 0,p=g>P,r.push("")},onObjectProperty:(P,m,I)=>{if(g<m||(C(P,m,I,"property"),r[r.length-1]=P,g<=m+I))throw s},onObjectEnd:(P,m)=>{if(g<=P)throw s;u=void 0,r.pop()},onArrayBegin:(P,m)=>{if(g<=P)throw s;u=void 0,r.push(0)},onArrayEnd:(P,m)=>{if(g<=P)throw s;u=void 0,r.pop()},onLiteralValue:(P,m,I)=>{if(g<m||(C(P,m,I,y(P)),g<=m+I))throw s},onSeparator:(P,m,I)=>{if(g<=m)throw s;if(P===":"&&u&&u.type==="property")u.colonOffset=m,p=!1,u=void 0;else if(P===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(p=!0,r[r.length-1]=""),u=void 0}}})}catch(P){if(P!==s)throw P}return{path:r,previousNode:u,isAtPropertyKey:p,matches:P=>{let m=0;for(let I=0;m<P.length&&I<r.length;I++)if(P[m]===r[I]||P[m]==="*")m++;else if(P[m]!=="**")return!1;return m===P.length}}}e.getLocation=b;function n(i,g=[],r=A.DEFAULT){let s=null,u=[];const f=[];function p(P){Array.isArray(u)?u.push(P):s!==null&&(u[s]=P)}return a(i,{onObjectBegin:()=>{const P={};p(P),f.push(u),u=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{u=f.pop()},onArrayBegin:()=>{const P=[];p(P),f.push(u),u=P,s=null},onArrayEnd:()=>{u=f.pop()},onLiteralValue:p,onError:(P,m,I)=>{g.push({error:P,offset:m,length:I})}},r),u[0]}e.parse=n;function h(i,g=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function f(P){return s.children.push(P),P}a(i,{onObjectBegin:P=>{s=f({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,m,I)=>{s=f({type:"property",offset:m,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:m,length:I,parent:s})},onObjectEnd:(P,m)=>{s.length=P+m-s.offset,s=s.parent,u(P+m)},onArrayBegin:(P,m)=>{s=f({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,m)=>{s.length=P+m-s.offset,s=s.parent,u(P+m)},onLiteralValue:(P,m,I)=>{f({type:y(P),offset:m,length:I,parent:s,value:P}),u(m+I)},onSeparator:(P,m,I)=>{s.type==="property"&&(P===":"?s.colonOffset=m:P===","&&u(m))},onError:(P,m,I)=>{g.push({error:P,offset:m,length:I})}},r);const C=s.children[0];return C&&delete C.parent,C}e.parseTree=h;function o(i,g){if(!i)return;let r=i;for(let s of g)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===s){r=f.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=o;function l(i){if(!i.parent||!i.parent.children)return[];const g=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;g.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&g.push(r)}return g}e.getNodePath=l;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const g=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(g[r.children[0].value]=v(s))}return g;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function S(i,g,r=!1){return g>=i.offset&&g<i.offset+i.length||r&&g===i.offset+i.length}e.contains=S;function _(i,g,r=!1){if(S(i,g,r)){const s=i.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=g;u++){const f=_(s[u],g,r);if(f)return f}return i}}e.findNodeAtOffset=_;function a(i,g,r=A.DEFAULT){const s=R(i,!1);function u(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function f(oe){return oe?ve=>oe(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=u(g.onObjectBegin),C=f(g.onObjectProperty),P=u(g.onObjectEnd),m=u(g.onArrayBegin),I=u(g.onArrayEnd),F=f(g.onLiteralValue),L=f(g.onSeparator),w=u(g.onComment),x=f(g.onError),W=r&&r.disallowComments,B=r&&r.allowTrailingComma;function G(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:W||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(oe){case 12:case 13:W?H(10):w();break;case 16:H(1);break;case 15:case 14:break;default:return oe}}}function H(oe,ve=[],Ae=[]){if(x(oe),ve.length+Ae.length>0){let Se=s.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){G();break}else if(Ae.indexOf(Se)!==-1)break;Se=G()}}}function U(oe){const ve=s.getTokenValue();return oe?F(ve):C(ve),G(),!0}function V(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(H(2),oe=0)}catch(ve){H(2)}F(oe);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return G(),!0}function Q(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(U(!1),s.getToken()===6?(L(":"),G(),Z()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ne(){p(),G();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||H(4,[],[]),L(","),G(),s.getToken()===2&&B)break}else oe&&H(6,[],[]);Q()||H(4,[],[2,5]),oe=!0}return P(),s.getToken()!==2?H(7,[2],[]):G(),!0}function ce(){m(),G();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||H(4,[],[]),L(","),G(),s.getToken()===4&&B)break}else oe&&H(6,[],[]);Z()||H(4,[],[4,5]),oe=!0}return I(),s.getToken()!==4?H(8,[4],[]):G(),!0}function Z(){switch(s.getToken()){case 3:return ce();case 1:return ne();case 10:return U(!0);default:return V()}}return G(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Z()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function c(i,g){let r=R(i),s=[],u,f=0,p;do switch(p=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:f!==p&&s.push(i.substring(f,p)),g!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,g)),f=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=c;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Te,ye){for(var Ce=0;Ce<ye.length;Ce++){var te=ye[Ce];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Te,te.key,te)}}function e(Te,ye,Ce){return ye&&re(Te.prototype,ye),Ce&&re(Te,Ce),Te}function d(Te,ye){if(!!Te){if(typeof Te=="string")return M(Te,ye);var Ce=Object.prototype.toString.call(Te).slice(8,-1);if(Ce==="Object"&&Te.constructor&&(Ce=Te.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Te);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Te,ye)}}function M(Te,ye){(ye==null||ye>Te.length)&&(ye=Te.length);for(var Ce=0,te=new Array(ye);Ce<ye;Ce++)te[Ce]=Te[Ce];return te}function E(Te,ye){var Ce=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Ce)return(Ce=Ce.call(Te)).next.bind(Ce);if(Array.isArray(Te)||(Ce=d(Te))||ye&&Te&&typeof Te.length=="number"){Ce&&(Te=Ce);var te=0;return function(){return te>=Te.length?{done:!0}:{done:!1,value:Te[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){A.exports.defaults=Te}A.exports={defaults:R(),getDefaults:R,changeDefaults:k};var D=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return n[ye]};function o(Te,ye){if(ye){if(D.test(Te))return Te.replace(T,h)}else if(t.test(Te))return Te.replace(b,h);return Te}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Te){return Te.replace(l,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var S=/(^|[^\[])\^/g;function _(Te,ye){Te=Te.source||Te,ye=ye||"";var Ce={replace:function(le,ge){return ge=ge.source||ge,ge=ge.replace(S,"$1"),Te=Te.replace(le,ge),Ce},getRegex:function(){return new RegExp(Te,ye)}};return Ce}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Te,ye,Ce){if(Te){var te;try{te=decodeURIComponent(v(Ce)).replace(a,"").toLowerCase()}catch(le){return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ye&&!c.test(Ce)&&(Ce=u(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var i={},g=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Te,ye){i[" "+Te]||(g.test(Te)?i[" "+Te]=Te+"/":i[" "+Te]=P(Te,"/",!0)),Te=i[" "+Te];var Ce=Te.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Te.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Te.replace(s,"$1")+ye:Te+ye}var f={exec:function(){}};function p(Te){for(var ye=1,Ce,te;ye<arguments.length;ye++){Ce=arguments[ye];for(te in Ce)Object.prototype.hasOwnProperty.call(Ce,te)&&(Te[te]=Ce[te])}return Te}function C(Te,ye){var Ce=Te.replace(/\|/g,function(ge,fe,Pe){for(var xe=!1,Oe=fe;--Oe>=0&&Pe[Oe]==="\\";)xe=!xe;return xe?"|":" |"}),te=Ce.split(/ \|/),le=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>ye)te.splice(ye);else for(;te.length<ye;)te.push("");for(;le<te.length;le++)te[le]=te[le].trim().replace(/\\\|/g,"|");return te}function P(Te,ye,Ce){var te=Te.length;if(te===0)return"";for(var le=0;le<te;){var ge=Te.charAt(te-le-1);if(ge===ye&&!Ce)le++;else if(ge!==ye&&Ce)le++;else break}return Te.substr(0,te-le)}function m(Te,ye){if(Te.indexOf(ye[1])===-1)return-1;for(var Ce=Te.length,te=0,le=0;le<Ce;le++)if(Te[le]==="\\")le++;else if(Te[le]===ye[0])te++;else if(Te[le]===ye[1]&&(te--,te<0))return le;return-1}function I(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Te,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Te),ye>>=1,Te+=Te;return Ce+Te}var L={escape:o,unescape:v,edit:_,cleanUrl:y,resolveUrl:u,noopTest:f,merge:p,splitCells:C,rtrim:P,findClosingBracket:m,checkSanitizeDeprecation:I,repeatString:F},w=A.exports.defaults,x=L.rtrim,W=L.splitCells,B=L.escape,G=L.findClosingBracket;function H(Te,ye,Ce,te){var le=ye.href,ge=ye.title?B(ye.title):null,fe=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){te.state.inLink=!0;var Pe={type:"link",raw:Ce,href:le,title:ge,text:fe,tokens:te.inlineTokens(fe,[])};return te.state.inLink=!1,Pe}else return{type:"image",raw:Ce,href:le,title:ge,text:B(fe)}}function U(Te,ye){var Ce=Te.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var te=Ce[1];return ye.split(`
`).map(function(le){var ge=le.match(/^\s+/);if(ge===null)return le;var fe=ge[0];return fe.length>=te.length?le.slice(te.length):le}).join(`
`)}var V=function(){function Te(Ce){this.options=Ce||w}var ye=Te.prototype;return ye.space=function(te){var le=this.rules.block.newline.exec(te);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(te){var le=this.rules.block.code.exec(te);if(le){var ge=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:x(ge,`
`)}}},ye.fences=function(te){var le=this.rules.block.fences.exec(te);if(le){var ge=le[0],fe=U(ge,le[3]||"");return{type:"code",raw:ge,lang:le[2]?le[2].trim():le[2],text:fe}}},ye.heading=function(te){var le=this.rules.block.heading.exec(te);if(le){var ge=le[2].trim();if(/#$/.test(ge)){var fe=x(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Pe={type:"heading",raw:le[0],depth:le[1].length,text:ge,tokens:[]};return this.lexer.inline(Pe.text,Pe.tokens),Pe}},ye.hr=function(te){var le=this.rules.block.hr.exec(te);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(te){var le=this.rules.block.blockquote.exec(te);if(le){var ge=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(te){var le=this.rules.block.list.exec(te);if(le){var ge,fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y=le[1].trim(),z=Y.length>1,we={type:"list",raw:"",ordered:z,start:z?+Y.slice(0,-1):"",loose:!1,items:[]};Y=z?"\\d{1,9}\\"+Y.slice(-1):"\\"+Y,this.options.pedantic&&(Y=z?Y:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Y+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(le=Ie.exec(te)));){de=le[2].split(`
`),this.options.pedantic?(xe=2,pe=de[0].trimLeft()):(xe=le[2].search(/[^ ]/),xe=le[1].length+(xe>4?1:xe),pe=de[0].slice(xe-le[1].length)),Ke=!1,ge=le[0],!de[0]&&/^ *$/.test(de[1])&&(ge=le[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<de.length;Oe++){if(Le=de[Oe],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}if(!Ke){Le.trim()||(Ke=!0),Le.search(/[^ ]/)>=xe?pe+=`
`+Le.slice(xe):pe+=`
`+Le;continue}if(Le.search(/[^ ]/)>=xe||!Le.trim()){pe+=`
`+Le.slice(xe);continue}else{ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}}we.loose||(tt?we.loose=!0:/\n *\n *$/.test(ge)&&(tt=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(pe),fe&&(Pe=fe[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:ge,task:!!fe,checked:Pe,loose:!1,text:pe}),we.raw+=ge,te=te.slice(ge.length)}we.items[we.items.length-1].raw=ge.trimRight(),we.items[we.items.length-1].text=pe.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Oe=0;Oe<Ue;Oe++)this.lexer.state.top=!1,we.items[Oe].tokens=this.lexer.blockTokens(we.items[Oe].text,[]),we.items[Oe].tokens.some(function(dt){return dt.type==="space"})&&(we.loose=!0,we.items[Oe].loose=!0);return we}},ye.html=function(te){var le=this.rules.block.html.exec(te);if(le){var ge={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(le[0]):B(le[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(te){var le=this.rules.block.def.exec(te);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ge=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(te){var le=this.rules.block.table.exec(te);if(le){var ge={type:"table",header:W(le[1]).map(function(tt){return{text:tt}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=le[0];var fe=ge.align.length,Pe,xe,Oe,Ke;for(Pe=0;Pe<fe;Pe++)/^ *-+: *$/.test(ge.align[Pe])?ge.align[Pe]="right":/^ *:-+: *$/.test(ge.align[Pe])?ge.align[Pe]="center":/^ *:-+ *$/.test(ge.align[Pe])?ge.align[Pe]="left":ge.align[Pe]=null;for(fe=ge.rows.length,Pe=0;Pe<fe;Pe++)ge.rows[Pe]=W(ge.rows[Pe],ge.header.length).map(function(tt){return{text:tt}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ke=ge.rows[xe],Oe=0;Oe<Ke.length;Oe++)Ke[Oe].tokens=[],this.lexer.inlineTokens(Ke[Oe].text,Ke[Oe].tokens);return ge}}},ye.lheading=function(te){var le=this.rules.block.lheading.exec(te);if(le){var ge={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(te){var le=this.rules.block.paragraph.exec(te);if(le){var ge={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(te){var le=this.rules.block.text.exec(te);if(le){var ge={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(te){var le=this.rules.inline.escape.exec(te);if(le)return{type:"escape",raw:le[0],text:B(le[1])}},ye.tag=function(te){var le=this.rules.inline.tag.exec(te);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):B(le[0]):le[0]}},ye.link=function(te){var le=this.rules.inline.link.exec(te);if(le){var ge=le[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=x(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Pe=G(le[2],"()");if(Pe>-1){var xe=le[0].indexOf("!")===0?5:4,Oe=xe+le[1].length+Pe;le[2]=le[2].substring(0,Pe),le[0]=le[0].substring(0,Oe).trim(),le[3]=""}}var Ke=le[2],tt="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);Le&&(Ke=Le[1],tt=Le[3])}else tt=le[3]?le[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(ge)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),H(le,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(te,le){var ge;if((ge=this.rules.inline.reflink.exec(te))||(ge=this.rules.inline.nolink.exec(te))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=le[fe.toLowerCase()],!fe||!fe.href){var Pe=ge[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return H(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(te,le,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(te);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=fe[1]||fe[2]||"";if(!Pe||Pe&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Oe,Ke,tt=xe,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,le=le.slice(-1*te.length+xe);(fe=de.exec(le))!=null;)if(Oe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Oe){if(Ke=Oe.length,fe[3]||fe[4]){tt+=Ke;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ke)%3)){Le+=Ke;continue}if(tt-=Ke,!(tt>0)){if(Ke=Math.min(Ke,Ke+tt+Le),Math.min(xe,Ke)%2){var pe=te.slice(1,xe+fe.index+Ke);return{type:"em",raw:te.slice(0,xe+fe.index+Ke+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var Y=te.slice(2,xe+fe.index+Ke-1);return{type:"strong",raw:te.slice(0,xe+fe.index+Ke+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}}}}},ye.codespan=function(te){var le=this.rules.inline.code.exec(te);if(le){var ge=le[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Pe=/^ /.test(ge)&&/ $/.test(ge);return fe&&Pe&&(ge=ge.substring(1,ge.length-1)),ge=B(ge,!0),{type:"codespan",raw:le[0],text:ge}}},ye.br=function(te){var le=this.rules.inline.br.exec(te);if(le)return{type:"br",raw:le[0]}},ye.del=function(te){var le=this.rules.inline.del.exec(te);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},ye.autolink=function(te,le){var ge=this.rules.inline.autolink.exec(te);if(ge){var fe,Pe;return ge[2]==="@"?(fe=B(this.options.mangle?le(ge[1]):ge[1]),Pe="mailto:"+fe):(fe=B(ge[1]),Pe=fe),{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(te,le){var ge;if(ge=this.rules.inline.url.exec(te)){var fe,Pe;if(ge[2]==="@")fe=B(this.options.mangle?le(ge[0]):ge[0]),Pe="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=B(ge[0]),ge[1]==="www."?Pe="http://"+fe:Pe=fe}return{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(te,le){var ge=this.rules.inline.text.exec(te);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):B(ge[0]):ge[0]:fe=B(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Te}(),Q=L.noopTest,ne=L.edit,ce=L.merge,Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=ne(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.listItemStart=ne(/^( *)(bull) */).replace("bull",Z.bullet).getRegex(),Z.list=ne(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=ne(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=ne(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=ne(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=ce({},Z),Z.gfm=ce({},Z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.table=ne(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=ce({},Z.normal,{html:ne(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:ne(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=ne(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=ne(Z._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=ne(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=ne(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=ne(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=ne(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=ne(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=ne(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=ne(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=ne(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=ce({},oe),oe.pedantic=ce({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ne(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:ne(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=ce({},oe.normal,{escape:ne(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=ne(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=ce({},oe.gfm,{br:ne(oe.br).replace("{2,}","*").getRegex(),text:ne(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:Z,inline:oe},Ae=V,Se=A.exports.defaults,Ne=ve.block,We=ve.inline,je=L.repeatString;function qe(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Te){var ye="",Ce,te,le=Te.length;for(Ce=0;Ce<le;Ce++)te=Te.charCodeAt(Ce),Math.random()>.5&&(te="x"+te.toString(16)),ye+="&#"+te+";";return ye}var K=function(){function Te(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Se,this.options.tokenizer=this.options.tokenizer||new Ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Ne.normal,inline:We.normal};this.options.pedantic?(te.block=Ne.pedantic,te.inline=We.pedantic):this.options.gfm&&(te.block=Ne.gfm,this.options.breaks?te.inline=We.breaks:te.inline=We.gfm),this.tokenizer.rules=te}Te.lex=function(te,le){var ge=new Te(le);return ge.lex(te)},Te.lexInline=function(te,le){var ge=new Te(le);return ge.inlineTokens(te)};var ye=Te.prototype;return ye.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(te,le){var ge=this;le===void 0&&(le=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var fe,Pe,xe,Oe;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(fe=tt.call({lexer:ge},te,le))?(te=te.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.space(te)){te=te.substring(fe.raw.length),fe.type&&le.push(fe);continue}if(fe=this.tokenizer.code(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(fe=this.tokenizer.fences(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.heading(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.hr(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.blockquote(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.list(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.html(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.def(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.lheading(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(xe=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=Infinity,Le=te.slice(1),de=void 0;ge.options.extensions.startBlock.forEach(function(pe){de=pe.call({lexer:this},Le),typeof de=="number"&&de>=0&&(tt=Math.min(tt,de))}),tt<Infinity&&tt>=0&&(xe=te.substring(0,tt+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Pe=le[le.length-1],Oe&&Pe.type==="paragraph"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe),Oe=xe.length!==te.length,te=te.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(te){var Ke="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,le},ye.inline=function(te,le){this.inlineQueue.push({src:te,tokens:le})},ye.inlineTokens=function(te,le){var ge=this;le===void 0&&(le=[]);var fe,Pe,xe,Oe=te,Ke,tt,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)de.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(tt||(Le=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(fe=Y.call({lexer:ge},te,le))?(te=te.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.tag(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.link(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.emStrong(te,Oe,Le)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.codespan(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.br(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.del(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.autolink(te,$)){te=te.substring(fe.raw.length),le.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(te,$))){te=te.substring(fe.raw.length),le.push(fe);continue}if(xe=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=Infinity,z=te.slice(1),we=void 0;ge.options.extensions.startInline.forEach(function(Ie){we=Ie.call({lexer:this},z),typeof we=="number"&&we>=0&&(Y=Math.min(Y,we))}),Y<Infinity&&Y>=0&&(xe=te.substring(0,Y+1))}(),fe=this.tokenizer.inlineText(xe,qe)){te=te.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),tt=!0,Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(te){var pe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},e(Te,null,[{key:"rules",get:function(){return{block:Ne,inline:We}}}]),Te}(),ee=A.exports.defaults,ae=L.cleanUrl,q=L.escape,se=function(){function Te(Ce){this.options=Ce||ee}var ye=Te.prototype;return ye.code=function(te,le,ge){var fe=(le||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(te,fe);Pe!=null&&Pe!==te&&(ge=!0,te=Pe)}return te=te.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+q(fe,!0)+'">'+(ge?te:q(te,!0))+`</code></pre>
`:"<pre><code>"+(ge?te:q(te,!0))+`</code></pre>
`},ye.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ye.html=function(te){return te},ye.heading=function(te,le,ge,fe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+te+"</h"+le+`>
`:"<h"+le+">"+te+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(te,le,ge){var fe=le?"ol":"ul",Pe=le&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Pe+`>
`+te+"</"+fe+`>
`},ye.listitem=function(te){return"<li>"+te+`</li>
`},ye.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(te){return"<p>"+te+`</p>
`},ye.table=function(te,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+le+`</table>
`},ye.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ye.tablecell=function(te,le){var ge=le.header?"th":"td",fe=le.align?"<"+ge+' align="'+le.align+'">':"<"+ge+">";return fe+te+"</"+ge+`>
`},ye.strong=function(te){return"<strong>"+te+"</strong>"},ye.em=function(te){return"<em>"+te+"</em>"},ye.codespan=function(te){return"<code>"+te+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(te){return"<del>"+te+"</del>"},ye.link=function(te,le,ge){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return ge;var fe='<a href="'+q(te)+'"';return le&&(fe+=' title="'+le+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(te,le,ge){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return ge;var fe='<img src="'+te+'" alt="'+ge+'"';return le&&(fe+=' title="'+le+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(te){return te},Te}(),he=function(){function Te(){}var ye=Te.prototype;return ye.strong=function(te){return te},ye.em=function(te){return te},ye.codespan=function(te){return te},ye.del=function(te){return te},ye.html=function(te){return te},ye.text=function(te){return te},ye.link=function(te,le,ge){return""+ge},ye.image=function(te,le,ge){return""+ge},ye.br=function(){return""},Te}(),Re=function(){function Te(){this.seen={}}var ye=Te.prototype;return ye.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(te,le){var ge=te,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[te];do fe++,ge=te+"-"+fe;while(this.seen.hasOwnProperty(ge))}return le||(this.seen[te]=fe,this.seen[ge]=0),ge},ye.slug=function(te,le){le===void 0&&(le={});var ge=this.serialize(te);return this.getNextSafeSlug(ge,le.dryrun)},Te}(),Be=se,ze=he,Qe=Re,it=A.exports.defaults,ke=L.unescape,Ze=function(){function Te(Ce){this.options=Ce||it,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Qe}Te.parse=function(te,le){var ge=new Te(le);return ge.parse(te)},Te.parseInline=function(te,le){var ge=new Te(le);return ge.parseInline(te)};var ye=Te.prototype;return ye.parse=function(te,le){le===void 0&&(le=!0);var ge="",fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y,z,we,Ie,Je,Ue,dt,gt,lt,ft,ut=te.length;for(fe=0;fe<ut;fe++){if(Y=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(ft=this.options.extensions.renderers[Y.type].call({parser:this},Y),ft!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){ge+=ft||"";continue}switch(Y.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,ke(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(de="",Le="",Oe=Y.header.length,Pe=0;Pe<Oe;Pe++)Le+=this.renderer.tablecell(this.parseInline(Y.header[Pe].tokens),{header:!0,align:Y.align[Pe]});for(de+=this.renderer.tablerow(Le),pe="",Oe=Y.rows.length,Pe=0;Pe<Oe;Pe++){for(tt=Y.rows[Pe],Le="",Ke=tt.length,xe=0;xe<Ke;xe++)Le+=this.renderer.tablecell(this.parseInline(tt[xe].tokens),{header:!1,align:Y.align[xe]});pe+=this.renderer.tablerow(Le)}ge+=this.renderer.table(de,pe);continue}case"blockquote":{pe=this.parse(Y.tokens),ge+=this.renderer.blockquote(pe);continue}case"list":{for(z=Y.ordered,we=Y.start,Ie=Y.loose,Oe=Y.items.length,pe="",Pe=0;Pe<Oe;Pe++)Ue=Y.items[Pe],dt=Ue.checked,gt=Ue.task,Je="",Ue.task&&(lt=this.renderer.checkbox(dt),Ie?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=lt+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=lt+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:lt}):Je+=lt),Je+=this.parse(Ue.tokens,Ie),pe+=this.renderer.listitem(Je,gt,dt);ge+=this.renderer.list(pe,z,we);continue}case"html":{ge+=this.renderer.html(Y.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(pe=Y.tokens?this.parseInline(Y.tokens):Y.text;fe+1<ut&&te[fe+1].type==="text";)Y=te[++fe],pe+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);ge+=le?this.renderer.paragraph(pe):pe;continue}default:{var pt='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return ge},ye.parseInline=function(te,le){le=le||this.renderer;var ge="",fe,Pe,xe,Oe=te.length;for(fe=0;fe<Oe;fe++){if(Pe=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(xe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){ge+=xe||"";continue}switch(Pe.type){case"escape":{ge+=le.text(Pe.text);break}case"html":{ge+=le.html(Pe.text);break}case"link":{ge+=le.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,le));break}case"image":{ge+=le.image(Pe.href,Pe.title,Pe.text);break}case"strong":{ge+=le.strong(this.parseInline(Pe.tokens,le));break}case"em":{ge+=le.em(this.parseInline(Pe.tokens,le));break}case"codespan":{ge+=le.codespan(Pe.text);break}case"br":{ge+=le.br();break}case"del":{ge+=le.del(this.parseInline(Pe.tokens,le));break}case"text":{ge+=le.text(Pe.text);break}default:{var Ke='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return ge},Te}(),j=K,J=Ze,me=V,He=se,Ye=he,st=Re,ot=L.merge,Et=L.checkSanitizeDeprecation,mt=L.escape,Dt=A.exports.getDefaults,Pt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Te,ye,Ce){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=ot({},Xe.defaults,ye||{}),Et(ye),Ce){var te=ye.highlight,le;try{le=j.lex(Te,ye)}catch(xe){return Ce(xe)}var ge=function(Oe){var Ke;if(!Oe)try{ye.walkTokens&&Xe.walkTokens(le,ye.walkTokens),Ke=J.parse(le,ye)}catch(tt){Oe=tt}return ye.highlight=te,Oe?Ce(Oe):Ce(null,Ke)};if(!te||te.length<3||(delete ye.highlight,!le.length))return ge();var fe=0;Xe.walkTokens(le,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){te(xe.text,xe.lang,function(Oe,Ke){if(Oe)return ge(Oe);Ke!=null&&Ke!==xe.text&&(xe.text=Ke,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Pe=j.lex(Te,ye);return ye.walkTokens&&Xe.walkTokens(Pe,ye.walkTokens),J.parse(Pe,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(xe.message+"",!0)+"</pre>";throw xe}}Xe.options=Xe.setOptions=function(Te){return ot(Xe.defaults,Te),Pt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Te=this,ye=arguments.length,Ce=new Array(ye),te=0;te<ye;te++)Ce[te]=arguments[te];var le=ot.apply(void 0,[{}].concat(Ce)),ge=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Pe){if(Pe.extensions&&(fe=!0,Pe.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ke=ge.renderers?ge.renderers[Oe.name]:null;Ke?ge.renderers[Oe.name]=function(){for(var tt=arguments.length,Le=new Array(tt),de=0;de<tt;de++)Le[de]=arguments[de];var pe=Oe.renderer.apply(this,Le);return pe===!1&&(pe=Ke.apply(this,Le)),pe}:ge.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Oe.level]?ge[Oe.level].unshift(Oe.tokenizer):ge[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?ge.startBlock?ge.startBlock.push(Oe.start):ge.startBlock=[Oe.start]:Oe.level==="inline"&&(ge.startInline?ge.startInline.push(Oe.start):ge.startInline=[Oe.start]))}Oe.childTokens&&(ge.childTokens[Oe.name]=Oe.childTokens)})),Pe.renderer&&function(){var Oe=Xe.defaults.renderer||new He,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var Ie=Pe.renderer[de].apply(Oe,z);return Ie===!1&&(Ie=pe.apply(Oe,z)),Ie}};for(var tt in Pe.renderer)Ke(tt);le.renderer=Oe}(),Pe.tokenizer&&function(){var Oe=Xe.defaults.tokenizer||new me,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var Ie=Pe.tokenizer[de].apply(Oe,z);return Ie===!1&&(Ie=pe.apply(Oe,z)),Ie}};for(var tt in Pe.tokenizer)Ke(tt);le.tokenizer=Oe}(),Pe.walkTokens){var xe=Xe.defaults.walkTokens;le.walkTokens=function(Oe){Pe.walkTokens.call(Te,Oe),xe&&xe(Oe)}}fe&&(le.extensions=ge),Xe.setOptions(le)})},Xe.walkTokens=function(Te,ye){for(var Ce=function(){var fe=le.value;switch(ye(fe),fe.type){case"table":{for(var Pe=E(fe.header),xe;!(xe=Pe()).done;){var Oe=xe.value;Xe.walkTokens(Oe.tokens,ye)}for(var Ke=E(fe.rows),tt;!(tt=Ke()).done;)for(var Le=tt.value,de=E(Le),pe;!(pe=de()).done;){var Y=pe.value;Xe.walkTokens(Y.tokens,ye)}break}case"list":{Xe.walkTokens(fe.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],ye)}):fe.tokens&&Xe.walkTokens(fe.tokens,ye)}},te=E(Te),le;!(le=te()).done;)Ce()},Xe.parseInline=function(Te,ye){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ye=ot({},Xe.defaults,ye||{}),Et(ye);try{var Ce=j.lexInline(Te,ye);return ye.walkTokens&&Xe.walkTokens(Ce,ye.walkTokens),J.parseInline(Ce,ye)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(te.message+"",!0)+"</pre>";throw te}},Xe.Parser=J,Xe.parser=J.parse,Xe.Renderer=He,Xe.TextRenderer=Ye,Xe.Lexer=j,Xe.lexer=j.lex,Xe.Tokenizer=me,Xe.Slugger=st,Xe.parse=Xe;var St=Xe;return St}),define(be[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(R,k,D){return Math.min(Math.max(R,k),D)}e.clamp=d;function M(R,k){return(k+R%k)%k}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function re(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function R(D){A.push(D,Date.now())}function k(){const D=[];for(let T=0;T<A.length;T+=2)D.push({name:A[T],startTime:A[T+1]});return D}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(E+R.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[104],Ee([0,1]),function(re,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,D,T){this.level=k,this.key=D,this.value=T,this.forward=[]}}const E=void 0;class A{constructor(k,D=2**16){this.comparator=k,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(D)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(k){return Boolean(A._search(this,k,this.comparator))}get(k){return A._search(this,k,this.comparator)?.value}set(k,D){return A._insert(this,k,D,this.comparator)&&(this._size+=1),this}delete(k){const D=A._delete(this,k,this.comparator);return D&&(this._size-=1),D}forEach(k,D){let T=this._header.forward[0];for(;T;)k.call(D,T.value,T.key,this),T=T.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",D=this._header.forward[0];for(;D;)k+=`node(${D.key}, ${D.value}, lvl:${D.level})`,D=D.forward[0];return k}static _search(k,D,T){let t=k._header;for(let b=k._level-1;b>=0;b--)for(;t.forward[b]&&T(t.forward[b].key,D)<0;)t=t.forward[b];if(t=t.forward[0],t&&T(t.key,D)===0)return t}static _insert(k,D,T,t){let b=[],n=k._header;for(let h=k._level-1;h>=0;h--){for(;n.forward[h]&&t(n.forward[h].key,D)<0;)n=n.forward[h];b[h]=n}if(n=n.forward[0],n&&t(n.key,D)===0)return n.value=T,!1;{let h=A._randomLevel(k);if(h>k._level){for(let o=k._level;o<h;o++)b[o]=k._header;k._level=h}n=new M(h,D,T);for(let o=0;o<h;o++)n.forward[o]=b[o].forward[o],b[o].forward[o]=n;return!0}}static _randomLevel(k,D=.5){let T=1;for(;Math.random()<D&&T<k._maxLevel;)T+=1;return T}static _delete(k,D,T){let t=[],b=k._header;for(let n=k._level-1;n>=0;n--){for(;b.forward[n]&&T(b.forward[n].key,D)<0;)b=b.forward[n];t[n]=b}if(b=b.forward[0],!b||T(b.key,D)!==0)return!1;for(let n=0;n<k._level&&t[n].forward[n]===b;n++)t[n].forward[n]=b.forward[n];for(;k._level>0&&k._header.forward[k._level-1]===E;)k._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(b){const n=this._icons.get(b.id);n?b.description?n.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,b){return new k(t,b)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(b,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=R;class k{constructor(b,n,h){this.id=b,this.definition=n,this.description=h,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(t,b){const n=["codicon","codicon-"+t];return b&&n.push("codicon-modifier-"+b),n}e.getClassNamesArray=D;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(l){if(l instanceof k)return["codicon","codicon-"+l.id];const v=b.exec(l.id);if(!v)return n(k.error);let[,S,_]=v;const a=["codicon","codicon-"+S];return _&&a.push("codicon-modifier-"+_.substr(1)),a}t.asClassNameArray=n;function h(l){return n(l).join(" ")}t.asClassName=h;function o(l){return"."+n(l).join(".")}t.asCSSSelector=o})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",{fontCharacter:"\\eb0f"}),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(a){const c=a;return c?[c.on,c.pause,c.resume,c.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=E;function A(a){const c=a;return c?E(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(a,c){return new k(a,c)}e.newWriteableStream=R;class k{constructor(c,y){this.reducer=c,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(y=>y(c))}emitError(c){this.listeners.error.length===0?(0,d.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(y=>y(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,y){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(c,y){if(this.state.destroyed)return;let i;switch(c){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const g=i.indexOf(y);g>=0&&i.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(a,c){const y=[];let i;for(;(i=a.read())!==null;)y.push(i);return c(y)}e.consumeReadable=D;function T(a,c,y){const i=[];let g;for(;(g=a.read())!==null&&i.length<y;)i.push(g);return g===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g!="undefined"){const r=g;return g=void 0,r}return a.read()}}}e.peekReadable=T;function t(a,c){return new Promise((y,i)=>{const g=[];b(a,{onData:r=>{c&&g.push(r)},onError:r=>{c?i(r):y(void 0)},onEnd:()=>{y(c?c(g):void 0)}})})}e.consumeStream=t;function b(a,c){a.on("error",y=>c.onError(y)),a.on("end",()=>c.onEnd()),a.on("data",y=>c.onData(y))}e.listenStream=b;function n(a,c){return new Promise((y,i)=>{const g=new M.DisposableStore,r=[],s=p=>{if(r.push(p),r.length>c)return g.dispose(),a.pause(),y({stream:a,buffer:r,ended:!1})},u=p=>i(p),f=()=>y({stream:a,buffer:r,ended:!0});g.add((0,M.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),g.add((0,M.toDisposable)(()=>a.removeListener("end",f))),a.on("end",f),g.add((0,M.toDisposable)(()=>a.removeListener("data",s))),a.on("data",s)})}e.peekStream=n;function h(a,c){const y=R(c);return y.end(a),y}e.toStream=h;function o(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=o;function l(a){let c=!1;return{read:()=>c?null:(c=!0,a)}}e.toReadable=l;function v(a,c,y){const i=R(y);return b(a,{onData:g=>i.write(c.data(g)),onError:g=>i.error(c.error?c.error(g):g),onEnd:()=>i.end()}),i}e.transform=v;function S(a,c,y){let i=!1;return{read:()=>{const g=c.read();return i?g:(i=!0,g!==null?y([a,g]):a)}}}e.prefixedReadable=S;function _(a,c,y){let i=!1;const g=R(y);return b(c,{onData:r=>i?g.write(r):(i=!0,g.write(y([a,r]))),onError:r=>g.error(r),onEnd:()=>{i||(i=!0,g.write(a)),g.end()}}),g}e.prefixedStream=_}),define(be[22],Ee([0,1,105]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class R{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new R(Buffer.allocUnsafe(s)):new R(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new R(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&M?new R(Buffer.from(s)):(E||(E=new TextEncoder),new R(E.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let C=0,P=s.length;C<P;C++)u+=s[C].byteLength}const f=R.alloc(u);let p=0;for(let C=0,P=s.length;C<P;C++){const m=s[C];f.set(m,p),p+=m.byteLength}return f}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,u){return new R(this.buffer.subarray(s,u))}set(s,u){s instanceof R?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return T(this.buffer,s)}writeUInt32BE(s,u){t(this.buffer,s,u)}readUInt32LE(s){return b(this.buffer,s)}writeUInt32LE(s,u){n(this.buffer,s,u)}readUInt8(s){return h(this.buffer,s)}writeUInt8(s,u){o(this.buffer,s,u)}}e.VSBuffer=R;function k(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=k;function D(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255}e.writeUInt16LE=D;function T(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=T;function t(r,s,u){r[u+3]=s,s=s>>>8,r[u+2]=s,s=s>>>8,r[u+1]=s,s=s>>>8,r[u]=s}e.writeUInt32BE=t;function b(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=b;function n(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255,s=s>>>8,r[u+2]=s&255,s=s>>>8,r[u+3]=s&255}e.writeUInt32LE=n;function h(r,s){return r[s]}e.readUInt8=h;function o(r,s,u){r[u]=s}e.writeUInt8=o;function l(r){return d.consumeReadable(r,s=>R.concat(s))}e.readableToBuffer=l;function v(r){return d.toReadable(r)}e.bufferToReadable=v;function S(r){return d.consumeStream(r,s=>R.concat(s))}e.streamToBuffer=S;async function _(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await S(r.stream)])}e.bufferedStreamToBuffer=_;function a(r){return d.toStream(r,s=>R.concat(s))}e.bufferToStream=a;function c(r){return d.transform(r,{data:s=>typeof s=="string"?R.fromString(s):R.wrap(s)},s=>R.concat(s))}e.streamToBufferReadableStream=c;function y(r){return d.newWriteableStream(s=>R.concat(s),r)}e.newWriteableBufferStream=y;function i(r,s){return d.prefixedReadable(r,s,u=>R.concat(u))}e.prefixedBufferReadable=i;function g(r,s){return d.prefixedStream(r,s,u=>R.concat(u))}e.prefixedBufferStream=g}),define(be[35],Ee([0,1,9]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",R="warning",k="warn",D="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?E.Error:d.equalsIgnoreCase(R,n)||d.equalsIgnoreCase(k,n)?E.Warning:d.equalsIgnoreCase(D,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function b(n){switch(n){case E.Error:return A;case E.Warning:return R;case E.Info:return D;default:return T}}E.toString=b}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function k(r){return r.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function D(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function T(r,s=d.posix.sep){if(!r)return"";const u=r.length,f=r.charCodeAt(0);if(R(f)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let C=3;const P=C;for(;C<u&&!R(r.charCodeAt(C));C++);if(P!==C&&!R(r.charCodeAt(C+1))){for(C+=1;C<u;C++)if(R(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,s)}}return s}else if(S(f)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<u;p++)if(R(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=T;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const f=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(f===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=t;const b=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,s=M.isWindows){const u=s?b:n;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&h.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function l(r,s,u){const f=r===s;return!u||f?f:!r||!s?!1:(0,E.equalsIgnoreCase)(r,s)}e.isEqual=l;function v(r,s,u,f=d.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,E.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let C=s.length;return s.charAt(s.length-1)===f&&C--,r.charAt(C)===f}return s.charAt(s.length-1)!==f&&(s+=f),r.indexOf(s)===0}e.isEqualOrParent=v;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function _(r,s){return M.isWindows&&r.endsWith(":")&&(r+=d.sep),(0,d.isAbsolute)(r)||(r=(0,d.join)(s,r)),r=(0,d.normalize)(r),M.isWindows?(r=(0,E.rtrim)(r,d.sep),r.endsWith(":")&&(r+=d.sep)):(r=(0,E.rtrim)(r,d.sep),r||(r=d.sep)),r}e.sanitizeFilePath=_;function a(r){const s=(0,d.normalize)(r);return M.isWindows?r.length>3?!1:c(s)&&(r.length===2||s.charCodeAt(2)===92):s===d.posix.sep}e.isRootOrDriveLetter=a;function c(r){return M.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function y(r){return c(r)?r[0]:void 0}e.getDriveLetter=y;function i(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function g(r){const s=r.split(":");let u,f,p;if(s.forEach(C=>{const P=Number(C);(0,A.isNumber)(P)?f===void 0?f=P:p===void 0&&(p=P):u=u?[u,C].join(":"):C}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:f!==void 0?f:void 0,column:p!==void 0?p:f!==void 0?1:void 0}}e.parseLineAndColumnAware=g}),define(be[23],Ee([0,1,10]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.keys(l).forEach(S=>{l[S]&&typeof l[S]=="object"?v[S]=M(l[S]):v[S]=l[S]}),v}e.deepClone=M;function E(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const S=v.shift();Object.freeze(S);for(const _ in S)if(A.call(S,_)){const a=S[_];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return l}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function R(l,v){return k(l,v,new Set)}e.cloneAndChange=R;function k(l,v,S){if((0,d.isUndefinedOrNull)(l))return l;const _=v(l);if(typeof _!="undefined")return _;if((0,d.isArray)(l)){const a=[];for(const c of l)a.push(k(c,v,S));return a}if((0,d.isObject)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const a={};for(let c in l)A.call(l,c)&&(a[c]=k(l[c],v,S));return S.delete(l),a}return l}function D(l,v,S=!0){return(0,d.isObject)(l)?((0,d.isObject)(v)&&Object.keys(v).forEach(_=>{_ in l?S&&((0,d.isObject)(l[_])&&(0,d.isObject)(v[_])?D(l[_],v[_],S):l[_]=v[_]):l[_]=v[_]}),l):v}e.mixin=D;function T(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let S,_;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(S=0;S<l.length;S++)if(!T(l[S],v[S]))return!1}else{const a=[];for(_ in l)a.push(_);a.sort();const c=[];for(_ in v)c.push(_);if(c.sort(),!T(a,c))return!1;for(S=0;S<a.length;S++)if(!T(l[a[S]],v[a[S]]))return!1}return!0}e.equals=T;function t(l){const v=new Set;return JSON.stringify(l,(S,_)=>{if((0,d.isObject)(_)||Array.isArray(_)){if(v.has(_))return"[Circular]";v.add(_)}return _})}e.safeStringify=t;function b(l,v,S){const _=v(l);return typeof _=="undefined"?S:_}e.getOrDefault=b;function n(l,v){const S=Object.create(null);return!l||!v||Object.keys(v).forEach(a=>{const c=l[a],y=v[a];T(c,y)||(S[a]=y)}),S}e.distinct=n;function h(l,v){const S=v.toLowerCase(),_=Object.keys(l).find(a=>a.toLowerCase()===S);return _?l[_]:l[v]}e.getCaseInsensitive=h;function o(l,v){const S=Object.create(null);for(const _ of Object.keys(l))v(_,l[_])&&(S[_]=l[_]);return S}e.filter=o});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[20],Ee([0,1,13,9,2]),function(re,e,d,M,E){"use strict";var A,R,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(g,r,s){let u=g.get(r);return u===void 0&&(u=s,g.set(r,u)),u}e.getOrSet=D;function T(g){const r=[];return g.forEach((s,u)=>{r.push(`${u} => ${s}`)}),`Map(${g.size}) {${r.join(", ")}}`}e.mapToString=T;function t(g){const r=[];return g.forEach(s=>{r.push(s)}),`Set(${g.size}) {${r.join(", ")}}`}e.setToString=t;class b{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=b;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class h{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var o;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(o||(o={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(r){this._iter=r}static forUris(r=()=>!1){return new S(new l(r))}static forPaths(){return new S(new h)}static forStrings(){return new S(new b)}static forConfigKeys(){return new S(new n)}clear(){this._root=void 0}set(r,s){const u=this._iter.reset(r);let f;for(this._root||(this._root=new v,this._root.segment=u.value()),f=this._root;;){const C=u.cmp(f.segment);if(C>0)f.left||(f.left=new v,f.left.segment=u.value()),f=f.left;else if(C<0)f.right||(f.right=new v,f.right.segment=u.value()),f=f.right;else if(u.hasNext())u.next(),f.mid||(f.mid=new v,f.mid.segment=u.value()),f=f.mid;else break}const p=f.value;return f.value=s,f.key=r,p}fill(r,s){const u=s.slice(0);(0,d.shuffle)(u);for(let f of u)this.set(f,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const f=s.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const u=this._iter.reset(r),f=[];let p=this._root;for(;p;){const C=u.cmp(p.segment);if(C>0)f.push([1,p]),p=p.left;else if(C<0)f.push([-1,p]),p=p.right;else if(u.hasNext())u.next(),f.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;f.length>0&&p.isEmpty();){let[P,m]=f.pop();switch(P){case 1:m.left=void 0;break;case 0:m.mid=void 0;break;case-1:m.right=void 0;break}p=m}break}}}findSubstr(r){const s=this._iter.reset(r);let u=this._root,f;for(;u;){const p=s.cmp(u.segment);if(p>0)u=u.left;else if(p<0)u=u.right;else if(s.hasNext())s.next(),f=u.value||f,u=u.mid;else break}return u&&u.value||f}findSuperstr(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const f=s.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[s,u]of this)r(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const u=s.pop();u&&(u.value&&(yield[u.key,u.value]),u.left&&s.push(u.left),u.mid&&s.push(u.mid),u.right&&s.push(u.right))}}}e.TernarySearchTree=S;class _{constructor(r,s){this[A]="ResourceMap",r instanceof _?(this.map=new Map(r.map),this.toKey=s??_.defaultToKey):(this.map=new Map,this.toKey=r??_.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[u,f]of this.map)r(f,E.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=_,_.defaultToKey=g=>g.toString();var a;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class c{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const u=this._map.get(r);if(!!u)return s!==0&&this.touch(u,s),u.value}set(r,s,u=0){let f=this._map.get(r);if(f)f.value=s,u!==0&&this.touch(f,u);else{switch(f={key:r,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const u=this._state;let f=this._head;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this._state;let u=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return f}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>r;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,u=r.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const u=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(u.previous=f,f.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const u=r.next,f=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=f,f.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,u)=>{r.push([u,s])}),r}fromJSON(r){this.clear();for(const[s,u]of r)this.set(s,u)}}e.LinkedMap=c;class y extends c{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class i{constructor(r){k.set(this,void 0),et(this,k,r,"f")}get size(){return Fe(this,k,"f").size}forEach(r,s){Fe(this,k,"f").forEach(r,s)}get(r){return Fe(this,k,"f").get(r)}has(r){return Fe(this,k,"f").has(r)}entries(){return Fe(this,k,"f").entries()}keys(){return Fe(this,k,"f").keys()}values(){return Fe(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Fe(this,k,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...q){return function(se,he){for(let Re=0,Be=q.length;Re<Be;Re++){const ze=q[Re](se,he);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(q,se,he){if(!he||he.length<se.length)return null;let Re;return q?Re=M.startsWithIgnoreCase(he,se):Re=he.indexOf(se)===0,Re?se.length>0?[{start:0,end:se.length}]:[]:null}function R(q,se){const he=se.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=R;function k(q,se){return D(q.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=k;function D(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]===se[Re]){let Be=null;return(Be=D(q,se,he+1,Re+1))?S({start:Re,end:Re+1},Be):null}return D(q,se,he,Re+1)}function T(q){return 97<=q&&q<=122}function t(q){return 65<=q&&q<=90}e.isUpper=t;function b(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>h.add(q.charCodeAt(0)));function o(q){return n(q)||h.has(q)}function l(q,se){return q===se||o(q)&&o(se)}function v(q){return T(q)||t(q)||b(q)}function S(q,se){return se.length===0?se=[q]:q.end===se[0].start?se[0].start=q.start:se.unshift(q),se}function _(q,se){for(let he=se;he<q.length;he++){const Re=q.charCodeAt(he);if(t(Re)||b(Re)||he>0&&!v(q.charCodeAt(he-1)))return he}return q.length}function a(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]!==se[Re].toLowerCase())return null;{let Be=null,ze=Re+1;for(Be=a(q,se,he+1,Re+1);!Be&&(ze=_(se,ze))<se.length;)Be=a(q,se,he+1,ze),ze++;return Be===null?null:S({start:Re,end:Re+1},Be)}}function c(q){let se=0,he=0,Re=0,Be=0,ze=0;for(let j=0;j<q.length;j++)ze=q.charCodeAt(j),t(ze)&&se++,T(ze)&&he++,v(ze)&&Re++,b(ze)&&Be++;const Qe=se/q.length,it=he/q.length,ke=Re/q.length,Ze=Be/q.length;return{upperPercent:Qe,lowerPercent:it,alphaPercent:ke,numericPercent:Ze}}function y(q){const{upperPercent:se,lowerPercent:he}=q;return he===0&&se>.6}function i(q){const{upperPercent:se,lowerPercent:he,alphaPercent:Re,numericPercent:Be}=q;return he>.2&&se<.8&&Re>.6&&Be<.2}function g(q){let se=0,he=0,Re=0,Be=0;for(let ze=0;ze<q.length;ze++)Re=q.charCodeAt(ze),t(Re)&&se++,T(Re)&&he++,n(Re)&&Be++;return(se===0||he===0)&&Be===0?q.length<=30:se<=5}function r(q,se){if(!se||(se=se.trim(),se.length===0)||!g(q)||se.length>60)return null;const he=c(se);if(!i(he)){if(!y(he))return null;se=se.toLowerCase()}let Re=null,Be=0;for(q=q.toLowerCase();Be<se.length&&(Re=a(q,se,0,Be))===null;)Be=_(se,Be+1);return Re}e.matchesCamelCase=r;function s(q,se,he=!1){if(!se||se.length===0)return null;let Re=null,Be=0;for(q=q.toLowerCase(),se=se.toLowerCase();Be<se.length&&(Re=u(q,se,0,Be,he))===null;)Be=f(se,Be+1);return Re}e.matchesWords=s;function u(q,se,he,Re,Be){if(he===q.length)return[];if(Re===se.length)return null;if(l(q.charCodeAt(he),se.charCodeAt(Re))){let ze=null,Qe=Re+1;if(ze=u(q,se,he+1,Re+1,Be),!Be)for(;!ze&&(Qe=f(se,Qe))<se.length;)ze=u(q,se,he+1,Qe,Be),Qe++;return ze===null?null:S({start:Re,end:Re+1},ze)}else return null}function f(q,se){for(let he=se;he<q.length;he++)if(o(q.charCodeAt(he))||he>0&&o(q.charCodeAt(he-1)))return he;return q.length}const p=E(e.matchesPrefix,r,R),C=E(e.matchesPrefix,r,k),P=new d.LRUCache(1e4);function m(q,se,he=!1){if(typeof q!="string"||typeof se!="string")return null;let Re=P.get(q);Re||(Re=new RegExp(M.convertSimple2RegExpPattern(q),"i"),P.set(q,Re));const Be=Re.exec(se);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?C(q,se):p(q,se)}e.matchesFuzzy=m;function I(q,se){const he=We(q,q.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=I;function F(q,se,he,Re,Be,ze){const Qe=Math.min(13,q.length);for(;he<Qe;he++){const it=We(q,se,he,Re,Be,ze,!1);if(it)return it}return[0,ze]}e.anyScore=F;function L(q){if(typeof q=="undefined")return[];const se=[],he=q[1];for(let Re=q.length-1;Re>1;Re--){const Be=q[Re]+he,ze=se[se.length-1];ze&&ze.end===Be?ze.end=Be+1:se.push({start:Be,end:Be+1})}return se}e.createMatches=L;const w=128;function x(){const q=[],se=[];for(let he=0;he<=w;he++)se[he]=0;for(let he=0;he<=w;he++)q.push(se.slice(0));return q}function W(q){const se=[];for(let he=0;he<=q;he++)se[he]=0;return se}const B=W(2*w),G=W(2*w),H=x(),U=x(),V=x(),Q=!1;function ne(q,se,he,Re,Be){function ze(it,ke,Ze=" "){for(;it.length<ke;)it=Ze+it;return it}let Qe=` |   |${Re.split("").map(it=>ze(it,3)).join("|")}
`;for(let it=0;it<=he;it++)it===0?Qe+=" |":Qe+=`${se[it-1]}|`,Qe+=q[it].slice(0,Be+1).map(ke=>ze(ke.toString(),3)).join("|")+`
`;return Qe}function ce(q,se,he,Re){q=q.substr(se),he=he.substr(Re),console.log(ne(U,q,q.length,he,he.length)),console.log(ne(V,q,q.length,he,he.length)),console.log(ne(H,q,q.length,he,he.length))}function Z(q,se){if(se<0||se>=q.length)return!1;const he=q.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function oe(q,se){if(se<0||se>=q.length)return!1;switch(q.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(q,se,he){return se[q]!==he[q]}function Ae(q,se,he,Re,Be,ze,Qe=!1){for(;se<he&&Be<ze;)q[se]===Re[Be]&&(Qe&&(B[se]=Be),se+=1),Be+=1;return se===he}e.isPatternInWord=Ae;var Se;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Ne;(function(q){q.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function We(q,se,he,Re,Be,ze,Qe){const it=q.length>w?w:q.length,ke=Re.length>w?w:Re.length;if(he>=it||ze>=ke||it-he>ke-ze||!Ae(se,he,it,Be,ze,ke,!0))return;je(it,ke,he,ze,se,Be);let Ze=1,j=1,J=he,me=ze;const He=[!1];for(Ze=1,J=he;J<it;Ze++,J++){const mt=B[J],Dt=G[J],Pt=J+1<it?G[J+1]:ke;for(j=mt-ze+1,me=mt;me<Pt;j++,me++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;me<=Dt&&(It=qe(q,se,J,he,Re,Be,me,ke,ze,H[Ze-1][j-1]===0,He));let St=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,St=It+U[Ze-1][j-1]);const Te=me>mt,ye=Te?U[Ze][j-1]+(H[Ze][j-1]>0?-5:0):0,Ce=me>mt+1&&H[Ze][j-1]>0,te=Ce?U[Ze][j-2]+(H[Ze][j-2]>0?-5:0):0;if(Ce&&(!Te||te>=ye)&&(!Xe||te>=St))U[Ze][j]=te,V[Ze][j]=3,H[Ze][j]=0;else if(Te&&(!Xe||ye>=St))U[Ze][j]=ye,V[Ze][j]=2,H[Ze][j]=0;else if(Xe)U[Ze][j]=St,V[Ze][j]=1,H[Ze][j]=H[Ze-1][j-1]+1;else throw new Error("not possible")}}if(Q&&ce(q,he,Re,ze),!He[0]&&!Qe)return;Ze--,j--;const Ye=[U[Ze][j],ze];let st=0,ot=0;for(;Ze>=1;){let mt=j;do{const Dt=V[Ze][mt];if(Dt===3)mt=mt-2;else if(Dt===2)mt=mt-1;else break}while(mt>=1);st>1&&se[he+Ze-1]===Be[ze+j-1]&&!ve(mt+ze-1,Re,Be)&&st+1>H[Ze][mt]&&(mt=j),mt===j?st++:st=1,ot||(ot=mt),Ze--,j=mt-1,Ye.push(j)}ke===it&&(Ye[0]+=2);const Et=ot-it;return Ye[0]-=Et,Ye}e.fuzzyScore=We;function je(q,se,he,Re,Be,ze){let Qe=q-1,it=se-1;for(;Qe>=he&&it>=Re;)Be[Qe]===ze[it]&&(G[Qe]=it,Qe--),it--}function qe(q,se,he,Re,Be,ze,Qe,it,ke,Ze,j){if(se[he]!==ze[Qe])return Number.MIN_SAFE_INTEGER;let J=1,me=!1;return Qe===he-Re?J=q[he]===Be[Qe]?7:5:ve(Qe,Be,ze)&&(Qe===0||!ve(Qe-1,Be,ze))?(J=q[he]===Be[Qe]?7:5,me=!0):Z(ze,Qe)&&(Qe===0||!Z(ze,Qe-1))?J=5:(Z(ze,Qe-1)||oe(ze,Qe-1))&&(J=5,me=!0),J>1&&he===Re&&(j[0]=!0),me||(me=ve(Qe,Be,ze)||Z(ze,Qe-1)||oe(ze,Qe-1)),he===Re?Qe>ke&&(J-=me?3:5):Ze?J+=me?2:0:J+=me?0:1,Qe+1===it&&(J-=me?3:5),J}function $(q,se,he,Re,Be,ze,Qe){return ee(q,se,he,Re,Be,ze,!0,Qe)}e.fuzzyScoreGracefulAggressive=$;function K(q,se,he,Re,Be,ze,Qe){return ee(q,se,he,Re,Be,ze,!1,Qe)}e.fuzzyScoreGraceful=K;function ee(q,se,he,Re,Be,ze,Qe,it){let ke=We(q,se,he,Re,Be,ze,it);if(ke&&!Qe)return ke;if(q.length>=3){const Ze=Math.min(7,q.length-1);for(let j=he+1;j<Ze;j++){const J=ae(q,j);if(J){const me=We(J,J.toLowerCase(),he,Re,Be,ze,it);me&&(me[0]-=3,(!ke||me[0]>ke[0])&&(ke=me))}}}return ke}function ae(q,se){if(se+1>=q.length)return;const he=q[se],Re=q[se+1];if(he!==Re)return q.slice(0,se)+Re+he+q.slice(se+2)}}),define(be[107],Ee([0,1,34,106,9]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function k(l){return l.replace(R,(v,S)=>S?v:`\\${v}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function T(l){return l.replace(D,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(v,S,_,a)=>_?v:S||a||"")}e.stripIcons=b;function n(l){const v=l.indexOf(e.iconStartMarker);return v===-1?{text:l}:h(l,v)}e.parseLabelWithIcons=n;function h(l,v){const S=[];let _="";function a(f){if(f){_+=f;for(const p of f)S.push(i)}}let c=-1,y="",i=0,g,r,s=v;const u=l.length;for(a(l.substr(0,v));s<u;)g=l[s],r=l[s+1],g===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(c=s,a(y),y=e.iconStartMarker,s++):g===")"&&c!==-1?(i+=s-c+1,c=-1,y=""):c!==-1?/^[a-z0-9\-]$/i.test(g)?y+=g:(a(y),c=-1,y=""):a(g),s++;return a(y),{text:_,iconOffsets:S}}function o(l,v,S=!1){const{text:_,iconOffsets:a}=v;if(!a||a.length===0)return(0,M.matchesFuzzy)(l,_,S);const c=(0,E.ltrim)(_," "),y=_.length-c.length,i=(0,M.matchesFuzzy)(l,c,S);if(i)for(const g of i){const r=a[g.start+y]+y;g.start+=r,g.end+=r}return i}e.matchesFuzzyIconAware=o}),define(be[76],Ee([0,1,16,107]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",o=!1){if(this.value=h,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(h,o=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(h):h).replace(/([ \t]+)/g,(l,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,o){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=A;function R(n){return k(n)?!n.value:Array.isArray(n)?n.every(R):!0}e.isEmptyMarkdownString=R;function k(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=D;function T(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function b(n){const h=[],o=n.split("|").map(v=>v.trim());n=o[0];const l=o[1];if(l){const v=/height=(\d+)/.exec(l),S=/width=(\d+)/.exec(l),_=v?v[1]:"",a=S?S[1]:"",c=isFinite(parseInt(a)),y=isFinite(parseInt(_));c&&h.push(`width="${a}"`),y&&h.push(`height="${_}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=b}),define(be[54],Ee([0,1,22,9,2]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,D)}e.stringify=A;function R(t){let b=JSON.parse(t);return b=T(b),b}e.parse=R;var k;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function D(t,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function T(t,b=0){if(!t||b>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],b+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],b+1))}return t}e.revive=T}),define(be[11],Ee([0,1,25,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,t){this._hosts[D]=T,this._ports[D]=t}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const b=this._ports[T],n=this._connectionTokens[T];let h=`path=${encodeURIComponent(D.path)}`;return typeof n=="string"&&(h+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${b}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class R{asBrowserUri(D,T){const t=this.toUri(D,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(D,T){const t=this.toUri(D,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(D,T){return M.URI.isUri(D)?D:M.URI.parse(T.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=D;class T{constructor(o){this._ignorePathCasing=o}compare(o,l,v=!1){return o===l?0:(0,R.compare)(this.getComparisonKey(o,v),this.getComparisonKey(l,v))}isEqual(o,l,v=!1){return o===l?!0:!o||!l?!1:this.getComparisonKey(o,v)===this.getComparisonKey(l,v)}getComparisonKey(o,l=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,l,v=!1){if(o.scheme===l.scheme){if(o.scheme===M.Schemas.file)return d.isEqualOrParent(D(o),D(l),this._ignorePathCasing(o))&&o.query===l.query&&(v||o.fragment===l.fragment);if((0,e.isEqualAuthority)(o.authority,l.authority))return d.isEqualOrParent(o.path,l.path,this._ignorePathCasing(o),"/")&&o.query===l.query&&(v||o.fragment===l.fragment)}return!1}joinPath(o,...l){return k.URI.joinPath(o,...l)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return E.posix.basename(o.path)}extname(o){return E.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let l;return o.scheme===M.Schemas.file?l=k.URI.file(E.dirname(D(o))).path:(l=E.posix.dirname(o.path),o.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),l="/")),o.with({path:l})}normalizePath(o){if(!o.path.length)return o;let l;return o.scheme===M.Schemas.file?l=k.URI.file(E.normalize(D(o))).path:l=E.posix.normalize(o.path),o.with({path:l})}relativePath(o,l){if(o.scheme!==l.scheme||!(0,e.isEqualAuthority)(o.authority,l.authority))return;if(o.scheme===M.Schemas.file){const _=E.relative(D(o),D(l));return A.isWindows?d.toSlashes(_):_}let v=o.path||"/",S=l.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const a=Math.min(v.length,S.length);_<a&&!(v.charCodeAt(_)!==S.charCodeAt(_)&&v.charAt(_).toLowerCase()!==S.charAt(_).toLowerCase());_++);v=S.substr(0,_)+v.substr(_)}return E.posix.relative(v,S)}resolvePath(o,l){if(o.scheme===M.Schemas.file){const v=k.URI.file(E.resolve(D(o),l));return o.with({authority:v.authority,path:v.path})}return l=d.toPosixPath(l),o.with({path:E.posix.resolve(o.path,l)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,l){return o===l||(0,R.equalsIgnoreCase)(o,l)}hasTrailingPathSeparator(o,l=E.sep){if(o.scheme===M.Schemas.file){const v=D(o);return v.length>d.getRoot(v).length&&v[v.length-1]===l}else{const v=o.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,l=E.sep){return(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,l=E.sep){let v=!1;if(o.scheme===M.Schemas.file){const S=D(o);v=S!==void 0&&S.length===d.getRoot(S).length&&S[S.length-1]===l}else{l="/";const S=o.path;v=S.length===1&&S.charCodeAt(S.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path+"/"}):o}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(h=>h.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(h,o){const l=[];for(let v=0;v<h.length;v++){const S=o(h[v]);h.some((_,a)=>a===v?!1:(0,e.isEqualOrParent)(S,o(_)))||l.push(h[v])}return l}e.distinctParents=t;var b;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function o(l){const v=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,y]=a.split(":");c&&y&&v.set(c,y)});const _=l.path.substring(0,l.path.indexOf(";"));return _&&v.set(h.META_DATA_MIME,_),v}h.parseMetaData=o})(b=e.DataUri||(e.DataUri={}));function n(h,o,l){if(o){let v=h.path;return v&&v[0]!==E.posix.sep&&(v=E.posix.sep+v),h.with({scheme:l,authority:o,path:v})}return h.with({scheme:l})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(H){return!!H&&typeof H.then=="function"}e.isThenable=k;function D(H){const U=new d.CancellationTokenSource,V=H(U.token),Q=new Promise((ne,ce)=>{const Z=U.token.onCancellationRequested(()=>{Z.dispose(),U.dispose(),ce((0,M.canceled)())});Promise.resolve(V).then(oe=>{Z.dispose(),U.dispose(),ne(oe)},oe=>{Z.dispose(),U.dispose(),ce(oe)})});return new class{cancel(){U.cancel()}then(ne,ce){return Q.then(ne,ce)}catch(ne){return this.then(void 0,ne)}finally(ne){return Q.finally(ne)}}}e.createCancelablePromise=D;function T(H,U,V){return Promise.race([H,new Promise(Q=>U.onCancellationRequested(()=>Q(V)))])}e.raceCancellation=T;async function t(H){let U=-1;const V=H.map((ne,ce)=>ne.then(Z=>(U=ce,Z))),Q=await Promise.race(V);return H.forEach((ne,ce)=>{ce!==U&&ne.cancel()}),Q}e.raceCancellablePromises=t;function b(H,U,V){let Q;const ne=setTimeout(()=>{Q?.(void 0),V?.()},U);return Promise.race([H.finally(()=>clearTimeout(ne)),new Promise(ce=>Q=ce)])}e.raceTimeout=b;function n(H){return new Promise((U,V)=>{const Q=H();k(Q)?Q.then(U,V):U(Q)})}e.asPromise=n;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(V,V).then(Q)})}return new Promise((V,Q)=>{this.queuedPromise.then(V,Q)})}return this.activePromise=U(),new Promise((V,Q)=>{this.activePromise.then(ne=>{this.activePromise=null,V(ne)},ne=>{this.activePromise=null,Q(ne)})})}}e.Throttler=h;class o{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=o;class l{constructor(){this.promiseMap=new Map}queue(U,V){const ne=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(U)===ne&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ne),ne}}e.SequencerByKey=l;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,V=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,ne)=>{this.doResolve=Q,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class S{constructor(U){this.delayer=new v(U),this.throttler=new h}trigger(U,V){return this.delayer.trigger(()=>this.throttler.queue(U),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class _{constructor(){this._isOpen=!1,this._promise=new Promise((U,V)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class a extends _{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function c(H,U){return U?new Promise((V,Q)=>{const ne=setTimeout(()=>{ce.dispose(),V()},H),ce=U.onCancellationRequested(()=>{clearTimeout(ne),ce.dispose(),Q((0,M.canceled)())})}):D(V=>c(H,V))}e.timeout=c;function y(H,U=0){const V=setTimeout(H,U);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=y;function i(H){const U=[];let V=0;const Q=H.length;function ne(){return V<Q?H[V++]():null}function ce(Z){Z!=null&&U.push(Z);const oe=ne();return oe?oe.then(ce):Promise.resolve(U)}return Promise.resolve(null).then(ce)}e.sequence=i;function g(H,U=Q=>!!Q,V=null){let Q=0;const ne=H.length,ce=()=>{if(Q>=ne)return Promise.resolve(V);const Z=H[Q++];return Promise.resolve(Z()).then(ve=>U(ve)?Promise.resolve(ve):ce())};return ce()}e.first=g;function r(H,U=Q=>!!Q,V=null){if(H.length===0)return Promise.resolve(V);let Q=H.length;const ne=()=>{Q=-1;for(const ce of H)ce.cancel?.()};return new Promise((ce,Z)=>{for(const oe of H)oe.then(ve=>{--Q>=0&&U(ve)?(ne(),ce(ve)):Q===0&&ce(V)}).catch(ve=>{--Q>=0&&(ne(),Z(ve))})})}e.firstParallel=r;class s{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((V,Q)=>{this.outstandingPromises.push({factory:U,c:V,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const V=U.factory();V.then(U.c,U.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class f{constructor(){this.queues=new Map}queueFor(U,V=R.extUri){const Q=V.getComparisonKey(U);let ne=this.queues.get(Q);return ne||(ne=new u,E.Event.once(ne.onFinished)(()=>{ne?.dispose(),this.queues.delete(Q)}),this.queues.set(Q,ne)),ne}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=f;class p{constructor(U,V){this._token=-1,typeof U=="function"&&typeof V=="number"&&this.setIfNotSet(U,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},V)}setIfNotSet(U,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},V))}}e.TimeoutTimer=p;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setInterval(()=>{U()},V)}}e.IntervalTimer=C;class P{constructor(U,V){this.timeoutToken=-1,this.runner=U,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class m{constructor(U,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=m;class I extends P{constructor(U,V){super(U,V);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=I;class F extends A.Disposable{constructor(U,V,Q,ne){super();this.maxWorkChunkSize=U,this.maxPendingWork=V,this.throttleDelay=Q,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const U=setTimeout(()=>{const Q=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout(U))}}}:e.runWhenIdle=(H,U)=>{const V=requestIdleCallback(H,typeof U=="number"?{timeout:U}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(V))}}}}();class L{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function w(H,U,V){let Q;for(let ne=0;ne<V;ne++)try{return await H()}catch(ce){Q=ce,await c(U)}throw Q}e.retry=w;class x{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,V,Q){return this._pending={taskId:U,cancel:()=>Q?.(),promise:V},V.then(()=>this.donePending(U),()=>this.donePending(U)),V}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let V,Q;const ne=new Promise((ce,Z)=>{V=ce,Q=Z});this._next={run:U,promise:ne,promiseResolve:V,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=x;class W{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,V)=>{this.completeCallback=U,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(V=>{this.completeCallback(U),this.resolved=!0,V()})}error(U){return new Promise(V=>{this.errorCallback(U),this.rejected=!0,V()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=B;var G;(function(H){async function U(V){let Q;const ne=await Promise.all(V.map(ce=>ce.then(Z=>Z,Z=>{Q||(Q=Z)})));if(typeof Q!="undefined")throw Q;return ne}H.settled=U})(G=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(P,m,I=!1){const F=P||"",L=m||"",w=E.value.collator.compare(F,L);return E.value.collatorIsNumeric&&w===0&&F!==L?F<L?-1:1:w}e.compareFileNames=k;function D(P,m){const I=A.value.collator;return P=P||"",m=m||"",y(I,P,m)}e.compareFileNamesDefault=D;function T(P,m){const I=A.value.collator;return P=P||"",m=m||"",s(P,m)||y(I,P,m)}e.compareFileNamesUpper=T;function t(P,m){const I=A.value.collator;return P=P||"",m=m||"",r(P,m)||y(I,P,m)}e.compareFileNamesLower=t;function b(P,m){return P=P||"",m=m||"",P===m?0:P<m?-1:1}e.compareFileNamesUnicode=b;function n(P,m,I=!1){I||(P=P&&P.toLowerCase(),m=m&&m.toLowerCase());const[F,L]=a(P),[w,x]=a(m);return F!==w?F<w?-1:1:L===x?0:L<x?-1:1}e.noIntlCompareFileNames=n;function h(P,m){const[I,F]=a(P),[L,w]=a(m);let x=E.value.collator.compare(F,w);if(x===0){if(E.value.collatorIsNumeric&&F!==w)return F<w?-1:1;if(x=E.value.collator.compare(I,L),E.value.collatorIsNumeric&&x===0&&I!==L)return I<L?-1:1}return x}e.compareFileExtensions=h;function o(P,m){P=P||"",m=m||"";const I=c(P),F=c(m),L=A.value.collator,w=R.value.collator;return y(w,I,F)||y(L,P,m)}e.compareFileExtensionsDefault=o;function l(P,m){P=P||"",m=m||"";const I=c(P),F=c(m),L=A.value.collator,w=R.value.collator;return y(w,I,F)||s(P,m)||y(L,P,m)}e.compareFileExtensionsUpper=l;function v(P,m){P=P||"",m=m||"";const I=c(P),F=c(m),L=A.value.collator,w=R.value.collator;return y(w,I,F)||r(P,m)||y(L,P,m)}e.compareFileExtensionsLower=v;function S(P,m){P=P||"",m=m||"";const I=c(P).toLowerCase(),F=c(m).toLowerCase();return I!==F?I<F?-1:1:P!==m?P<m?-1:1:0}e.compareFileExtensionsUnicode=S;const _=/^(.*?)(\.([^.]*))?$/;function a(P,m=!1){const I=P?_.exec(P):[];let F=[I&&I[1]||"",I&&I[3]||""];return m&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function c(P){const m=P?_.exec(P):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function y(P,m,I){let F=P.compare(m,I);return F!==0?F:m.length!==I.length?m.length<I.length?-1:1:0}function i(P){const m=P.charAt(0);return m.toLocaleUpperCase()!==m}function g(P){const m=P.charAt(0);return m.toLocaleLowerCase()!==m}function r(P,m){return i(P)&&g(m)?-1:g(P)&&i(m)?1:0}function s(P,m){return g(P)&&i(m)?-1:i(P)&&g(m)?1:0}function u(P,m,I=!1){return I||(P=P&&P.toLowerCase(),m=m&&m.toLowerCase()),P===m?0:P<m?-1:1}function f(P,m,I=!1){const F=P.split(M.sep),L=m.split(M.sep),w=F.length-1,x=L.length-1;let W,B;for(let G=0;;G++){if(W=w===G,B=x===G,W&&B)return k(F[G],L[G],I);if(W)return-1;if(B)return 1;const H=u(F[G],L[G],I);if(H!==0)return H}}e.comparePaths=f;function p(P,m,I){const F=P.toLowerCase(),L=m.toLowerCase(),w=C(P,m,I);if(w)return w;const x=F.endsWith(I),W=L.endsWith(I);if(x!==W)return x?-1:1;const B=k(F,L);return B!==0?B:F.localeCompare(L)}e.compareAnything=p;function C(P,m,I){const F=P.toLowerCase(),L=m.toLowerCase(),w=F.startsWith(I),x=L.startsWith(I);if(w!==x)return w?-1:1;if(w&&x){if(F.length<L.length)return-1;if(F.length>L.length)return 1}return 0}e.compareByPrefix=C}),define(be[27],Ee([0,1,14,43,20,17,9]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",T="/",t="[/\\\\]",b="[^/\\\\]",n=/\//g;function h(Q){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${t}|${b}+${t}|${t}${b}+)*?`}}function o(Q,ne){if(!Q)return[];const ce=[];let Z=!1,oe=!1,ve="";for(const Ae of Q){switch(Ae){case ne:if(!Z&&!oe){ce.push(ve),ve="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ve+=Ae}return ve&&ce.push(ve),ce}e.splitGlobAware=o;function l(Q){if(!Q)return"";let ne="";const ce=o(Q,T);if(ce.every(Z=>Z===D))ne=".*";else{let Z=!1;ce.forEach((oe,ve)=>{if(oe===D){Z||(ne+=h(2),Z=!0);return}let Ae=!1,Se="",Ne=!1,We="";for(const je of oe){if(je!=="}"&&Ae){Se+=je;continue}if(Ne&&(je!=="]"||!We)){let qe;je==="-"?qe=je:(je==="^"||je==="!")&&!We?qe="^":je===T?qe="":qe=R.escapeRegExpCharacters(je),We+=qe;continue}switch(je){case"{":Ae=!0;continue;case"[":Ne=!0;continue;case"}":ne+=`(?:${o(Se,",").map(K=>l(K)).join("|")})`,Ae=!1,Se="";break;case"]":ne+="["+We+"]",Ne=!1,We="";break;case"?":ne+=b;continue;case"*":ne+=h(1);continue;default:ne+=R.escapeRegExpCharacters(je)}}ve<ce.length-1&&(ce[ve+1]!==D||ve+2<ce.length)&&(ne+=t),Z=!1})}return ne}const v=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),g=function(){return!1},r=function(){return null};function s(Q,ne){if(!Q)return r;let ce;typeof Q!="string"?ce=Q.pattern:ce=Q,ce=ce.trim();const Z=`${ce}_${!!ne.trimForExclusions}`;let oe=i.get(Z);if(oe)return u(oe,Q);let ve;if(v.test(ce)){const Ae=ce.substr(4);oe=function(Se,Ne){return typeof Se=="string"&&Se.endsWith(Ae)?ce:null}}else(ve=S.exec(f(ce,ne)))?oe=p(ve[1],ce):(ne.trimForExclusions?a:_).test(ce)?oe=C(ce,ne):(ve=c.exec(f(ce,ne)))?oe=P(ve[1].substr(1),ce,!0):(ve=y.exec(f(ce,ne)))?oe=P(ve[1],ce,!1):oe=m(ce);return i.set(Z,oe),u(oe,Q)}function u(Q,ne){return typeof ne=="string"?Q:function(ce,Z){return M.isEqualOrParent(ce,ne.base)?Q(A.relative(ne.base,ce),Z):null}}function f(Q,ne){return ne.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function p(Q,ne){const ce=`/${Q}`,Z=`\\${Q}`,oe=function(Ae,Se){return typeof Ae!="string"?null:Se?Se===Q?ne:null:Ae===Q||Ae.endsWith(ce)||Ae.endsWith(Z)?ne:null},ve=[Q];return oe.basenames=ve,oe.patterns=[ne],oe.allBasenames=ve,oe}function C(Q,ne){const ce=V(Q.slice(1,-1).split(",").map(Se=>s(Se,ne)).filter(Se=>Se!==r),Q),Z=ce.length;if(!Z)return r;if(Z===1)return ce[0];const oe=function(Se,Ne){for(let We=0,je=ce.length;We<je;We++)if(ce[We](Se,Ne))return Q;return null},ve=ce.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ce.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function P(Q,ne,ce){const Z=A.sep===A.posix.sep,oe=Z?Q:Q.replace(n,A.sep),ve=A.sep+oe,Ae=A.posix.sep+Q,Se=ce?function(Ne,We){return typeof Ne=="string"&&(Ne===oe||Ne.endsWith(ve)||!Z&&(Ne===Q||Ne.endsWith(Ae)))?ne:null}:function(Ne,We){return typeof Ne=="string"&&(Ne===oe||!Z&&Ne===Q)?ne:null};return Se.allPaths=[(ce?"*/":"./")+Q],Se}function m(Q){try{const ne=new RegExp(`^${l(Q)}$`);return function(ce){return ne.lastIndex=0,typeof ce=="string"&&ne.test(ce)?Q:null}}catch(ne){return r}}function I(Q,ne,ce){return!Q||typeof ne!="string"?!1:F(Q)(ne,void 0,ce)}e.match=I;function F(Q,ne={}){if(!Q)return g;if(typeof Q=="string"||W(Q)){const ce=s(Q,ne);if(ce===r)return g;const Z=function(oe,ve){return!!ce(oe,ve)};return ce.allBasenames&&(Z.allBasenames=ce.allBasenames),ce.allPaths&&(Z.allPaths=ce.allPaths),Z}return H(Q,ne)}e.parse=F;function L(Q){if(!Q)return;let ne;return ce=>(ne||(ne=(Q()||Promise.resolve([])).then(Z=>Z?x(Z):{})),ne.then(Z=>!!Z[ce]))}e.hasSiblingPromiseFn=L;function w(Q){if(!Q)return;let ne;return ce=>{if(!ne){const Z=Q();ne=Z?x(Z):{}}return!!ne[ce]}}e.hasSiblingFn=w;function x(Q){const ne={};for(const ce of Q)ne[ce]=!0;return ne}function W(Q){const ne=Q;return ne&&typeof ne.base=="string"&&typeof ne.pattern=="string"}e.isRelativePattern=W;function B(Q){return Q.allBasenames||[]}e.getBasenameTerms=B;function G(Q){return Q.allPaths||[]}e.getPathTerms=G;function H(Q,ne){const ce=V(Object.getOwnPropertyNames(Q).map(Se=>U(Se,Q[Se],ne)).filter(Se=>Se!==r)),Z=ce.length;if(!Z)return r;if(!ce.some(Se=>!!Se.requiresSiblings)){if(Z===1)return ce[0];const Se=function(je,qe){for(let $=0,K=ce.length;$<K;$++){const ee=ce[$](je,qe);if(ee)return ee}return null},Ne=ce.find(je=>!!je.allBasenames);Ne&&(Se.allBasenames=Ne.allBasenames);const We=ce.reduce((je,qe)=>qe.allPaths?je.concat(qe.allPaths):je,[]);return We.length&&(Se.allPaths=We),Se}const oe=function(Se,Ne,We){let je;for(let qe=0,$=ce.length;qe<$;qe++){const K=ce[qe];K.requiresSiblings&&We&&(Ne||(Ne=A.basename(Se)),je||(je=Ne.substr(0,Ne.length-A.extname(Se).length)));const ee=K(Se,Ne,je,We);if(ee)return ee}return null},ve=ce.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ce.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function U(Q,ne,ce){if(ne===!1)return r;const Z=s(Q,ce);if(Z===r)return r;if(typeof ne=="boolean")return Z;if(ne){const oe=ne.when;if(typeof oe=="string"){const ve=(Ae,Se,Ne,We)=>{if(!We||!Z(Ae,Se))return null;const je=oe.replace("$(basename)",Ne),qe=We(je);return(0,d.isThenable)(qe)?qe.then($=>$?Q:null):qe?Q:null};return ve.requiresSiblings=!0,ve}}return Z}function V(Q,ne){const ce=Q.filter(Se=>!!Se.basenames);if(ce.length<2)return Q;const Z=ce.reduce((Se,Ne)=>{const We=Ne.basenames;return We?Se.concat(We):Se},[]);let oe;if(ne){oe=[];for(let Se=0,Ne=Z.length;Se<Ne;Se++)oe.push(ne)}else oe=ce.reduce((Se,Ne)=>{const We=Ne.patterns;return We?Se.concat(We):Se},[]);const ve=function(Se,Ne){if(typeof Se!="string")return null;if(!Ne){let je;for(je=Se.length;je>0;je--){const qe=Se.charCodeAt(je-1);if(qe===47||qe===92)break}Ne=Se.substr(je)}const We=Z.indexOf(Ne);return We!==-1?oe[We]:null};ve.basenames=Z,ve.patterns=oe,ve.allBasenames=Z;const Ae=Q.filter(Se=>!Se.basenames);return Ae.push(ve),Ae}}),define(be[77],Ee([0,1,43,11,17,25,24,9,2]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(s,u,f){if(typeof s=="string"&&(s=D.URI.file(s)),f){const C=f.getWorkspaceFolder(s);if(C){const P=f.getWorkspace().folders.length>1;let m;if((0,R.isEqual)(C.uri,s)?m="":m=(0,R.relativePath)(C.uri,s),P){const I=C.name?C.name:(0,R.basename)(C.uri);m=m?I+" \u2022 "+m:I}return m}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(s.fsPath))return(0,E.normalize)(b(s.fsPath));let p=(0,E.normalize)(s.fsPath);return!A.isWindows&&u?.userHome&&(p=h(p,u.userHome.fsPath)),p}e.getPathLabel=T;function t(s){if(!s)return;typeof s=="string"&&(s=D.URI.file(s));const u=(0,R.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(u)?b(u):u}e.getBaseLabel=t;function b(s){return(0,d.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=b;let n=Object.create(null);function h(s,u){if(A.isWindows||!s||!u)return s;let f=n.original===u?n.normalized:void 0;return f||(f=`${(0,k.rtrim)(u,E.posix.sep)}${E.posix.sep}`,n={original:u,normalized:f}),(A.isLinux?s.startsWith(f):(0,k.startsWithIgnoreCase)(s,f))&&(s=`~/${s.substr(f.length)}`),s}e.tildify=h;function o(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=o;const l="\u2026",v="\\\\",S="~";function _(s,u=E.sep){const f=new Array(s.length);let p=!1;for(let C=0;C<s.length;C++){let P=s[C];if(P===""){f[C]=`.${u}`;continue}if(!P){f[C]=P;continue}p=!0;let m="";P.indexOf(v)===0?(m=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(u)===0?(m=P.substr(0,P.indexOf(u)+u.length),P=P.substr(P.indexOf(u)+u.length)):P.indexOf(S)===0&&(m=P.substr(0,P.indexOf(S)+S.length),P=P.substr(P.indexOf(S)+S.length));const I=P.split(u);for(let F=1;p&&F<=I.length;F++)for(let L=I.length-F;p&&L>=0;L--){p=!1;let w=I.slice(L,L+F).join(u);for(let x=0;!p&&x<s.length;x++)if(x!==C&&s[x]&&s[x].indexOf(w)>-1){const W=L+F===I.length,B=L>0&&s[x].indexOf(u)>-1?u+w:w,G=s[x].endsWith(B);p=!W||G}if(!p){let x="";(I[0].endsWith(":")||m!=="")&&(L===1&&(L=0,F++,w=I[0]+u+w),L>0&&(x=I[0]+u),x=m+x),L>0&&(x=x+l+u),x=x+w,L+F<I.length&&(x=x+u+l),f[C]=x}}p&&(f[C]=P)}return f}e.shorten=_;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function c(s,u=Object.create(null)){const f=[];let p=!1,C="";for(const P of s)if(P==="$"||p&&P==="{")C&&f.push({value:C,type:a.TEXT}),C="",p=!0;else if(P==="}"&&p){const m=u[C];if(typeof m=="string")m.length&&f.push({value:m,type:a.VARIABLE});else if(m){const I=f[f.length-1];(!I||I.type!==a.SEPARATOR)&&f.push({value:m.label,type:a.SEPARATOR})}C="",p=!1}else C+=P;return C&&!p&&f.push({value:C,type:a.TEXT}),f.filter((P,m)=>{if(P.type===a.SEPARATOR){const I=f[m-1],F=f[m+1];return[I,F].every(L=>L&&(L.type===a.VARIABLE||L.type===a.TEXT)&&L.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=c;function y(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):s.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):A.isWindows?s.replace(/&&|&/g,f=>f==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function g(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=g;function r(s){const u=s.indexOf("/")!==-1?E.posix:E.win32,f=u.basename(s),p=u.dirname(s);return f.length?{name:f,parentPath:p}:{name:p,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown",s.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let D=[],T=[],t=[];function b(s,u=!1){const f=n(s);D.push(f),f.userConfigured?t.push(f):T.push(f),u&&!f.userConfigured&&D.forEach(p=>{p.mime===f.mime||p.userConfigured||(f.extension&&p.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&p.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&p.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&p.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=b;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,d.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(E.posix.sep)>=0:!1}}function h(s){s?(D=D.filter(u=>!u.userConfigured),t=[]):(D=[],T=[],t=[])}e.clearTextMimes=h;function o(s,u){let f;if(s)switch(s.scheme){case M.Schemas.file:f=s.fsPath;break;case M.Schemas.data:f=A.DataUri.parseMetaData(s).get(A.DataUri.META_DATA_LABEL);break;default:f=s.path}if(!f)return[k.unknown];f=f.toLowerCase();const p=(0,E.basename)(f),C=l(f,p,t);if(C)return[C,k.text];const P=l(f,p,T);if(P)return[P,k.text];if(u){const m=v(u);if(m)return[m,k.text]}return[k.unknown]}e.guessMimeTypes=o;function l(s,u,f){let p=null,C=null,P=null;for(let m=f.length-1;m>=0;m--){const I=f[m];if(u===I.filenameLowercase){p=I;break}if(I.filepattern&&(!C||I.filepattern.length>C.filepattern.length)){const F=I.filepatternOnPath?s:u;I.filepatternLowercase?.(F)&&(C=I)}I.extension&&(!P||I.extension.length>P.extension.length)&&u.endsWith(I.extensionLowercase)&&(P=I)}return p?p.mime:C?C.mime:P?P.mime:null}function v(s){if((0,R.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=D.length-1;u>=0;u--){const f=D[u];if(!f.firstline)continue;const p=s.match(f.firstline);if(p&&p.length>0)return f.mime}return null}function S(s){return s?typeof s=="string"?s===k.binary||s===k.text||s===k.unknown:s.length===1&&S(s[0]):!0}e.isUnspecific=S;const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(s){const u=(0,E.extname)(s),f=_[u.toLowerCase()];return f!==void 0?f:y(s)}e.getMediaOrTextMime=c;function y(s){const u=(0,E.extname)(s);return a[u.toLowerCase()]}e.getMediaMime=y;function i(s){for(const u in a)if(a[u]===s)return u}e.getExtensionForMimeType=i;const g=/^(.+)\/(.+?)(;.+)?$/;function r(s,u){const f=g.exec(s);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:u?void 0:s}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(b){this._uriTransformer=b}transformIncoming(b){const n=this._uriTransformer.transformIncoming(b);return n===b?b:M(d.URI.from(n))}transformOutgoing(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:M(d.URI.from(n))}transformOutgoingURI(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:d.URI.from(n)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,b,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return b.transformOutgoing(t);for(let h in t)if(Object.hasOwnProperty.call(t,h)){const o=A(t[h],b,n+1);o!==null&&(t[h]=o)}}return null}function R(t,b){const n=A(t,b,0);return n===null?t:n}e.transformOutgoingURIs=R;function k(t,b,n,h){if(!t||h>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(b.transformIncoming(t)):b.transformIncoming(t);for(let o in t)if(Object.hasOwnProperty.call(t,o)){const l=k(t[o],b,n,h+1);l!==null&&(t[o]=l)}}return null}function D(t,b){const n=k(t,b,!1,0);return n===null?t:n}e.transformIncomingURIs=D;function T(t,b){const n=k(t,b,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(be[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(D){return d.test(D)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function k(){R(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let D=0,T="";return T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+="-",T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T+=A[E[D++]],T}e.generateUuid=k}),define(be[110],Ee([0,1,227]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(k){super(0);for(let D=0,T=k.length;D<T;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(R){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=R(D)),k[D])}e.getMapForWordSeparators=A(R=>new E(R))}),define(be[79],Ee([0,1,23]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(S){S[S.Left=1]="Left",S[S.Center=2]="Center",S[S.Right=4]="Right",S[S.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(S){S[S.Inline=1]="Inline",S[S.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(S){S[S.TextDefined=0]="TextDefined",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(S){S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(S){S[S.LF=0]="LF",S[S.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class T{constructor(_,a){this._findMatchBrand=void 0,this.range=_,this.matches=a}}e.FindMatch=T;var t;(function(S){S[S.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",S[S.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",S[S.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",S[S.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class b{constructor(_,a){this.visibleColumn=_,this.className=a}}e.IndentGuide=b;class n{constructor(_,a,c,y){this.range=_,this.openingBracketRange=a,this.closingBracketRange=c,this.nestingLevel=y}}e.BracketPair=n;var h;(function(S){S[S.Left=0]="Left",S[S.Right=1]="Right",S[S.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var o;(function(S){S[S.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(o=e.ModelConstants||(e.ModelConstants={}));class l{constructor(_,a,c,y,i,g){this.identifier=_,this.range=a,this.text=c,this.forceMoveMarkers=y,this.isAutoWhitespaceEdit=i,this._isTracked=g}}e.ValidAnnotatedEditOperation=l;class v{constructor(_,a,c){this.reverseEdits=_,this.changes=a,this.trimAutoWhitespaceLineNumbers=c}}e.ApplyEditsResult=v}),define(be[111],Ee([0,1,9,110,112,44,79]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(a,c,y,i){this.searchString=a,this.isRegex=c,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=T(this.searchString):a=this.searchString.indexOf(`
`)>=0;let c=null;try{c=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(i){return null}if(!c)return null;let y=!this.isRegex&&!a;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(c,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=D;function T(_){if(!_||_.length===0)return!1;for(let a=0,c=_.length;a<c;a++)if(_.charCodeAt(a)===92){if(a++,a>=c)break;const i=_.charCodeAt(a);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(a,c,y){this.regex=a,this.wordSeparators=c,this.simpleSearch=y}}e.SearchData=t;function b(_,a,c){if(!c)return new R.FindMatch(_,null);let y=[];for(let i=0,g=a.length;i<g;i++)y[i]=a[i];return new R.FindMatch(_,y)}e.createFindMatch=b;class n{constructor(a){let c=[],y=0;for(let i=0,g=a.length;i<g;i++)a.charCodeAt(i)===10&&(c[y++]=i);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(a){const c=this._lineFeedsOffsets;let y=0,i=c.length-1;if(i===-1||a<=c[0])return 0;for(;y<i;){const g=y+((i-y)/2>>0);c[g]>=a?i=g-1:c[g+1]>=a?(y=g,i=g):y=g+1}return y+1}}class h{static findMatches(a,c,y,i,g){const r=c.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,y,new S(r.wordSeparators,r.regex),i,g):this._doFindMatchesLineByLine(a,y,r,i,g):[]}static _getMultilineMatchRange(a,c,y,i,g,r){let s,u=0;i?(u=i.findLineFeedCountBeforeOffset(g),s=c+g+u):s=c+g;let f;if(i){let m=i.findLineFeedCountBeforeOffset(g+r.length)-u;f=s+r.length+m}else f=s+r.length;const p=a.getPositionAt(s),C=a.getPositionAt(f);return new A.Range(p.lineNumber,p.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(a,c,y,i,g){const r=a.getOffsetAt(c.getStartPosition()),s=a.getValueInRange(c,1),u=a.getEOL()===`\r
`?new n(s):null,f=[];let p=0,C;for(y.reset(0);C=y.next(s);)if(f[p++]=b(this._getMultilineMatchRange(a,r,s,u,C.index,C[0]),C,i),p>=g)return f;return f}static _doFindMatchesLineByLine(a,c,y,i,g){const r=[];let s=0;if(c.startLineNumber===c.endLineNumber){const f=a.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(y,f,c.startLineNumber,c.startColumn-1,s,r,i,g),r}const u=a.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(y,u,c.startLineNumber,c.startColumn-1,s,r,i,g);for(let f=c.startLineNumber+1;f<c.endLineNumber&&s<g;f++)s=this._findMatchesInLine(y,a.getLineContent(f),f,0,s,r,i,g);if(s<g){const f=a.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(y,f,c.endLineNumber,0,s,r,i,g)}return r}static _findMatchesInLine(a,c,y,i,g,r,s,u){const f=a.wordSeparators;if(!s&&a.simpleSearch){const P=a.simpleSearch,m=P.length,I=c.length;let F=-m;for(;(F=c.indexOf(P,F+m))!==-1;)if((!f||v(f,c,I,F,m))&&(r[g++]=new R.FindMatch(new A.Range(y,F+1+i,y,F+1+m+i),null),g>=u))return g;return g}const p=new S(a.wordSeparators,a.regex);let C;p.reset(0);do if(C=p.next(c),C&&(r[g++]=b(new A.Range(y,C.index+1+i,y,C.index+1+C[0].length+i),C,s),g>=u))return g;while(C);return g}static findNextMatch(a,c,y,i){const g=c.parseSearchRequest();if(!g)return null;const r=new S(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(a,y,r,i):this._doFindNextMatchLineByLine(a,y,r,i)}static _doFindNextMatchMultiline(a,c,y,i){const g=new E.Position(c.lineNumber,1),r=a.getOffsetAt(g),s=a.getLineCount(),u=a.getValueInRange(new A.Range(g.lineNumber,g.column,s,a.getLineMaxColumn(s)),1),f=a.getEOL()===`\r
`?new n(u):null;y.reset(c.column-1);let p=y.next(u);return p?b(this._getMultilineMatchRange(a,r,u,f,p.index,p[0]),p,i):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(a,new E.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(a,c,y,i){const g=a.getLineCount(),r=c.lineNumber,s=a.getLineContent(r),u=this._findFirstMatchInLine(y,s,r,c.column,i);if(u)return u;for(let f=1;f<=g;f++){const p=(r+f-1)%g,C=a.getLineContent(p+1),P=this._findFirstMatchInLine(y,C,p+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(a,c,y,i,g){a.reset(i-1);const r=a.next(c);return r?b(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,g):null}static findPreviousMatch(a,c,y,i){const g=c.parseSearchRequest();if(!g)return null;const r=new S(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(a,y,r,i):this._doFindPreviousMatchLineByLine(a,y,r,i)}static _doFindPreviousMatchMultiline(a,c,y,i){const g=this._doFindMatchesMultiline(a,new A.Range(1,1,c.lineNumber,c.column),y,i,10*k);if(g.length>0)return g[g.length-1];const r=a.getLineCount();return c.lineNumber!==r||c.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new E.Position(r,a.getLineMaxColumn(r)),y,i):null}static _doFindPreviousMatchLineByLine(a,c,y,i){const g=a.getLineCount(),r=c.lineNumber,s=a.getLineContent(r).substring(0,c.column-1),u=this._findLastMatchInLine(y,s,r,i);if(u)return u;for(let f=1;f<=g;f++){const p=(g+r-f-1)%g,C=a.getLineContent(p+1),P=this._findLastMatchInLine(y,C,p+1,i);if(P)return P}return null}static _findLastMatchInLine(a,c,y,i){let g=null,r;for(a.reset(0);r=a.next(c);)g=b(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,i);return g}}e.TextModelSearch=h;function o(_,a,c,y,i){if(y===0)return!0;const g=a.charCodeAt(y-1);if(_.get(g)!==0||g===13||g===10)return!0;if(i>0){const r=a.charCodeAt(y);if(_.get(r)!==0)return!0}return!1}function l(_,a,c,y,i){if(y+i===c)return!0;const g=a.charCodeAt(y+i);if(_.get(g)!==0||g===13||g===10)return!0;if(i>0){const r=a.charCodeAt(y+i-1);if(_.get(r)!==0)return!0}return!1}function v(_,a,c,y,i){return o(_,a,c,y,i)&&l(_,a,c,y,i)}e.isValidMatch=v;class S{constructor(a,c){this._wordSeparators=a,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const c=a.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(y=this._searchRegex.exec(a),!y))return null;const i=y.index,g=y[0].length;if(i===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){d.getNextCodePoint(a,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=g,!this._wordSeparators||v(this._wordSeparators,a,c,i,g))return y}while(y);return null}}e.Searcher=S}),define(be[113],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,T=k.notIn.length;D<T;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=E;function A(R,k,D){R.has(k)?R.get(k).push(D):R.set(k,[D])}}),define(be[55],Ee([0,1,27,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,R,k,D){if(Array.isArray(A)){let T=0;for(const t of A){const b=E(t,R,k,D);if(b===10)return b;b>T&&(T=b)}return T}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:T,pattern:t,scheme:b,hasAccessToAllModels:n}=A;if(!D&&!n)return 0;let h=0;if(b)if(b===R.scheme)h=10;else if(b==="*")h=5;else return 0;if(T)if(T===k)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(t){let o;if(typeof t=="string"?o=t:o={...t,base:(0,M.normalize)(t.base)},o===R.fsPath||(0,d.match)(o,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,k){return this._map.set(R,k),this.fire([R]),(0,M.toDisposable)(()=>{this._map.get(R)===k&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,k){let D=null,T=!1;return this._promises.set(R,k.then(t=>{this._promises.delete(R),!(T||!t)&&(D=this.register(R,t))})),(0,M.toDisposable)(()=>{T=!0,D&&D.dispose()})}getPromise(R){const k=this.get(R);if(k)return Promise.resolve(k);const D=this._promises.get(R);return D?D.then(T=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[80],Ee([0,1,22,25]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(E||(E={}));function A(b){for(let n=0,h=b.length;n<h;n+=4){const o=b[n+0],l=b[n+1],v=b[n+2],S=b[n+3];b[n+0]=S,b[n+1]=v,b[n+2]=l,b[n+3]=o}}function R(b){const n=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function k(b){const n=b.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const h=new Uint8Array(n.byteLength);return h.set(n),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(b){const n=new Uint32Array(T(b));let h=0;if(n[h++]=b.id,b.type==="full")n[h++]=1,n[h++]=b.data.length,n.set(b.data,h),h+=b.data.length;else{n[h++]=2,n[h++]=b.deltas.length;for(const o of b.deltas)n[h++]=o.start,n[h++]=o.deleteCount,o.data?(n[h++]=o.data.length,n.set(o.data,h),h+=o.data.length):n[h++]=0}return R(n)}e.encodeSemanticTokensDto=D;function T(b){let n=0;if(n+=1+1,b.type==="full")n+=1+b.data.length;else{n+=1,n+=(1+1+1)*b.deltas.length;for(const h of b.deltas)h.data&&(n+=h.data.length)}return n}function t(b){const n=k(b);let h=0;const o=n[h++];if(n[h++]===1){const _=n[h++],a=n.subarray(h,h+_);return h+=_,{id:o,type:"full",data:a}}const v=n[h++];let S=[];for(let _=0;_<v;_++){const a=n[h++],c=n[h++],y=n[h++];let i;y>0&&(i=n.subarray(h,h+y),h+=y),S[_]={start:a,deleteCount:c,data:i}}return{id:o,type:"delta",deltas:S}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,115]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,k(T),R(T.stack)||R(T.stacktrace)):k(T)}function R(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function D(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const b=d.coalesce(T),n=D(b[0],t);return b.length>1?E.localize(4,null,n,b.length):n}if(M.isString(T))return T;if(T.detail){const b=T.detail;if(b.error)return A(b.error,t);if(b.exception)return A(b.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=D}),define(be[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=R;class k{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class T{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}compute(J,me,He){return He}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class b{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,He){return He}}function n(j,J){return typeof j=="undefined"?J:j==="false"?!1:Boolean(j)}e.boolean=n;class h extends b{constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=He),super(J,me,He,Ye)}validate(J){return n(J,this.defaultValue)}}function o(j,J,me,He){if(typeof j=="undefined")return J;let Ye=parseInt(j,10);return isNaN(Ye)?J:(Ye=Math.max(me,Ye),Ye=Math.min(He,Ye),Ye|0)}e.clampedInt=o;class l extends b{constructor(J,me,He,Ye,st,ot=void 0){typeof ot!="undefined"&&(ot.type="integer",ot.default=He,ot.minimum=Ye,ot.maximum=st),super(J,me,He,ot),this.minimum=Ye,this.maximum=st}static clampedInt(J,me,He,Ye){return o(J,me,He,Ye)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class v extends b{constructor(J,me,He,Ye,st){typeof st!="undefined"&&(st.type="number",st.default=He),super(J,me,He,st),this.validationFn=Ye}static clamp(J,me,He){return J<me?me:J>He?He:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const He=parseFloat(J);return isNaN(He)?me:He}validate(J){return this.validationFn(v.float(J,this.defaultValue))}}class S extends b{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=He),super(J,me,He,Ye)}validate(J){return S.string(J,this.defaultValue)}}function _(j,J,me){return typeof j!="string"||me.indexOf(j)===-1?J:j}e.stringSet=_;class a extends b{constructor(J,me,He,Ye,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=Ye,st.default=He),super(J,me,He,st),this._allowedValues=Ye}validate(J){return _(J,this.defaultValue,this._allowedValues)}}class c extends T{constructor(J,me,He,Ye,st,ot,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=st,Et.default=Ye),super(J,me,He,Et),this._allowedValues=st,this._convert=ot}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function y(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,He){return He===0?J.accessibilitySupport:He}}class g extends T{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:d.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(j){switch(j){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function p(j){switch(j){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class C extends t{constructor(){super(126,[65,33])}compute(J,me,He){const Ye=["monaco-editor"];return me.get(33)&&Ye.push(me.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),me.get(65)==="default"?Ye.push("mouse-default"):me.get(65)==="copy"&&Ye.push("mouse-copy"),me.get(99)&&Ye.push("showUnused"),me.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class P extends h{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(J,me,He){return He&&J.emptySelectionClipboard}}class m extends T{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:d.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":_(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":_(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class I extends T{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?I.OFF:J==="true"?I.ON:J:Boolean(J)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class F extends t{constructor(){super(43)}compute(J,me,He){return J.fontInfo}}class L extends b{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(J){let me=v.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(me,6,100)}compute(J,me,He){return J.fontInfo.fontSize}}class w extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:w.MINIMUM_VALUE,maximum:w.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:w.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,w.MINIMUM_VALUE,w.MAXIMUM_VALUE))}}w.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],w.MINIMUM_VALUE=1,w.MAXIMUM_VALUE=1e3;class x extends T{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:He,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:He,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:He,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:He,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:He,description:d.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:_(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??_(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??_(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??_(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??_(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??_(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends T{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:d.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var B;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,me,He){return G.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,He=J.scrollBeyondLastLine?me-1:0,Ye=(J.viewLineCount+He)/(J.pixelRatio*J.height),st=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:He,desiredRatio:Ye,minimapLineCount:st}}static _computeMinimapLayout(J,me){const He=J.outerWidth,Ye=J.outerHeight,st=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ot=me.stableMinimapLayoutInput,Et=ot&&J.outerHeight===ot.outerHeight&&J.lineHeight===ot.lineHeight&&J.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&J.pixelRatio===ot.pixelRatio&&J.scrollBeyondLastLine===ot.scrollBeyondLastLine&&J.minimap.enabled===ot.minimap.enabled&&J.minimap.side===ot.minimap.side&&J.minimap.size===ot.minimap.size&&J.minimap.showSlider===ot.minimap.showSlider&&J.minimap.renderCharacters===ot.minimap.renderCharacters&&J.minimap.maxColumn===ot.minimap.maxColumn&&J.minimap.scale===ot.minimap.scale&&J.verticalScrollbarWidth===ot.verticalScrollbarWidth&&J.isViewportWrapping===ot.isViewportWrapping,mt=J.lineHeight,Dt=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let Xe=st>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const St=J.minimap.maxColumn,Te=J.minimap.size,ye=J.minimap.side,Ce=J.verticalScrollbarWidth,te=J.viewLineCount,le=J.remainingWidth,ge=J.isViewportWrapping,fe=It?2:3;let Pe=Math.floor(st*Ye);const xe=Pe/st;let Oe=!1,Ke=!1,tt=fe*Xe,Le=Xe/st,de=1;if(Te==="fill"||Te==="fit"){const{typicalViewportLineCount:Ue,extraLinesBeyondLastLine:dt,desiredRatio:gt,minimapLineCount:lt}=G.computeContainedMinimapLineCount({viewLineCount:te,scrollBeyondLastLine:Pt,height:Ye,lineHeight:mt,pixelRatio:st});if(te/lt>1)Oe=!0,Ke=!0,Xe=1,tt=1,Le=Xe/st;else{let ut=!1,pt=Xe+1;if(Te==="fit"){const bt=Math.ceil((te+dt)*tt);ge&&Et&&le<=me.stableFitRemainingWidth?(ut=!0,pt=me.stableFitMaxMinimapScale):ut=bt>Pe}if(Te==="fill"||ut){Oe=!0;const bt=Xe;tt=Math.min(mt*st,Math.max(1,Math.floor(1/gt))),ge&&Et&&le<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),Xe=Math.min(pt,Math.max(1,Math.floor(tt/fe))),Xe>bt&&(de=Math.min(2,Xe/bt)),Le=Xe/st/de,Pe=Math.ceil(Math.max(Ue,te+dt)*tt),ge?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=le,me.stableFitMaxMinimapScale=Xe):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(St*Le),Y=Math.min(pe,Math.max(0,Math.floor((le-Ce-2)*Le/(Dt+Le)))+e.MINIMAP_GUTTER_WIDTH);let z=Math.floor(st*Y);const we=z/st;z=Math.floor(z*de);const Ie=It?1:2,Je=ye==="left"?0:He-Y-Ce;return{renderMinimap:Ie,minimapLeft:Je,minimapWidth:Y,minimapHeightIsEditorHeight:Oe,minimapIsSampling:Ke,minimapScale:Xe,minimapLineHeight:tt,minimapCanvasInnerWidth:z,minimapCanvasInnerHeight:Pe,minimapCanvasOuterWidth:we,minimapCanvasOuterHeight:xe}}static computeLayout(J,me){const He=me.outerWidth|0,Ye=me.outerHeight|0,st=me.lineHeight|0,ot=me.lineNumbersDigitCount|0,Et=me.typicalHalfwidthCharacterWidth,mt=me.maxDigitWidth,Dt=me.pixelRatio,Pt=me.viewLineCount,It=J.get(121),Xe=It==="inherit"?J.get(120):It,St=Xe==="inherit"?J.get(116):Xe,Te=J.get(119),ye=J.get(2),Ce=me.isDominatedByLongLines,te=J.get(49),le=J.get(59).renderType!==0,ge=J.get(60),fe=J.get(93),Pe=J.get(64),xe=J.get(91),Oe=xe.verticalScrollbarSize,Ke=xe.verticalHasArrows,tt=xe.arrowSize,Le=xe.horizontalScrollbarSize,de=J.get(57),pe=J.get(37);let Y;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const yt=parseFloat(de.substr(0,de.length-2));Y=l.clampedInt(yt*Et,0,0,1e3)}else Y=l.clampedInt(de,0,0,1e3);pe&&(Y+=16);let z=0;if(le){const yt=Math.max(ot,ge);z=Math.round(yt*mt)}let we=0;te&&(we=st);let Ie=0,Je=Ie+we,Ue=Je+z,dt=Ue+Y;const gt=He-we-z-Y;let lt=!1,ft=!1,ut=-1;ye!==2&&(Xe==="inherit"&&Ce?(lt=!0,ft=!0):St==="on"||St==="bounded"?ft=!0:St==="wordWrapColumn"&&(ut=Te));const pt=G._computeMinimapLayout({outerWidth:He,outerHeight:Ye,lineHeight:st,typicalHalfwidthCharacterWidth:Et,pixelRatio:Dt,scrollBeyondLastLine:fe,minimap:Pe,verticalScrollbarWidth:Oe,viewLineCount:Pt,remainingWidth:gt,isViewportWrapping:ft},me.memory||new D);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Ie+=pt.minimapWidth,Je+=pt.minimapWidth,Ue+=pt.minimapWidth,dt+=pt.minimapWidth);const bt=gt-pt.minimapWidth,Ut=Math.max(1,Math.floor((bt-Oe-2)/Et)),Vt=Ke?tt:0;return ft&&(ut=Math.max(1,Ut),St==="bounded"&&(ut=Math.min(ut,Te))),{width:He,height:Ye,glyphMarginLeft:Ie,glyphMarginWidth:we,lineNumbersLeft:Je,lineNumbersWidth:z,decorationsLeft:Ue,decorationsWidth:Y,contentLeft:dt,contentWidth:bt,minimap:pt,viewportColumn:Ut,isWordWrapMinified:lt,isViewportWrapping:ft,wrappingColumn:ut,verticalScrollbarWidth:Oe,horizontalScrollbarHeight:Le,overviewRuler:{top:Vt,width:Oe,height:Ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=G;class H extends T{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:d.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class U extends T{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:d.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(me.fontFamily,this.defaultValue.fontFamily)}}}class V extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>v.clamp(J,0,150),{markdownDescription:d.localize(46,null)})}compute(J,me,He){return J.fontInfo.lineHeight}}class Q extends T{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:J.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:d.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:_(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(me.side,this.defaultValue.side,["right","left"]),showSlider:_(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(j){return j==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class Z extends T{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:d.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class oe extends t{constructor(){super(127)}compute(J,me,He){return J.pixelRatio}}class ve extends T{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:d.localize(61,null)},comments:{type:"boolean",default:J.comments,description:d.localize(62,null)},other:{type:"boolean",default:J.other,description:d.localize(63,null)}}}],default:J,description:d.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,He={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return He.other&&He.comments&&He.strings?!0:!He.other&&!He.comments&&!He.strings?!1:He}return this.defaultValue}}var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,He=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function Ne(j){const J=j.get(86);return J==="editable"?j.get(80):J!=="on"}e.filterValidationDecorations=Ne;class We extends T{constructor(){const J=[],me={type:"number",description:d.localize(70,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:J,description:d.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let He of J)if(typeof He=="number")me.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ye=He;me.push({column:l.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((He,Ye)=>He.column-Ye.column),me}return this.defaultValue}}function je(j,J){if(typeof j!="string")return J;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends T{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:d.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,He=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(me.vertical,this.defaultValue.vertical),horizontal:je(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class $ extends T{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:d.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:_(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends T{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:d.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const J={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:"boolean",default:J.bracketPairs,description:d.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:d.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:d.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{bracketPairs:n(me.bracketPairs,this.defaultValue.bracketPairs),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class ae extends T{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(89,null),d.localize(90,null)],default:J.insertMode,description:d.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:d.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:d.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:d.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:d.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:d.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:d.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:d.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:d.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:_(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:_(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class q extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(131,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class se extends t{constructor(){super(128,[80])}compute(J,me,He){return me.get(80)?!0:J.tabFocusMode}}var he;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(he=e.WrappingIndent||(e.WrappingIndent={}));function Re(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends t{constructor(){super(130,[129])}compute(J,me,He){const Ye=me.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ze="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?Qe:M.isLinux?it:ze,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ke(j){return e.editorOptionsRegistry[j.id]=j,j}var Ze;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unusualLineTerminators=112]="unusualLineTerminators",j[j.useShadowDOM=113]="useShadowDOM",j[j.useTabStops=114]="useTabStops",j[j.wordSeparators=115]="wordSeparators",j[j.wordWrap=116]="wordWrap",j[j.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=119]="wordWrapColumn",j[j.wordWrapOverride1=120]="wordWrapOverride1",j[j.wordWrapOverride2=121]="wordWrapOverride2",j[j.wrappingIndent=122]="wrappingIndent",j[j.wrappingStrategy=123]="wrappingStrategy",j[j.showDeprecated=124]="showDeprecated",j[j.inlayHints=125]="inlayHints",j[j.editorClassName=126]="editorClassName",j[j.pixelRatio=127]="pixelRatio",j[j.tabFocusMode=128]="tabFocusMode",j[j.layoutInfo=129]="layoutInfo",j[j.wrappingInfo=130]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(132,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(133,null),""],markdownDescription:d.localize(134,null)})),accessibilitySupport:ke(new i),accessibilityPageSize:ke(new l(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(135,null)})),ariaLabel:ke(new S(4,"ariaLabel",d.localize(136,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(137,null),d.localize(138,null),""],description:d.localize(139,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(140,null),""],description:d.localize(141,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(142,null),""],description:d.localize(143,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(144,null),d.localize(145,null),""],description:d.localize(146,null)})),autoIndent:ke(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[d.localize(147,null),d.localize(148,null),d.localize(149,null),d.localize(150,null),d.localize(151,null)],description:d.localize(152,null)})),automaticLayout:ke(new h(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(153,null),d.localize(154,null),d.localize(155,null),""],description:d.localize(156,null)})),bracketPairColorization:ke(new K),bracketPairGuides:ke(new ee),stickyTabStops:ke(new h(103,"stickyTabStops",!1,{description:d.localize(157,null)})),codeLens:ke(new h(14,"codeLens",!0,{description:d.localize(158,null)})),codeLensFontFamily:ke(new S(15,"codeLensFontFamily","",{description:d.localize(159,null)})),codeLensFontSize:ke(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(160,null)})),colorDecorators:ke(new h(17,"colorDecorators",!0,{description:d.localize(161,null)})),columnSelection:ke(new h(18,"columnSelection",!1,{description:d.localize(162,null)})),comments:ke(new g),contextmenu:ke(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new h(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(163,null)})),cursorBlinking:ke(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:d.localize(164,null)})),cursorSmoothCaretAnimation:ke(new h(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(165,null)})),cursorStyle:ke(new c(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:d.localize(166,null)})),cursorSurroundingLines:ke(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(167,null)})),cursorSurroundingLinesStyle:ke(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(168,null),d.localize(169,null)],description:d.localize(170,null)})),cursorWidth:ke(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(171,null)})),disableLayerHinting:ke(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new h(30,"domReadOnly",!1)),dragAndDrop:ke(new h(31,"dragAndDrop",!0,{description:d.localize(172,null)})),emptySelectionClipboard:ke(new P),extraEditorClassName:ke(new S(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new v(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:d.localize(173,null)})),find:ke(new m),fixedOverflowWidgets:ke(new h(36,"fixedOverflowWidgets",!1)),folding:ke(new h(37,"folding",!0,{description:d.localize(174,null)})),foldingStrategy:ke(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(175,null),d.localize(176,null)],description:d.localize(177,null)})),foldingHighlight:ke(new h(39,"foldingHighlight",!0,{description:d.localize(178,null)})),foldingImportsByDefault:ke(new h(40,"foldingImportsByDefault",!1,{description:d.localize(179,null)})),unfoldOnClickAfterEndOfLine:ke(new h(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(180,null)})),fontFamily:ke(new S(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(181,null)})),fontInfo:ke(new F),fontLigatures2:ke(new I),fontSize:ke(new L),fontWeight:ke(new w),formatOnPaste:ke(new h(47,"formatOnPaste",!1,{description:d.localize(182,null)})),formatOnType:ke(new h(48,"formatOnType",!1,{description:d.localize(183,null)})),glyphMargin:ke(new h(49,"glyphMargin",!0,{description:d.localize(184,null)})),gotoLocation:ke(new x),hideCursorInOverviewRuler:ke(new h(51,"hideCursorInOverviewRuler",!1,{description:d.localize(185,null)})),hover:ke(new W),inDiffEditor:ke(new h(53,"inDiffEditor",!1)),letterSpacing:ke(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>v.clamp(j,-5,20),{description:d.localize(186,null)})),lightbulb:ke(new H),lineDecorationsWidth:ke(new b(57,"lineDecorationsWidth",10)),lineHeight:ke(new V),lineNumbers:ke(new Se),lineNumbersMinChars:ke(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new h(61,"linkedEditing",!1,{description:d.localize(187,null)})),links:ke(new h(62,"links",!0,{description:d.localize(188,null)})),matchBrackets:ke(new a(63,"matchBrackets","always",["always","near","never"],{description:d.localize(189,null)})),minimap:ke(new Q),mouseStyle:ke(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new v(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:d.localize(190,null)})),mouseWheelZoom:ke(new h(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(191,null)})),multiCursorMergeOverlapping:ke(new h(68,"multiCursorMergeOverlapping",!0,{description:d.localize(192,null)})),multiCursorModifier:ke(new c(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[d.localize(193,null),d.localize(194,null)],markdownDescription:d.localize(195,null)})),multiCursorPaste:ke(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(196,null),d.localize(197,null)],markdownDescription:d.localize(198,null)})),occurrencesHighlight:ke(new h(71,"occurrencesHighlight",!0,{description:d.localize(199,null)})),overviewRulerBorder:ke(new h(72,"overviewRulerBorder",!0,{description:d.localize(200,null)})),overviewRulerLanes:ke(new l(73,"overviewRulerLanes",3,0,3)),padding:ke(new ce),parameterHints:ke(new Z),peekWidgetDefaultFocus:ke(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(201,null),d.localize(202,null)],description:d.localize(203,null)})),definitionLinkOpensInPeek:ke(new h(77,"definitionLinkOpensInPeek",!1,{description:d.localize(204,null)})),quickSuggestions:ke(new ve),quickSuggestionsDelay:ke(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(205,null)})),readOnly:ke(new h(80,"readOnly",!1)),renameOnType:ke(new h(81,"renameOnType",!1,{description:d.localize(206,null),markdownDeprecationMessage:d.localize(207,null)})),renderControlCharacters:ke(new h(82,"renderControlCharacters",!1,{description:d.localize(208,null)})),renderFinalNewline:ke(new h(83,"renderFinalNewline",!0,{description:d.localize(209,null)})),renderLineHighlight:ke(new a(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(210,null)],description:d.localize(211,null)})),renderLineHighlightOnlyWhenFocus:ke(new h(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(212,null)})),renderValidationDecorations:ke(new a(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(213,null),d.localize(214,null),d.localize(215,null),""],description:d.localize(216,null)})),revealHorizontalRightPadding:ke(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new h(89,"roundedSelection",!0,{description:d.localize(217,null)})),rulers:ke(new We),scrollbar:ke(new qe),scrollBeyondLastColumn:ke(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(218,null)})),scrollBeyondLastLine:ke(new h(93,"scrollBeyondLastLine",!0,{description:d.localize(219,null)})),scrollPredominantAxis:ke(new h(94,"scrollPredominantAxis",!0,{description:d.localize(220,null)})),selectionClipboard:ke(new h(95,"selectionClipboard",!0,{description:d.localize(221,null),included:M.isLinux})),selectionHighlight:ke(new h(96,"selectionHighlight",!0,{description:d.localize(222,null)})),selectOnLineNumbers:ke(new h(97,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(223,null),d.localize(224,null)],description:d.localize(225,null)})),showUnused:ke(new h(99,"showUnused",!0,{description:d.localize(226,null)})),showDeprecated:ke(new h(124,"showDeprecated",!0,{description:d.localize(227,null)})),inlayHints:ke(new U),snippetSuggestions:ke(new a(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(228,null),d.localize(229,null),d.localize(230,null),d.localize(231,null)],description:d.localize(232,null)})),smartSelect:ke(new q),smoothScrolling:ke(new h(102,"smoothScrolling",!1,{description:d.localize(233,null)})),stopRenderingLineAfter:ke(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new ae),inlineSuggest:ke(new $),suggestFontSize:ke(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(234,null)})),suggestLineHeight:ke(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(235,null)})),suggestOnTriggerCharacters:ke(new h(108,"suggestOnTriggerCharacters",!0,{description:d.localize(236,null)})),suggestSelection:ke(new a(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(237,null),d.localize(238,null),d.localize(239,null)],description:d.localize(240,null)})),tabCompletion:ke(new a(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(241,null),d.localize(242,null),d.localize(243,null)],description:d.localize(244,null)})),tabIndex:ke(new l(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null)],description:d.localize(248,null)})),useShadowDOM:ke(new h(113,"useShadowDOM",!0)),useTabStops:ke(new h(114,"useTabStops",!0,{description:d.localize(249,null)})),wordSeparators:ke(new S(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(250,null)})),wordWrap:ke(new a(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(251,null),d.localize(252,null),d.localize(253,null),d.localize(254,null)],description:d.localize(255,null)})),wordWrapBreakAfterCharacters:ke(new S(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new S(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new l(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(256,null)})),wordWrapOverride1:ke(new a(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new c(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Re,{enumDescriptions:[d.localize(257,null),d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),wrappingStrategy:ke(new a(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(262,null),d.localize(263,null)],description:d.localize(264,null)})),editorClassName:ke(new C),pixelRatio:ke(new oe),tabFocusMode:ke(new se),layoutInfo:ke(new G),wrappingInfo:ke(new Be)}}),define(be[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function R(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=n.match(M);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function k(n){if(!n)return null;let h=n.majorBase,o=n.majorMustEqual,l=n.minorBase,v=n.minorMustEqual,S=n.patchBase,_=n.patchMustEqual;n.hasCaret&&(h===0||(v=!1),_=!1);let a=0;if(n.preRelease){const c=E.exec(n.preRelease);if(c){const[,y,i,g]=c;a=Date.UTC(Number(y),Number(i)-1,Number(g))}}return{majorBase:h,majorMustEqual:o,minorBase:l,minorMustEqual:v,patchBase:S,patchMustEqual:_,isMinimum:n.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function D(n,h,o){let l;typeof n=="string"?l=k(R(n)):l=n;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let S;if(typeof o=="string"?S=k(R(o)):S=o,!l||!S)return!1;let _=l.majorBase,a=l.minorBase,c=l.patchBase,y=S.majorBase,i=S.minorBase,g=S.patchBase,r=S.notBefore,s=S.majorMustEqual,u=S.minorMustEqual,f=S.patchMustEqual;return S.isMinimum?_>y?!0:_<y?!1:a>i?!0:a<i||v&&v<r?!1:c>=g:(_===1&&y===0&&(!s||!u||!f)&&(y=1,i=0,g=0,s=!0,u=!1,f=!1),_<y?!1:_>y?!s:a<i?!1:a>i?!u:c<g?!1:c>g?!f:!(v&&v<r))}e.isValidVersion=D;function T(n,h,o,l){return o.isBuiltin||typeof o.main=="undefined"?!0:b(n,h,o.engines.vscode,l)}e.isValidExtensionVersion=T;function t(n,h,o){return n==="*"||b(h,o,n)}e.isEngineValid=t;function b(n,h,o,l=[]){let v=k(R(o));if(!v)return l.push(d.localize(0,null,o)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return l.push(d.localize(1,null,o)),!1}else if(!v.majorMustEqual)return l.push(d.localize(2,null,o)),!1;return D(n,h,v)?!0:(l.push(d.localize(3,null,n,o)),!1)}}),define(be[81],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],R=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,81]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(R,k,D){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],D)),M.push([R,k])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(R);k.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let k of this._nodes.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let k=this._nodes.get(R);return k||(k=new d(A),this._nodes.set(R,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,k]of this._nodes)A.push(`${R}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const k=new Set([A]),D=this._findCycle(R,k);if(D)return D}}_findCycle(A,R){for(let[k,D]of A.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const T=this._findCycle(D,R);if(T)return T;R.delete(k)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(T){return T[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(k,D,T,t){D[d.DI_TARGET]===D?D[d.DI_DEPENDENCIES].push({id:k,index:T,optional:t}):(D[d.DI_DEPENDENCIES]=[{id:k,index:T,optional:t}],D[d.DI_TARGET]=D)}function E(k){if(d.serviceIds.has(k))return d.serviceIds.get(k);const D=function(T,t,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(D,T,b,!1)};return D.toString=()=>k,d.serviceIds.set(k,D),D}e.createDecorator=E;function A(k){return k}e.refineServiceDecorator=A;function R(k){return function(D,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(k,D,t,!0)}}e.optional=R}),define(be[140],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(T):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(v,S){let _={selector:v,provider:S,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(_){let a=this._entries.indexOf(_);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const S=[];for(let _ of this._entries)_._score>0&&S.push(_.provider);return S}ordered(v){const S=[];return this._orderedForEach(v,_=>S.push(_.provider)),S}orderedGroups(v){const S=[];let _,a;return this._orderedForEach(v,c=>{_&&a===c._score?_.push(c.provider):(a=c._score,_=[c.provider],S.push(_))}),S}_orderedForEach(v,S){if(!!v){this._updateScores(v);for(const _ of this._entries)_._score>0&&S(_)}}_updateScores(v){let S={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===S.language&&this._lastCandidate.uri===S.uri)){this._lastCandidate=S;for(let _ of this._entries)if(_._score=(0,k.score)(_.selector,v.uri,v.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(v)),T(_.selector)&&_._score>0){for(let a of this._entries)a._score=0;_._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,S){return v._score<S._score?1:v._score>S._score?-1:v._time<S._time?1:v._time>S._time?-1:0}}e.LanguageFeatureRegistry=t;const b=new WeakMap;let n=0;function h(l){let v=b.get(l);return v===void 0&&(v=++n,b.set(l,v)),v}class o{constructor(v,S,_=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=S,this.max=_,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((S,_)=>(0,M.doHash)(h(_),S),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const S=this._key(v),_=this._cache.get(S);return this._clamp(_?.value)}update(v,S){const _=this._key(v);let a=this._cache.get(_);return a||(a=new R.MovingAverage,this._cache.set(_,a)),a.update(S),this.get(v)}}e.LanguageFeatureRequestDelays=o}),define(be[59],Ee([0,1,2,44,141,114,34]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(I,F){this.language=I,this.id=F}}e.LanguageIdentifier=D;var T;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var t;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var b;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(b=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(I){return(I&255)>>>0}static getTokenType(I){return(I&1792)>>>8}static getFontStyle(I){return(I&14336)>>>11}static getForeground(I){return(I&8372224)>>>14}static getBackground(I){return(I&4286578688)>>>23}static getClassNameFromMetadata(I){let F=this.getForeground(I),L="mtk"+F,w=this.getFontStyle(I);return w&1&&(L+=" mtki"),w&2&&(L+=" mtkb"),w&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(I,F){const L=this.getForeground(I),w=this.getFontStyle(I);let x=`color: ${F[L]};`;return w&1&&(x+="font-style: italic;"),w&2&&(x+="font-weight: bold;"),w&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=h;var o;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(I){const F=m[I];let L=F&&R.iconRegistry.get(F);return L||(console.info("No codicon found for CompletionItemKind "+I),L=R.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(I,F){let L=m[I];return typeof L=="undefined"&&!F&&(L=9),L}}();var l;(function(m){m[m.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var S;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(m){m[m.Automatic=0]="Automatic",m[m.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(m){return m&&d.URI.isUri(m.uri)&&M.Range.isIRange(m.range)&&(M.Range.isIRange(m.originSelectionRange)||M.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=i;var g;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var r;(function(m){m[m.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(m){const I=new Map;I.set("file",0),I.set("module",1),I.set("namespace",2),I.set("package",3),I.set("class",4),I.set("method",5),I.set("property",6),I.set("field",7),I.set("constructor",8),I.set("enum",9),I.set("interface",10),I.set("function",11),I.set("variable",12),I.set("constant",13),I.set("string",14),I.set("number",15),I.set("boolean",16),I.set("array",17),I.set("object",18),I.set("key",19),I.set("null",20),I.set("enum-member",21),I.set("struct",22),I.set("event",23),I.set("operator",24),I.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function L(W){return I.get(W)}m.fromString=L;function w(W){return F.get(W)}m.toString=w;function x(W,B){const G=F.get(W);let H=G&&R.iconRegistry.get("symbol-"+G);return H||(console.info("No codicon found for SymbolKind "+W),H=R.Codicon.symbolProperty),`${B?"inline":"block"} ${H.classNames}`}m.toCssClassName=x})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(I){this.value=I}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var f;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var C;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(C=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var P;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,25,9,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",d.isMacintosh),R.set("isLinux",d.isLinux),R.set("isWindows",d.isWindows),R.set("isWeb",d.isWeb),R.set("isMacNative",d.isMacintosh&&!d.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return h.INSTANCE}static has(w){return o.create(w)}static equals(w,x){return l.create(w,x)}static notEquals(w,x){return _.create(w,x)}static regex(w,x){return r.create(w,x)}static in(w,x){return v.create(w,x)}static not(w){return a.create(w)}static and(...w){return f.create(w,null)}static or(...w){return p.create(w,null,!0)}static greater(w,x){return c.create(w,x)}static less(w,x){return i.create(w,x)}static deserialize(w,x=!1){if(!!w)return this._deserializeOrExpression(w,x)}static _deserializeOrExpression(w,x){let W=w.split("||");return p.create(W.map(B=>this._deserializeAndExpression(B,x)),null,!0)}static _deserializeAndExpression(w,x){let W=w.split("&&");return f.create(W.map(B=>this._deserializeOne(B,x)),null)}static _deserializeOne(w,x){if(w=w.trim(),w.indexOf("!=")>=0){let W=w.split("!=");return _.create(W[0].trim(),this._deserializeValue(W[1],x))}if(w.indexOf("==")>=0){let W=w.split("==");return l.create(W[0].trim(),this._deserializeValue(W[1],x))}if(w.indexOf("=~")>=0){let W=w.split("=~");return r.create(W[0].trim(),this._deserializeRegexValue(W[1],x))}if(w.indexOf(" in ")>=0){let W=w.split(" in ");return v.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const W=w.split(">=");return y.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const W=w.split(">");return c.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const W=w.split("<=");return g.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const W=w.split("<");return i.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(w)?a.create(w.substr(1).trim()):o.create(w)}static _deserializeValue(w,x){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let W=/^'([^']*)'$/.exec(w);return W?W[1].trim():w}static _deserializeRegexValue(w,x){if((0,M.isFalsyOrWhitespace)(w)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=w.indexOf("/"),B=w.lastIndexOf("/");if(W===B||W<0){if(x)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let G=w.slice(W+1,B),H=w[B+1]==="i"?"i":"";try{return new RegExp(G,H)}catch(U){if(x)throw new Error(`bad regexp-value '${w}', parse error: ${U}`);return console.warn(`bad regexp-value '${w}', parse error: ${U}`),null}}}e.ContextKeyExpr=T;function t(L,w){const x=L?L.substituteConstants():void 0,W=w?w.substituteConstants():void 0;return!x&&!W?!0:!x||!W?!1:x.equals(W)}e.expressionsAreEqualWithConstantSubstitution=t;function b(L,w){return L.cmp(w)}class n{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class h{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class o{constructor(w,x){this.key=w,this.negated=x,this.type=2}static create(w,x=null){const W=R.get(w);return typeof W=="boolean"?W?h.INSTANCE:n.INSTANCE:new o(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=R.get(this.key);return typeof w=="boolean"?w?h.INSTANCE:n.INSTANCE:this}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class l{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=4}static create(w,x,W=null){if(typeof x=="boolean")return x?o.create(w,W):a.create(w,W);const B=R.get(w);return typeof B=="boolean"?x===(B?"true":"false")?h.INSTANCE:n.INSTANCE:new l(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=R.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?h.INSTANCE:n.INSTANCE}return this}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class v{constructor(w,x){this.key=w,this.valueKey=x,this.type=10,this.negated=null}static create(w,x){return new v(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}substituteConstants(){return this}evaluate(w){const x=w.getValue(this.valueKey),W=w.getValue(this.key);return Array.isArray(x)?x.indexOf(W)>=0:typeof W=="string"&&typeof x=="object"&&x!==null?k.call(x,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=v;class S{constructor(w){this._actual=w,this.type=11}static create(w){return new S(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new S(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class _{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=5}static create(w,x,W=null){if(typeof x=="boolean")return x?a.create(w,W):o.create(w,W);const B=R.get(w);return typeof B=="boolean"?x===(B?"true":"false")?n.INSTANCE:h.INSTANCE:new _(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=R.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?n.INSTANCE:h.INSTANCE}return this}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class a{constructor(w,x){this.key=w,this.negated=x,this.type=3}static create(w,x=null){const W=R.get(w);return typeof W=="boolean"?W?n.INSTANCE:h.INSTANCE:new a(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=R.get(this.key);return typeof w=="boolean"?w?n.INSTANCE:h.INSTANCE:this}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;class c{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=12}static create(w,x,W=null){return new c(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class y{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=13}static create(w,x,W=null){return new y(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=y;class i{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=14}static create(w,x,W=null){return new i(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class g{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=15}static create(w,x,W=null){return new g(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=g;class r{constructor(w,x){this.key=w,this.regexp=x,this.type=7,this.negated=null}static create(w,x){return new r(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const x=this.regexp?this.regexp.source:"",W=w.regexp?w.regexp.source:"";return x<W?-1:x>W?1:0}equals(w){if(w.type===this.type){const x=this.regexp?this.regexp.source:"",W=w.regexp?w.regexp.source:"";return this.key===w.key&&x===W}return!1}substituteConstants(){return this}evaluate(w){let x=w.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(w){this._actual=w,this.type=8}static create(w){return new s(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new s(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function u(L){let w=null;for(let x=0,W=L.length;x<W;x++){const B=L[x].substituteConstants();if(L[x]!==B&&w===null){w=[];for(let G=0;G<x;G++)w[G]=L[G]}w!==null&&(w[x]=B)}return w===null?L:w}class f{constructor(w,x){this.expr=w,this.negated=x,this.type=6}static create(w,x){return f._normalizeArr(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const B=b(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=u(this.expr);return w===this.expr?this:f.create(w,this.negated)}evaluate(w){for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].evaluate(w))return!1;return!0}static _normalizeArr(w,x){const W=[];let B=!1;for(const G of w)if(!!G){if(G.type===1){B=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){W.push(...G.expr);continue}W.push(G)}if(W.length===0&&B)return h.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(b);for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];for(;W.length>1;){const G=W[W.length-1];if(G.type!==9)break;W.pop();const H=W.pop(),U=W.length===0,V=p.create(G.expr.map(Q=>f.create([Q,H],null)),null,U);V&&(W.push(V),W.sort(b))}return W.length===1?W[0]:new f(W,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new f(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){const w=[];for(let x of this.expr)w.push(x.negate());this.negated=p.create(w,this,!0)}return this.negated}}class p{constructor(w,x){this.expr=w,this.negated=x,this.type=9}static create(w,x,W){return p._normalizeArr(w,x,W)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const B=b(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=u(this.expr);return w===this.expr?this:p.create(w,this.negated,!1)}evaluate(w){for(let x=0,W=this.expr.length;x<W;x++)if(this.expr[x].evaluate(w))return!0;return!1}static _normalizeArr(w,x,W){let B=[],G=!1;if(w){for(let H=0,U=w.length;H<U;H++){const V=w[H];if(!!V){if(V.type===0){G=!0;continue}if(V.type===1)return h.INSTANCE;if(V.type===9){B=B.concat(V.expr);continue}B.push(V)}}if(B.length===0&&G)return n.INSTANCE;B.sort(b)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if(W){for(let H=0;H<B.length;H++)for(let U=H+1;U<B.length;U++)I(B[H],B[U])&&(B.splice(U,1),U--);if(B.length===1)return B[0]}return new p(B,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new p(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){let w=[];for(let x of this.expr)w.push(x.negate());for(;w.length>1;){const x=w.shift(),W=w.shift(),B=[];for(const H of F(x))for(const U of F(W))B.push(f.create([H,U],null));const G=w.length===0;w.unshift(p.create(B,null,G))}this.negated=w[0]}return this.negated}}class C extends o{constructor(w,x,W){super(w,null);this._defaultValue=x,typeof W=="object"?C._info.push({...W,key:w}):W!==!0&&C._info.push({key:w,description:W,type:x!=null?typeof x:void 0})}static all(){return C._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return l.create(this.key,w)}notEqualsTo(w){return _.create(this.key,w)}}e.RawContextKey=C,C._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(L,w){return L<w?-1:L>w?1:0}function m(L,w,x,W){return L<x?-1:L>x?1:w<W?-1:w>W?1:0}function I(L,w){if(w.type===6&&L.type!==9&&L.type!==6){for(const B of w.expr)if(L.equals(B))return!0}const x=L.negate(),W=F(x).concat(F(w));W.sort(b);for(let B=0;B<W.length;B++){const H=W[B].negate();for(let U=B+1;U<W.length;U++){const V=W[U];if(H.equals(V))return!0}}return!1}e.implies=I;function F(L){return L.type===9?L.expr:[L]}}),define(be[142],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,9,4]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class k{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,n){if(typeof b=="undefined"||b===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof b=="string"||typeof n=="string"){let h=typeof b=="string"?b:b.value,o=typeof n=="string"?n:n.value;return d.equalsIgnoreCase(h,o)}return b._lower===n._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=k;function D(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function T(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,26]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,d.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=E;class A{constructor(l,v){this.version=v,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(o,l){return`${o}.${l}`}e.getExtensionId=R;function k(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(o,l){return k(R(o,l))}e.getGalleryExtensionId=D;function T(o,l){const v=[],S=_=>{for(const a of v)if(a.some(c=>E(l(c),l(_))))return a;return null};for(const _ of o){const a=S(_);a?a.push(_):v.push([_])}return v}e.groupByExtension=T;function t(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function b(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(o){const l=new Set;for(const v of o)v.malicious&&l.add(v.id.id);return l}e.getMaliciousExtensionsSet=n;function h(o,l){const v=[],S=l.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const _=S.shift();if(_&&v.every(a=>!E(a.identifier,{id:_}))){const a=o.filter(c=>E(c.identifier,{id:_}));a.length===1&&(v.push(a[0]),S.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=h}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(B){return B.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var b;(function(B){B[B.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var n;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=h;function o(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=o;function l(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=v;var S;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(G,H){super(G);this.code=H}}e.FileSystemProviderError=_;function a(B,G){const H=new _(B.toString(),G);return y(H,G),H}e.createFileSystemProviderError=a;function c(B){return B||a((0,k.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function y(B,G){return B.name=G?`${G} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=y;function i(B){if(!B)return S.Unknown;if(B instanceof _)return B.code;const G=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!G)return S.Unknown;switch(G[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=i;function g(B){if(B instanceof C)return B.fileOperationResult;switch(i(B)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var r;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(G,H,U){this.resource=G,this.operation=H,this.target=U}isOperation(G){return this.operation===G}}e.FileOperationEvent=s;var u;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class f{constructor(G,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of G)switch(U.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>H)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>H)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>H)),this.deleted.set(U.resource,U);break}}contains(G,...H){return this.doContains(G,{includeChildren:!1},...H)}affects(G,...H){return this.doContains(G,{includeChildren:!0},...H)}doContains(G,H,...U){if(!G)return!1;const V=U.length>0;return!!((!V||U.includes(1))&&(this.added?.get(G)||H.includeChildren&&this.added?.findSuperstr(G))||(!V||U.includes(0))&&(this.updated?.get(G)||H.includeChildren&&this.updated?.findSuperstr(G))||(!V||U.includes(2))&&(this.deleted?.findSubstr(G)||H.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function p(B,G,H){return!B||!G||B===G||G.length>B.length?!1:(G.charAt(G.length-1)!==M.sep&&(G+=M.sep),H?(0,E.startsWithIgnoreCase)(B,G):B.indexOf(G)===0)}e.isParent=p;class C extends Error{constructor(G,H,U){super(G);this.fileOperationResult=H,this.options=U}}e.FileOperationError=C;class P extends C{constructor(G,H,U){super(G,2,U);this.stat=H}}e.NotModifiedSinceFileOperationError=P;var m;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(m=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=F;async function L(B,G){if(!G.canHandleResource(R.URI.from({scheme:B.scheme})))return new Promise(H=>{const U=G.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===B.scheme&&V.added&&(U.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class w{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<w.KB?(0,k.localize)(1,null,G.toFixed(0)):G<w.MB?(0,k.localize)(2,null,(G/w.KB).toFixed(2)):G<w.GB?(0,k.localize)(3,null,(G/w.MB).toFixed(2)):G<w.TB?(0,k.localize)(4,null,(G/w.GB).toFixed(2)):(0,k.localize)(5,null,(G/w.TB).toFixed(2))}}e.ByteSize=w,w.KB=1024,w.MB=w.KB*w.KB,w.GB=w.MB*w.KB,w.TB=w.GB*w.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function W(B){return{maxFileSize:B===0?300*w.MB:16*w.GB,maxHeapSize:B===0?700*w.MB:2*700*w.MB}}e.getPlatformLimits=W}),define(be[61],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,R]of E)this.set(A,R)}set(E,A){const R=this._entries.get(E);return this._entries.set(E,A),R}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class t{constructor(o=new k.ServiceCollection,l=!1,v){this._activeInstantiations=new Set,this._services=o,this._strict=l,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(o){return new t(o,this._strict,this)}invokeFunction(o,...l){let v=n.traceInvocation(o),S=!1;try{return o({get:(a,c)=>{if(S)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(a,v);if(!y&&c!==R.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return y}},...l)}finally{S=!0,v.stop()}}createInstance(o,...l){let v,S;return o instanceof E.SyncDescriptor?(v=n.traceCreation(o.ctor),S=this._createInstance(o.ctor,o.staticArguments.concat(l),v)):(v=n.traceCreation(o),S=this._createInstance(o,l,v)),v.stop(),S}_createInstance(o,l=[],v){let S=R._util.getServiceDependencies(o).sort((c,y)=>c.index-y.index),_=[];for(const c of S){let y=this._getOrCreateServiceInstance(c.id,v);if(!y&&this._strict&&!c.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${c.id}.`);_.push(y)}let a=S.length>0?S[0].index:l.length;if(l.length!==a){console.warn(`[createInstance] First service dependency of ${o.name} at position ${a+1} conflicts with ${l.length} static arguments`);let c=a-l.length;c>0?l=l.concat(new Array(c)):l=l.slice(0,a)}return new o(...[...l,..._])}_setServiceInstance(o,l){if(this._services.get(o)instanceof E.SyncDescriptor)this._services.set(o,l);else if(this._parent)this._parent._setServiceInstance(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let l=this._services.get(o);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):l}_getOrCreateServiceInstance(o,l){let v=this._getServiceInstanceOrDescriptor(o);return v instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,v,l.branch(o,!0)):(l.branch(o,!1),v)}_safeCreateAndCacheServiceInstance(o,l,v){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,l,v)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,l,v){const S=new A.Graph(c=>c.id.toString());let _=0;const a=[{id:o,desc:l,_trace:v}];for(;a.length;){const c=a.pop();if(S.lookupOrInsertNode(c),_++>1e3)throw new T(S);for(let y of R._util.getServiceDependencies(c.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${o} depends on ${y.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const g={id:y.id,desc:i,_trace:c._trace.branch(y.id,!0)};S.insertEdge(c,g),a.push(g)}}}for(;;){const c=S.roots();if(c.length===0){if(!S.isEmpty())throw new T(S);break}for(const{data:y}of c){if(this._getServiceInstanceOrDescriptor(y.id)instanceof E.SyncDescriptor){const g=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,g)}S.removeNode(y)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,l,v=[],S,_){if(this._services.get(o)instanceof E.SyncDescriptor)return this._createServiceInstance(l,v,S,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,l,v,S,_);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(o,l=[],v,S){if(v){const _=new d.IdleValue(()=>this._createInstance(o,l,S));return new Proxy(Object.create(null),{get(a,c){if(c in a)return a[c];let y=_.value,i=y[c];return typeof i!="function"||(i=i.bind(y),a[c]=i),i},set(a,c,y){return _.value[c]=y,!0}})}else return this._createInstance(o,l,S)}}e.InstantiationService=t;var b;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(b||(b={}));class n{constructor(o,l){this.type=o,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return D?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return D?new n(0,o.name):n._None}branch(o,l){let v=new n(2,o.toString());return this._dep.push([o,l,v]),v}stop(){let o=Date.now()-this._start;n._totals+=o;let l=!1;function v(_,a){let c=[],y=new Array(_+1).join("	");for(const[i,g,r]of a._dep)if(g&&r){l=!0,c.push(`${y}CREATES -> ${i}`);let s=v(_+1,r);s&&c.push(s)}else c.push(`${y}uses -> ${i}`);return c.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||l)&&console.log(S.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,25,4]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...g){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([i,...g]))}debug(i,...g){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([i,...g]))}info(i,...g){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([i,...g]))}warn(i,...g){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([i,...g]))}error(i,...g){if(this.checkLogLevel(D.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([i,...g]))}critical(i,...g){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([i,...g]))}flush(){}format(i){let g="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}g+=(r>0?" ":"")+s}return g}}e.AbstractMessageLogger=t;class b extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...g){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...g):console.log(`[main ${k()}]`,i,...g))}debug(i,...g){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...g):console.log(`[main ${k()}]`,i,...g))}info(i,...g){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...g):console.log(`[main ${k()}]`,i,...g))}warn(i,...g){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...g):console.warn(`[main ${k()}]`,i,...g))}error(i,...g){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...g):console.error(`[main ${k()}]`,i,...g))}critical(i,...g){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...g):console.error(`[main ${k()}]`,i,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...g){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",i,...g)}debug(i,...g){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...g)}info(i,...g){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",i,...g)}warn(i,...g){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",i,...g)}error(i,...g){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",i,...g)}critical(i,...g){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...g)}dispose(){}flush(){}}e.ConsoleLogger=n;class h extends T{constructor(i,g=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(g)}trace(i,...g){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(i),...g])}debug(i,...g){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(i),...g])}info(i,...g){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(i),...g])}warn(i,...g){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(i),...g])}error(i,...g){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(i),...g])}critical(i,...g){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(i),...g])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class o extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const g of this.logServices)g.setLevel(i);super.setLevel(i)}trace(i,...g){for(const r of this.logServices)r.trace(i,...g)}debug(i,...g){for(const r of this.logServices)r.debug(i,...g)}info(i,...g){for(const r of this.logServices)r.info(i,...g)}warn(i,...g){for(const r of this.logServices)r.warn(i,...g)}error(i,...g){for(const r of this.logServices)r.error(i,...g)}critical(i,...g){for(const r of this.logServices)r.critical(i,...g)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=o;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...g){this.logger.trace(i,...g)}debug(i,...g){this.logger.debug(i,...g)}info(i,...g){this.logger.info(i,...g)}warn(i,...g){this.logger.warn(i,...g)}error(i,...g){this.logger.error(i,...g)}critical(i,...g){this.logger.critical(i,...g)}flush(){this.logger.flush()}}e.LogService=l;class v extends E.Disposable{constructor(i,g){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(g(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,g){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,g?.always?D.Trace:this.logLevel,g),this.loggers.set(i.toString(),r),g?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class S{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return D.Info}trace(i,...g){}debug(i,...g){}info(i,...g){}warn(i,...g){}error(i,...g){}critical(i,...g){}dispose(){}flush(){}}e.NullLogService=S;function _(y){if(y.verbose)return D.Trace;if(typeof y.logLevel=="string"){const i=a(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function a(y){switch(y){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=a;function c(y){switch(y){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(be[82],Ee([0,1,35,122,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(o,l){return l-o}D.compare=T;const t=Object.create(null);t[D.Error]=(0,M.localize)(0,null),t[D.Warning]=(0,M.localize)(1,null),t[D.Info]=(0,M.localize)(2,null);function b(o){return t[o]||""}D.toString=b;function n(o){switch(o){case d.default.Error:return D.Error;case d.default.Warning:return D.Warning;case d.default.Info:return D.Info;case d.default.Ignore:return D.Hint}}D.fromSeverity=n;function h(o){switch(o){case D.Error:return d.default.Error;case D.Warning:return d.default.Warning;case D.Info:return d.default.Info;case D.Hint:return d.default.Ignore}}D.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const T="";function t(n){return b(n,!0)}D.makeKey=t;function b(n,h){let o=[T];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(T),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(T),n.severity!==void 0&&n.severity!==null?o.push(R.toString(n.severity)):o.push(T),n.message&&h?o.push(n.message.replace("\xA6","\\\xA6")):o.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(T),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(T),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(T),o.push(T),o.join("\xA6")}D.makeKeyOptionalMessage=b})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=D}),define(be[146],Ee([0,1,6,9,2,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function R(k,D){return E.URI.isUri(k)?(0,M.equalsIgnoreCase)(k.scheme,D):(0,M.startsWithIgnoreCase)(k,D+":")}e.matchesScheme=R});var $e=this&&this.__decorate||function(re,e,d,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,d,M);else for(var k=re.length-1;k>=0;k--)(R=re[k])&&(A=(E<3?R(A):E>3?R(e,d,A):R(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},Ve=this&&this.__param||function(re,e){return function(d,M){e(d,M,re)}};define(be[147],Ee([0,1,14,21,6,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends E.Disposable{constructor(b,n){super();this.deferred=new d.DeferredPromise,n.withProgress(b,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};D=$e([Ve(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends E.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(b){this.stop();const n=++this.currentOperationId,h=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:h.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(R,k){d.ok(M.isString(R)),d.ok(M.isObject(k)),d.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,k)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new E}),define(be[83],Ee([0,1,3,28]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[E(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;M.Registry.add(e.Extensions.JSONContribution,R)}),define(be[62],Ee([0,1,13,3,10,119,83,28]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=k.Registry.as(R.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(a,c=!0){this.registerConfigurations([a],c)}registerConfigurations(a,c=!0){const y=this.doRegisterConfigurations(a,c);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(a){const c=this.doDeregisterConfigurations(a);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:a,remove:c}){const y=[];y.push(...this.doDeregisterConfigurations(c)),y.push(...this.doRegisterConfigurations(a,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(y))}registerDefaultConfigurations(a){const c=[],y=[];for(const i of a)for(const g in i)if(c.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]={...this.defaultValues[g]||{},...i[g]};const r={type:"object",default:this.defaultValues[g],description:A.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};y.push(h(g)),this.configurationProperties[g]=r,this.defaultLanguageConfigurationOverridesNode.properties[g]=r}else{this.defaultValues[g]=i[g];const r=this.configurationProperties[g];r&&(this.updatePropertyDefaultValue(g,r),this.updateSchema(g,r))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(a){const c=[];for(const y of a)for(const i in y)if(c.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const c of a)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,c){const y=[];return a.forEach(i=>{y.push(...this.validateAndRegisterProperties(i,c,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),y}doDeregisterConfigurations(a){const c=[],y=i=>{if(i.properties)for(const g in i.properties)c.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,i.properties[g]);i.allOf&&i.allOf.forEach(g=>y(g))};for(const i of a){y(i);const g=this.configurationContributors.indexOf(i);g!==-1&&this.configurationContributors.splice(g,1)}return c}validateAndRegisterProperties(a,c=!0,y,i=3){i=E.isUndefinedOrNull(a.scope)?i:a.scope;let g=[],r=a.properties;if(r)for(let u in r){if(c&&v(u)){delete r[u];continue}const f=r[u];if(this.updatePropertyDefaultValue(u,f),e.OVERRIDE_PROPERTY_PATTERN.test(u)?f.scope=void 0:(f.scope=E.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=E.isUndefinedOrNull(f.restricted)?!!y?.restrictedConfigurations?.includes(u):f.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),g.push(u)}let s=a.allOf;if(s)for(let u of s)g.push(...this.validateAndRegisterProperties(u,c,y,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const c=y=>{let i=y.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let g=y.allOf;g&&g.forEach(c)};c(a)}updateSchema(a,c){switch(e.allSettings.properties[a]=c,c.scope){case 1:e.applicationSettings.properties[a]=c;break;case 2:e.machineSettings.properties[a]=c;break;case 6:e.machineOverridableSettings.properties[a]=c;break;case 3:e.windowSettings.properties[a]=c;break;case 4:e.resourceSettings.properties[a]=c;break;case 5:e.resourceSettings.properties[a]=c,this.resourceLanguageSettingsSchema.properties[a]=c;break}}removeFromSchema(a,c){switch(delete e.allSettings.properties[a],c.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const c=`[${a}]`,y={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,y),e.allSettings.properties[c]=y,e.applicationSettings.properties[c]=y,e.machineSettings.properties[c]=y,e.machineOverridableSettings.properties[c]=y,e.windowSettings.properties[c]=y,e.resourceSettings.properties[c]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,c){let y=this.defaultValues[a];E.isUndefined(y)&&(y=c.default),E.isUndefined(y)&&(y=o(c.type)),c.default=y}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function h(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=h;function o(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const l=new b;k.Registry.add(e.Extensions.Configuration,l);function v(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?A.localize(5,null,_):l.getConfigurationProperties()[_]!==void 0?A.localize(6,null,_):null:A.localize(4,null)}e.validateProperty=v;function S(){const _=[],a=l.getConfigurationProperties();for(const c of Object.keys(a))_.push([c,a[c].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=S}),define(be[84],Ee([0,1,23,10,2,62,4,28]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof E.URI)}e.isConfigurationOverrides=D;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function b(g,r){const s=r?g?r.keys.filter(I=>g.keys.indexOf(I)===-1):[...r.keys]:[],u=g?r?g.keys.filter(I=>r.keys.indexOf(I)===-1):[...g.keys]:[],f=[];if(r&&g){for(const I of g.keys)if(r.keys.indexOf(I)!==-1){const F=S(g.contents,I),L=S(r.contents,I);d.equals(F,L)||f.push(I)}}const p=[],C=I=>{const F={};for(const L of I)for(const w of L.identifiers)F[y(w)]=L;return F},P=r?C(r.overrides):{},m=g?C(g.overrides):{};if(Object.keys(P).length)for(const I of s){const F=P[I];F&&p.push([(0,A.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(m).length)for(const I of u){const F=m[I];F&&p.push([(0,A.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(P).length&&Object.keys(m).length)for(const I of f){const F=m[I],L=P[I];if(F&&L){const w=b({contents:F.contents,keys:F.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});p.push([(0,A.overrideIdentifierFromKey)(I),[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:u,updated:f,overrides:p}}e.compare=b;function n(g,r){const s=[];for(const u of Object.keys(g))if(A.OVERRIDE_PROPERTY_PATTERN.test(u)){const f={};for(const p in g[u])f[p]=g[u][p];s.push({identifiers:[(0,A.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(f),contents:h(f,r)})}return s}e.toOverrides=n;function h(g,r){const s=Object.create(null);for(let u in g)o(s,u,g[u],r);return s}e.toValuesTree=h;function o(g,r,s,u){const f=r.split("."),p=f.pop();let C=g;for(let P=0;P<f.length;P++){let m=f[P],I=C[m];switch(typeof I){case"undefined":I=C[m]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${f.slice(0,P+1).join(".")} is ${JSON.stringify(I)}`);return}C=I}if(typeof C=="object"&&C!==null)try{C[p]=s}catch(P){u(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(C)}`)}else u(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=o;function l(g,r){const s=r.split(".");v(g,s)}e.removeFromValueTree=l;function v(g,r){const s=r.shift();if(r.length===0){delete g[s];return}if(Object.keys(g).indexOf(s)!==-1){const u=g[s];typeof u=="object"&&!Array.isArray(u)&&(v(u,r),Object.keys(u).length===0&&delete g[s])}}function S(g,r,s){function u(C,P){let m=C;for(const I of P){if(typeof m!="object"||m===null)return;m=m[I]}return m}const f=r.split("."),p=u(g,f);return typeof p=="undefined"?s:p}e.getConfigurationValue=S;function _(g,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in g?M.isObject(g[u])&&M.isObject(r[u])?_(g[u],r[u],s):s&&(g[u]=r[u]):g[u]=r[u])})}e.merge=_;function a(){const g=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(g)}e.getConfigurationKeys=a;function c(){const g=Object.create(null),r=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;o(g,s,u,f=>console.error(`Conflict in default settings: ${f}`))}return g}e.getDefaultValues=c;function y(g){return`[${g}]`}e.keyFromOverrideIdentifier=y;function i(g,r,s){const u=g.inspect(r),f=g.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:u.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,13,3,102,6,20,23,10,2,84,62,28]),function(re,e,d,M,E,A,R,k,D,T,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(i={},g=[],r=[]){this._contents=i,this._keys=g,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,g){const r=this.getContentsForOverrideIdentifer(g);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.keys;return[]}override(i){let g=this.overrideConfigurations.get(i);return g||(g=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,g)),g}merge(...i){const g=k.deepClone(this.contents),r=k.deepClone(this.overrides),s=[...this.keys];for(const u of i){this.mergeContents(g,u.contents);for(const f of u.overrides){const[p]=r.filter(C=>d.equals(C.identifiers,f.identifiers));p?this.mergeContents(p.contents,f.contents):r.push(k.deepClone(f))}for(const f of u.keys)s.indexOf(f)===-1&&s.push(f)}return new h(g,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const g=this.getContentsForOverrideIdentifer(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;let r={};for(const s of d.distinct([...Object.keys(this.contents),...Object.keys(g)])){let u=this.contents[s],f=g[s];f&&(typeof u=="object"&&typeof f=="object"?(u=k.deepClone(u),this.mergeContents(u,f)):u=f),r[s]=u}return new h(r,this.keys,this.overrides)}mergeContents(i,g){for(const r of Object.keys(g)){if(r in i&&D.isObject(i[r])&&D.isObject(g[r])){this.mergeContents(i[r],g[r]);continue}i[r]=k.deepClone(g[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,g){this.addKey(i),(0,t.addToValueTree)(this.contents,i,g,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let g=this.keys.length;for(let r=0;r<g;r++)i.indexOf(this.keys[r])===0&&(g=r);this.keys.splice(g,1,i)}removeKey(i){let g=this.keys.indexOf(i);return g!==-1?(this.keys.splice(g,1),!0):!1}}e.ConfigurationModel=h;class o extends h{constructor(){const i=(0,t.getDefaultValues)(),g=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))b.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,b.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(i,g,r)}}e.DefaultConfigurationModel=o;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,g){if(!D.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,g)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,g){this._raw=i;const{contents:r,keys:s,overrides:u,restricted:f}=this.doParseRaw(i,g);this._configurationModel=new h(r,s,u),this._restrictedConfigurations=f||[]}doParseContent(i){let g={},r=null,s=[],u=[],f=[];function p(P){Array.isArray(s)?s.push(P):r!==null&&(s[r]=P)}let C={onObjectBegin:()=>{let P={};p(P),u.push(s),s=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let P=[];p(P),u.push(s),s=P,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:p,onError:(P,m,I)=>{f.push({error:P,offset:m,length:I})}};if(i)try{E.visit(i,C),g=s[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return g}doParseRaw(i,g){const r=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,g);i=s.raw;const u=(0,t.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),f=Object.keys(i),p=(0,t.toOverrides)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:u,keys:f,overrides:p,restricted:s.restricted}}filter(i,g,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const u={},f=[];for(let p in i)if(b.OVERRIDE_PROPERTY_PATTERN.test(p)&&r){const C=this.filter(i[p],g,!1,s);u[p]=C.raw,f.push(...C.restricted)}else{const C=g[p],P=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&f.push(p),(P===void 0||s.scopes===void 0||s.scopes.includes(P))&&(s.skipRestricted&&C?.restricted||(u[p]=i[p]))}return{raw:u,restricted:f}}}e.ConfigurationModelParser=l;class v extends A.Disposable{constructor(i,g,r,s){super();this.userSettingsResource=i,this.scopes=g,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class S{constructor(i,g,r=new h,s=new h,u=new R.ResourceMap,f=new h,p=new R.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=g,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=p,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,g,r){return this.getConsolidateConfigurationModel(g,r).getValue(i)}updateValue(i,g,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new h,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,g===void 0?s.removeValue(i):s.setValue(i,g),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,g,r){const s=this.getConsolidateConfigurationModel(g,r),u=this.getFolderConfigurationModelForResource(g.resource,r),f=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,p=g.overrideIdentifier?this._defaultConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=g.overrideIdentifier?this.userConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=g.overrideIdentifier?this.localUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),m=g.overrideIdentifier?this.remoteUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),I=r?g.overrideIdentifier?this._workspaceConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,F=u?g.overrideIdentifier?u.freeze().override(g.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,L=g.overrideIdentifier?f.override(g.overrideIdentifier).getValue(i):f.getValue(i),w=s.getValue(i),x=d.distinct(d.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(i,W)!==void 0);return{defaultValue:p,userValue:C,userLocalValue:P,userRemoteValue:m,workspaceValue:I,workspaceFolderValue:F,memoryValue:L,value:w,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userRemote:m!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u?.freeze().getValue(i),override:g.overrideIdentifier?u?.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:f.getValue(i),override:g.overrideIdentifier?f.getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(i){const g=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:g?g.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,g){this._folderConfigurations.set(i,g),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const r=g.filter(s=>b.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,b.overrideIdentifierFromKey)(s),f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=i.getKeysForOverrideIdentifier(u),C=[...p.filter(P=>f.indexOf(P)===-1),...f.filter(P=>p.indexOf(P)===-1),...f.filter(P=>!k.equals(this._defaultConfiguration.override(u).getValue(P),i.override(u).getValue(P)))];return[u,C]});return this.updateDefaultConfiguration(i),{keys:g,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:r,removed:s,overrides:u}=(0,t.compare)(this.localUserConfiguration,i),f=[...g,...r,...s];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:r,removed:s,overrides:u}=(0,t.compare)(this.remoteUserConfiguration,i);let f=[...g,...r,...s];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:r,removed:s,overrides:u}=(0,t.compare)(this.workspaceConfiguration,i);let f=[...g,...r,...s];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(i,g){const r=this.folderConfigurations.get(i),{added:s,updated:u,removed:f,overrides:p}=(0,t.compare)(r,g);let C=[...s,...u,...f];return(C.length||!r)&&this.updateFolderConfiguration(i,g),{keys:C,overrides:p}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:u,overrides:f}=(0,t.compare)(g,void 0);return{keys:[...r,...s,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,g){let r=this.getConsolidatedConfigurationModelForResource(i,g);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},g){let r=this.getWorkspaceConsolidatedConfiguration();if(g&&i){const s=g.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let g=this._foldersConsolidatedConfigurations.get(i);if(!g){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(g=r.merge(s),this._freeze&&(g=g.freeze()),this._foldersConsolidatedConfigurations.set(i,g)):g=r}return g}getFolderConfigurationModelForResource(i,g){if(g&&i){const r=g.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,g)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(g);return i.push([g,{contents:r,overrides:s,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(g=>i.add(g)),this.userConfiguration.freeze().keys.forEach(g=>i.add(g)),this._workspaceConfiguration.freeze().keys.forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>g.add(s))),[...g.values()]}static parse(i){const g=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((f,p)=>(f.set(T.URI.revive(p[0]),this.parseConfigurationModel(p[1])),f),new R.ResourceMap);return new S(g,r,new h,s,u,new h,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=S;function _(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,g=new Map;for(const s of y)s.keys.forEach(u=>i.add(u)),s.overrides.forEach(([u,f])=>{const p=(0,R.getOrSet)(g,u,new Set);f.forEach(C=>p.add(C))});const r=[];return g.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=_;class a{constructor(i,g,r,s){this.change=i,this.previous=g,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(p=>u.add(p)),i.overrides.forEach(([,p])=>p.forEach(C=>u.add(C))),this.affectedKeys=[...u.values()];const f=new h;this.affectedKeys.forEach(p=>f.setValue(p,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,g){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(g){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,g,this.currentWorkspace);return!k.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,g){let r=(0,t.toValuesTree)({[g]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=a;class c extends a{constructor(i,g,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,g);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=c}),define(be[85],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(R,k=M.Unknown,D){super(R);this._message=R,this._code=k,this._detail=D,this.isHandled=k===M.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(R){return R instanceof E&&R._code===M.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof E&&R._code===M.NoResolverFound}static isHandled(R){return R instanceof E&&R.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[86],Ee([0,1,11]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function R(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=R;function k(T){return R(T)?.scheme}e.getVirtualWorkspaceScheme=k;function D(T){return R(T)!==void 0}e.isVirtualWorkspace=D}),define(be[149],Ee([0,1,3,25,4,15]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService");var R;(function(o){o.Http="http",o.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=b;function n(o,l){return l?l!==1&&o<1024:!M.isWindows&&o<1024}e.isPortPrivileged=n;let h=class{constructor(l){this.logService=l,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async l=>{const v=[],S=Array.from(this._tunnels.values());for(let _ of S){const a=Array.from(_.values());for(let c of a){const y=await c.value;y&&v.push(y)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(S=>S?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,S,_,a=!1,c=k.Private,y){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${S} on local port ${_}.`),!l)return;v||(v="localhost");const i=this.retainOrCreateTunnel(l,v,S,_,a,c,y);return i?i.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(g);return(g.tunnelRemoteHost!==v||g.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const S=v.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,v,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const _=S.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),_}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const S=this._tunnels.get(l);if(S&&S.has(v)){const _=S.get(v);_.refcount=0,await this.tryDisposeTunnel(l,v,_)}}addTunnelToMap(l,v,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:S})}async removeEmptyTunnelFromMap(l,v){const S=this._tunnels.get(l);S&&(await S.get(v)||S.delete(v),S.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let S=[l];t(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):b(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const _=S.map(a=>this._tunnels.get(a));for(const a of _){const c=a?.get(v);if(c)return c}}canTunnel(l){return!!T(l)}createWithProvider(l,v,S,_,a,c,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${S} on local port ${_}.`);const g={elevationRequired:a?n(_===void 0?S:_):!1},r={remoteAddress:{host:v,port:S},localAddressPort:_,privacy:c,public:c!==k.Private,protocol:y},s=l.forwardPort(r,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,S,s),s}};h=$e([Ve(0,A.ILogService)],h),e.AbstractTunnelService=h}),define(be[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,R=5){let k;return k=A(D=>{const T=typeof D=="string"?D:D.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const b=setTimeout(()=>this.flushBuffer(E),R);t={data:[T],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(E),k.dispose()}},this._terminalBufferMap.set(E,t)}),k}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[151],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[46],Ee([0,1,34,3,6,4,28,151]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(v){function S(_){return _&&typeof _=="object"&&typeof _.id=="string"}v.isThemeColor=S})(D=e.ThemeColor||(e.ThemeColor={}));function T(v){return{id:v}}e.themeColorFromId=T;var t;(function(v){function S(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color=="undefined"||D.isThemeColor(g.color))}v.isThemeIcon=S;const _=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function a(g){const r=_.exec(g);if(!r)return;let[,s]=r;return{id:s}}v.fromString=a;function c(g,r){let s=g.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}v.modify=c;function y(g,r){return g.id===r.id&&g.color?.id===r.color?.id}v.isEqual=y;function i(g,r){return{id:g.id,color:r?T(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=d.CSSIcon.asClassNameArray,v.asClassName=d.CSSIcon.asClassName,v.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function b(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,E.toDisposable)(()=>{const _=this.themingParticipants.indexOf(S);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new n;R.Registry.add(e.Extensions.ThemingContribution,h);function o(v){return h.onColorThemeChange(v)}e.registerThemingParticipant=o;class l extends E.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,_){let a=this.theme.getColor(S);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}e.Themable=l}),define(be[152],Ee([0,1,14,34,3,123,83,28,46]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,_,a,c){const y=this.iconsById[S];if(y){if(a&&!y.description){y.description=a,this.iconSchema.properties[S].markdownDescription=`${a} $(${S})`;const r=this.iconReferenceSchema.enum.indexOf(S);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return y}let i={id:S,description:a,defaults:_,deprecationMessage:c};this.iconsById[S]=i;let g={$ref:"#/definitions/icons"};return c&&(g.deprecationMessage=c),a&&(g.markdownDescription=`${a}: $(${S})`),this.iconSchema.properties[S]=g,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const _=this.iconReferenceSchema.enum.indexOf(S);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,_){const a=this.iconFontsById[S];if(a)return a;let c={id:S,definition:_};return this.iconFontsById[S]=c,this._onDidChange.fire(),c}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFonts(){return Object.keys(this.iconFontsById).map(S=>this.iconFontsById[S])}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(y,i)=>y.id.localeCompare(i.id),_=y=>{for(;D.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of c.filter(i=>!!i.description).sort(S))a.push(`|<i class="${_(y)}"></i>|${y.id}|${D.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const y of c.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(S))a.push(`|<i class="${_(y)}"></i>|${y.id}|`);return a.join(`
`)}}const t=new T;k.Registry.add(e.Extensions.IconContribution,t);function b(v,S,_,a){return t.registerIcon(v,S,_,a)}e.registerIcon=b;function n(){return t}e.getIconRegistry=n;function h(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let o=k.Registry.as(R.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new d.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=b("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=D.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[47],Ee([0,1,20,24,2,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function k(n){const h=n;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=k;function D(n){const h=n;return!!(h&&typeof h=="object"&&E.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(h,o,l,v,S){this._id=h,this._transient=l,this._configuration=v,this._ignorePathCasing=S,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(h){this._id=h.id,this._configuration=h.configuration,this._transient=h.transient,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(h,o){this.raw=o,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,M.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function b(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b}),define(be[63],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(k=>{const D=this._providerInfo.get(k.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(R,k,D){this._deferredPromises=new Map,this._id=R,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const b of T.values())b.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,k){let D=this._value[R];return typeof D=="undefined"&&(D=k),D}update(R,k){this._value[R]=k;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const T=new d.DeferredPromise;return this._deferredPromises.set(R,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(R,k){super(R.identifier.value,!0,k);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=$e([Ve(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[155],Ee([0,1,26,3]),function(re,e,d,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),et(this,E,D,"f"),Fe(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(k){return Fe(this,E,"f").get(this._id,k)}store(k,D){return Fe(this,E,"f").store(this._id,k,D)}delete(k){return Fe(this,E,"f").delete(this._id,k)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(_,a)=>{const c={controllerId:a};return M.set(_,c),c};e.createPrivateApiFor=E;const A=_=>M.get(_);e.getPrivateApiFor=A;const R=(_,a,c,y)=>{let i=c;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!y(i,g)){const r=i;i=g,_.listener?.({op:3,key:a,value:g,previous:r})}}}},k=(_,a)=>_===a,D={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(_,a)=>!(_.length!==a.length||_.some(c=>!a.find(y=>c.id===y.id)))},T=Object.keys(D),t=(_,a)=>({range:R(_,"range",void 0,D.range),label:R(_,"label",a,D.label),description:R(_,"description",void 0,D.description),canResolveChildren:R(_,"canResolveChildren",!1,D.canResolveChildren),busy:R(_,"busy",!1,D.busy),error:R(_,"error",void 0,D.error),tags:R(_,"tags",[],D.tags)}),b=(_,a)=>{const c=new Map;for(const y of T)D[y](_[y],a[y])||c.set(y,a[y]);return c};e.diffTestItems=b;class n extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=n;class h extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class o extends Error{constructor(a,c,y){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=o;const l=_=>{const a=(0,e.getPrivateApiFor)(_);let c=new Map;return{get size(){return c.size},forEach(y,i){for(const g of c.values())y.call(i,g,this)},replace(y){const i=new Map,g=new Set(c.keys()),r={op:4,ops:[]};for(const s of y){if(!(s instanceof v))throw new h(s.id);const u=(0,e.getPrivateApiFor)(s).controllerId;if(u!==a.controllerId)throw new o(s.id,u,a.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),g.delete(s.id),r.ops.push({op:0,item:s})}for(const s of g.keys())r.ops.push({op:1,id:s});a.listener?.(r),c=i},add(y){if(!(y instanceof v))throw new h(y.id);c.set(y.id,y),a.listener?.({op:0,item:y})},delete(y){c.delete(y)&&a.listener?.({op:1,id:y})},get(y){return c.get(y)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class v{constructor(a,c,y,i){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const g=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof S?void 0:g.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(g,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class S extends v{constructor(a,c){super(a,a,c,void 0)}}e.TestItemRootImpl=S}),define(be[64],Ee([0,1,4,149,3,12]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(D){function T(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:b.protocol}}D.fromApiTunnel=T;function t(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==M.TunnelPrivacyId.ConstantPrivate&&b.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}D.fromServiceTunnel=t})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(T){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,b,n,h){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([Ve(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(re,e,d,M,E,A,R,k,D,T,t,b){"use strict";var n,h,o,l,v,S,_,a,c,y,i,g,r,s,u,f,p,C,P,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let F=v=class{constructor(O){n.set(this,void 0),et(this,n,O,"f")}static from(...O){let ie=O;return new v(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Fe(this,n,"f")=="function"&&(Fe(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,F=v=$e([I],F),e.Disposable=F;let L=S=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof S)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new S(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new S(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};L=S=$e([I],L),e.Position=L;let w=_=class{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new L(O,ie),at=new L(_e,Ge)):O instanceof L&&ie instanceof L&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof _?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof _?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=L.Max(O.start,this._start),_e=L.Min(O.end,this._end);if(!ie.isAfter(_e))return new _(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=L.Min(O.start,this._start),_e=L.Max(O.end,this.end);return new _(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?L.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new _(_e,ie)}toJSON(){return[this.start,this.end]}};w=_=$e([I],w),e.Range=w;let x=a=class extends w{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new L(O,ie),at=new L(_e,Ge)):O instanceof L&&ie instanceof L&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof a?!0:O?w.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=a=$e([I],x),e.Selection=x;class W{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=W;class B extends Error{constructor(O,ie=b.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(O,ie){return new B(O,b.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new B(O,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var G;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(G=e.EndOfLine||(e.EndOfLine={}));var H;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=c=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof c?!0:O?w.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new c(O,ie)}static insert(O,ie){return c.replace(new w(O,O),ie)}static delete(O){return c.replace(O,"")}static setEndOfLine(O){const ie=new c(new w(new L(0,0),new L(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!w.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=c=$e([I],U),e.TextEdit=U;var V;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,nt){let at,ct,Ct=[],At;if(zt.isNotebookRange(ie)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ge)?(at=ie.start,ct=ie.end,Ct=_e,At=Ge):typeof ie=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ge)&&(at=ie,ct=_e,Ct=Ge,At=nt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ct-at,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new U(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new w(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=$e([I],Q),e.WorkspaceEdit=Q;let ne=y=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof y?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=y._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new y;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=y._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new y;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ne=y=$e([I],ne),e.SnippetString=ne;var ce;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var Z;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(Z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof w)this.range=ie;else if(ie instanceof L)this.range=new w(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?w.isRange(O.range)&&D.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=$e([I],oe),e.Location=oe;let ve=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&w.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};ve=$e([I],ve),e.DiagnosticRelatedInformation=ve;let Ae=class{constructor(O,ie,_e=Z.Error){if(!w.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:Z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,d.equals)(O.tags,ie.tags)&&(0,d.equals)(O.relatedInformation,ie.relatedInformation,ve.isEqual)}};Ae=$e([I],Ae),e.Diagnostic=Ae;let Se=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Se=$e([I],Se),e.Hover=Se;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ie=Ne.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};We=$e([I],We),e.DocumentHighlight=We;var je;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let $=g=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.kind=ie,this.containerName=nt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof oe?this.location=Ge:_e instanceof w&&(this.location=new oe(Ge,_e)),g.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};$=g=$e([I],$),e.SymbolInformation=$;let K=r=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=nt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};K=r=$e([I],K),e.DocumentSymbol=K;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,ie){this.title=O,this.kind=ie}};ae=$e([I],ae),e.CodeAction=ae;let q=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};q.sep=".",q=s=$e([I],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let se=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=$e([I],se),e.SelectionRange=se;class he{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=he;class Re{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Re;class Be{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=Be;var ze;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Qe=$e([I],Qe),e.CodeLens=Qe;let it=u=class{constructor(O,ie=!1){h.set(this,void 0),et(this,h,new E.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Fe(this,h,"f").value}set value(O){Fe(this,h,"f").value=O}get isTrusted(){return Fe(this,h,"f").isTrusted}set isTrusted(O){Fe(this,h,"f").isTrusted=O}get supportThemeIcons(){return Fe(this,h,"f").supportThemeIcons}set supportThemeIcons(O){Fe(this,h,"f").supportThemeIcons=O}get supportHtml(){return Fe(this,h,"f").supportHtml}set supportHtml(O){Fe(this,h,"f").supportHtml=O}appendText(O){return Fe(this,h,"f").appendText(O),this}appendMarkdown(O){return Fe(this,h,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Fe(this,h,"f").appendCodeblock(ie??"",O),this}};h=new WeakMap,it=u=$e([I],it),e.MarkdownString=it;let ke=class{constructor(O,ie){this.label=O,this.documentation=ie}};ke=$e([I],ke),e.ParameterInformation=ke;let Ze=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};Ze=$e([I],Ze),e.SignatureInformation=Ze;let j=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};j=$e([I],j),e.SignatureHelp=j;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let He=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};He=$e([I],He),e.InlayHint=He;var Ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var st;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(st=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(N){N[N.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let Et=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Et=$e([I],Et),e.CompletionItem=Et;let mt=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};mt=$e([I],mt),e.CompletionList=mt;let Dt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Dt=$e([I],Dt),e.InlineSuggestion=Dt;let Pt=class{constructor(O){this.items=O}};Pt=$e([I],Pt),e.InlineSuggestions=Pt;var It;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(It=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var te;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(te=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var le;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,ie){if(ie&&!D.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};ge=$e([I],ge),e.DocumentLink=ge;let fe=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};fe=$e([I],fe),e.Color=fe;let Pe=class{constructor(O,ie){if(ie&&!(ie instanceof fe))throw(0,M.illegalArgument)("color");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Pe=$e([I],Pe),e.ColorInformation=Pe;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=$e([I],xe),e.ColorPresentation=xe;var Oe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Oe=e.ColorFormat||(e.ColorFormat={}));var Ke;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class tt{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=tt;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var pe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let z=f=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};z.Clean=new f("clean","Clean"),z.Build=new f("build","Build"),z.Rebuild=new f("rebuild","Rebuild"),z.Test=new f("test","Test"),z=f=$e([I],z),e.TaskGroup=z;function we(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let Ie=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return we(O)}};Ie=$e([I],Ie),e.ProcessExecution=Ie;let Je=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return we(O)}};Je=$e([I],Je),e.ShellExecution=Je;var Ue;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var dt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(dt=e.TaskScope||(e.TaskScope={}));class gt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=gt;let lt=p=class{constructor(O,ie,_e,Ge,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,ct=nt,this.__deprecated=!0):ie===dt.Global||ie===dt.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,ct=at):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(p.EmptyType===ie||p.ProcessType===ie||p.ShellType===ie||p.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=p=$e([I],lt),e.Task=lt;var ft;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,ie=pt.None){this.collapsibleState=ie,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=$e([I],ut),e.TreeItem=ut;var pt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let bt=class{constructor(O,ie){this.id=O,this.color=ie}};bt=$e([I],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Ut=class{constructor(O){this.id=O}};Ut=$e([I],Ut),e.ThemeColor=Ut;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=D.URI.file(O),this.base=O):D.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};yt=$e([I],yt),e.RelativePattern=yt;let $t=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};$t=$e([I],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ti=$e([I],ti),e.SourceBreakpoint=ti;let vt=class extends $t{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);this.functionName=O}};vt=$e([I],vt),e.FunctionBreakpoint=vt;let Qt=class extends $t{constructor(O,ie,_e,Ge,nt,at,ct){super(Ge,nt,at,ct);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};Qt=$e([I],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};jt=$e([I],jt),e.DebugAdapterExecutable=jt;let ii=class{constructor(O,ie){this.port=O,this.host=ie}};ii=$e([I],ii),e.DebugAdapterServer=ii;let ni=class{constructor(O){this.path=O}};ni=$e([I],ni),e.DebugAdapterNamedPipeServer=ni;let Tt=class{constructor(O){this.implementation=O}};Tt=$e([I],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,ie){this.range=O,this.expression=ie}};Yt=$e([I],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=$e([I],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};Ht=$e([I],Ht),e.InlineValueVariableLookup=Ht;let ht=class{constructor(O,ie){this.range=O,this.expression=ie}};ht=$e([I],ht),e.InlineValueEvaluatableExpression=ht;let ri=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};ri=$e([I],ri),e.InlineValueContext=ri;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=C=class extends Error{constructor(O,ie=t.FileSystemProviderErrorCode.Unknown,_e){super(D.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new C(O,t.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(O){return new C(O,t.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(O){return new C(O,t.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(O){return new C(O,t.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(O){return new C(O,t.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(O){return new C(O,t.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Nt=C=$e([I],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};Jt=$e([I],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=fi;function Xt(N){return typeof N=="undefined"||(0,k.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,nt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ie,_e,Ge,nt);if(w.isRange(O)&&typeof ie=="string"&&Xt(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(ie);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);Ct|=1<<Ft>>>0}this._pushEncoded(Ge,nt,at,ct,Ct)}_pushEncoded(O,ie,_e,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<Ct;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let at=O,ct=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let ct=0;ct<_e;ct++)ie[ct]=ct;ie.sort((ct,Ct)=>{const At=O[5*ct],Ft=O[5*Ct];if(At===Ft){const Lt=O[5*ct+1],xt=O[5*Ct+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let nt=0,at=0;for(let ct=0;ct<_e;ct++){const Ct=5*ie[ct],At=O[Ct+0],Ft=O[Ct+1],Lt=O[Ct+2],xt=O[Ct+3],ci=O[Ct+4],xi=At-nt,qi=xi===0?Ft-at:Ft,di=5*ct;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,nt=At,at=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new bt("arrow-left")},Zt=$e([I],Zt),e.QuickInputButtons=Zt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=$e([I],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new zt(ie,_e)}}e.NotebookRange=zt;class Mt{constructor(O,ie,_e,Ge,nt,at,ct){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=nt??[],this.metadata=at,this.executionSummary=ct,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Mt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Me{constructor(O){this.cells=O}}e.NotebookData=Me;class Rt{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,R.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Rt.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Rt(O,ie)}static text(O,ie=R.Mimes.text){const _e=Fe(Rt,o,"f",l).encode(String(O));return new Rt(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,ie)}}e.NotebookCellOutputItem=Rt,o=Rt,l={value:new TextEncoder};class Kt{constructor(O,ie,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,T.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,k.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ct=(0,R.normalizeMimeType)(at.mime);if(!_e.has(ct)){_e.add(ct);continue}Ge.add(nt),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((nt,at)=>!Ge.has(at))}}e.NotebookCellOutput=Kt;var wt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(wt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,ie=[]){this.uri=O,this.provides=(0,d.asArray)(ie)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,ie){this.label=O,this.timestamp=ie}};ui=$e([I],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};X=$e([I],X),e.TestRunRequest=X;let ue=P=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new P(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};ue=P=$e([I],ue),e.TestMessage=ue;let De=class{constructor(O){this.id=O}};De=$e([I],De),e.TestTag=De;let rt=class{constructor(O,ie){this.covered=O,this.total=ie}};rt=$e([I],rt),e.CoveredCount=rt;let _t=m=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new rt(0,0),Ge=new rt(0,0),nt=new rt(0,0);for(const ct of ie)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)Ge.total+=1,Ge.covered+=Ct.executionCount>0?1:0}else nt.total+=1,nt.covered+=ct.executionCount>0?1:0;const at=new m(O,_e,Ge.total>0?Ge:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ie,at}};_t=m=$e([I],_t),e.FileCoverage=_t;let kt=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};kt=$e([I],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Oi=$e([I],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=$e([I],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,118,7,13]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(o,l){l?T.set(o,l):T.delete(o)}e.setWordDefinitionFor=t;function b(o){return T.get(o)}e.getWordDefinitionFor=b;class n extends A.MirrorTextModel{constructor(l,v,S,_,a,c,y,i){super(v,S,_,a);this._proxy=l,this._languageId=c,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,D.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===M.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(v){return v?l._getTextInRange(v):l.getText()},get eol(){return l._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(v){return l._lineAt(v)},offsetAt(v){return l._offsetAt(v)},positionAt(v){return l._positionAt(v)},validateRange(v){return l._validateRange(v)},validatePosition(v){return l._validatePosition(v)},getWordRangeAtPosition(v,S){return l._getWordRangeAtPosition(v,S)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,d.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,d.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const v=this._validateRange(l);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const S=this._eol,_=v.start.line,a=v.end.line,c=[];c.push(this._lines[_].substring(v.start.character));for(let y=_+1;y<a;y++)c.push(this._lines[y]);return c.push(this._lines[a].substring(0,v.end.character)),c.join(S)}_lineAt(l){let v;if(l instanceof k.Position?v=l.line:typeof l=="number"&&(v=l),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new h(v,this._lines[v],v===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(l),S=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,S))}_validateRange(l){if(!(l instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(l.start),S=this._validatePosition(l.end);return v===l.start&&S===l.end?l:new k.Range(v.line,v.character,S.line,S.character)}_validatePosition(l){if(!(l instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:v,character:S}=l,_=!1;if(v<0)v=0,S=0,_=!0;else if(v>=this._lines.length)v=this._lines.length-1,S=this._lines[v].length,_=!0;else{const a=this._lines[v].length;S<0?(S=0,_=!0):S>a&&(S=a,_=!0)}return _?new k.Position(v,S):l}_getWordRangeAtPosition(l,v){const S=this._validatePosition(l);if(!v)v=b(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const _=(0,R.getWordAtText)(S.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[S.line],0);if(_)return new k.Range(S.line,_.startColumn-1,S.line,_.endColumn-1)}}e.ExtHostDocumentData=n;class h{constructor(l,v,S){this._line=l,this._text=v,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[156],Ee([0,1,7,3,229,6,55,20,2,36]),function(re,e,d,M,E,A,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,h,o,l){this._notebook=o,this._selector=l,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(S=>{const _=this._cellUris.get(S.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(S=>v(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const n=[],h=[];for(const o of this._notebook.getCells())o.kind===d.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),h.push(o.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(n){if(!n){let _="";for(const a of this._cells)_+=a.document.getText()+`
`;return _=_.slice(0,-1),_}if(n.isEmpty)return"";const h=this.locationAt(n.start),o=this.locationAt(n.end),l=this._cellUris.get(h.uri),v=this._cellUris.get(o.uri);if(l===void 0||v===void 0)return"";if(l===v)return this._cells[l].document.getText(new d.Range(h.range.start,o.range.end));const S=[this._cells[l].document.getText(new d.Range(h.range.start,new d.Position(this._cells[l].document.lineCount,0)))];for(let _=l+1;_<v;_++)S.push(this._cells[_].document.getText());return S.push(this._cells[v].document.getText(new d.Range(new d.Position(0,0),o.range.end))),S.join(`
`)}offsetAt(n){const h=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(h.index-1),l=this._cells[h.index].document.offsetAt(n.with(h.remainder));return o+l}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(l)}const h=this._cellUris.get(n.uri);if(h!==void 0){const o=this._cellLines.getPrefixSum(h-1);return new d.Position(o+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const h=this._cellLines.getIndexOf(n.start.line);let o=h;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const l=new d.Position(h.remainder,n.start.character),v=new d.Position(o.remainder,n.end.character),S=new d.Range(l,v),_=this._cells[h.index];return new d.Location(_.document.uri,_.document.validateRange(S))}contains(n){return this._cellUris.has(n)}validateRange(n){const h=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(h,o)}validatePosition(n){const h=this._cellLines.getIndexOf(n.line),o=new d.Position(h.remainder,n.character),l=this._cells[h.index].document.validatePosition(o),v=this._cellLines.getPrefixSum(h.index-1);return new d.Position(v+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[65],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function E(k,D){if(D.serializeBuffersForPostMessage){const T=new M,t=(h,o)=>{if(o instanceof ArrayBuffer){const l=T.add(o);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(o)){const l=A(o);if(l){const v=T.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:l,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},b=JSON.stringify(k,t),n=T.buffers.map(h=>{const o=new Uint8Array(h);return d.VSBuffer.wrap(o)});return{message:b,buffers:n}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=E;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(k,D){const T=D.map(n=>{const h=new ArrayBuffer(n.byteLength);return new Uint8Array(h).set(n.buffer),h}),t=D.length?(n,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const o=h,{index:l}=o,v=T[l];if(o.view)switch(o.view.type){case 1:return new Int8Array(v,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return h}:void 0;return{message:JSON.parse(k,t),arrayBuffers:T}}e.deserializeWebviewMessage=R}),define(be[159],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function E(R){const k={items:new Map};return R.types.forEach((D,T)=>{k.items.set(D,{asString:async()=>R.items[T].asString})}),k}M.toITreeDataTransfer=E;async function A(R){const k={types:[],items:[]},D=Array.from(R.items.entries());for(const T of D)k.types.push(T[0]),k.items.push({asString:await T[1].asString()});return k}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(k,D){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===d.Schemas.file&&(k=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:D.authority,path:k.path})),M.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=E;function A(k){return k.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function R(k){return k.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=R}),define(be[160],Ee([0,1,3,6,66]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,D,T){this._proxy=k,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const t=D.getVisibleTextEditors();for(const b of this._insets.values())t.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,T,t,b){let n;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){n=a;break}if(!n)throw new Error("not a visible editor");const h=this,o=this._handlePool++,l=new d.Emitter,v=new d.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,E.asWebviewUri)(a,h._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(a){this._options=a,h._proxy.$setOptions(o,a)}get options(){return this._options}set html(a){this._html=a,h._proxy.$setHtml(o,a)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(a){return h._proxy.$postMessage(o,a)}},_=new class{constructor(){this.editor=k,this.line=D,this.height=T,this.webview=S,this.onDidDispose=v.event}dispose(){h._insets.has(o)&&(h._insets.delete(o),h._proxy.$disposeEditorInset(o),v.fire(),v.dispose(),l.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,D+1,T,t||{},b.identifier,b.extensionLocation),this._insets.set(o,{editor:k,inset:_,onDidReceiveMessage:l}),_}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const T=this._insets.get(k);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,45,28,13,11]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function b(L,w,x){for(const W of x.visibleEditorPanes)if(W.group.id===w&&L.matches(W.input))return W.getViewState()}e.findViewStateForEditor=b;function n(L){if(c(L))return!1;const w=L;return E.URI.isUri(w?.resource)}e.isResourceEditorInput=n;function h(L){if(c(L))return!1;const w=L;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=h;function o(L){if(c(L)||h(L))return!1;const w=L;return w?.primary!==void 0&&w.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(L){if(c(L))return!1;const w=L;return w?w.resource===void 0||w.resource.scheme===t.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var S;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var _;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function c(L){return L instanceof a}e.isEditorInput=c;function y(L){const w=L;return E.URI.isUri(w?.preferredResource)}function i(L){const w=L;return c(w?.primary)&&c(w?.secondary)}e.isSideBySideEditorInput=i;function g(L){const w=L;return c(w?.modified)&&c(w?.original)}e.isDiffEditorInput=g;function r(L){return c(L?.editor)}e.isEditorInputWithOptions=r;function s(L){const w=L;return r(L)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(L){const w=L;return typeof w?.groupId=="number"&&c(w.editor)}e.isEditorIdentifier=u;var f;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(f=e.EditorCloseContext||(e.EditorCloseContext={}));var p;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class C{getOriginalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(w);if(B&&G){if(x?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===p.ANY)return this.getOriginalUri(B,{filterByScheme:x.filterByScheme})??this.getOriginalUri(G,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===p.PRIMARY?B:G}}if(h(w)||o(w))return;const W=y(w)?w.preferredResource:w.resource;return!W||!x||!x.filterByScheme?W:this.filterUri(W,x.filterByScheme)}getSideEditors(w){return i(w)||o(w)?{primary:w.primary,secondary:w.secondary}:g(w)||h(w)?{primary:w.modified,secondary:w.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(w);if(B&&G){if(x?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===p.ANY)return this.getCanonicalUri(B,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===p.PRIMARY?B:G}}if(h(w)||o(w))return;const W=w.resource;return!W||!x||!x.filterByScheme?W:this.filterUri(W,x.filterByScheme)}filterUri(w,x){if(Array.isArray(x)){if(x.some(W=>w.scheme===W))return w}else if(x===w.scheme)return w}}e.EditorResourceAccessor=new C;var P;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(P=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const x=this.instantiationService=w.get(R.IInstantiationService);for(const[W,B]of this.editorSerializerConstructors)this.createEditorSerializer(W,B,x);this.editorSerializerConstructors.clear()}createEditorSerializer(w,x,W){const B=W.createInstance(x);this.editorSerializerInstances.set(w,B)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,x){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,x,this.instantiationService):this.editorSerializerConstructors.set(w,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new m);async function I(L,w){if(!L||!L.length)return[];const x=await Promise.all(L.map(async W=>{const B=E.URI.revive(W.fileUri);if(!B||(await w.activateProvider(B.scheme),!w.canHandleResource(B)))return;const G=typeof W.exists=="boolean"?W.exists:await w.exists(B);if(!G&&W.openOnlyIfExists)return;const H={selection:G?W.selection:void 0,pinned:!0,override:W.editorOverrideId};let U;return G?U={resource:B,options:H}:U={resource:B,options:H,forceUntitled:!0},U}));return(0,T.coalesce)(x)}e.pathsToEditors=I;var F;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(F=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,45,132,4,6,20,28,13,51,23,34,152]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var o;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var l;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function v(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=v;function S(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=S;class _ extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(f,p,C){const P=this.get(f.id);if(P)return P;const m=f;return m.openCommandActionDescriptor=C?.donotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,k.getOrSet)(this.viewContainers,p,[]).push(m),C?.isDefault&&this.defaultViewContainers.push(m),this._onDidRegister.fire({viewContainer:m,viewContainerLocation:p}),m}deregisterViewContainer(f){for(const p of this.viewContainers.keys()){const C=this.viewContainers.get(p),P=C?.indexOf(f);if(P!==-1){C?.splice(P,1),C.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:p});return}}}get(f){return this.all.filter(p=>p.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(C=>C?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===f)}}D.Registry.add(o.ViewContainersRegistry,new _);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function c(u,f){const p=u.group??a.More,C=f.group??a.More;return p!==C?p.localeCompare(C):(u.order??5)-(f.order??5)}class y extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(f,p){this.registerViews2([{views:f,viewContainer:p}])}registerViews2(f){f.forEach(({views:p,viewContainer:C})=>this.addViews(p,C)),this._onViewsRegistered.fire(f)}deregisterViews(f,p){const C=this.removeViews(f,p);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:p})}moveViews(f,p){for(const C of this._views.keys())if(C!==p){const P=this.removeViews(f,C);P.length&&(this.addViews(P,p),this._onDidChangeContainer.fire({views:P,from:C,to:p}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const p of this._viewContainers){const C=(this._views.get(p)||[]).filter(P=>P.id===f)[0];if(C)return C}return null}getViewContainer(f){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(P=>P.id===f)[0])return p;return null}registerViewWelcomeContent(f,p){return this._viewWelcomeContents.add(f,p),this._onDidChangeViewWelcomeContent.fire(f),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,p),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,p){const C=new Map;for(const[P,m]of p)this._viewWelcomeContents.add(f,m),C.set(P,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),C}getViewWelcomeContent(f){const p=[];return this._viewWelcomeContents.forEach(f,C=>p.push(C)),p.sort(c)}addViews(f,p){let C=this._views.get(p);C||(C=[],this._views.set(p,C),this._viewContainers.push(p));for(const P of f){if(this.getView(P.id)!==null)throw new Error((0,E.localize)(1,null,P.id));C.push(P)}}removeViews(f,p){const C=this._views.get(p);if(!C)return[];const P=[],m=[];for(const I of C)f.includes(I)?P.push(I):m.push(I);return P.length&&(m.length?this._views.set(p,m):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),P}}D.Registry.add(o.ViewsRegistry,new y),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(u){return`view.${u}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var g;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(g=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(f,p){this.resolved=!1,this._hasResolve=!1,(0,b.mixin)(this,f),this._hasResolve=!!p,this.resolve=async C=>{if(p&&!this.resolved){const P=await p(C);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,T,t){const b={command:k};if(D&&Object.keys(D).length>0&&(b.arguments=D),this.internalSend("request",b),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const h=this.pendingRequests.get(b.seq);if(h){this.pendingRequests.delete(b.seq);const o={type:"response",seq:0,request_seq:b.seq,success:!1,command:k,message:(0,E.localize)(0,null,t,k)};h(o)}},t)}return T&&this.pendingRequests.set(b.seq,T),b.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,M.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,T)=>k.set(T,D)),await(0,M.timeout)(500),k.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(r,s,u){return r.replace(k,function(f,p){return s&&p.length>0&&p[0]!=="_"?f:u&&u.hasOwnProperty(p)?u[p]:f})}e.formatPII=D;function T(r){const s={};for(const u of Object.keys(r))u.startsWith("!")||(s[u]=r[u]);return s}e.filterExceptionsFromTelemetry=T;function t(r){return r.configuration.request==="attach"&&!b(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function b(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(s,"extensionhost")||(0,d.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?b(r.parentSession):void 0}e.getExtensionHostDebugSession=b;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function h(r,s,u){let f,p=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=C.exec(r);){let m=P.index+1,I=m+P[0].length;if(m<=s&&I>=u){f=P[0],p=m;break}}if(f){let m=/\w+/g,I=null;for(;(I=m.exec(f))&&!(I.index+1+p+I[0].length>=u););I&&(f=f.substring(0,m.lastIndex))}return f?{start:p,end:p+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(o))}e.isUri=l;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return M.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function S(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===R.Schemas.file?s.fsPath:s.toString()}return r.path}function _(r,s){const u=s?v:S,f=(0,A.deepClone)(r);return c(f,(p,C)=>{p&&C&&(C.path=u(C))}),f}e.convertToDAPaths=_;function a(r,s){const u=s?v:S,f=(0,A.deepClone)(r);return c(f,(p,C)=>{!p&&C&&(C.path=u(C))}),f}e.convertToVSCPaths=a;function c(r,s){switch(r.type){case"event":const u=r;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break;case"request":const f=r;switch(f.command){case"setBreakpoints":s(!0,f.arguments.source);break;case"breakpointLocations":s(!0,f.arguments.source);break;case"source":s(!0,f.arguments.source);break;case"gotoTargets":s(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(C=>s(!1,C));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(C=>s(!1,C.source));break;case"loadedSources":p.body.sources.forEach(C=>s(!1,C));break;case"scopes":p.body.scopes.forEach(C=>s(!1,C.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(C=>s(!1,C.source));break;case"setBreakpoints":p.body.breakpoints.forEach(C=>s(!1,C.source));break;default:break}break}}function y(r){return r.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):i(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:i(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=y;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function g(r,s){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const f=s.activeEditorPane;f&&await s.save({editor:f.input,groupId:f.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(be[89],Ee([0,1,27,78,11,17,25,45]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(m){m[m.Markup=1]="Markup",m[m.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(m){m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(m){m.Always="always",m.Never="never",m.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",m[m.ChangeCellMime=13]="ChangeCellMime",m[m.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata",m[m.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(m){m.scheme=E.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function F(B,G){return B.with({scheme:m.scheme,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}m.generate=F;function L(B){if(B.scheme!==m.scheme)return;const G=I.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parse=L;function w(B){if(B.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const G=I.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parseCellMetadataUri=w;function x(B,G,H){return B.with({scheme:H,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}m.generateCellUri=x;function W(B,G){if(B.scheme!==G)return;const H=I.exec(B.fragment);return H?{handle:Number(H[1]),notebook:B.with({scheme:B.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}m.parseCellUri=W})(v=e.CellUri||(e.CellUri={}));const S=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(m){return S.get(m)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function a(m){return S.get(m)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function c(m){return S.get(m)?.mergeable??!1}e.mimeTypeIsMergeable=c;function y(m,I){return R.isWindows&&(m=m.replace(/\//g,"\\"),I=I.replace(/\//g,"\\")),d.match(m,I)}function i(m,I,F){let L=0;for(let w=0;w<I.length;w++){if(y(I[w],m))return L;L++}for(let w=0;w<F.length;w++){if(y(F[w],m))return L;L++}return L}function g(m,I,F){return m.sort((L,w)=>i(L,I,F)-i(w,I,F))}e.sortMimeTypes=g;function r(m,I,F,L=(w,x)=>w===x){const w=[];function x(G,H,U){if(H===0&&U.length===0)return;const V=w[w.length-1];V&&V.start+V.deleteCount===G?(V.deleteCount+=H,V.toInsert.push(...U)):w.push({start:G,deleteCount:H,toInsert:U})}let W=0,B=0;for(;;){if(W===m.length){x(W,0,I.slice(B));break}if(B===I.length){x(W,m.length-W,[]);break}const G=m[W],H=I[B];if(L(G,H)){W+=1,B+=1;continue}F(H)?(x(W,1,[]),W+=1):(x(W,0,[H]),B+=1)}return w}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(m){m.default="default",m.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(m){const I=m;return!!((typeof I.include=="string"||d.isRelativePattern(I.include))&&(typeof I.exclude=="string"||d.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=u;function f(m,I,F){if(Array.isArray(m.viewType)&&m.viewType.indexOf(I)>=0||m.viewType===I)return!0;if(m.filenamePattern){let L=u(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,w=u(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(d.match(L,(0,A.basename)(F.fsPath).toLowerCase()))return!(w&&d.match(w,(0,A.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class p{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)I[F]=this.textModel.cells[F].getHashValue();return I}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var C;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(C=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(I){return`${P._prefix}${I}`}static parse(I){if(I.startsWith(P._prefix))return I.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,45]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(b,n)=>{n.expand!==void 0&&(b.expand=n.expand),n.item!==void 0&&(b.item=b.item?Object.assign(b.item,n.item):n.item)};e.applyTestItemUpdate=R;var k;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,h){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const h=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const l=o[1];if(l.parent){if(this.items.has(l.parent)){const v=this.items.get(l.parent);v.children.add(l.item.extId);const S=this.createItem(l,v);this.items.set(l.item.extId,S),h.add(S)}}else{const v=this.createItem(l);this.roots.add(v),this.items.set(l.item.extId,v),h.add(v)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=o[1],v=this.items.get(l.extId);if(!v)break;l.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,l),h.update(v);break}case 2:{const l=this.items.get(o[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const v=[[o[1]]];for(;v.length;)for(const S of v.pop()){const _=this.items.get(S);_&&(v.push(_.children),this.items.delete(S),h.remove(_,_!==l),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}h.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(R,k=R.length){if(this.path=R,this.viewEnd=k,R.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,k,D=R.parent){if(R.id===k)return new E([k]);let T=[R.id];for(let t=D;t&&t.id!==k;t=t.parent)T.push(t.id);return T.push(k),new E(T.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new E(R.split("\0"))}static join(R,k){return new E([...R.path,k])}static joinToString(R,k){return R.toString()+"\0"+k}static compare(R,k){return R===k?0:k.startsWith(R+"\0")?2:R.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let k=0;k<R.viewEnd&&k<this.viewEnd;k++)if(R.path[k]!==this.path[k])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,77,136]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(b,n,h){this._contributedVariables=new Map,this._context=b,this._labelService=n,h&&(this._envVariablesPromise=h.then(o=>this.prepareEnv(o)))}prepareEnv(b){if(R.isWindows){const n=Object.create(null);return Object.keys(b).forEach(h=>{n[h.toLowerCase()]=b[h]}),n}return b}resolveWithEnvironment(b,n,h){return this.recursiveResolve(this.prepareEnv(b),n?n.uri:void 0,h)}async resolveAsync(b,n){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,n)}async resolveAnyBase(b,n,h,o){const l=A.deepClone(n);return R.isWindows&&l.windows?Object.keys(l.windows).forEach(v=>l[v]=l.windows[v]):R.isMacintosh&&l.osx?Object.keys(l.osx).forEach(v=>l[v]=l.osx[v]):R.isLinux&&l.linux&&Object.keys(l.linux).forEach(v=>l[v]=l.linux[v]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,l,h,o)}async resolveAnyAsync(b,n,h){return this.resolveAnyBase(b,n,h)}async resolveAnyMap(b,n,h){const o=new Map;return{newConfig:await this.resolveAnyBase(b,n,h,o),resolvedVariables:o}}resolveWithInteractionReplace(b,n,h,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,n,h,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,n){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,n)}recursiveResolve(b,n,h,o,l){if(E.isString(h))return this.resolveString(b,n,h,o,l);if(E.isArray(h))return h.map(v=>this.recursiveResolve(b,n,v,o,l));if(E.isObject(h)){let v=Object.create(null);return Object.keys(h).forEach(S=>{const _=this.resolveString(b,n,S,o,l);v[_]=this.recursiveResolve(b,n,h[S],o,l)}),v}return h}resolveString(b,n,h,o,l){return h.replace(T.VARIABLE_REGEXP,(S,_)=>{if(_.includes(T.VARIABLE_LHS))return S;let a=this.evaluateSingleVariable(b,S,_,n,o);return l&&l.set(_,a),a!==S&&E.isString(a)&&a.match(T.VARIABLE_REGEXP)&&(a=this.resolveString(b,n,a,o,l)),a})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,n,h,o,l){let v;const S=h.split(":");S.length>1&&(h=S[0],v=S[1]);const _=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,D.localize)(0,null,n))},a=()=>{const y=_();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,D.localize)(1,null,n,d.basename(y)))},c=()=>{if(v){const y=this._context.getFolderUri(v);if(y)return y;throw new Error((0,D.localize)(2,null,n,v))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,n)):new Error((0,D.localize)(4,null,n))};switch(h){case"env":if(v){if(b){const y=b[R.isWindows?v.toLowerCase():v];if(E.isString(y))return y}return""}throw new Error((0,D.localize)(5,null,n));case"config":if(v){const y=this._context.getConfigurationValue(o,v);if(E.isUndefinedOrNull(y))throw new Error((0,D.localize)(6,null,n,v));if(E.isObject(y))throw new Error((0,D.localize)(7,null,n,v));return y}throw new Error((0,D.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,l,"command");case"input":return this.resolveFromMap(n,v,l,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return o||v?(0,k.normalizeDriveLetter)(this.fsPath(c())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(c()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,D.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,D.localize)(10,null,n));case"file":return _();case"fileWorkspaceFolder":return a();case"relativeFile":return o||v?d.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const g=d.dirname(_());if(o||v){const f=d.relative(this.fsPath(c()),g);return f.length===0?".":f}return g;case"fileDirname":return d.dirname(_());case"fileExtname":return d.extname(_());case"fileBasename":return d.basename(_());case"fileBasenameNoExtension":const r=d.basename(_());return r.slice(0,r.length-d.extname(r).length);case"fileDirnameBasename":return d.basename(d.dirname(_()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const u=this._context.getAppRoot();return u||n;case"pathSeparator":return d.sep;default:try{const f=v?`${h}:${v}`:h;return this.resolveFromMap(n,f,l,void 0)}catch(f){return n}}}}resolveFromMap(b,n,h,o){if(n&&h){const l=o===void 0?h[n]:h[o+":"+n];if(typeof l=="string")return l;throw new Error((0,D.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var k;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(l){const v=l;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=T;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(b=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function h(l){const v=l;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=h;function o(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(be[169],Ee([0,1,4,92]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const R=A;return typeof A=="number"||(0,M.isEditorGroup)(R)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,13,22,76,230,54,23,10,2,44,59,137,82,48,89,67,169,7]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(de){function pe(z){const{selectionStartLineNumber:we,selectionStartColumn:Ie,positionLineNumber:Je,positionColumn:Ue}=z,dt=new _.Position(we-1,Ie-1),gt=new _.Position(Je-1,Ue-1);return new _.Selection(dt,gt)}de.to=pe;function Y(z){const{anchor:we,active:Ie}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}de.from=Y})(a=e.Selection||(e.Selection={}));var c;(function(de){function pe(z){if(!z)return;const{start:we,end:Ie}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}de.from=pe;function Y(z){if(!z)return;const{startLineNumber:we,startColumn:Ie,endLineNumber:Je,endColumn:Ue}=z;return new _.Range(we-1,Ie-1,Je-1,Ue-1)}de.to=Y})(c=e.Range||(e.Range={}));var y;(function(de){function pe(Y){switch(Y){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 4:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}de.to=pe})(y=e.TokenType||(e.TokenType={}));var i;(function(de){function pe(z){return new _.Position(z.lineNumber-1,z.column-1)}de.to=pe;function Y(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=Y})(i=e.Position||(e.Position={}));var g;(function(de){function pe(we,Ie){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>Y(Je,Ie)))}de.from=pe;function Y(we,Ie){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,Ie),pattern:typeof we.pattern=="undefined"?void 0:ot.from(we.pattern),exclusive:we.exclusive}}function z(we,Ie){return Ie&&typeof we=="string"?Ie.transformOutgoingScheme(we):we}})(g=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(de){function pe(z){switch(z){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}de.from=pe;function Y(z){switch(z){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}de.to=Y})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(de){function pe(z){let we;return z.code&&((0,D.isString)(z.code)||(0,D.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...c.from(z.range),message:z.message,source:z.source,code:we,severity:f.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(u.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(r.from)):void 0}}de.from=pe;function Y(z){const we=new _.Diagnostic(c.to(z),z.message,f.to(z.severity));return we.source=z.source,we.code=(0,D.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(u.to),we.tags=z.tags&&(0,d.coalesce)(z.tags.map(r.to)),we}de.to=Y})(s=e.Diagnostic||(e.Diagnostic={}));var u;(function(de){function pe(z){return{...c.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=pe;function Y(z){return new _.DiagnosticRelatedInformation(new _.Location(z.resource,c.to(z)),z.message)}de.to=Y})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(de){function pe(z){switch(z){case _.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}de.from=pe;function Y(z){switch(z){case h.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}de.to=Y})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(de){function pe(z){return typeof z=="number"&&z>=_.ViewColumn.One?z-1:z===_.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}de.from=pe;function Y(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=Y})(p=e.ViewColumn||(e.ViewColumn={}));function C(de){return typeof de.range!="undefined"}function P(de){return de.length===0?!0:!!C(de[0])}e.isDecorationOptionsArr=P;var m;(function(de){function pe(Ue){return Ue.map(de.from)}de.fromMany=pe;function Y(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function z(Ue){let dt;if(Y(Ue)){const{language:ut,value:pt}=Ue;dt={value:"```"+ut+`
`+pt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Ue)?dt={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?dt={value:Ue}:dt={value:""};const gt=Object.create(null);dt.uris=gt;const lt=ut=>{try{let pt=T.URI.parse(ut,!0);pt=pt.with({query:we(pt.query,gt)}),gt[ut]=pt}catch(pt){}return""},ft=new A.Renderer;return ft.link=lt,ft.image=ut=>lt(E.parseHrefAndDimensions(ut).href),A(dt.value,{renderer:ft}),dt}de.from=z;function we(Ue,dt){if(!Ue)return Ue;let gt;try{gt=(0,R.parse)(Ue)}catch(ft){}if(!gt)return Ue;let lt=!1;return gt=(0,k.cloneAndChange)(gt,ft=>{if(T.URI.isUri(ft)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ut]=ft,lt=!0,ut}else return}),lt?JSON.stringify(gt):Ue}function Ie(Ue){const dt=new _.MarkdownString(Ue.value,Ue.supportThemeIcons);return dt.isTrusted=Ue.isTrusted,dt.supportHtml=Ue.supportHtml,dt}de.to=Ie;function Je(Ue){if(!!Ue)return typeof Ue=="string"?Ue:de.from(Ue)}de.fromStrict=Je})(m=e.MarkdownString||(e.MarkdownString={}));function I(de){return P(de)?de.map(pe=>({range:c.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?m.fromMany(pe.hoverMessage):pe.hoverMessage?m.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):de.map(pe=>({range:c.from(pe)}))}e.fromRangeOrRangeWithMessage=I;function F(de){return typeof de=="undefined"?de:typeof de=="string"?T.URI.file(de):de}e.pathOrURIToURI=F;var L;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?F(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}de.from=pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?F(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(de){function pe(Y){if(typeof Y=="undefined")return Y;switch(Y){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=pe})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(de){function pe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?x.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?w.from(Y.light):void 0,dark:Y.dark?w.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?F(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(de){function pe(z){return{text:z.newText,eol:z.newEol&&J.from(z.newEol),range:c.from(z.range)}}de.from=pe;function Y(z){const we=new _.TextEdit(c.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:J.to(z.eol),we}de.to=Y})(B=e.TextEdit||(e.TextEdit={}));var G;(function(de){function pe(z,we,Ie){const Je={edits:[]};if(z instanceof _.WorkspaceEdit)for(let Ue of z._allEntries())if(Ue._type===1)Je.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const dt=we?.getDocument(Ue.uri);Je.edits.push({_type:2,resource:Ue.uri,edit:B.from(Ue.edit),modelVersionId:dt?.version,metadata:Ue.metadata})}else Ue._type===3?Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}});return Je}de.from=pe;function Y(z){const we=new _.WorkspaceEdit;for(const Ie of z.edits)Ie.edit?we.replace(T.URI.revive(Ie.resource),c.to(Ie.edit.range),Ie.edit.text):we.renameFile(T.URI.revive(Ie.oldUri),T.URI.revive(Ie.newUri),Ie.options);return we}de.to=Y})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const pe=Object.create(null);pe[_.SymbolKind.File]=0,pe[_.SymbolKind.Module]=1,pe[_.SymbolKind.Namespace]=2,pe[_.SymbolKind.Package]=3,pe[_.SymbolKind.Class]=4,pe[_.SymbolKind.Method]=5,pe[_.SymbolKind.Property]=6,pe[_.SymbolKind.Field]=7,pe[_.SymbolKind.Constructor]=8,pe[_.SymbolKind.Enum]=9,pe[_.SymbolKind.Interface]=10,pe[_.SymbolKind.Function]=11,pe[_.SymbolKind.Variable]=12,pe[_.SymbolKind.Constant]=13,pe[_.SymbolKind.String]=14,pe[_.SymbolKind.Number]=15,pe[_.SymbolKind.Boolean]=16,pe[_.SymbolKind.Array]=17,pe[_.SymbolKind.Object]=18,pe[_.SymbolKind.Key]=19,pe[_.SymbolKind.Null]=20,pe[_.SymbolKind.EnumMember]=21,pe[_.SymbolKind.Struct]=22,pe[_.SymbolKind.Event]=23,pe[_.SymbolKind.Operator]=24,pe[_.SymbolKind.TypeParameter]=25;function Y(we){return typeof pe[we]=="number"?pe[we]:6}de.from=Y;function z(we){for(const Ie in pe)if(pe[Ie]===we)return Number(Ie);return _.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var U;(function(de){function pe(z){switch(z){case _.SymbolTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return _.SymbolTag.Deprecated}}de.to=Y})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(de){function pe(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(U.from),containerName:z.containerName,location:oe.from(z.location)}}de.from=pe;function Y(z){const we=new _.SymbolInformation(z.name,H.to(z.kind),z.containerName,oe.to(z.location));return we.tags=z.tags&&z.tags.map(U.to),we}de.to=Y})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(de){function pe(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:c.from(z.range),selectionRange:c.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(U.from)??[]};return z.children&&(we.children=z.children.map(pe)),we}de.from=pe;function Y(z){const we=new _.DocumentSymbol(z.name,z.detail,H.to(z.kind),c.to(z.range),c.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(U.to)),z.children&&(we.children=z.children.map(Y)),we}de.to=Y})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var ne;(function(de){function pe(z){const we=new _.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),c.to(z.range),c.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,Ie){if(we=we??z._sessionId,Ie=Ie??z._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:c.from(z.range),selectionRange:c.from(z.selectionRange),tags:z.tags?.map(U.from)}}de.from=Y})(ne=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(de){function pe(Y){return new _.CallHierarchyIncomingCall(ne.to(Y.from),Y.fromRanges.map(z=>c.to(z)))}de.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(de){function pe(Y){return new _.CallHierarchyOutgoingCall(ne.to(Y.to),Y.fromRanges.map(z=>c.to(z)))}de.to=pe})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var oe;(function(de){function pe(z){return{range:z.range&&c.from(z.range),uri:z.uri}}de.from=pe;function Y(z){return new _.Location(T.URI.revive(z.uri),c.to(z.range))}de.to=Y})(oe=e.location||(e.location={}));var ve;(function(de){function pe(z){const we=z,Ie=z;return{originSelectionRange:we.originSelectionRange?c.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Ie.uri,range:c.from(we.targetRange?we.targetRange:Ie.range),targetSelectionRange:we.targetSelectionRange?c.from(we.targetSelectionRange):void 0}}de.from=pe;function Y(z){return{targetUri:T.URI.revive(z.uri),targetRange:c.to(z.range),targetSelectionRange:z.targetSelectionRange?c.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?c.to(z.originSelectionRange):void 0}}de.to=Y})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Ae;(function(de){function pe(z){return{range:c.from(z.range),contents:m.fromMany(z.contents)}}de.from=pe;function Y(z){return new _.Hover(z.contents.map(m.to),c.to(z.range))}de.to=Y})(Ae=e.Hover||(e.Hover={}));var Se;(function(de){function pe(z){return{range:c.from(z.range),expression:z.expression}}de.from=pe;function Y(z){return new _.EvaluatableExpression(c.to(z.range),z.expression)}de.to=Y})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(de){function pe(z){if(z instanceof _.InlineValueText)return{type:"text",range:c.from(z.range),text:z.text};if(z instanceof _.InlineValueVariableLookup)return{type:"variable",range:c.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=pe;function Y(z){switch(z.type){case"text":return{range:c.to(z.range),text:z.text};case"variable":return{range:c.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:c.to(z.range),expression:z.expression}}}de.to=Y})(Ne=e.InlineValue||(e.InlineValue={}));var We;(function(de){function pe(z){return{frameId:z.frameId,stoppedLocation:c.from(z.stoppedLocation)}}de.from=pe;function Y(z){return new _.InlineValueContext(z.frameId,c.to(z.stoppedLocation))}de.to=Y})(We=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function pe(z){return{range:c.from(z.range),kind:z.kind}}de.from=pe;function Y(z){return new _.DocumentHighlight(c.to(z.range),z.kind)}de.to=Y})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(de){function pe(Y){switch(Y){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}de.to=pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(de){function pe(Y){return{triggerKind:qe.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}de.to=pe})($=e.CompletionContext||(e.CompletionContext={}));var K;(function(de){function pe(z){switch(z){case _.CompletionItemTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return _.CompletionItemTag.Deprecated}}de.to=Y})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(de){const pe=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function Y(Ie){return pe.get(Ie)??9}de.from=Y;const z=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function we(Ie){return z.get(Ie)??_.CompletionItemKind.Property}de.to=we})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function pe(Y,z){const we=new _.CompletionItem(Y.label);return we.insertText=Y.insertText,we.kind=ee.to(Y.kind),we.tags=Y.tags?.map(K.to),we.detail=Y.detail,we.documentation=E.isMarkdownString(Y.documentation)?m.to(Y.documentation):Y.documentation,we.sortText=Y.sortText,we.filterText=Y.filterText,we.preselect=Y.preselect,we.commitCharacters=Y.commitCharacters,t.Range.isIRange(Y.range)?we.range=c.to(Y.range):typeof Y.range=="object"&&(we.range={inserting:c.to(Y.range.insert),replacing:c.to(Y.range.replace)}),we.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?we.insertText=new _.SnippetString(Y.insertText):(we.insertText=Y.insertText,we.textEdit=we.range instanceof _.Range?new _.TextEdit(we.range,we.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(we.additionalTextEdits=Y.additionalTextEdits.map(Ie=>B.to(Ie))),we.command=z&&Y.command?z.fromInternal(Y.command):void 0,we}de.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?m.fromStrict(z.documentation):void 0}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?m.to(z.documentation):z.documentation}}de.to=Y})(q=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?m.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(q.from):[],activeParameter:z.activeParameter}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?m.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(q.to):[],activeParameter:z.activeParameter}}de.to=Y})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function pe(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.from):[]}}de.from=pe;function Y(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.to):[]}}de.to=Y})(he=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(de){function pe(z){return{text:z.text,position:i.from(z.position),kind:Be.from(z.kind??_.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=pe;function Y(z){const we=new _.InlayHint(z.text,i.to(z.position),Be.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=Y})(Re=e.InlayHint||(e.InlayHint={}));var Be;(function(de){function pe(z){return z}de.from=pe;function Y(z){return z}de.to=Y})(Be=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(de){function pe(z){return{range:c.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=pe;function Y(z){let we;if(z.url)try{we=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(Ie){}return new _.DocumentLink(c.to(z.range),we)}de.to=Y})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function pe(z){const we=new _.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=B.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(Ie=>B.to(Ie))),we}de.to=pe;function Y(z){return{label:z.label,textEdit:z.textEdit?B.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>B.from(we)):void 0}}de.from=Y})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(de){function pe(z){return new _.Color(z[0],z[1],z[2],z[3])}de.to=pe;function Y(z){return[z.red,z.green,z.blue,z.alpha]}de.from=Y})(it=e.Color||(e.Color={}));var ke;(function(de){function pe(z){return{range:c.from(z.range)}}de.from=pe;function Y(z){return new _.SelectionRange(c.to(z.range))}de.to=Y})(ke=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(de){function pe(Y){switch(Y){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}de.to=pe})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(de){function pe(z){switch(z){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}de.from=pe;function Y(z){switch(z){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}de.to=Y})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(de){function pe(z){if(z===_.EndOfLine.CRLF)return 1;if(z===_.EndOfLine.LF)return 0}de.from=pe;function Y(z){if(z===1)return _.EndOfLine.CRLF;if(z===0)return _.EndOfLine.LF}de.to=Y})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(de){function pe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var He;(function(de){function pe(Y){const z={start:Y.start+1,end:Y.end+1};return Y.kind&&(z.kind=Ye.from(Y.kind)),z}de.from=pe})(He=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(de){function pe(Y){if(Y)switch(Y){case _.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}de.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(de){function pe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?c.from(Y.selection):void 0,override:typeof Y.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=pe})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ot;(function(de){function pe(z){return z instanceof _.RelativePattern||typeof z=="string"?z:Y(z)?new _.RelativePattern(z.base,z.pattern):z}de.from=pe;function Y(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(ot=e.GlobPattern||(e.GlobPattern={}));var Et;(function(de){function pe(Y){if(Y){if(Array.isArray(Y))return Y.map(pe);if(typeof Y=="string")return Y;{const z=Y;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:ot.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=pe})(Et=e.LanguageSelector||(e.LanguageSelector={}));var mt;(function(de){function pe(z){return{start:z.start,end:z.end}}de.from=pe;function Y(z){return new _.NotebookRange(z.start,z.end)}de.to=Y})(mt=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(de){function pe(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=pe;function Y(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=Y})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Pt;(function(de){function pe(z){switch(z){case _.NotebookCellKind.Markup:return l.CellKind.Markup;case _.NotebookCellKind.Code:default:return l.CellKind.Code}}de.from=pe;function Y(z){switch(z){case l.CellKind.Markup:return _.NotebookCellKind.Markup;case l.CellKind.Code:default:return _.NotebookCellKind.Code}}de.to=Y})(Pt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function pe(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let Ie of z.cells)_.NotebookCellData.validate(Ie),we.cells.push(Xe.from(Ie));return we}de.from=pe;function Y(z){const we=new _.NotebookData(z.cells.map(Xe.to));return(0,D.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=Y})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function pe(z){return{cellKind:Pt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Dt.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Te.from):[]}}de.from=pe;function Y(z){return new _.NotebookCellData(Pt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Te.to):void 0,z.metadata,z.internalMetadata?Dt.to(z.internalMetadata):void 0)}de.to=Y})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(de){function pe(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=pe;function Y(z){return new _.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=Y})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(de){function pe(z){return{outputId:z.id,items:z.items.map(St.from),metadata:z.metadata}}de.from=pe;function Y(z){const we=z.items.map(St.to);return new _.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=Y})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(de){function pe(Ie){if(Ie!=null){if(Ie instanceof _.RelativePattern||typeof Ie=="string")return Ie;if(we(Ie))return new _.RelativePattern(Ie.base,Ie.pattern);if(z(Ie))return{include:ot.from(Ie.include)||void 0,exclude:ot.from(Ie.exclude)||void 0}}}de.from=pe;function Y(Ie){return typeof Ie=="string"?Ie:we(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}de.to=Y;function z(Ie){const Je=Ie,Ue=ot.from(Je.include);if(!(Ue&&Ue instanceof _.RelativePattern||typeof Ue=="string"))return!1;const dt=ot.from(Je.exclude);return!!(dt&&dt instanceof _.RelativePattern||typeof dt=="string")}function we(Ie){const Je=Ie;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function pe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?L.from(Y.top):void 0}}de.from=pe})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(de){function pe(Y,z,we){const Ie=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Ie,we),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}de.from=pe})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var le;(function(de){function pe(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}de.from=pe})(le=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ge;(function(de){function pe(z){return{uri:z.uri,provides:z.provides}}de.from=pe;function Y(z){return new _.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}de.to=Y})(ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function pe(z){return{message:m.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?oe.from(z.location):void 0}}de.from=pe;function Y(z){const we=new _.TestMessage(typeof z.message=="string"?z.message:m.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?oe.to(z.location):void 0,we}de.to=Y})(fe=e.TestMessage||(e.TestMessage={}));var Pe;(function(de){let pe;(function(Y){Y.Delimiter="\0"})(pe||(pe={})),de.namespace=(Y,z)=>Y+"\0"+z,de.denamespace=Y=>{const z=Y.indexOf("\0");return{ctrlId:Y.slice(0,z),tagId:Y.slice(z+1)}}})(Pe=e.TestTag||(e.TestTag={}));var xe;(function(de){function pe(Ie){const Je=(0,o.getPrivateApiFor)(Ie).controllerId;return{extId:v.TestId.fromExtHostTestItem(Ie,Je).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(Ue=>Pe.namespace(Je,Ue.id)),range:c.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&m.fromStrict(Ie.error)||null}}de.from=pe;function Y(Ie){return{id:v.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:T.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Je=>{const{tagId:Ue}=Pe.denamespace(Je);return new _.TestTag(Ue)}),range:c.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}de.toPlain=Y;function z(Ie){const Je=v.TestId.fromString(Ie.extId),Ue=new o.TestItemImpl(Je.controllerId,Je.localId,Ie.label,T.URI.revive(Ie.uri));return Ue.range=c.to(Ie.range||void 0),Ue.description=Ie.description||void 0,Ue}function we(Ie){let Je;for(const Ue of Ie.tests){const dt=z(Ue.item);(0,o.getPrivateApiFor)(dt).parent=Je,Je=dt}return Je}de.toItemFromContext=we})(xe=e.TestItem||(e.TestItem={})),function(de){function pe(z){return{id:z.id}}de.from=pe;function Y(z){return new _.TestTag(z.id)}de.to=Y}(Pe=e.TestTag||(e.TestTag={}));var Oe;(function(de){const pe=(z,we)=>{const Ie={...xe.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ue=>Ue.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(D.isDefined).map(Je=>pe(Je,we))};for(const Je of Ie.children)Je.parent=Ie;return Ie};function Y(z){const we=[],Ie=new Map;for(const Je of z.items)Ie.set(Je.item.extId,Je),z.request.targets.some(Ue=>Ue.controllerId===Je.controllerId&&Ue.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>pe(Je,Ie))}}de.to=Y})(Oe=e.TestResults||(e.TestResults={}));var Ke;(function(de){function pe(Ie){return{covered:Ie.covered,total:Ie.covered}}function Y(Ie){return"line"in Ie?i.from(Ie):c.from(Ie)}function z(Ie){return"branches"in Ie?{count:Ie.executionCount,location:Y(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Y(Je.location)})):void 0}:{type:0,count:Ie.executionCount,location:Y(Ie.location)}}de.fromDetailed=z;function we(Ie){return{uri:Ie.uri,statement:pe(Ie.statementCoverage),branch:Ie.branchCoverage&&pe(Ie.branchCoverage),function:Ie.functionCoverage&&pe(Ie.functionCoverage),details:Ie.detailedCoverage?.map(z)}}de.fromFile=we})(Ke=e.TestCoverage||(e.TestCoverage={}));var tt;(function(de){function pe(Y){switch(Y){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}de.to=pe})(tt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function pe(z){const we=new _.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),c.to(z.range),c.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,Ie){if(we=we??z._sessionId,Ie=Ie??z._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:c.from(z.range),selectionRange:c.from(z.selectionRange),tags:z.tags?.map(U.from)}}de.from=Y})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(T,t,b,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=b,this._thresholds=n,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,b,n)=>{const o={dispose:this._callbacks.push([t,b,T])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(T,t){const b=d.URI.revive(T);let n=!1;const h=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let l of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(b),S=await this._deliverEventAsyncAndBlameBadListeners(l,{document:v,reason:A.TextDocumentSaveReason.to(t)});o.push(S)}}finally{clearTimeout(h)}return o}_deliverEventAsyncAndBlameBadListeners([T,t,b],n){const h=this._badListeners.get(T);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,T,t,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const l=this._badListeners.get(T);this._badListeners.set(T,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,b,n){const h=[],o=Date.now(),{document:l,reason:v}=n,{version:S}=l,_=Object.freeze({document:l,reason:v,waitUntil(a){if(Object.isFrozen(h))throw(0,M.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(a))}});try{t.apply(b,[_])}catch(a){return Promise.reject(a)}return Object.freeze(h),new Promise((a,c)=>{const y=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(y),a(i)}).catch(i=>{clearTimeout(y),c(i)})}).then(a=>{const c={edits:[]};for(const y of a)if(Array.isArray(y)&&y.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:g,range:r}of y)c.edits.push({_type:2,resource:l.uri,edit:{range:r&&A.Range.from(r),text:i,eol:g&&A.EndOfLine.from(g)}});if(c.edits.length!==0)return S===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[171],Ee([0,1,3,27,2,8,7]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(t,b,n,h,o){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),h&&(this._config+=2),o&&(this._config+=4);const l=(0,M.parse)(b),v=t(S=>{if(!n)for(let _ of S.created){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidCreate.fire(a)}if(!h)for(let _ of S.changed){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidChange.fire(a)}if(!o)for(let _ of S.deleted){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(t,b,n){this._logService=b,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,b,n,h){return new k(this._onFileSystemEvent.event,t,b,n,h)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,b){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,b){return(n,h,o)=>{const l=function(S){n.call(h,S)};return l.extension=t,b.event(l,void 0,o)}}async $onWillRunFileOperation(t,b,n,h){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(o=>({oldUri:E.URI.revive(o.source),newUri:E.URI.revive(o.target)}))},n,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(o=>E.URI.revive(o.target))},n,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(o=>E.URI.revive(o.target))},n,h)}}async _fireWillEvent(t,b,n,h){const o=new Set,l=[];if(await t.fireAsync(b,h,async(S,_)=>{const a=Date.now(),c=await Promise.resolve(S);c instanceof R.WorkspaceEdit&&(l.push(c),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-a>n&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),h.isCancellationRequested||l.length===0)return;const v={edits:[]};for(let S of l){let{edits:_}=A.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(_)}return{edit:v,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=D}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(n,h,o,l){this.start=n,this.deletedCount=h,this.deletedItems=o,this.items=l}static asApiEvents(n){return n.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(o=>o.apiCell)}))}}class T{constructor(n,h,o){this.notebook=n,this._extHostDocument=h,this._cellData=o,this.handle=o.handle,this.uri=E.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,h,o){const l=o.map(A.NotebookCellOutputItem.to),v=this._outputs.find(S=>S.id===n);v&&(h||(v.items.length=0),v.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,h,o,l,v,S){this._proxy=n,this._textDocumentsAndEditors=h,this._textDocuments=o,this._emitter=l,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=S.viewType,this._metadata=Object.freeze(S.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,S.cells]],!0),this._versionId=S.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(h){return h=n._validateIndex(h),n._cells[h].apiCell},getCells(h){return(h?n._getCells(h):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,h){this._versionId=n.versionId,this._isDirty=h;for(const o of n.rawEvents)o.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===k.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let h=n.start|0,o=n.end|0;return h<0&&(h=0),o>this._cells.length&&(o=this._cells.length),n.with({start:h,end:o})}_getCells(n){n=this._validateRange(n);const h=[];for(let o=n.start;o<n.end;o++)h.push(this._cells[o]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,h){if(this._disposed)return;const o=[],l=[],v=[];n.reverse().forEach(S=>{const a=S[2].map(i=>{const g=new T(this,this._textDocumentsAndEditors,i);return h||l.push(T.asModelAddData(this.apiNotebook,i)),g}),c=new D(S[0],S[1],[],a),y=this._cells.splice(S[0],S[1],...a);for(const i of y)v.push(i.uri),c.deletedItems.push(i.apiCell);o.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:v}),h||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(o)}))}_moveCell(n,h){const o=this._cells.splice(n,1);this._cells.splice(h,0,...o);const l=[new D(n,1,o.map(v=>v.apiCell),[]),new D(h,0,[],o)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_setCellOutputs(n,h){const o=this._cells[n];o.setOutputs(h),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,h,o,l){const v=this._cells[n];v.setOutputItems(h,o,l),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,h){const o=this._cells[n];o.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(o.uri,h)}_changeCellMime(n,h){const o=this._cells[n];o.apiCell.mime=h}_changeCellMetadata(n,h){const o=this._cells[n],l=o.apiCell.metadata;o.setMetadata(h);const v=o.apiCell.metadata;(0,M.equals)(l,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,h){const o=this._cells[n],l=o.internalMetadata;if(o.setInternalMetadata(h),l.runState!==h.runState){const v=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(h=>h.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(h=>h.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,t){this._throwIfFinalized(),!(D===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:t.map(M.NotebookCellData.from)})}}class R{constructor(D,T,t,b,n,h){this.id=D,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=b,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,t){D._proxy.$tryRevealRange(D.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const t=new A(this.document.version);return T(t),D._applyEdit(t.finalize())},setDecorations(T,t){return D.setDecorations(T,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(M.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let b=0;b<D.cellEdits.length;b++){if(t<0){T.push(D.cellEdits[b]),t++;continue}const h=T[t],o=D.cellEdits[b];if(h.editType===1&&o.editType===1&&h.index===o.index){h.cells.push(...D.cellEdits[b].cells),h.count+=D.cellEdits[b].count;continue}T.push(D.cellEdits[b]),t++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,147,126,21,52]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}withProgress(b,n,h){const o=this._handles++,{title:l,location:v,cancellable:S}=n,_={label:(0,E.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(o,{location:d.ProgressLocation.from(v),title:l,source:_,cancellable:S},b),this._withProgress(o,h,!!S)}_withProgress(b,n,h){let o;h&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,o));const l=S=>{this._proxy.$progressEnd(S),this._mapHandleToCancellationSource.delete(S),o&&o.dispose()};let v;try{v=n(new T(this._proxy,b),h&&o?o.token:A.CancellationToken.None)}catch(S){throw l(b),S}return v.then(S=>l(b),S=>l(b)),v}$acceptProgressCanceled(b){const n=this._mapHandleToCancellationSource.get(b);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=k;function D(t,b){return t.message=b.message,typeof b.increment=="number"&&(typeof t.increment=="number"?t.increment+=b.increment:t.increment=b.increment),t}class T extends M.Progress{constructor(b,n){super(h=>this.throttledReport(h));this._proxy=b,this._handle=n}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}$e([(0,R.throttle)(100,(t,b)=>D(t,b),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,53,8,7]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(n,h,o){const l=k._Keys.nextId();n.$registerTextEditorDecorationType(h.identifier,l,A.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=k,k._Keys=new E.IdGenerator("TextEditorDecorationType");class D{constructor(n,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,h){this._throwIfFinalized();let o=null;if(n instanceof R.Position)o=new R.Range(n,n);else if(n instanceof R.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,h,!1)}insert(n,h){this._throwIfFinalized(),this._pushEdit(new R.Range(n,n),h,!0)}delete(n){this._throwIfFinalized();let h=null;if(n instanceof R.Range)h=n;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(n,h,o){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:h,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==R.EndOfLine.LF&&n!==R.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=D;class T{constructor(n,h,o,l){this._proxy=n,this._id=h,this._accept(o),this._logService=l;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(S){v._setTabSize(S)},get insertSpaces(){return v._insertSpaces},set insertSpaces(S){v._setInsertSpaces(S)},get cursorStyle(){return v._cursorStyle},set cursorStyle(S){v._setCursorStyle(S)},get lineNumbers(){return v._lineNumbers},set lineNumbers(S){v._setLineNumbers(S)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const h=Math.floor(n);return h>0?h:null}if(typeof n=="string"){const h=parseInt(n,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(n){const h=this._validateTabSize(n);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const h=this._validateInsertSpaces(n);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const h={};let o=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(o=!0,h.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,o=!0,h.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(o=!0,h.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,o=!0,h.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,h.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(n){n.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,h,o,l,v,S,_,a){this.id=n,this._proxy=h,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new T(this._proxy,this.id,S,o),this._visibleRanges=_,this._viewColumn=a;const c=this;this.value=Object.freeze({get document(){return l.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(y){if(!(y instanceof R.Selection))throw(0,M.illegalArgument)("selection");c._selections=[y],c._trySetSelection()},get selections(){return c._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof R.Selection)))throw(0,M.illegalArgument)("selections");c._selections=y,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return c._options.value},set options(y){c._disposed||c._options.assign(y)},get viewColumn(){return c._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new D(l.getValue(),i);return y(g),c._applyEdit(g)},insertSnippet(y,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=c._selections.map(s=>A.Range.from(s));else if(i instanceof R.Position){const{lineNumber:s,column:u}=A.Position.from(i);r=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(i instanceof R.Range)r=[A.Range.from(i)];else{r=[];for(const s of i)if(s instanceof R.Range)r.push(A.Range.from(s));else{const{lineNumber:u,column:f}=A.Position.from(s);r.push({startLineNumber:u,startColumn:f,endLineNumber:u,endColumn:f})}}return h.$tryInsertSnippet(n,y.value,r,g)},setDecorations(y,i){const g=i.length===0;g&&!c._hasDecorationsForKey.has(y.key)||(g?c._hasDecorationsForKey.delete(y.key):c._hasDecorationsForKey.add(y.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return h.$trySetDecorations(n,y.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,u=i.length;s<u;s++){const f=i[s];r[4*s]=f.start.line+1,r[4*s+1]=f.start.character+1,r[4*s+2]=f.end.line+1,r[4*s+3]=f.end.character+1}return h.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,i){c._runOnProxy(()=>h.$tryRevealRange(n,A.Range.from(y),i||R.TextEditorRevealType.Default))},show(y){h.$tryShowEditor(n,A.ViewColumn.from(y))},hide(){h.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const h=n.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const o=h.edits.map(v=>v.range);o.sort((v,S)=>v.end.line===S.end.line?v.end.character===S.end.character?v.start.line===S.start.line?v.start.character-S.start.character:v.start.line-S.start.line:v.end.character-S.end.character:v.end.line-S.end.line);for(let v=0,S=o.length-1;v<S;v++){const _=o[v].end;if(o[v+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=h.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,l,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(_,a){if((0,t.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let c;return Array.isArray(_.highlights)&&(c=_.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),c=c.length?c:void 0),{label:_.label,highlights:c}}}class v{constructor(a,c,y){this._proxy=a,this.commands=c,this.logService=y,this.treeViews=new Map;function i(g){return g&&g.$treeViewId&&g.$treeItemHandle}c.registerArgumentProcessor({processArgument:g=>i(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(r=>i(r)?this.convertArgument(r):r):g})}registerTreeDataProvider(a,c,y){const i=this.createTreeView(a,{treeDataProvider:c},y);return{dispose:()=>i.dispose()}}createTreeView(a,c,y){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=c.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(a,c,y);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,u)=>r.reveal(s,u),dispose:async()=>{await g,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,c){const y=this.treeViews.get(a);return y?y.getChildren(c):Promise.reject(new Error((0,d.localize)(0,null,a)))}async $onDrop(a,c,y){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,a)));const g=o.TreeDataTransferConverter.toITreeDataTransfer(c);if(g.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await g.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>i.getExtensionElement(u)).filter(u=>!!u);s.length>0?g.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):g.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(g,y)}async $hasResolve(a){const c=this.treeViews.get(a);if(!c)throw new Error((0,d.localize)(2,null,a));return c.hasResolve}$resolve(a,c,y){const i=this.treeViews.get(a);if(!i)throw new Error((0,d.localize)(3,null,a));return i.resolveTreeItem(c,y)}$setExpanded(a,c,y){const i=this.treeViews.get(a);if(!i)throw new Error((0,d.localize)(4,null,a));i.setExpanded(c,y)}$setSelection(a,c){const y=this.treeViews.get(a);if(!y)throw new Error((0,d.localize)(5,null,a));y.setSelection(c)}$setVisible(a,c){const y=this.treeViews.get(a);if(!y)throw new Error((0,d.localize)(6,null,a));y.setVisible(c)}createExtHostTreeView(a,c,y){const i=new S(a,c,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(a,i),i}convertArgument(a){const c=this.treeViews.get(a.$treeViewId);return c?c.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class S extends R.Disposable{constructor(a,c,y,i,g,r){super();if(this.viewId=a,this.proxy=y,this.commands=i,this.logService=g,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,r.contributes&&r.contributes.views)for(const f in r.contributes.views)for(const p of r.contributes.views[f])p.id===a&&(this._title=p.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let s,u;this._register(A.Event.debounce(this._onDidChangeData.event,(f,p)=>(f||(f={message:!1,elements:[]}),p.element!==!1&&(s||(s=new Promise(C=>u=C),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(p.element)?f.elements.push(...p.element):f.elements.push(p.element)),p.message&&(f.message=!0),f),200,!0)(({message:f,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=u;return s=null,this.refresh(p).then(()=>C())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,t.isUndefinedOrNull)(a))}async getChildren(a){const c=a?this.getExtensionElement(a):void 0;if(a&&!c)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(a);return y||(y=await this.fetchChildrenNodes(c)),y?y.map(i=>i.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,c){c=c||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(c.select)?!0:c.select,i=(0,t.isUndefinedOrNull)(c.focus)?!1:c.focus,g=(0,t.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(u=>u.item)},{select:y,focus:i,expand:g})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:g})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,c){const y=this.getExtensionElement(a);y&&(c?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(a){(0,b.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,c){const y=this.getExtensionElement(c);if(!!y)return(0,D.asPromise)(()=>this.dndController?.onDrop(a,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,c){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(a);if(y){const i=this.nodes.get(y);if(i){const g=await this.dataProvider.resolveTreeItem(i.extensionItem,y,c)??i.extensionItem;return i.item.tooltip=this.getTooltip(g.tooltip),i.item.command=this.getCommand(i.disposableStore,g.command),i.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(c=>c?this.resolveUnknownParentChain(c).then(y=>this.resolveTreeNode(c,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(a){const c=this.nodes.get(a);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,c){const y=this.nodes.get(a);return y?Promise.resolve(y):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(i=>this.createHandle(a,i,c,!0)).then(i=>this.getChildren(c?c.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const r=this.nodes.get(g);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(a){if(a){let c;if(typeof a=="string"){const y=this.getExtensionElement(a);c=y?this.nodes.get(y):void 0}else c=a;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const c=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=a?this.nodes.get(a):void 0,i=await this.dataProvider.getChildren(a);if(c.token.isCancellationRequested)return;const g=await Promise.all((0,b.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,y):null}));return c.token.isCancellationRequested?void 0:(0,b.coalesce)(g)}finally{c.dispose()}}refresh(a){if(a.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(a);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const c=new Set,y=a.map(g=>this.nodes.get(g));for(const g of y)if(g&&!c.has(g.item.handle)){let r=g;for(;r&&r.parent&&y.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&c.add(g.item.handle)}const i=[];return c.forEach(g=>{const r=this.elements.get(g);if(r){const s=this.nodes.get(r);s&&(!s.parent||!c.has(s.parent.item.handle))&&i.push(g)}}),i}refreshHandles(a){const c={};return Promise.all(a.map(y=>this.refreshNode(y).then(i=>{i&&(c[y]=i.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(a){const c=this.getExtensionElement(a);if(c){const y=this.nodes.get(c);if(y)return this.clearChildren(c),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(i=>{if(i){const g=this.createTreeNode(c,i,y.parent);return this.updateNodeCache(c,g,y,y.parent),y.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,c,y){const i=this.createTreeNode(a,c,y);if(c.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,c.id));return this.addNodeToCache(a,i),this.addNodeToParentCache(i,y),i}getTooltip(a){return T.MarkdownString.isMarkdownString(a)?n.MarkdownString.from(a):a}getCommand(a,c){return c?this.commands.toInternal(c,a):void 0}createTreeNode(a,c,y){const i=new R.DisposableStore,g=this.createHandle(a,c,y),r=this.getLightIconPath(c);return{item:{handle:g,parentHandle:y?y.item.handle:void 0,label:l(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(i,c.command),contextValue:c.contextValue,icon:r,iconDark:this.getDarkIconPath(c)||r,themeIcon:this.getThemeIcon(c),collapsibleState:(0,t.isUndefinedOrNull)(c.collapsibleState)?T.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(a){return a.iconPath instanceof T.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:c,label:y,resourceUri:i},g,r){if(c)return`${S.ID_HANDLE_PREFIX}/${c}`;const s=l(y,this.extension),u=g?g.item.handle:S.LABEL_HANDLE_PREFIX;let f=s?s.label:i?(0,M.basename)(i):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,C=this.getChildrenNodes(g)||[];let P,m=0;do{if(P=`${u}/${m}:${f}`,r||!this.elements.has(P)||p===P)break;m++}while(m<=C.length);return P}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon))return typeof a.iconPath=="string"||E.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof T.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return E.URI.isUri(a)?a:E.URI.file(a)}addNodeToCache(a,c){this.elements.set(c.item.handle,a),this.nodes.set(a,c)}updateNodeCache(a,c,y,i){this.elements.delete(c.item.handle),this.nodes.delete(a),c.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(a,c);const g=this.getChildrenNodes(i)||[],r=g.filter(s=>s.item.handle===y.item.handle)[0];r&&g.splice(g.indexOf(r),1,c)}addNodeToParentCache(a,c){c?(c.children||(c.children=[]),c.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const c=this.nodes.get(a);if(c){if(c.children)for(const y of c.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}c.children=void 0}}else this.clearAll()}clear(a){const c=this.nodes.get(a);if(c){if(c.children)for(const y of c.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(a),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,48,8,90,67]),function(re,e,d,M,E,A,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const h=this.diff[this.diff.length-1];if(h&&n[0]===1){if(h[0]===1&&h[1].extId===n[1].extId){(0,D.applyTestItemUpdate)(h[1],n[1]);return}if(h[0]===0&&h[1].item.extId===n[1].extId){(0,D.applyTestItemUpdate)(h[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,h){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||h>o.expandLevels)&&(o.expandLevels=h),o.expand===1){const l=this.resolveChildren(o);return l.isOpen()?this.expandChildren(o,h-1):l.wait().then(()=>this.expandChildren(o,h-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,h-1)):this.expandChildren(o,h-1)}}dispose(){for(const n of this.tree.values())(0,R.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,h){switch(h.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,h.id));break;case 0:this.upsertItem(h.item,n);break;case 4:for(const _ of h.ops)this.onTestItemEvent(n,_);break;case 3:const{key:o,value:l,previous:v}=h,S=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,v,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:k.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:k.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[o]:l??null}}]);break}break;default:(0,A.assertNever)(h)}}upsertItem(n,h){if(!(n instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=T.TestId.fromExtHostTestItem(n,this.root.id,h?.actual),l=(0,R.getPrivateApiFor)(n);l.parent&&l.parent!==h?.actual&&l.parent.children.delete(n.id);let v=this.tree.get(o.toString());if(!v){v={fullId:o,actual:n,parent:h?o.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,h),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:k.TestItem.from(n)}]),this.connectItemAndChildren(n,v,h);return}if(v.actual===n){this.connectItem(n,v,h);return}const S=v.actual.children,_=v.actual,a=(0,R.diffTestItems)(_,n);(0,R.getPrivateApiFor)(_).listener=void 0,v.actual=n,v.expand=0;for(const[c,y]of a)this.onTestItemEvent(v,{op:3,key:c,value:y,previous:_[c]});this.connectItemAndChildren(n,v,h);for(const c of S)n.children.get(c.id)||this.removeItem(T.TestId.joinToString(o,c.id))}diffTagRefs(n,h,o){const l=new Set(h.map(v=>v.id));for(const v of n)l.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:o,item:{tags:n.map(v=>k.TestTag.namespace(this.controllerId,v.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const h=this.tags.get(n.id);h?h.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const h=this.tags.get(n);h&&!--h.refCount&&(this.tags.delete(n),this.pushDiff([6,k.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,h){(0,R.getPrivateApiFor)(n).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(n,h,o){this.setItemParent(n,o);const l=(0,R.getPrivateApiFor)(n);l.parent=o?.actual,l.listener=v=>this.onTestItemEvent(h,v),this.updateExpandability(h)}connectItemAndChildren(n,h,o){this.connectItem(n,h,o);for(const l of n.children)this.upsertItem(l,h)}updateExpandability(n){let h;this._resolveHandler?n.resolveBarrier?h=n.resolveBarrier.isOpen()?3:2:h=n.actual.canResolveChildren?1:0:h=0,h!==n.expand&&(n.expand=h,this.pushDiff([1,{extId:n.fullId.toString(),expand:h}]),h===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,h){if(h<0)return;const o=[];for(const l of n.actual.children){const v=this.expand(T.TestId.joinToString(n.fullId,l.id),h);(0,d.isThenable)(v)&&o.push(v)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new d.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const h=n.resolveBarrier=new d.Barrier,o=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){o(v)}return(0,d.isThenable)(l)?l.catch(o).then(()=>{h.open(),this.updateExpandability(n)}):(h.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const h=this.tree.get(n);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[h];for(;o.length;){const l=o.pop();if(!!l){(0,R.getPrivateApiFor)(l.actual).listener=void 0;for(const v of l.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(l.fullId.toString());for(const v of l.actual.children)o.push(this.tree.get(T.TestId.joinToString(l.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let b of t.activationEvents)b==="onUri"&&(b=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(t)}}keepOnly(t){const b=new Set;t.forEach(n=>b.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>b.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,b){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=R._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(n.map(h=>h.identifier)),b.length>0){const h=new Set;b.forEach(o=>h.add(d.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!h.has(d.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,S){this.addNode(v),this.addNode(S),this._arcs.has(v)?this._arcs.get(v).push(S):this._arcs.set(v,[S])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,S){const _=b.getArcs(v);for(let a=0;a<_.length;a++)if(!S.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const S=d.ExtensionIdentifier.toKey(v.identifier);if(n.set(S,v),v.extensionDependencies)for(let _ of v.extensionDependencies){const a=d.ExtensionIdentifier.toKey(_);b.addArc(S,a)}}let h=new Set;b.getNodes().filter(v=>b.getArcs(v).length===0).forEach(v=>h.add(v));let o=b.getNodes().filter(v=>!h.has(v)),l;do{l=!1;for(let v=0;v<o.length;v++){const S=o[v];b.hasOnlyGoodArcs(S,h)&&(o.splice(v,1),v--,h.add(S),l=!0)}}while(l);return o.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const b=this._activationMap.get(t);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const b=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return b||void 0}}e.ExtensionDescriptionRegistry=R;var k;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(k||(k={}));function D(T,t){const b=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(b!==n)return b-n;const h=E.posix.basename(T.extensionLocation.path),o=E.posix.basename(t.extensionLocation.path);return h<o?-1:h>o?1:0}}),define(be[178],Ee([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(k){const D=d.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function R(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(be[30],Ee([0,1,3,2,4,26,143]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var k;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(y){this.dependency=y}}e.MissingExtensionDependency=T;var t;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;class n{constructor(y,i,g,r){this.codeLoadingTime=y,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=r}}e.ActivationTimes=n;class h{constructor(y,i){this.description=y,this.value=i}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function l(c){c.enableProposedApi||v(c)}e.checkProposedApiEnabled=l;function v(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=v;function S(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=S;function _(c,y){return{identifier:new A.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!y,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=_;class a{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,i){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,i,g,r,s){}_onDidActivateExtensionError(y,i){}_onExtensionRuntimeError(y,i){}_onExtensionHostExit(y){}}e.NullExtensionService=a}),define(be[179],Ee([0,1,26,30,15]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(o,l,v,S){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=v,this.activateResolvedTime=S}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class k{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,l){return o===-1||l===-1?-1:l-o}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(o,l,v,S,_,a){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=v,this.module=S,this.exports=_,this.subscriptions=a}}e.ActivatedExtension=D;class T extends D{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends D{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class b extends D{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let n=class{constructor(o,l,v,S,_){this._logService=_,this._registry=o,this._resolvedExtensionsSet=new Set,l.forEach(a=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,v.forEach(a=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(a),a)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const l=d.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(l)}getActivatedExtension(o){const l=d.ExtensionIdentifier.toKey(o),v=this._activatedExtensions.get(l);if(!v)throw new Error("Extension `"+o.value+"` is not known or not activated");return v}activateByEvent(o,l){if(this._alreadyActivatedEvents[o])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(v.map(S=>({id:S.identifier,reason:{startup:l,extensionId:S.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,l){const v=this._registry.getExtensionDescription(o);if(!v)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:v.identifier,reason:l}])}_handleActivateRequest(o,l,v){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(o.id))){l[d.ExtensionIdentifier.toKey(o.id)]=o;return}const S=this._registry.getExtensionDescription(o.id);if(!S){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,c,new M.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(o.id),new b(c));return}const _=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let a=!0;for(let c=0,y=_.length;c<y;c++){const i=_[c];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const g=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(g&&!g.activationFailed)continue;if(g&&g.activationFailed){const f=S.displayName||S.identifier.value,p=this._registry.getExtensionDescription(i),C=p&&p.displayName||i,P=new Error(`Cannot activate the '${f}' extension because its dependency '${C}' failed to activate`);P.detail=g.activationFailedError,this._host.onExtensionActivationError(S.identifier,P,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(S.identifier),new b(P));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){a=!1,l[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:o.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){if(!r.main&&!r.browser)continue;a=!1,l[d.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:o.reason};continue}const s=S.displayName||S.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(S.identifier,u,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(S.identifier),new b(u));return}a?l[d.ExtensionIdentifier.toKey(S.identifier)]=o:v.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(_=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(_.id))),o.length===0))return Promise.resolve(void 0);const l=Object.create(null),v=[];for(let _=0,a=o.length;_<a;_++)this._handleActivateRequest(o[_],l,v);for(let _=0,a=v.length;_<a;_++){const c=d.ExtensionIdentifier.toKey(v[_].id);l[c]&&delete l[c]}const S=Object.keys(l).map(_=>l[_]);return v.length===0?Promise.all(S.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(S).then(_=>this._activateExtensions(v))}_activateExtension(o,l){const v=d.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const S=this._activatingExtensions.get(v);if(S)return S;const _=this._host.actualActivateExtension(o,l).then(void 0,a=>{const c=new Error;return a&&a.name&&(c.name=a.name),a&&a.message?c.message=`Activating extension '${o.value}' failed: ${a.message}.`:c.message=`Activating extension '${o.value}' failed: ${a}.`,a&&a.stack&&(c.stack=a.stack),this._host.onExtensionActivationError(o,c,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(a),new b(a)}).then(a=>{this._activatedExtensions.set(v,a),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,_),_}};n=$e([Ve(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function E(D){const T=new d(!0,D);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(D){const T=new d(!1,D);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function R(D){return M[D].sid}e.getStringIdentifierForProxy=R;class k{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=k}),define(be[5],Ee([0,1,54,2,38]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(a){a.name="$ident";function c(i,g){return Object.defineProperty(i,a.name,{value:g,enumerable:!0}),i}a.mixin=c;function y(i){return i[a.name]}a.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(c){return c._id=h._n++,c}}e.IdObject=h,h._n=0;var o;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(a){if(a&&a.edits)for(const c of a.edits)typeof c.resource=="object"?c.resource=M.URI.revive(c.resource):(c.newUri=M.URI.revive(c.newUri),c.oldUri=M.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,d.revive)(c.metadata));return a}e.reviveWorkspaceEditDto=S;var _;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[68],Ee([0,1,5,3,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,T){return this._proxy.$setPassword(k,D,T)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[69],Ee([0,1,4,15,5,12]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(E.MainContext.MainThreadTelemetry)}report(D,T,t){const b=this.getUsageKey(D,T);this._reportedUsages.has(b)||(this._reportedUsages.add(b),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};R=$e([Ve(0,A.IExtHostRpcService),Ve(1,M.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,T){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,t,b={}){const n=A.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(n)||[],o=[...t].sort().join(" ");let l=h.find(v=>v.scopes===o);if(l)return l.result;{const v=this._getSession(D,n,T,t,b);l={scopes:o,result:v},h.push(l),this._inFlightRequests.set(n,h);try{await v}finally{const S=h.findIndex(_=>_.scopes===o);S>-1&&(h.splice(S),this._inFlightRequests.set(n,h))}return v}}async _getSession(D,T,t,b,n={}){await this._proxy.$ensureProvider(t);const h=D.displayName||D.name;return this._proxy.$getSession(t,b,T,h,n)}async removeSession(D,T){const t=this._authenticationProviders.get(D);return t?t.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,t,b){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:t,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===D)||this._providers.push({id:D,label:T});const n=t.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(D,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,b?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(D);const h=this._providers.findIndex(o=>o.id===D);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(be[182],Ee([0,1,5,12,8]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=E.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const R=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(k){return R.$writeText(k)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,13,15,54,44,112,2,6,4,12,48,22,38]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(R.MainContext.MainThreadCommands),this._logService=u,this.converter=new c(this,f=>{const p=this._apiCommands.get(f);return p?.result===i.Void?p:void 0},u),this._argumentProcessors=[{processArgument(f){return(0,T.revive)(f)}},{processArgument(f){return(0,A.cloneAndChange)(f,function(p){if(t.Range.isIRange(p))return E.Range.to(p);if(b.Position.isIPosition(p))return E.Position.to(p);if(t.Range.isIRange(p.range)&&n.URI.isUri(p.uri))return E.location.to(p);if(p instanceof S.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const u=this.registerCommand(!1,s.id,async(...f)=>{const p=s.args.map((P,m)=>{if(!P.validate(f[m]))throw new Error(`Invalid argument '${P.name}' when running '${s.id}', received: ${f[m]}`);return P.convert(f[m])}),C=await this.executeCommand(s.internalId,...p);return s.result.convert(C,f,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{u.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,u,f,p,C){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:f,thisArg:p,description:C}),s&&this._proxy.$registerCommand(u),new M.Disposable(()=>{this._commands.delete(u)&&s&&this._proxy.$unregisterCommand(u)})}executeCommand(s,...u){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,u,!0)}async _doExecuteCommand(s,u,f){if(this._commands.has(s))return this._executeContributedCommand(s,u);{let p=!1;const C=(0,A.cloneAndChange)(u,function(P){if(P instanceof M.Position)return E.Position.from(P);if(P instanceof M.Range)return E.Range.from(P);if(P instanceof M.Location)return E.location.from(P);if(M.NotebookRange.isNotebookRange(P))return E.NotebookRange.from(P);if(P instanceof ArrayBuffer)return p=!0,S.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return p=!0,S.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await this._proxy.$executeCommand(s,p?new _.SerializableObjectWithBuffers(C):C,f);return(0,T.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(s,u,!1);throw P}}}async _executeContributedCommand(s,u){const f=this._commands.get(s);if(!f)throw new Error("Unknown command");let{callback:p,thisArg:C,description:P}=f;if(P)for(let m=0;m<P.args.length;m++)try{(0,d.validateConstraint)(u[m],P.args[m].constraint)}catch(I){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${P.args[m].name}' - ${P.args[m].description}`)}try{return await p.apply(C,u)}catch(m){if(s===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...u);I&&(s=I.command)}throw this._logService.error(m,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(u=u.map(f=>this._argumentProcessors.reduce((p,C)=>C.processArgument(p),f)),this._executeContributedCommand(s,u)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(u=>(s&&(u=u.filter(f=>f[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[u,f]of this._commands){let{description:p}=f;p&&(s[u]=p)}return Promise.resolve(s)}};a=$e([Ve(0,l.IExtHostRpcService),Ve(1,D.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class c{constructor(s,u,f){this._commands=s,this._lookupApiCommand=u,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,u){if(!s)return;const f={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return f;const p=this._lookupApiCommand(s.command);if(p)f.id=p.internalId,f.arguments=p.args.map((C,P)=>C.convert(s.arguments&&s.arguments[P]));else if((0,k.isNonEmptyArray)(s.arguments)){const C=++this._cachIdPool;this._cache.set(C,s),u.add((0,h.toDisposable)(()=>{this._cache.delete(C),this._logService.trace("CommandsConverter#DISPOSE",C)})),f.$ident=C,f.id=this.delegatingCommandId,f.arguments=[C],this._logService.trace("CommandsConverter#CREATE",s.command,C)}return f}fromInternal(s){const u=R.ObjectIdentifier.of(s);return typeof u=="number"?this._cache.get(u):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const u=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class y{constructor(s,u,f,p){this.name=s,this.description=u,this.validate=f,this.convert=p}optional(){return new y(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,u){return new y(s??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),y.Position=new y("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),y.Range=new y("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),y.Selection=new y("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),y.Number=new y("number","",r=>typeof r=="number",r=>r),y.String=new y("string","",r=>typeof r=="string",r=>r),y.CallHierarchyItem=new y("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,E.TestItem.from);class i{constructor(s,u){this.description=s,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class g{constructor(s,u,f,p,C){this.id=s,this.internalId=u,this.description=f,this.args=p,this.result=C}}e.ApiCommand=g}),define(be[184],Ee([0,1,8,7,59,39,13,80]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,R.isFalsyOrEmpty)(n))return;class o extends M.SymbolInformation{static to(v){const S=new o(v.name,d.SymbolKind.to(v.kind),v.containerName||"",new M.Location(h[0],d.Range.to(v.range)));return S.detail=v.detail,S.range=S.location.range,S.selectionRange=d.Range.to(v.selectionRange),S.children=v.children?v.children.map(o.to):[],S}}return n.map(o.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>M.Position.isPosition(h)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let o;for(const l of h.reverse())o=new M.SelectionRange(d.Range.to(l),o);return o}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const h=[];if(Array.isArray(n))for(let o of n)h.push(...o[1].map(d.WorkspaceSymbol.to));return h})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,k.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,k.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,o)=>{if(!n)return new M.CompletionList([]);const l=n.suggestions.map(v=>d.CompletionItem.to(v,o));return new M.CompletionList(l,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,o)=>t(l=>new M.CodeLens(d.Range.to(l.range),l.command&&o.fromInternal(l.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,o)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(l.command)}else{const v=new M.CodeAction(l.title,l.kind?new M.CodeActionKind(l.kind):void 0);return l.edit&&(v.edit=d.WorkspaceEdit.to(l.edit)),l.command&&(v.command=o.fromInternal(l.command)),v.isPreferred=l.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new M.ColorInformation(d.Range.to(h.range),d.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>d.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(h){D.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=T;function t(n){return h=>{if(Array.isArray(h))return h.map(n)}}function b(n){if(!Array.isArray(n))return;const h=[];for(const o of n)E.isLocationLink(o)?h.push(d.DefinitionLink.to(o)):h.push(d.location.to(o));return h}}),define(be[185],Ee([0,1,14,52,3,6,2,59,26,8,7,5]),function(re,e,d,M,E,A,R,k,D,T,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(h,o,l){const v=h.getProxy(b.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const u=this._commentControllers.get(s.handle);return u||s}else if(s&&s.$mid===7){const u=this._commentControllers.get(s.commentControlHandle);if(!u)return s;const f=u.getCommentThread(s.commentThreadHandle);return f||s}else if(s&&s.$mid===8){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const f=u.getCommentThread(s.thread.commentThreadHandle);return f?{thread:f,text:s.text}:s}else if(s&&s.$mid===9){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const f=u.getCommentThread(s.thread.commentThreadHandle);if(!f)return s;let p=s.commentUniqueId,C=f.getCommentByUniqueId(p);return C||s}else if(s&&s.$mid===10){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const f=u.getCommentThread(s.thread.commentThreadHandle);if(!f)return s;let p=s.text,C=s.commentUniqueId,P=f.getCommentByUniqueId(C);return P?(P.body=p,P):s}return s}})}createCommentController(s,u,f){const p=S.handlePool++,C=new a(s,p,u,f);this._commentControllers.set(C.handle,C);const P=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(s.identifier))||[];return P.push(C),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(s.identifier),P),C.value}$createCommentThreadTemplate(s,u,f){const p=this._commentControllers.get(s);!p||p.$createCommentThreadTemplate(u,f)}async $updateCommentThreadTemplate(s,u,f){const p=this._commentControllers.get(s);!p||p.$updateCommentThreadTemplate(u,f)}$deleteCommentThread(s,u){const f=this._commentControllers.get(s);f&&f.$deleteCommentThread(u)}$provideCommentingRanges(s,u,f){const p=this._commentControllers.get(s);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const C=l.getDocument(R.URI.revive(u));return(0,d.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(C,f)).then(P=>P?P.map(m=>T.Range.from(m)):void 0)}$toggleReaction(s,u,f,p,C){const P=this._commentControllers.get(s);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const m=P.getCommentThread(u);if(m){const I=m.getCommentByUniqueId(p.uniqueIdInThread);if(P!==void 0&&I&&P.reactionHandler)return P.reactionHandler(I,i(C))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class _{constructor(s,u,f,p,C,P,m){this._commentControllerHandle=u,this._id=f,this._uri=p,this._range=C,this._comments=P,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),v.$createCommentThread(u,this.handle,this._id,this._uri,T.Range.from(this._range),m),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(u,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(F){I.range=F},get comments(){return I.comments},set comments(F){I.comments=F},get collapsibleState(){return I.collapsibleState},set collapsibleState(F){I.collapsibleState=F},get canReply(){return I.canReply},set canReply(F){I.canReply=F},get contextValue(){return I.contextValue},set contextValue(F){I.contextValue=F},get label(){return I.label},set label(F){I.label=F},dispose:()=>{I.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const s=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),u={};s("range")&&(u.range=T.Range.from(this._range)),s("label")&&(u.label=this.label),s("contextValue")&&(u.contextValue=this.contextValue),s("comments")&&(u.comments=this._comments.map(f=>c(this,f,this._commentsMap))),s("collapsibleState")&&(u.collapseState=g(this._collapseState)),s("canReply")&&(u.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(s){for(let u of this._commentsMap){let f=u[0],p=u[1];if(s===p)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}_._handlePool=0,$e([(0,M.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(s,u,f,p){this._extension=s,this._handle=u,this._id=f,this._label=p,this._threads=new Map,v.$registerCommentController(this.handle,f,p);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(P){C.options=P},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(P){C.commentingRangeProvider=P},get reactionHandler(){return C.reactionHandler},set reactionHandler(P){C.reactionHandler=P},createCommentThread(P,m,I){return C.createCommentThread(P,m,I).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,u,f,p){if(typeof s=="string"){const C=new _(this.id,this.handle,s,u,f,p,this._extension.identifier);return this._threads.set(C.handle,C),C}else{const C=new _(this.id,this.handle,void 0,s,u,f,this._extension.identifier);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(s,u){const f=new _(this.id,this.handle,void 0,R.URI.revive(s),T.Range.to(u),[],this._extension.identifier);return f.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(s,u){let f=this._threads.get(s);f&&(f.range=T.Range.to(u))}$deleteCommentThread(s){let u=this._threads.get(s);u&&u.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function c(r,s,u){let f=u.get(s);f||(f=++r.commentHandle,u.set(s,f));const p=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:f,body:T.MarkdownString.from(s.body),userName:s.author.name,userIconPath:p,label:s.label,commentReactions:s.reactions?s.reactions.map(C=>y(C)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function g(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class vi{constructor(h,o){this._logService=o,this._provider=new Map,this._proxy=h.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,o){const l=vi._handlePool++;this._provider.set(l,{provider:h,extensionId:o}),this._proxy.$registerDecorationProvider(l,o.value);const v=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(l,null);return}let _=(0,D.asArray)(S);if(_.length<=vi._maxEventSize){this._proxy.$onDidChange(l,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const a=_.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),c=(0,D.groupBy)(a,(i,g)=>i.rank-g.rank||(0,T.compare)(i.uri.path,g.uri.path));let y=[];e:for(let i of c){let g;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(g!==s&&(g=s,y.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(l,y)});return new E.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(h,o,l){if(!this._provider.has(h))return Object.create(null);const v=Object.create(null),{provider:S,extensionId:_}=this._provider.get(h);return await Promise.all(o.map(async a=>{try{const{uri:c,id:y}=a,i=await Promise.resolve(S.provideFileDecoration(d.URI.revive(c),l));if(!i)return;try{E.FileDecoration.validate(i),v[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this._logService.warn(`INVALID decoration from extension '${_.value}': ${g}`)}}catch(c){this._logService.error(c)}})),v}};b._handlePool=0,b._maxEventSize=250,b=$e([Ve(0,R.IExtHostRpcService),Ve(1,k.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[186],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(re,e,d,M,E,A,R,k,D,T,t,b,n){"use strict";var h,o,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(a,c,y,i,g,r){this._name=a,this._owner=c,this._maxDiagnosticsPerFile=y,h.set(this,void 0),o.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,et(this,l,new n.SkipList((s,u)=>i.compare(s,u)),"f"),et(this,h,g,"f"),et(this,o,r,"f")}dispose(){this._isDisposed||(Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,h,"f")&&Fe(this,h,"f").$clear(this._owner),Fe(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,c){if(!a){this.clear();return}this._checkDisposed();let y=[];if(E.URI.isUri(a)){if(!c){this.delete(a);return}Fe(this,l,"f").set(a,c.slice()),y=[a]}else if(Array.isArray(a)){y=[];let g;a=[...a].sort(v._compareIndexedTuplesByUri);for(const r of a){const[s,u]=r;if((!g||s.toString()!==g.toString())&&(g&&Fe(this,l,"f").get(g).length===0&&Fe(this,l,"f").delete(g),g=s,y.push(s),Fe(this,l,"f").set(s,[])),u){const f=Fe(this,l,"f").get(s);f&&f.push(...u)}else{const f=Fe(this,l,"f").get(s);f&&(f.length=0)}}}if(Fe(this,o,"f").fire(y),!Fe(this,h,"f"))return;const i=[];for(let g of y){let r=[];const s=Fe(this,l,"f").get(g);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(let p of s)if(p.severity===u[f]&&r.push(k.Diagnostic.from(p))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(u=>k.Diagnostic.from(u));i.push([g,r])}Fe(this,h,"f").$changeMany(this._owner,i)}delete(a){this._checkDisposed(),Fe(this,o,"f").fire([a]),Fe(this,l,"f").delete(a),Fe(this,h,"f")&&Fe(this,h,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,l,"f").clear(),Fe(this,h,"f")&&Fe(this,h,"f").$clear(this._owner)}forEach(a,c){this._checkDisposed();for(let y of Fe(this,l,"f").keys())a.apply(c,[y,this.get(y),this])}get(a){this._checkDisposed();const c=Fe(this,l,"f").get(a);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Fe(this,l,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,c){return a[0].toString()<c[0].toString()?-1:a[0].toString()>c[0].toString()?1:0}}e.DiagnosticCollection=v,h=new WeakMap,o=new WeakMap,l=new WeakMap;let S=class ei{constructor(a,c,y){this._logService=c,this._fileSystemInfoService=y,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(a){const c=new t.ResourceMap;for(const y of a)c.set(y,y);return{uris:Object.freeze(Array.from(c.values()))}}createDiagnosticCollection(a,c){const{_collections:y,_proxy:i,_onDidChangeDiagnostics:g,_logService:r,_fileSystemInfoService:s}=this,u=new class{$changeMany(C,P){i.$changeMany(C,P),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,C,P.length===0?"CLEARING":P)}$clear(C){i.$clear(C),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,C)}dispose(){i.dispose()}};let f;if(!c)c="_generated_diagnostic_collection_name_#"+ei._idPool++,f=c;else if(!y.has(c))f=c;else{this._logService.warn(`DiagnosticCollection with name '${c}' does already exist.`);do f=c+ei._idPool++;while(y.has(f))}return new class extends v{constructor(){super(c,f,ei._maxDiagnosticsPerFile,s.extUri,u,g);y.set(f,this)}dispose(){super.dispose(),y.delete(f)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const c=new Map,y=[];for(const i of this._collections.values())i.forEach((g,r)=>{let s=c.get(g.toString());typeof s=="undefined"&&(s=y.length,c.set(g.toString(),s),y.push([g,[]])),y[s][1]=y[s][1].concat(...r)});return y}}_getDiagnostics(a){let c=[];for(let y of this._collections.values())y.has(a)&&(c=c.concat(y.get(a)));return c}$acceptMarkersChange(a){if(!this._mirrorCollection){const c="_generated_mirror",y=new v(c,c,ei._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(c,y),this._mirrorCollection=y}for(const[c,y]of a)this._mirrorCollection.set(E.URI.revive(c),y.map(k.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=$e([Ve(1,T.ILogService),Ve(2,b.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(be[187],Ee([0,1,2,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(R){this._proxy=R.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(k=>k?k.map(D=>d.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(b,n,h){this._documentsAndEditors=n,this._logService=h,this._documentContentProviders=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,n){if(Object.keys(R.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const h=T._handlePool++;this._documentContentProviders.set(h,n),this._proxy.$registerTextContentProvider(h,b);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(l=>{if(l.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(h,l).then(v=>{if(!v&&typeof v!="string")return;const S=this._documentsAndEditors.getDocument(l);if(!S)return;const _=(0,D.splitLines)(v);if(!S.equalLines(_))return this._proxy.$onVirtualDocumentChange(l,v)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(b,n){const h=this._documentContentProviders.get(b);return h?Promise.resolve(h.provideTextDocumentContent(M.URI.revive(n),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(h,o){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const v of l)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const v of l)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const o=this._documentsAndEditors.getDocument(h);if(o)return o}getDocument(h){const o=this.getDocumentData(h);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return o.document}ensureDocumentData(h){const o=this._documentsAndEditors.getDocument(h);if(o)return Promise.resolve(o);let l=this._documentLoader.get(h.toString());return l||(l=this._proxy.$tryOpenDocument(h).then(v=>{this._documentLoader.delete(h.toString());const S=E.URI.revive(v);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(S))},v=>(this._documentLoader.delete(h.toString()),Promise.reject(v))),this._documentLoader.set(h.toString(),l)),l}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(o=>E.URI.revive(o))}$acceptModelModeChanged(h,o){const l=E.URI.revive(h),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(o),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(h){const o=E.URI.revive(h),l=this._documentsAndEditors.getDocument(o);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(h,o){const l=E.URI.revive(h),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");v._acceptIsDirty(o),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,o,l){const v=E.URI.revive(h),S=this._documentsAndEditors.getDocument(v);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),S.onEvents(o);let _;o.isUndoing?_=t.TextDocumentChangeReason.Undo:o.isRedoing&&(_=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:S.document,contentChanges:o.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:_}))}setWordDefinitionFor(h,o){(0,R.setWordDefinitionFor)(h,o)}}e.ExtHostDocuments=b}),define(be[49],Ee([0,1,42,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,y){this._extHostRpc=c,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const y=[],i=[],g=[];if(c.removedDocuments)for(const r of c.removedDocuments){const s=A.URI.revive(r),u=this._documents.get(s);u?.unref()&&(this._documents.delete(s),y.push(u.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const s=A.URI.revive(r.uri);let u=this._documents.get(s);if(u&&s.scheme!==o.Schemas.vscodeNotebookCell&&s.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);u||(u=new S(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,u),i.push(u.value)),u.ref()}if(c.removedEditors)for(const r of c.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&g.push(s)}if(c.addedEditors)for(const r of c.addedEditors){const s=A.URI.revive(r.documentUri);d.ok(this._documents.has(s),`document '${s}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(s).value,f=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>u.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(p=>b.Range.to(p)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}c.newActiveEditor!==void 0&&(d.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,E.dispose)(y),(0,E.dispose)(g),c.removedDocuments&&this._onDidRemoveDocuments.fire(y),c.addedDocuments&&this._onDidAddDocuments.fire(i),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return c?y:y?.value}allEditors(){return[...this._editors.values()]}};_=$e([Ve(0,T.IExtHostRpcService),Ve(1,n.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[70],Ee([0,1,8,5,2,3,4,12,14]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");let T=class{constructor(b){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let n=-1;this._tabs=b.map((o,l)=>(o.isActive&&(n=l),Object.freeze({label:o.label,viewColumn:d.ViewColumn.to(o.viewColumn),index:l,resource:E.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:v,viewId:S})=>({resource:E.URI.revive(v),viewId:S})),viewId:o.editorId,isActive:o.isActive,move:async(v,S)=>{this._proxy.$moveTab(o,v,d.ViewColumn.from(S)),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,l)=>o.viewColumn===l.viewColumn?o.index-l.index:o.viewColumn-l.viewColumn);const h=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==h&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=$e([Ve(0,k.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(re,e,d,M,E,A,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const o=this._schemes.indexOf(h);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),o=[];let l,v,S=14,_=14;for(const a of h){let c=l?(0,D.commonPrefixLength)(l,a):0;for(c===0?v=1:v=_;c<a.length;c++)c+1===a.length?(S=_,_=9):_+=1,o.push([v,a.toUpperCase().charCodeAt(c),_]),o.push([v,a.toLowerCase().charCodeAt(c),_]),v=_;l=a,_=S}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new k.StateMachine(o)}}provideDocumentLinks(h){this._initStateMachine();const o=[],l=k.LinkComputer.computeLinks({getLineContent(v){return h.lineAt(v-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const v of l){const S=R.DocumentLink.to(v);S.target&&o.push(S)}return o}}class b{constructor(h,o){this._extHostLanguageFeatures=o,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,o,l,v={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(S,l);let _=2;v.isCaseSensitive&&(_+=1024),v.isReadonly&&(_+=2048),typeof l.copy=="function"&&(_+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(S,o,_).catch(c=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${o}`),console.error(c)});const a=l.onDidChangeFile(c=>{const y=[];for(const i of c){let{uri:g,type:r}=i;if(g.scheme!==o)continue;let s;switch(r){case A.FileChangeType.Changed:s=0;break;case A.FileChangeType.Created:s=1;break;case A.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}y.push({resource:g,type:s})}this._proxy.$onFileSystemChange(S,y)});return(0,E.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(h){const{type:o,ctime:l,mtime:v,size:S,permissions:_}=h;return{type:o,ctime:l,mtime:v,size:S,permissions:_}}$stat(h,o){return Promise.resolve(this._getFsProvider(h).stat(d.URI.revive(o))).then(l=>b._asIStat(l))}$readdir(h,o){return Promise.resolve(this._getFsProvider(h).readDirectory(d.URI.revive(o)))}$readFile(h,o){return Promise.resolve(this._getFsProvider(h).readFile(d.URI.revive(o))).then(l=>T.VSBuffer.wrap(l))}$writeFile(h,o,l,v){return Promise.resolve(this._getFsProvider(h).writeFile(d.URI.revive(o),l.buffer,v))}$delete(h,o,l){return Promise.resolve(this._getFsProvider(h).delete(d.URI.revive(o),l))}$rename(h,o,l,v){return Promise.resolve(this._getFsProvider(h).rename(d.URI.revive(o),d.URI.revive(l),v))}$copy(h,o,l,v){const S=this._getFsProvider(h);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(d.URI.revive(o),d.URI.revive(l),v))}$mkdir(h,o){return Promise.resolve(this._getFsProvider(h).createDirectory(d.URI.revive(o)))}$watch(h,o,l,v){const S=this._getFsProvider(h).watch(d.URI.revive(l),v);this._watches.set(o,S)}$unwatch(h,o){const l=this._watches.get(o);l&&(l.dispose(),this._watches.delete(o))}$open(h,o,l){const v=this._getFsProvider(h);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(d.URI.revive(o),l))}$close(h,o){const l=this._getFsProvider(h);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(o))}$read(h,o,l,v){const S=this._getFsProvider(h);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const _=T.VSBuffer.alloc(v);return Promise.resolve(S.read(o,l,_.buffer,0,v)).then(a=>_.slice(0,a))}$write(h,o,l,v){const S=this._getFsProvider(h);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(o,l,v.buffer,0,v.byteLength))}_getFsProvider(h){const o=this._fsProvider.get(h);if(!o){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return o}}e.ExtHostFileSystem=b}),define(be[71],Ee([0,1,5,60,7,22,4,12,37]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Bt{constructor(b,n){const h=b.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return h.$stat(o).catch(Bt._handleError)},readDirectory(o){return h.$readdir(o).catch(Bt._handleError)},createDirectory(o){return h.$mkdir(o).catch(Bt._handleError)},async readFile(o){return h.$readFile(o).then(l=>l.buffer).catch(Bt._handleError)},writeFile(o,l){return h.$writeFile(o,A.VSBuffer.wrap(l)).catch(Bt._handleError)},delete(o,l){return h.$delete(o,{recursive:!1,useTrash:!1,...l}).catch(Bt._handleError)},rename(o,l,v){return h.$rename(o,l,{overwrite:!1,...v}).catch(Bt._handleError)},copy(o,l,v){return h.$copy(o,l,{overwrite:!1,...v}).catch(Bt._handleError)},isWritableFileSystem(o){const l=n.getCapabilities(o);if(typeof l=="number")return!(l&2048)}})}static _handleError(b){if(!(b instanceof Error))throw new E.FileSystemError(String(b));if(b.name==="ENOPRO")throw E.FileSystemError.Unavailable(b.message);switch(b.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(b.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(b.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(b.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(b.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(b.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(b.message);default:throw new E.FileSystemError(b.message,b.name)}}};T=$e([Ve(0,k.IExtHostRpcService),Ve(1,D.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(R,k,D,T){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new M.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new M.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new M.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new M.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:d.URI.revive(b.notebookUri),inputUri:d.URI.revive(b.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(b.notebookUri),inputUri:d.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,k,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(R){this._handlePool=0,this._proxy=R.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,R),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,13,10,234,6,80,53,63,194,16,3]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(ee,K);if(!(0,T.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,q)=>{let se=ae.location.range.start.compareTo(q.location.range.start);return se===0&&(se=q.location.range.end.compareTo(ae.location.range.end)),se});const K=[],ee=[];for(const ae of $){const q={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(q),K.push(q);break}const se=ee[ee.length-1];if(D.Range.containsRange(se.range,q.range)&&!D.Range.equalsRange(se.range,q.range)){se.children&&se.children.push(q),ee.push(q);break}ee.pop()}}return K}}class c{constructor($,K,ee){this._documents=$,this._commands=K,this._provider=ee,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(ee,K);if(!ae||K.isCancellationRequested)return;const q=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(q,se);const he={cacheId:q,lenses:[]};for(let Re=0;Re<ae.length;Re++)he.lenses.push({cacheId:[q,Re],range:E.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,se)});return he}async resolveCodeLens($,K){const ee=$.cacheId&&this._cache.get(...$.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,K),ae||(ae=ee),K.isCancellationRequested)return;const q=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!q)return $.command=this._commands.toInternal(ae.command??c._badCmd,q),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class i{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDefinition(ae,q,ee);return y(se)}}class g{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDeclaration(ae,q,ee);return y(se)}}class r{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideImplementation(ae,q,ee);return y(se)}}class s{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideTypeDefinition(ae,q,ee);return y(se)}}class u{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideHover(ae,q,ee);if(!(!se||(0,T.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(q)),se.range||(se.range=new A.Range(q,q)),E.Hover.from(se)}}class f{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideEvaluatableExpression(ae,q,ee);if(se)return E.EvaluatableExpression.from(se)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,ee,ae){const q=this._documents.getDocument($),se=await this._provider.provideInlineValues(q,E.Range.to(K),E.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(he=>E.InlineValue.from(he))}}class C{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDocumentHighlights(ae,q,ee);if(Array.isArray(se))return se.map(E.DocumentHighlight.from)}}class P{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideLinkedEditingRanges(ae,q,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,T.coalesce)(se.ranges.map(E.Range.from)),wordPattern:se.wordPattern}}}class m{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=await this._provider.provideReferences(q,se,ee,ae);if(Array.isArray(he))return he.map(E.location.from)}}class I{constructor($,K,ee,ae,q,se,he){this._documents=$,this._commands=K,this._diagnostics=ee,this._provider=ae,this._logService=q,this._extension=se,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,ee,ae){const q=this._documents.getDocument($),se=b.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),he=[];for(const ke of this._diagnostics.getDiagnostics($))if(se.intersection(ke.range)&&he.push(ke)>I._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ee.trigger)},Be=await this._provider.provideCodeActions(q,se,Re,ae);if(!(0,T.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const ze=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set(ze,Qe);const it=[];for(let ke=0;ke<Be.length;ke++){const Ze=Be[ke];!Ze||(I._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,Qe)})):(Re.only&&(Ze.kind?Re.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[ze,ke],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,Qe),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(E.Diagnostic.from),edit:Ze.edit&&E.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:ze,actions:it}}async resolveCodeAction($,K){const[ee,ae]=$,q=this._cache.get(ee,ae);if(!q||I._isCommand(q)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(q,K)??q;return se?.edit?E.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}I._maxCodeActionsPerFile=1e3;class F{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentFormattingEdits(ae,K,ee);if(Array.isArray(q))return q.map(E.TextEdit.from)}}class L{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,ee,ae){const q=this._documents.getDocument($),se=E.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(q,se,ee,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class w{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,ee,ae,q){const se=this._documents.getDocument($),he=E.Position.to(K),Re=await this._provider.provideOnTypeFormattingEdits(se,he,ee,ae,q);if(Array.isArray(Re))return Re.map(E.TextEdit.from)}}class x{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,K){const ee=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,K);if((0,T.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const se=R.IdObject.mixin(E.WorkspaceSymbol.from(q));this._symbolCache.set(se._id,q),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ee=this._symbolCache.get($._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,K);return ae&&(0,M.mixin)($,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[ee,ae]=K;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete($)}}}class W{constructor($,K,ee){this._documents=$,this._provider=K,this._logService=ee}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K);try{const he=await this._provider.provideRenameEdits(q,se,ee,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Re=W._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),q=E.Position.to(K);try{const se=await this._provider.prepareRename(ae,q,ee);let he,Re;if(A.Range.isRange(se)?(he=se,Re=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Re=se.placeholder),!he||!Re)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Re}}catch(se){const he=W._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class B{constructor($,K){this.resultId=$,this.tokens=K}}class G{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,ee){const ae=this._documents.getDocument($),q=K!==0?this._previousResults.get(K):null;let se=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return q&&this._previousResults.delete(K),se?(se=G._fixProvidedSemanticTokens(se),this._send(G._convertToEdits(q,se),se)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return G._isSemanticTokens($)?G._isCorrectSemanticTokens($)?$:new A.SemanticTokens(new Uint32Array($.data),$.resultId):G._isSemanticTokensEdits($)?G._isCorrectSemanticTokensEdits($)?$:new A.SemanticTokensEdits($.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!G._isSemanticTokens(K)||!$||!$.tokens)return K;const ee=$.tokens,ae=ee.length,q=K.data,se=q.length;let he=0;const Re=Math.min(ae,se);for(;he<Re&&ee[he]===q[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],K.resultId);let Be=0;const ze=Re-he;for(;Be<ze&&ee[ae-Be-1]===q[se-Be-1];)Be++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:q.subarray(he,se-Be)}],K.resultId)}_send($,K){if(G._isSemanticTokens($)){const ee=this._nextResultId++;return this._previousResults.set(ee,new B($.resultId,$.data)),(0,h.encodeSemanticTokensDto)({id:ee,type:"full",data:$.data})}if(G._isSemanticTokensEdits($)){const ee=this._nextResultId++;return G._isSemanticTokens(K)?this._previousResults.set(ee,new B(K.resultId,K.data)):this._previousResults.set(ee,new B($.resultId)),(0,h.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class H{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(K),ee);return q?this._send(q):null}_send($){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class U{constructor($,K,ee,ae,q){this._documents=$,this._commands=K,this._provider=ee,this._apiDeprecation=ae,this._extension=q,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=q.getWordRangeAtPosition(se)||new A.Range(se,se),Re=he.with({end:se}),Be=new v.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,se,ae,E.CompletionContext.to(ee));if(!ze||ae.isCancellationRequested)return;const Qe=Array.isArray(ze)?new A.CompletionList(ze):ze,it=U.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),ke=new n.DisposableStore;this._disposables.set(it,ke);const Ze=[],j={x:it,b:Ze,a:{replace:E.Range.from(he),insert:E.Range.from(Re)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let J=0;J<Qe.items.length;J++){const me=Qe.items[J],He=this._convertCompletionItem(me,[it,J],Re,he);Ze.push(He)}return j}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,K);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,ee,ae){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const se={x:K,a:$.label,b:$.kind!==void 0?E.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(E.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:E.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal($.command,q)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=$.textEdit.newText):typeof $.insertText=="string"?se.h=$.insertText:$.insertText instanceof A.SnippetString&&(se.h=$.insertText.value,se.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),A.Range.isRange(he)?se.j=E.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),se}}class V{constructor($,K,ee){this._documents=$,this._provider=K,this._commands=ee,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=await this._provider.provideInlineCompletionItems(q,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:E.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Re=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Re.items);let ze;return{pid:Be,items:Re.items.map((Qe,it)=>{let ke;return Qe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(Be,ze)),ke=this._commands.toInternal(Qe.command,ze)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:ke,idx:it}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const ee=this._cache.get($,K);ee&&Q.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Q{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=Q.map.get($);return K||(K=new Q,Q.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=Q,Q.map=new WeakMap;class ne{constructor($,K){this._documents=$,this._provider=K,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=this.reviveContext(ee),Re=await this._provider.provideSignatureHelp(q,se,ae,he);if(Re){const Be=this._cache.add([Re]);return{...E.SignatureHelp.from(Re),id:Be}}}reviveContext($){let K;if($.activeSignatureHelp){const ee=E.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class ce{constructor($,K){this._documents=$,this._provider=K}async provideInlayHints($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideInlayHints(ae,E.Range.to(K),ee);return q?{hints:q.map(E.InlayHint.from)}:void 0}}class Z{constructor($,K){this._documents=$,this._provider=K,this._cache=new l.Cache("DocumentLink")}async provideLinks($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Z._validateLink).map(E.DocumentLink.from)};{const q=this._cache.add(ae),se={links:[],id:q};for(let he=0;he<ae.length;he++){if(!Z._validateLink(ae[he]))continue;const Re=E.DocumentLink.from(ae[he]);Re.cacheId=[q,he],se.links.push(Re)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,K);if(!(!ae||!Z._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class oe{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(ee,K);return Array.isArray(ae)?ae.map(se=>({color:E.Color.from(se.color),range:E.Range.from(se.range)})):[]}async provideColorPresentations($,K,ee){const ae=this._documents.getDocument($),q=E.Range.to(K.range),se=E.Color.to(K.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:q},ee);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideFoldingRanges(ae,K,ee);if(!!Array.isArray(q))return q.map(E.FoldingRange.from)}}class Ae{constructor($,K,ee){this._documents=$,this._provider=K,this._logService=ee}async provideSelectionRanges($,K,ee){const ae=this._documents.getDocument($),q=K.map(E.Position.to),se=await this._provider.provideSelectionRanges(ae,q,ee);if(!(0,T.isNonEmptyArray)(se))return[];if(se.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<q.length;Re++){const Be=[];he.push(Be);let ze=q[Re],Qe=se[Re];for(;;){if(!Qe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(E.SelectionRange.from(Qe)),!Qe.parent)break;ze=Qe.range,Qe=Qe.parent}}return he}}class Se{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.prepareCallHierarchy(ae,q,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!q)return q.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!q)return q.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ee=this._cache.get($),ae=E.CallHierarchyItem.from(K,$,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Ne{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.prepareTypeHierarchy(ae,q,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!q)return q.map(se=>this._cacheAndConvertItem($,se))}async provideSubtypes($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!q)return q.map(se=>this._cacheAndConvertItem($,se))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ee=this._cache.get($),ae=E.TypeHierarchyItem.from(K,$,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class We{constructor($,K){this.adapter=$,this.extension=K}}class je{constructor($,K,ee,ae,q,se,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=q,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector($){return E.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new A.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,K,ee,ae,q=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(ae);if(se.adapter instanceof K){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=ee(se.adapter,se.extension),Be=se.extension;return Be&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{q&&ze instanceof S.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,K){const ee=this._nextHandle();return this._adapter.set(ee,new We($,K)),ee}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,ee,ae){const q=this._addNewAdapter(new a(this._documents,ee),$),se=ae&&ae.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentSymbols($,K,ee){return this._withAdapter($,a,ae=>ae.provideDocumentSymbols(d.URI.revive(K),ee),void 0)}registerCodeLensProvider($,K,ee){const ae=this._nextHandle(),q=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new c(this._documents,this._commands.converter,ee),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),q);let se=this._createDisposable(ae);if(q!==void 0){const he=ee.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));se=A.Disposable.from(se,he)}return se}$provideCodeLenses($,K,ee){return this._withAdapter($,c,ae=>ae.provideCodeLenses(d.URI.revive(K),ee),void 0)}$resolveCodeLens($,K,ee){return this._withAdapter($,c,ae=>ae.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses($,K){this._withAdapter($,c,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider($,K,ee){const ae=this._addNewAdapter(new i(this._documents,ee),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition($,K,ee,ae){return this._withAdapter($,i,q=>q.provideDefinition(d.URI.revive(K),ee,ae),[])}registerDeclarationProvider($,K,ee){const ae=this._addNewAdapter(new g(this._documents,ee),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration($,K,ee,ae){return this._withAdapter($,g,q=>q.provideDeclaration(d.URI.revive(K),ee,ae),[])}registerImplementationProvider($,K,ee){const ae=this._addNewAdapter(new r(this._documents,ee),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation($,K,ee,ae){return this._withAdapter($,r,q=>q.provideImplementation(d.URI.revive(K),ee,ae),[])}registerTypeDefinitionProvider($,K,ee){const ae=this._addNewAdapter(new s(this._documents,ee),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition($,K,ee,ae){return this._withAdapter($,s,q=>q.provideTypeDefinition(d.URI.revive(K),ee,ae),[])}registerHoverProvider($,K,ee,ae){const q=this._addNewAdapter(new u(this._documents,ee),$);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover($,K,ee,ae){return this._withAdapter($,u,q=>q.provideHover(d.URI.revive(K),ee,ae),void 0)}registerEvaluatableExpressionProvider($,K,ee,ae){const q=this._addNewAdapter(new f(this._documents,ee),$);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression($,K,ee,ae){return this._withAdapter($,f,q=>q.provideEvaluatableExpression(d.URI.revive(K),ee,ae),void 0)}registerInlineValuesProvider($,K,ee,ae){const q=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new p(this._documents,ee),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),q);let he=this._createDisposable(se);if(q!==void 0){const Re=ee.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(q));he=A.Disposable.from(he,Re)}return he}$provideInlineValues($,K,ee,ae,q){return this._withAdapter($,p,se=>se.provideInlineValues(d.URI.revive(K),ee,ae,q),void 0)}registerDocumentHighlightProvider($,K,ee){const ae=this._addNewAdapter(new C(this._documents,ee),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights($,K,ee,ae){return this._withAdapter($,C,q=>q.provideDocumentHighlights(d.URI.revive(K),ee,ae),void 0)}registerLinkedEditingRangeProvider($,K,ee){const ae=this._addNewAdapter(new P(this._documents,ee),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges($,K,ee,ae){return this._withAdapter($,P,async q=>{const se=await q.provideLinkedEditingRanges(d.URI.revive(K),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,K,ee){const ae=this._addNewAdapter(new m(this._documents,ee),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences($,K,ee,ae,q){return this._withAdapter($,m,se=>se.provideReferences(d.URI.revive(K),ee,ae,q),void 0)}registerCodeActionProvider($,K,ee,ae){const q=new n.DisposableStore,se=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},je._extLabel($),Boolean(ee.resolveCodeAction)),q.add(this._createDisposable(se)),q}$provideCodeActions($,K,ee,ae,q){return this._withAdapter($,I,se=>se.provideCodeActions(d.URI.revive(K),ee,ae,q),void 0)}$resolveCodeAction($,K,ee){return this._withAdapter($,I,ae=>ae.resolveCodeAction(K,ee),void 0)}$releaseCodeActions($,K){this._withAdapter($,I,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider($,K,ee){const ae=this._addNewAdapter(new F(this._documents,ee),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,K,ee,ae){return this._withAdapter($,F,q=>q.provideDocumentFormattingEdits(d.URI.revive(K),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider($,K,ee){const ae=this._addNewAdapter(new L(this._documents,ee),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,K,ee,ae,q){return this._withAdapter($,L,se=>se.provideDocumentRangeFormattingEdits(d.URI.revive(K),ee,ae,q),void 0)}registerOnTypeFormattingEditProvider($,K,ee,ae){const q=this._addNewAdapter(new w(this._documents,ee),$);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),ae,$.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits($,K,ee,ae,q,se){return this._withAdapter($,w,he=>he.provideOnTypeFormattingEdits(d.URI.revive(K),ee,ae,q,se),void 0)}registerWorkspaceSymbolProvider($,K){const ee=this._addNewAdapter(new x(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols($,K,ee){return this._withAdapter($,x,ae=>ae.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol($,K,ee){return this._withAdapter($,x,ae=>ae.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,x,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider($,K,ee){const ae=this._addNewAdapter(new W(this._documents,ee,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),W.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits($,K,ee,ae,q){return this._withAdapter($,W,se=>se.provideRenameEdits(d.URI.revive(K),ee,ae,q),void 0)}$resolveRenameLocation($,K,ee,ae){return this._withAdapter($,W,q=>q.resolveRenameLocation(d.URI.revive(K),ee,ae),void 0)}registerDocumentSemanticTokensProvider($,K,ee,ae){const q=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new We(new G(this._documents,ee),$)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),ae,se);let he=this._createDisposable(q);if(se){const Re=ee.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens($,K,ee,ae){return this._withAdapter($,G,q=>q.provideDocumentSemanticTokens(d.URI.revive(K),ee,ae),null,!0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,G,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider($,K,ee,ae){const q=this._addNewAdapter(new H(this._documents,ee),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens($,K,ee,ae){return this._withAdapter($,H,q=>q.provideDocumentRangeSemanticTokens(d.URI.revive(K),ee,ae),null,!0)}registerCompletionItemProvider($,K,ee,ae){const q=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),ae,U.supportsResolving(ee),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems($,K,ee,ae,q){return this._withAdapter($,U,se=>se.provideCompletionItems(d.URI.revive(K),ee,ae,q),void 0)}$resolveCompletionItem($,K,ee){return this._withAdapter($,U,ae=>ae.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems($,K){this._withAdapter($,U,ee=>ee.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider($,K,ee){const ae=this._addNewAdapter(new V(this._documents,ee,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideInlineCompletions($,K,ee,ae,q){return this._withAdapter($,V,se=>se.provideInlineCompletions(d.URI.revive(K),ee,ae,q),void 0)}$handleInlineCompletionDidShow($,K,ee){this._withAdapter($,V,async ae=>{ae.handleDidShowCompletionItem(K,ee)},void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,V,async ee=>{ee.disposeCompletions(K)},void 0)}registerSignatureHelpProvider($,K,ee,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new ne(this._documents,ee),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),q),this._createDisposable(se)}$provideSignatureHelp($,K,ee,ae,q){return this._withAdapter($,ne,se=>se.provideSignatureHelp(d.URI.revive(K),ee,ae,q),void 0)}$releaseSignatureHelp($,K){this._withAdapter($,ne,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider($,K,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new ce(this._documents,ee),$);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),ae);let se=this._createDisposable(q);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints($,K,ee,ae){return this._withAdapter($,ce,q=>q.provideInlayHints(d.URI.revive(K),ee,ae),void 0)}registerDocumentLinkProvider($,K,ee){const ae=this._addNewAdapter(new Z(this._documents,ee),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,K,ee){return this._withAdapter($,Z,ae=>ae.provideLinks(d.URI.revive(K),ee),void 0)}$resolveDocumentLink($,K,ee){return this._withAdapter($,Z,ae=>ae.resolveLink(K,ee),void 0)}$releaseDocumentLinks($,K){this._withAdapter($,Z,ee=>ee.releaseLinks(K),void 0)}registerColorProvider($,K,ee){const ae=this._addNewAdapter(new oe(this._documents,ee),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors($,K,ee){return this._withAdapter($,oe,ae=>ae.provideColors(d.URI.revive(K),ee),[])}$provideColorPresentations($,K,ee,ae){return this._withAdapter($,oe,q=>q.provideColorPresentations(d.URI.revive(K),ee,ae),void 0)}registerFoldingRangeProvider($,K,ee){const ae=this._nextHandle(),q=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new ve(this._documents,ee),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),q);let se=this._createDisposable(ae);if(q!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges($,K,ee,ae){return this._withAdapter($,ve,q=>q.provideFoldingRanges(d.URI.revive(K),ee,ae),void 0)}registerSelectionRangeProvider($,K,ee){const ae=this._addNewAdapter(new Ae(this._documents,ee,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges($,K,ee,ae){return this._withAdapter($,Ae,q=>q.provideSelectionRanges(d.URI.revive(K),ee,ae),[])}registerCallHierarchyProvider($,K,ee){const ae=this._addNewAdapter(new Se(this._documents,ee),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy($,K,ee,ae){return this._withAdapter($,Se,q=>Promise.resolve(q.prepareSession(d.URI.revive(K),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls($,K,ee,ae){return this._withAdapter($,Se,q=>q.provideCallsTo(K,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls($,K,ee,ae){return this._withAdapter($,Se,q=>q.provideCallsFrom(K,ee,ae),void 0)}$releaseCallHierarchy($,K){this._withAdapter($,Se,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}registerTypeHierarchyProvider($,K,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareTypeHierarchy($,K,ee,ae){return this._withAdapter($,Ne,q=>Promise.resolve(q.prepareSession(d.URI.revive(K),ee,ae)),void 0)}$provideTypeHierarchySupertypes($,K,ee,ae){return this._withAdapter($,Ne,q=>q.provideSupertypes(K,ee,ae),void 0)}$provideTypeHierarchySubtypes($,K,ee,ae){return this._withAdapter($,Ne,q=>q.provideSubtypes(K,ee,ae),void 0)}$releaseTypeHierarchy($,K){this._withAdapter($,Ne,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,k.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,K,ee){let{wordPattern:ae}=ee;if(ae&&(0,k.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const q=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?je._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?je._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?je._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,se),this._createDisposable(q)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(t,b,n,h){this._documents=b,this._commands=n,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,b){await this._proxy.$changeLanguage(t,b);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,b){const n=t.version,h=M.Position.from(b),o=await this._proxy.$tokensAtPosition(t.uri,h),l={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(b)??new E.Range(b.line,b.character,b.line,b.character)};if(!o)return l;const v={range:M.Range.to(o.range),type:M.TokenType.to(o.type)};return!v.range.contains(b)||n!==t.version?l:v}createLanguageStatusItem(t,b,n){const h=this._handlePool++,o=this._proxy,l=this._ids,v=`${t.identifier.value}/${b}`;if(l.has(v))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);l.add(v);const S={selector:n,id:b,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let _,a=new k.DisposableStore;const c=()=>{_?.dispose(),_=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(h,{id:v,name:S.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===E.LanguageStatusSeverity.Error?A.default.Error:S.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:S.command&&this._commands.toInternal(S.command,a),accessibilityInfo:S.accessibilityInformation})},0)},y={dispose(){a.dispose(),_?.dispose(),o.$removeLanguageStatus(h),l.delete(v)},get id(){return S.id},get name(){return S.name},set name(i){S.name=i,c()},get selector(){return S.selector},set selector(i){S.selector=i,c()},get text(){return S.text},set text(i){S.text=i,c()},get detail(){return S.detail},set detail(i){S.detail=i,c()},get severity(){return S.severity},set severity(i){S.severity=i,c()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(i){S.accessibilityInformation=i,c()},get command(){return S.command},set command(i){S.command=i,c()}};return c(),y}}e.ExtHostLanguages=D}),define(be[196],Ee([0,1,5,15,30]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let R=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(d.MainContext.MainThreadMessageService)}showMessage(D,T,t,b,n){const h={extension:D};let o;typeof b=="string"||A(b)?o=[b,...n]:(h.modal=b?.modal,h.useCustom=b?.useCustom,h.detail=b?.detail,o=n),h.useCustom&&(0,E.checkProposedApiEnabled)(D);const l=[];for(let v=0;v<o.length;v++){const S=o[v];if(typeof S=="string")l.push({title:S,handle:v,isCloseAffordance:!1});else if(typeof S=="object"){let{title:_,isCloseAffordance:a}=S;l.push({title:_,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(T,t,h,l).then(v=>{if(typeof v=="number")return o[v]})}};R=$e([Ve(1,M.ILogService)],R),e.ExtHostMessageService=R}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,172,93]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(a,c,y,i,g){this._textDocumentsAndEditors=y,this._textDocuments=i,this._extensionStoragePaths=g,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,u=r.cell.handle,p=this._documents.get(s)?.getCell(u);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const c=this._editors.get(a);if(!c)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(a){for(const[c,y]of this._editors)if(y.apiEditor===a)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,c){const y=this._documents.get(a);if(!y&&!c)throw new Error(`NO notebook document for '${a}'`);return y}_getProviderData(a){const c=this._notebookContentProviders.get(a);if(!c)throw new Error(`NO provider for '${a}'`);return c}registerNotebookContentProvider(a,c,y,i,g){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:a,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(c,s)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},c,n.NotebookDocumentContentOptions.from(i),S._convertNotebookRegistrationData(a,g)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(a,c){if(!c)return;const y=c.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(c.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:c.displayName,filenamePattern:y,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,c,y){const i=S._notebookStatusBarItemProviderHandlePool++,g=typeof y.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,g,c);let r;return g!==void 0&&(r=y.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(g))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,g),r&&r.dispose()})}async createNotebookDocument(a){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&n.NotebookData.from(a.content)});return T.URI.revive(c)}async openNotebookDocument(a){const c=this._documents.get(a);if(c)return c.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(a),i=this._documents.get(T.URI.revive(y));return(0,D.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(a,c){T.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let y;typeof c=="object"?y={position:n.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(n.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:y={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,y),g=i&&this._editors.get(i)?.apiEditor;if(g)return g;throw i?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,c,y,i){const g=this._notebookStatusBarItemProviders.get(a),r=T.URI.revive(c),s=this._documents.get(r);if(!s||!g)return;const u=s.getCellFromIndex(y);if(!u)return;const f=await g.provideCellStatusBarItems(u.apiCell,i);if(!f)return;const p=new A.DisposableStore,C=this._statusBarCache.add([p]),m=(Array.isArray(f)?f:[f]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,p));return{cacheId:C,items:m}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,c,y,i,g){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},c,n.NotebookDocumentContentOptions.from(i),S._convertNotebookRegistrationData(a,g)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,c,y){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const g=await i.deserializeNotebook(c.buffer,y);return new o.SerializableObjectWithBuffers(n.NotebookData.from(g))}async $notebookToData(a,c,y){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const g=await i.serializeNotebook(n.NotebookData.to(c.value),y);return d.VSBuffer.wrap(g)}async $openNotebook(a,c,y,i,g){const{provider:r}=this._getProviderData(a),s=await r.openNotebook(T.URI.revive(c),{backupId:y,untitledDocumentData:i?.buffer},g);return new o.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(a,c,y){const i=this.getNotebookDocument(T.URI.revive(c)),{provider:g}=this._getProviderData(a);return await g.saveNotebook(i.apiNotebook,y),!0}async $saveNotebookAs(a,c,y,i){const g=this.getNotebookDocument(T.URI.revive(c)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(T.URI.revive(y),g.apiNotebook,i),!0}async $backupNotebook(a,c,y){const i=this.getNotebookDocument(T.URI.revive(c)),g=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension),s=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),u=T.URI.joinPath(r,s),f=await g.provider.backupNotebook(i.apiNotebook,{destination:u},y);return i.updateBackup(f),f.id}_createExtHostEditor(a,c,y){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const i=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,a,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(c,i)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const y of a.value.removedDocuments){const i=T.URI.revive(y),g=this._documents.get(i);g&&(g.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const y=[];for(const i of a.value.addedDocuments){const g=T.URI.revive(i.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const r=this,s=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){r._onDidChangeCellExecutionState.fire(u)}},g,i);y.push(...i.cells.map(u=>l.ExtHostCell.asModelAddData(s.apiNotebook,u))),this._documents.get(g)?.dispose(),this._documents.set(g,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const y of a.value.addedEditors){if(this._editors.has(y.id))return;const i=T.URI.revive(y.documentUri),g=this._documents.get(i);g&&this._createExtHostEditor(g,y.id,y)}const c=[];if(a.value.removedEditors)for(const y of a.value.removedEditors){const i=this._editors.get(y);i&&(this._editors.delete(y),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),c.push(i))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const y=new Set;this._visibleNotebookEditors.forEach(i=>y.add(i.id));for(const i of this._editors.values()){const g=y.has(i.id);i._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,53,15,5,12,8]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(b,n){const h=D._Keys.nextId();b.$registerNotebookEditorDecorationType(h,k.NotebookDecorationRenderOptions.from(n)),this.value={key:h,dispose(){b.$removeNotebookEditorDecorationType(h)}}}}D._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(b,n,h){this._logService=b,this._extHostRpc=n,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,n);const h=this._notebooksAndEditors.getEditorById(b);n.visibleRanges&&h._acceptVisibleRanges(n.visibleRanges.ranges.map(k.NotebookRange.to)),n.selections&&h._acceptSelections(n.selections.selections.map(k.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const n in b)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(k.ViewColumn.to(b[n]))}};T=$e([Ve(0,E.ILogService),Ve(1,R.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,26,15,5,39,8,7,66,165,30,38]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,s,u,f,p){this._initData=s,this._extHostNotebook=u,this._commands=f,this._logService=p,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(b.MainContext.MainThreadNotebookKernels);const C=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const m=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:m}}else if(P&&"notebookEditor"in P){const m=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(m===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:m}}return P})],n.ApiCommandResult.Void);this._commands.registerApiCommand(C)}createNotebookController(r,s,u,f,p,C){for(let ne of this._kernelData.values())if(ne.controller.id===s&&T.ExtensionIdentifier.equals(r.identifier,ne.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const P=this._handlePool++,m=this;this._logService.trace(`NotebookController[${P}], CREATED by ${r.identifier.value}, ${s}`);const I=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${r.identifier}'`);let F=!1;const L=new R.DisposableStore,w=new A.Emitter,x=new A.Emitter,W={id:`${r.identifier.value}/${s}`,notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:f||r.identifier.value,preloads:C?C.map(h.NotebookRendererScript.from):[]};let B=p??I,G;this._proxy.$addKernel(P,W).catch(ne=>{console.log(ne),F=!0});let H=0;const U=()=>{if(F)return;const ne=++H;Promise.resolve().then(()=>{ne===H&&this._proxy.$updateKernel(P,W)})},V=new k.ResourceMap,Q={get id(){return s},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:w.event,get label(){return W.label},set label(ne){W.label=ne??r.displayName??r.name,U()},get detail(){return W.detail??""},set detail(ne){W.detail=ne,U()},get description(){return W.description??""},set description(ne){W.description=ne,U()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(ne){W.supportedLanguages=ne,U()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){W.supportsExecutionOrder=ne,U()},get rendererScripts(){return W.preloads?W.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(ne){B=ne??I},get interruptHandler(){return G},set interruptHandler(ne){G=ne,W.supportsInterrupt=Boolean(ne),U()},createNotebookCellExecution(ne){if(F)throw new Error("notebook controller is DISPOSED");if(!V.has(ne.notebook.uri))throw m._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return m._createNotebookCellExecution(ne)},dispose:()=>{F||(this._logService.trace(`NotebookController[${P}], DISPOSED`),F=!0,this._kernelData.delete(P),L.dispose(),w.dispose(),x.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(ne,ce){m._proxy.$updateNotebookPriority(P,ne.uri,ce)},onDidReceiveMessage:x.event,postMessage(ne,ce){return(0,S.checkProposedApiEnabled)(r),m._proxy.$postMessage(P,ce&&m._extHostNotebook.getIdByEditor(ce),ne)},asWebviewUri(ne){return(0,S.checkProposedApiEnabled)(r),(0,l.asWebviewUri)(ne,m._initData.remote)}};return this._kernelData.set(P,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:x,onDidChangeSelection:w,associatedNotebooks:V}),Q}$acceptNotebookAssociation(r,s,u){const f=this._kernelData.get(r);if(f){const p=this._extHostNotebook.getNotebookDocument(D.URI.revive(s));u?f.associatedNotebooks.set(p.uri,!0):f.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),u),f.onDidChangeSelection.fire({selected:u,notebook:p.apiNotebook})}}async $executeCells(r,s,u){const f=this._kernelData.get(r);if(!f)return;const p=this._extHostNotebook.getNotebookDocument(D.URI.revive(s)),C=[];for(let P of u){const m=p.getCell(P);m&&C.push(m.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),C.length),await f.controller.executeHandler.call(f.controller,C,p.apiNotebook,f.controller)}catch(P){this._logService.error(`NotebookController[${r}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(r,s,u){const f=this._kernelData.get(r);if(!f)return;const p=this._extHostNotebook.getNotebookDocument(D.URI.revive(s));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,p.apiNotebook);else for(let C of u){const P=p.getCell(C);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,u){const f=this._kernelData.get(r);if(!f)return;const p=this._extHostNotebook.getEditorById(s);f.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:u}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const f=new y(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,f);const p=f.onDidChangeState(()=>{f.state===c.Resolved&&(f.dispose(),p.dispose(),this._activeExecutions.delete(u.uri))});return f.asApiObject()}};a=$e([Ve(4,t.ILogService)],a),e.ExtHostNotebookKernels=a;var c;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(c||(c={}));class y extends R.Disposable{constructor(r,s,u){super();this._document=r,this._cell=s,this._proxy=u,this._handle=y.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,f=>this.update(f)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const u=o.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return u===s.items?h.NotebookCellOutput.from(s):h.NotebookCellOutput.from({items:u,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,u){const f=this.cellIndexToHandle(s),p=this.validateAndConvertOutputs((0,d.asArray)(r));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:u,outputs:p})}async updateOutputItems(r,s,u){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(r),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(h.NotebookCellOutputItem.from),outputId:s.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(u){if(r._state===c.Resolved||r._state===c.Started)throw new Error("Cannot call start again");r._state=c.Started,r._onDidChangeState.fire(),r.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:u})},end(u,f){if(r._state===c.Resolved)throw new Error("Cannot call resolve twice");r._state=c.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:f,lastRunSuccess:u}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,f){return r.verifyStateForOutput(),r.updateOutputs(u,f,!0)},replaceOutput(u,f){return r.verifyStateForOutput(),r.updateOutputs(u,f,!1)},appendOutputItems(u,f){return r.verifyStateForOutput(),r.updateOutputItems(u,f,!0)},replaceOutputItems(u,f){return r.verifyStateForOutput(),r.updateOutputItems(u,f,!1)}})}}y.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,D,T){const t=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(D)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(k,D){if(!k.contributes?.notebookRenderer?.some(n=>n.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const T=!!k.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,h,o)=>{const l=T?n:v=>{const S={};t.set(S,v.editor),n({editor:S,message:v.message})};return this.getOrCreateEmitterFor(D).event(l,h,o)},postMessage:(n,h)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,h]=[h,n]);const o=T?h:t.get(h),l=o&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(l?.id,D,n)}}}getOrCreateEmitterFor(k){let D=this._rendererMessageEmitters.get(k);return D||(D=new d.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,D),D)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,12]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends E.Disposable{constructor(o,l,v,S,_){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=_,this._id=_.$register(this.name,l,v,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(l=>this._proxy.$clear(l,o))}show(o,l){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof o=="boolean"?o:l)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class T extends D{constructor(o,l,v){super(o,!1,void 0,l,v)}append(o){super.append(o),this._id.then(l=>this._proxy.$append(l,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends D{constructor(o,l,v){super(o,!0,l,void 0,v)}append(o){throw new Error("Not supported")}}class b{constructor(o,l){this.name=o,this._channel=l}append(o){this._channel.then(l=>l.append(o))}appendLine(o){this._channel.then(l=>l.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,l){this._channel.then(v=>v.show(o,l))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=b;let n=class{constructor(o){this._proxy=o.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new T(o,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(o,l,this._proxy)}};n=$e([Ve(0,k.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,46]),function(re,e,d,M,E,A,R,k,D,T,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(o,l,v){const S=o.getProxy(R.MainContext.MainThreadQuickOpen);class _{constructor(f,p){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=p}showQuickPick(f,p,C,P=M.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(f),I=++this._instances,F=S.$show(I,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},P),L={},w=F.then(()=>L);return Promise.race([w,m]).then(x=>{if(x!==L)return m.then(W=>{const B=[];for(let G=0;G<W.length;G++){const H=W[G];let U,V,Q,ne,ce;typeof H=="string"?U=H:(U=H.label,V=H.description,Q=H.detail,ne=H.picked,ce=H.alwaysShow),B.push({label:U,description:V,handle:G,detail:Q,picked:ne,alwaysShow:ce})}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{C.onDidSelectItem(W[G])}),S.$setItems(I,B),F.then(G=>{if(typeof G=="number")return W[G];if(Array.isArray(G))return G.map(H=>W[H])})})}).then(void 0,x=>{if(!(0,T.isPromiseCanceledError)(x))return S.$setError(I,x),Promise.reject(x)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,p=M.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,S.$input(f,typeof this._validateInput=="function",p).then(void 0,C=>{if(!(0,T.isPromiseCanceledError)(C))return Promise.reject(C)})}$validateInput(f){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,p=M.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!C)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(m=>m.uri.toString()===C.uri.toString())}createQuickPick(f,p){const C=new r(f,p,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(f){const p=new s(f,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}$onDidChangeValue(f,p){const C=this._sessions.get(f);C&&C._fireDidChangeValue(p)}$onDidAccept(f){const p=this._sessions.get(f);p&&p._fireDidAccept()}$onDidChangeActive(f,p){const C=this._sessions.get(f);C instanceof r&&C._fireDidChangeActive(p)}$onDidChangeSelection(f,p){const C=this._sessions.get(f);C instanceof r&&C._fireDidChangeSelection(p)}$onDidTriggerButton(f,p){const C=this._sessions.get(f);C&&C._fireDidTriggerButton(p)}$onDidTriggerItemButton(f,p,C){const P=this._sessions.get(f);P instanceof r&&P._fireDidTriggerItemButton(p,C)}$onDidHide(f){const p=this._sessions.get(f);p&&p._fireDidHide()}}class a{constructor(f,p){this._extensionId=f,this._onDidDispose=p,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((p,C)=>{const P=p===D.QuickInputButtons.Back?-1:C;this._handlesToButtons.set(P,p)}),this.update({buttons:f.map((p,C)=>({...g(p),tooltip:p.tooltip,handle:p===D.QuickInputButtons.Back?-1:C}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const p=this._handlesToButtons.get(f);p&&this._onDidTriggerButtonEmitter.fire(p)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(f){if(!this._disposed){for(const p of Object.keys(f)){const C=f[p];this._pendingUpdate[p]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function c(u){if(u instanceof D.ThemeIcon)return{id:u.id};const f=i(u),p=y(u);return{dark:typeof f=="string"?k.URI.file(f):f,light:typeof p=="string"?k.URI.file(p):p}}function y(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function g(u){const f=c(u.iconPath);let p,C;return"id"in f?C=n.ThemeIcon.asClassName(f):p=f,{iconPath:p,iconClass:C}}class r extends a{constructor(f,p,C){super(f,C);this.enableProposedApi=p,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((p,C)=>{this._handlesToItems.set(C,p),this._itemsToHandles.set(p,C)}),this.update({items:f.map((p,C)=>({label:p.label,description:p.description,handle:C,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,buttons:p.buttons&&this.enableProposedApi?p.buttons.map((P,m)=>({...g(P),tooltip:P.tooltip,handle:m})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(p=>this._itemsToHandles.has(p)),this.update({activeItems:this._activeItems.map(p=>this._itemsToHandles.get(p))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(p=>this._itemsToHandles.has(p)),this.update({selectedItems:this._selectedItems.map(p=>this._itemsToHandles.get(p))})}_fireDidChangeActive(f){const p=(0,t.coalesce)(f.map(C=>this._handlesToItems.get(C)));this._activeItems=p,this._onDidChangeActiveEmitter.fire(p)}_fireDidChangeSelection(f){const p=(0,t.coalesce)(f.map(C=>this._handlesToItems.get(C)));this._selectedItems=p,this._onDidChangeSelectionEmitter.fire(p)}_fireDidTriggerItemButton(f,p){const C=this._handlesToItems.get(f);if(!C||!C.buttons||!C.buttons.length)return;const P=C.buttons[p];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:C})}}class s extends a{constructor(f,p){super(f,p);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?b.default.Error:b.default.Ignore})}}return new _(l,v)}e.createExtHostQuickOpen=h}),define(be[202],Ee([0,1,2,3,52,6,14,5,13,108,15,26,30,46,8]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(f){if(f)return typeof f.iconPath=="string"?d.URI.file(f.iconPath):d.URI.isUri(f.iconPath)||h.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function v(f,p){if(!f.iconPath&&!p.iconPath)return 0;if(f.iconPath){if(!p.iconPath)return 1}else return-1;const C=typeof f.iconPath=="string"?f.iconPath:d.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,P=typeof p.iconPath=="string"?p.iconPath:d.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,T.comparePaths)(C,P)}function S(f,p){let C=0;if(f.strikeThrough!==p.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==p.faded)return f.faded?1:-1;if(f.tooltip!==p.tooltip)return(f.tooltip||"").localeCompare(p.tooltip||"");if(C=v(f,p),C!==0)return C;if(f.light&&p.light)C=v(f.light,p.light);else{if(f.light)return 1;if(p.light)return-1}if(C!==0)return C;if(f.dark&&p.dark)C=v(f.dark,p.dark);else{if(f.dark)return 1;if(p.dark)return-1}return C}function _(f,p){if(f.command!==p.command)return f.command<p.command?-1:1;if(f.title!==p.title)return f.title<p.title?-1:1;if(f.tooltip!==p.tooltip){if(f.tooltip!==void 0&&p.tooltip!==void 0)return f.tooltip<p.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(f.arguments===p.arguments)return 0;if(f.arguments)if(p.arguments){if(f.arguments.length!==p.arguments.length)return f.arguments.length-p.arguments.length}else return 1;else return-1;for(let C=0;C<f.arguments.length;C++){const P=f.arguments[C],m=p.arguments[C];if(P!==m)return P<m?-1:1}return 0}function a(f,p){let C=(0,T.comparePaths)(f.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(C!==0)return C;if(f.command&&p.command)C=_(f.command,p.command);else{if(f.command)return 1;if(p.command)return-1}if(C!==0)return C;if(f.decorations&&p.decorations)C=S(f.decorations,p.decorations);else{if(f.decorations)return 1;if(p.decorations)return-1}return C}function c(f,p){for(let C=0;C<f.length;C++)if(f[C]!==p[C])return!1;return!0}function y(f,p){return f.command===p.command&&f.title===p.title&&f.tooltip===p.tooltip&&(f.arguments&&p.arguments?c(f.arguments,p.arguments):f.arguments===p.arguments)}function i(f,p){return(0,D.equals)(f,p,y)}class g{constructor(p,C,P){this._extension=p,this._proxy=C,this._sourceControlHandle=P,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(p){this._proxy.$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(p){if((0,n.checkProposedApiEnabled)(this._extension),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,p))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(p,C){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,p,C)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=g;class r{constructor(p,C,P,m,I){this._proxy=p,this._commands=C,this._sourceControlHandle=P,this._id=m,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,C){const P=this._resourceStatesCommandsMap.get(p);return P?(0,R.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(a),P=(0,D.sortedDiff)(this._resourceSnapshot,p,a).map(F=>{const L=F.toInsert.map(w=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,w);const W=w.resourceUri;let B;if(w.command)if(w.command.command==="vscode.open"||w.command.command==="vscode.diff"){const ve=new A.DisposableStore;B=this._commands.converter.toInternal(w.command,ve),this._resourceStatesDisposablesMap.set(x,ve)}else this._resourceStatesCommandsMap.set(x,w.command);const G=l(w.decorations),H=w.decorations&&l(w.decorations.light)||G,U=w.decorations&&l(w.decorations.dark)||G,V=[H,U],Q=w.decorations&&w.decorations.tooltip||"",ne=w.decorations&&!!w.decorations.strikeThrough,ce=w.decorations&&!!w.decorations.faded,Z=w.contextValue||"";return{rawResource:[x,W,V,Q,ne,ce,Z,B],handle:x}});return{start:F.start,deleteCount:F.deleteCount,toInsert:L}}),m=P.map(({start:F,deleteCount:L,toInsert:w})=>[F,L,w.map(x=>x.rawResource)]),I=P.reverse();for(const{start:F,deleteCount:L,toInsert:w}of I){const x=w.map(B=>B.handle),W=this._handlesSnapshot.splice(F,L,...x);for(const B of W)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=p,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(p,C,P,m,I,F){this._extension=p,this._proxy=C,this._commands=P,this._id=m,this._label=I,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(p,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,m,I,F)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,this._proxy.$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,this._proxy.$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=p;const C=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(p){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=p;const C=p!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=p;const C=(p||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(p,C){const P=new r(this._proxy,this._commands,this.handle,p,C),m=M.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,m),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const p=[],C=[];for(const[P,m]of this.createdResourceGroups){m.dispose();const I=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});M.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),I.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),p.push([P.handle,P.id,P.label,P.features]);const F=P._takeResourceStateSnapshot();F.length>0&&C.push([P.handle,F]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,p,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(C=>{const P=C._takeResourceStateSnapshot();P.length!==0&&p.push([C.handle,P])}),p.length>0&&this._proxy.$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,$e([(0,E.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let u=class Bi{constructor(p,C,P){this._commands=C,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=p.getProxy(k.MainContext.MainThreadSCM),this._telemetry=p.getProxy(k.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===3){const I=this._sourceControls.get(m.sourceControlHandle);if(!I)return m;const F=I.getResourceGroup(m.groupHandle);return F?F.getResourceState(m.handle):m}else if(m&&m.$mid===4){const I=this._sourceControls.get(m.sourceControlHandle);return I?I.getResourceGroup(m.groupHandle):m}else if(m&&m.$mid===5){const I=this._sourceControls.get(m.handle);return I||m}return m}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,C,P,m){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,C,P,m),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const I=Bi._handlePool++,F=new s(p,this._proxy,this._commands,C,P,m);this._sourceControls.set(I,F);const L=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier))||[];return L.push(F),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(p.identifier),L),F}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const C=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier)),P=C&&C[C.length-1];return P&&P.inputBox}$provideOriginalResource(p,C,P){const m=d.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,m.toString());const I=this._sourceControls.get(p);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(m,P)).then(F=>F||null)}$onInputBoxValueChange(p,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const P=this._sourceControls.get(p);return P&&P.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(p,C,P,m){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,C,P);const I=this._sourceControls.get(p);if(!I)return Promise.resolve(void 0);const F=I.getResourceGroup(C);return F?F.$executeResourceCommand(P,m):Promise.resolve(void 0)}$validateInput(p,C,P){this.logService.trace("ExtHostSCM#$validateInput",p);const m=this._sourceControls.get(p);return!m||!m.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>m.inputBox.validateInput(C,P)).then(I=>{if(!I)return Promise.resolve(void 0);const F=o.MarkdownString.fromStrict(I.message);return F?Promise.resolve([F,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};u._handlePool=0,u=$e([Ve(2,t.ILogService)],u),e.ExtHostSCM=u});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(re,e,d,M,E,A,R,k){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(o,l,v,S,_=d.StatusBarAlignment.Left,a){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,D,o,"f"),et(this,T,l,"f"),this._entryId=t.ID_GEN++,this._extension=v,this._id=S,this._alignment=_,this._priority=this.validatePriority(a)}validatePriority(o){if(!!(0,k.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!t.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Fe(this,T,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Fe(this,T,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let l;this._name?l=this._name:l=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,D,"f").$setEntry(this._entryId,o,l,this._text,S,this._command?.internal,v,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,D=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const l={message:o};return this._messages.unshift(l),this._update(),new d.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,l){this._proxy=o.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new b(this)}createStatusBarEntry(o,l,v,S){return new t(this._proxy,this._commands,o,l,v,S)}setStatusBarMessage(o,l){const v=this._statusMessage.setMessage(o);let S;return typeof l=="number"?S=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new d.Disposable(()=>{v.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=n}),define(be[72],Ee([0,1,5,3,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,T){return this._proxy.$getValue(k,D).then(t=>t||T)}setValue(k,D,T){return this._proxy.$setValue(k,D,T)}$acceptValue(k,D,T){this._onDidChangeStorage.fire({shared:k,key:D,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(T,t,b){this._logService=t,this._extHostFileSystem=b,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return R.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(T){if(this._value)return R.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return R.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([Ve(0,M.IExtHostInitDataService),Ve(1,E.ILogService),Ve(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[40],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,150,46,10]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class S{constructor(u,f,p,C){this._proxy=u,this._id=f,this._creationOptions=p,this._name=C,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(m=>this._pidPromiseComplete=m);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(m,I=!0){P._checkDisposed(),P._proxy.$sendText(P._id,m,I)},show(m){P._checkDisposed(),P._proxy.$show(P._id,m)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(u,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,v.withNullAsUndefined)(u.shellPath),shellArgs:(0,v.withNullAsUndefined)(u.shellArgs),cwd:(0,v.withNullAsUndefined)(u.cwd),env:(0,v.withNullAsUndefined)(u.env),icon:(0,v.withNullAsUndefined)(g(u.iconPath)),color:l.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,v.withNullAsUndefined)(u.message),strictEnv:(0,v.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(f?.useShellEnvironment),location:f?.location||this._serializeParentTerminal(u.location,f?.resolvedExtHostIdentifier)})}async createExtensionTerminal(u,f,p,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:l.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(u,f)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,f){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,f){return u===this._cols&&f===this._rows||u===0||f===0?!1:(this._cols=u,this._rows=f,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=S;class _{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(u){return Promise.resolve("")}async updateProperty(u,f){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,f){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:f})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose&&this._pty.onDidClose((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f&&{cols:f.columns,rows:f.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(f=>this._onProcessTitleChanged.fire(f)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=_;let a=1,c=class extends k.Disposable{constructor(u,f){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=f.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[p,C]of this._terminalProcesses)C.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,f){const p=new S(this._proxy,(0,h.generateUuid)(),u,u.name),C=new _(u.pty);return p.createExtensionTerminal(u.location,this._serializeParentTerminal(u,f).resolvedExtHostIdentifier,g(u.iconPath),r(u.color)).then(P=>{const m=this._setupExtHostProcessListeners(P,C);this._terminalProcessDisposables[P]=m}),this._terminals.push(p),p.value}_serializeParentTerminal(u,f){if(f=f||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const p=u.location.parentTerminal;if(p){const C=this._terminals.find(P=>P.value===p);C&&(f.resolvedExtHostIdentifier=C._id)}}else u.location&&typeof u.location!="object"?f.location=u.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(u,f){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const C=new _(f),P=this._setupExtHostProcessListeners(u,C);this._terminalProcessDisposables[u]=P}async $acceptActiveTerminalChanged(u){const f=this._activeTerminal;if(u===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(u);p&&(this._activeTerminal=p,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,f){const p=this._getTerminalById(u);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:f})}async $acceptTerminalDimensions(u,f,p){const C=this._getTerminalById(u);C&&C.setDimensions(f,p)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(u,f,p){this._terminalProcesses.get(u)?.resize(f,p)}async $acceptTerminalTitleChange(u,f){const p=this._getTerminalById(u);p&&(p.name=f)}async $acceptTerminalClosed(u,f){const p=this._getTerminalObjectIndexById(this._terminals,u);if(p!==null){const C=this._terminals.splice(p,1)[0];C.setExitCode(f),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(u,f,p,C){if(f){const I=this._getTerminalObjectIndexById(this._terminals,f);if(I!==null){this._terminals[I]._id=u,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},m=new S(this._proxy,u,P,p);this._terminals.push(m),this._onDidOpenTerminal.fire(m.value),m.isOpen=!0}async $acceptTerminalProcessId(u,f){const p=this._getTerminalById(u);p&&p._setProcessId(f)}async $startExtensionTerminal(u,f){const p=this._getTerminalById(u);if(!p)return{message:(0,T.localize)(0,null,u)};p.isOpen||await new Promise(P=>{const m=this.onDidOpenTerminal(async I=>{I===p.value&&(m.dispose(),P())})});const C=this._terminalProcesses.get(u);C?C.startSendingEvents(f):this._extensionTerminalAwaitingStart[u]={initialDimensions:f}}_setupExtHostProcessListeners(u,f){const p=new k.DisposableStore;p.add(f.onProcessReady(P=>this._proxy.$sendProcessReady(u,P.pid,P.cwd))),p.add(f.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(u,P))),this._bufferer.startBuffering(u,f.onProcessData),p.add(f.onProcessExit(P=>this._onProcessExit(u,P))),f.onProcessOverrideDimensions&&p.add(f.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(u,P))),this._terminalProcesses.set(u,f);const C=this._extensionTerminalAwaitingStart[u];return C&&f instanceof _&&(f.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),p}$acceptProcessAckDataEvent(u,f){this._terminalProcesses.get(u)?.acknowledgeDataEvent(f)}$acceptProcessInput(u,f){this._terminalProcesses.get(u)?.input(f)}$acceptTerminalInteraction(u){const f=this._getTerminalById(u);f?.setInteractedWith()&&this._onDidChangeTerminalState.fire(f.value)}$acceptProcessResize(u,f,p){try{this._terminalProcesses.get(u)?.resize(f,p)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(u,f){this._terminalProcesses.get(u)?.shutdown(f)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(f=>this._proxy.$sendProcessInitialCwd(u,f))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(f=>this._proxy.$sendProcessCwd(u,f))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,f,p){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,p),this._proxy.$registerProfileProvider(f,u.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}async $createContributedProfileTerminal(u,f){const p=new n.CancellationTokenSource().token,C=await this._profileProviders.get(u)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,f);return}this.createTerminalFromOptions(C.options,f)}}async $provideLinks(u,f){const p=this._getTerminalById(u);if(!p)return[];this._terminalLinkCache.delete(u);const C=this._terminalLinkCancellationSource.get(u);C&&C.dispose(!0);const P=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,P);const m=[],I={terminal:p.value,line:f},F=[];for(const x of this._linkProviders)F.push(new Promise(async W=>{P.token.onCancellationRequested(()=>W({provider:x,links:[]}));const B=await x.provideTerminalLinks(I,P.token)||[];P.token.isCancellationRequested||W({provider:x,links:B})}));const L=await Promise.all(F);if(P.token.isCancellationRequested)return[];const w=new Map;for(const x of L)x&&x.links.length>0&&m.push(...x.links.map(W=>{const B={id:a++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return w.set(B.id,{provider:x.provider,link:W}),B}));return this._terminalLinkCache.set(u,w),m}$activateLink(u,f){const p=this._terminalLinkCache.get(u)?.get(f);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(u,f){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const p=this._terminalProcessDisposables[u];p&&(p.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,f)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,f){const p=this._getTerminalObjectIndexById(u,f);return p!==null?u[p]:null}_getTerminalObjectIndexById(u,f){let p=null;return u.some((C,P)=>C._id===f?(p=P,!0):!1),p}getEnvironmentVariableCollection(u){let f=this._environmentVariableCollections.get(u.identifier.value);return f||(f=new y,this._setEnvironmentVariableCollection(u.identifier.value,f)),f}_syncEnvironmentVariableCollection(u,f){const p=(0,b.serializeEnvironmentVariableCollection)(f.map);this._proxy.$setEnvironmentVariableCollection(u,f.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(u){u.forEach(f=>{const p=f[0],C=new y(f[1]);this._setEnvironmentVariableCollection(p,C)})}$acceptDefaultProfile(u,f){this._defaultProfile=u,this._defaultAutomationProfile=f}_setEnvironmentVariableCollection(u,f){this._environmentVariableCollections.set(u,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,f)})}};c=$e([Ve(1,R.IExtHostRpcService)],c),e.BaseExtHostTerminalService=c;class y{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,f){this._setIfDiffers(u,{value:f,type:D.EnvironmentVariableMutatorType.Replace})}append(u,f){this._setIfDiffers(u,{value:f,type:D.EnvironmentVariableMutatorType.Append})}prepend(u,f){this._setIfDiffers(u,{value:f,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,f){const p=this.map.get(u);(!p||p.value!==f.value||p.type!==f.type)&&(this.map.set(u,f),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,f){this.map.forEach((p,C)=>u.call(f,C,p,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends c{constructor(u){super(!1,u)}createTerminal(u,f,p){throw new t.NotSupportedError}createTerminalFromOptions(u,f){throw new t.NotSupportedError}};i=$e([Ve(0,R.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function g(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return l.ThemeColor.isThemeColor(s)?s:void 0}});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[204],Ee([0,1,13,22,21,3,235,58,6,23,10,36,5,12,48,8,7,175,90,67]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(F,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(n.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new g(this.proxy),L.registerArgumentProcessor({processArgument:w=>w?.$mid===13?l.TestItem.toItemFromContext(w):w})}createTestController(F,L){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const w=new D.DisposableStore,x=w.add(new S.SingleUseTestCollection(F));x.root.label=L;const W=new Map,B=this.proxy,G={items:x.root.children,get label(){return L},set label(U){L=U,x.root.label=U,B.$updateControllerLabel(F,L)},get id(){return F},createRunProfile:(U,V,Q,ne,ce)=>{let Z=(0,k.hash)(U);for(;W.has(Z);)Z++;const oe=new P(this.proxy,F,Z,U,V,Q,ne,ce);return W.set(Z,oe),oe},createTestItem(U,V,Q){return new o.TestItemImpl(F,U,V,Q)},createTestRun:(U,V,Q=!0)=>this.runTracker.createTestRun(F,x,U,V,Q),set resolveHandler(U){x.resolveHandler=U},get resolveHandler(){return x.resolveHandler},dispose:()=>{w.dispose()}};G.createRunConfiguration=G.createRunProfile,B.$registerTestController(F,L),w.add((0,D.toDisposable)(()=>B.$unregisterTestController(F)));const H={controller:G,collection:x,profiles:W};return this.controllers.set(F,H),w.add((0,D.toDisposable)(()=>this.controllers.delete(F))),w.add(x.onDidGenerateDiff(U=>B.$publishDiff(F,U))),G}createTestObserver(){return this.observer.checkout()}async runTests(F,L=E.CancellationToken.None){const w=r(F);if(!w)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get(w.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(W=>W.id)??[x.collection.root.id],profileGroup:m[w.kind],profileId:w.profileId,controllerId:w.controllerId}],exclude:F.exclude?.map(W=>W.id)},L)}$provideFileCoverage(F,L,w){return(0,d.mapFind)(this.runTracker.trackers,W=>W.id===F?W.getCoverage(L):void 0)?.provideFileCoverage(w)??Promise.resolve([])}$resolveFileCoverage(F,L,w,x){return(0,d.mapFind)(this.runTracker.trackers,B=>B.id===F?B.getCoverage(L):void 0)?.resolveFileCoverage(w,x)??Promise.resolve([])}$configureRunProfile(F,L){this.controllers.get(F)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,T.deepFreeze)(l.TestResults.to(L))).concat(this.results).sort((L,w)=>w.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,L){const w=this.controllers.get(a.TestId.fromString(F).controllerId)?.collection;w&&(await w.expand(F,L<0?Infinity:L),w.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,L){const w=this.controllers.get(F.controllerId);if(!w)return;const{collection:x,profiles:W}=w,B=W.get(F.profileId);if(!B)return;const G=F.testIds.map(Q=>x.tree.get(Q)).filter(t.isDefined),H=F.excludeExtIds.map(Q=>w.collection.tree.get(Q)).filter(t.isDefined).filter(Q=>G.some(ne=>ne.fullId.compare(Q.fullId)===2));if(!G.length)return;const U=new v.TestRunRequest(G.some(Q=>Q.actual instanceof o.TestItemRootImpl)?void 0:G.map(Q=>Q.actual),H.map(Q=>Q.actual),B),V=this.runTracker.prepareForMainThreadTestRun(U,s.fromInternal(F,w.collection),L);try{await B.runHandler(U,L)}finally{V.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};y=$e([Ve(0,h.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends D.Disposable{constructor(F,L,w){super();this.dto=F,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(w)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const L=this.dto.id,w=this.dto.controllerId,x=(0,b.generateUuid)(),W=new u(this.proxy,L,x),B=V=>(Q,...ne)=>{if(H){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),V(Q,...ne))},G=(V,Q)=>{const ne=Q instanceof Array?Q.map(l.TestMessage.from):[l.TestMessage.from(Q)];if(V.uri&&V.range){const ce={range:l.Range.from(V.range),uri:V.uri};for(const Z of ne)Z.location=Z.location||ce}this.proxy.$appendTestMessagesInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),ne)};let H=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return W.coverageProvider},set coverageProvider(V){W.coverageProvider=V},enqueued:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),1)}),skipped:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),5)}),started:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),2)}),errored:B((V,Q,ne)=>{G(V,Q),this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),6,ne)}),failed:B((V,Q,ne)=>{G(V,Q),this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),4,ne)}),passed:B((V,Q)=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,Q)}),appendOutput:(V,Q,ne)=>{H||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(L,x,M.VSBuffer.fromString(V),Q&&l.location.from(Q),ne&&a.TestId.fromExtHostTestItem(ne,w).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:U,coverage:W}),this.proxy.$startedTestRunTask(L,{id:x,name:F,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof o.TestItemImpl))throw new o.InvalidTestItemError(F.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const L=[],w=this.dto.colllection.root;for(;;){const x=l.TestItem.from(F);if(L.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),F===w))break;F=F.parent||w}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class g{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,L,w){return this.getTracker(F,L,w)}cancelRunById(F){for(const L of this.tracked.values())if(L.id===F){L.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,L,w,x,W){const B=this.tracked.get(w);if(B)return B.createRun(x);const G=s.fromPublic(F,L,w,W),H=r(w);this.proxy.$startedExtensionTestRun({controllerId:F,profile:H&&{group:m[H.kind],id:H.profileId},exclude:w.exclude?.map(V=>V.id)??[],id:G.id,include:w.include?.map(V=>V.id)??[L.root.id],persist:W});const U=this.getTracker(w,G);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),U.createRun(x)}getTracker(F,L,w){const x=new i(L,this.proxy,w);return this.tracked.set(F,x),x.onEnd(()=>this.tracked.delete(F)),x}}e.TestRunCoordinator=g;const r=I=>{if(!!I.profile){if(!(I.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class s{constructor(F,L,w,x,W,B){this.controllerId=F,this.id=L,this.isPersisted=W,this.colllection=B,this.includePrefix=w.map(G=>G+"\0"),this.excludePrefix=x.map(G=>G+"\0")}static fromPublic(F,L,w,x){return new s(F,(0,b.generateUuid)(),w.include?.map(W=>a.TestId.fromExtHostTestItem(W,F).toString())??[F],w.exclude?.map(W=>a.TestId.fromExtHostTestItem(W,F).toString())??[],x,L)}static fromInternal(F,L){return new s(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,L)}isIncluded(F){const L=a.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const w of this.excludePrefix)if(L===w||L.startsWith(w))return!1;for(const w of this.includePrefix)if(L===w||L.startsWith(w))return!0;return!1}}e.TestRunDto=s;class u{constructor(F,L,w){this.proxy=F,this.runId=L,this.taskId=w}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(F,L){const w=await this.fileCoverage;let x=w?.[F];return!this._coverageProvider||!w||!x?[]:(x.detailedCoverage||(x=w[F]=await this._coverageProvider.resolveFileCoverage?.(x,L)??x),x.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class f extends _.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,l.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:w}=this;return{get added(){return[...F].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...w].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return{...F,revived:l.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=p;class C{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(L=>L.revived)},dispose:(0,R.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class P{constructor(F,L,w,x,W,B,G=!1,H=void 0){this.controllerId=L,this.profileId=w,this._label=x,this.kind=W,this.runHandler=B,this._isDefault=G,this._tag=H,c.set(this,void 0),et(this,c,F,"f");const U=m[W];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Fe(this,c,"f").$publishTestRunProfile({profileId:w,controllerId:L,tag:H?l.TestTag.namespace(this.controllerId,H.id):null,label:x,group:U,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Fe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Fe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Fe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?l.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Fe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Fe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,c=new WeakMap;const m={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(t,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const b=this._extHostDocumentsAndEditors.allEditors();return t?b:b.map(n=>n.value)}async showTextDocument(t,b,n){let h;typeof b=="number"?h={position:R.ViewColumn.from(b),preserveFocus:n}:typeof b=="object"?h={position:R.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?R.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:h={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(t.uri,h),l=o&&this._extHostDocumentsAndEditors.getEditor(o);if(l)return l.value;throw o?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,b){return new A.TextEditorDecorationType(this._proxy,t,b).value}$acceptEditorPropertiesChanged(t,b){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(b.options&&n._acceptOptions(b.options),b.selections){const h=b.selections.selections.map(R.Selection.to);n._acceptSelections(h)}if(b.visibleRanges){const h=M.coalesce(b.visibleRanges.map(R.Range.to));n._acceptVisibleRanges(h)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...b.options,lineNumbers:R.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const h=k.TextEditorSelectionChangeKind.fromValue(b.selections.source),o=b.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:h})}if(b.visibleRanges){const h=M.coalesce(b.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:h})}}$acceptEditorPositionData(t){for(const b in t){const n=this._extHostDocumentsAndEditors.getEditor(b);if(!n)throw new Error("Unknown text editor");const h=R.ViewColumn.to(t[b]);n.value.viewColumn!==h&&(n._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:h}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=D}),define(be[206],Ee([0,1,2,4,5,6,7]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class k{constructor(t,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const h=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(D(h))?.get(n.handle)}return n}})}async $getTimeline(t,b,n,h,o){return this._providers.get(t)?.provideTimeline(d.URI.revive(b),n,h,o)}registerTimelineProvider(t,b,n,h){const o=new A.DisposableStore,l=this.convertTimelineItem(b.id,h,o).bind(this);let v;b.onDidChange&&(v=b.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:b.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:t,onDidChange:void 0,async provideTimeline(_,a,c,y){y?.resetCache&&(o.clear(),S.get(b.id)?.clear());const i=await b.provideTimeline(_,a,c);if(i==null)return;const g=l(_,y);return{...i,source:b.id,items:i.items.map(g)}},dispose(){for(const _ of S.values())_.get(b.id)?.clear();v?.dispose(),o.dispose()}})}convertTimelineItem(t,b,n){return(h,o)=>{let l;if(o?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const S=D(h);l=v.get(S),l===void 0&&(l=new Map,v.set(S,l))}return v=>{const{iconPath:S,..._}=v,a=`${t}|${v.id??v.timestamp}`;l?.set(a,v);let c,y,i;return v.iconPath&&(S instanceof R.ThemeIcon?i={id:S.id,color:S.color}:d.URI.isUri(S)?(c=S,y=S):{light:c,dark:y}=S),{..._,id:_.id??void 0,handle:a,source:t,command:v.command?b.toInternal(v.command,n):void 0,icon:c,iconDark:y,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=k;function D(T){return T?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,t,b){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=b.schemes.find(h=>!R.supportedSchemes.has(h));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,b.schemes,D,b.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,t){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener with id: ${D}`);const n=E.URI.revive(T);return b.canOpenExternalUri(n,t)}async $openUri(D,T,t){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener id: '${D}'`);return b.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(re,e,d,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(R.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const b=k.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(T)),this.handlers.set(b,t),this._proxy.$registerUriHandler(b,T),(0,E.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(T)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(T,t){const b=this.handlers.get(T);if(!b)return Promise.resolve(void 0);try{b.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=k,k.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[50],Ee([0,1,3,11,2,138,158,66,5]),function(re,e,d,M,E,A,R,k,D){"use strict";var T,t,b,n,h,o,l,v,S,_,a,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class y{constructor(C,P,m,I,F,L,w){T.set(this,void 0),t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),h.set(this,void 0),o.set(this,void 0),l.set(this,""),v.set(this,void 0),S.set(this,!1),_.set(this,!1),a.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new d.Emitter),this._onDidDispose=Fe(this,c,"f").event,et(this,T,C,"f"),et(this,t,P,"f"),et(this,v,m,"f"),et(this,n,I,"f"),et(this,h,F,"f"),et(this,o,L,"f"),et(this,a,i(L),"f"),et(this,b,w,"f")}dispose(){et(this,S,!0,"f"),Fe(this,c,"f").fire(),Fe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return et(this,_,!0,"f"),(0,k.asWebviewUri)(C,Fe(this,n,"f").remote)}get cspSource(){const C=Fe(this,o,"f").extensionLocation;if(C.scheme===M.Schemas.https||C.scheme===M.Schemas.http){let P=C.toString();return P.endsWith("/")||(P+="/"),P+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,l,"f")}set html(C){this.assertNotDisposed(),Fe(this,l,"f")!==C&&(et(this,l,C,"f"),!Fe(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(et(this,_,!0,"f"),Fe(this,b,"f").report("Webview vscode-resource: uris",Fe(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,t,"f").$setHtml(Fe(this,T,"f"),C))}get options(){return this.assertNotDisposed(),Fe(this,v,"f")}set options(C){this.assertNotDisposed(),Fe(this,t,"f").$setOptions(Fe(this,T,"f"),s(Fe(this,o,"f"),Fe(this,h,"f"),C)),et(this,v,C,"f")}async postMessage(C){if(Fe(this,S,"f"))return!1;const P=(0,R.serializeWebviewMessage)(C,{serializeBuffersForPostMessage:Fe(this,a,"f")});return Fe(this,t,"f").$postMessage(Fe(this,T,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Fe(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=y,T=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,_=new WeakMap,a=new WeakMap,c=new WeakMap;function i(p){try{const C=(0,A.normalizeVersion)((0,A.parseVersion)(p.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class g{constructor(C,P,m,I,F){this.initData=P,this.workspace=m,this._logService=I,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=C.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(C,P,...m){const I=this.getWebview(C);if(I){const{message:F}=(0,R.deserializeWebviewMessage)(P,m);I._onMessageEmitter.fire(F)}}$onMissingCsp(C,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,P,m){const I=new y(C,this._webviewProxy,u(P),this.initData,this.workspace,m,this._deprecationService);return this._webviews.set(C,I),I._onDidDispose(()=>{this._webviews.delete(C)}),I}deleteWebview(C){this._webviews.delete(C)}getWebview(C){return this._webviews.get(C)}}e.ExtHostWebviews=g;function r(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=r;function s(p,C,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||f(p,C)}}e.serializeWebviewOptions=s;function u(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(C=>E.URI.from(C))}}e.reviveOptions=u;function f(p,C){return[...(C?.getWorkspaceFolders()||[]).map(P=>P.uri),p.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(re,e,d,M,E,A,R,k,D,T,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(i,g){this.document=i,this._storagePath=g,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,g){await this.getEdit(i).undo(),g||this.disposeBackup()}async redo(i,g){await this.getEdit(i).redo(),g||this.disposeBackup()}disposeEdits(i){for(const g of i)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=c(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const g=this._edits.get(i,0);if(!g)throw new Error("No edit found");return g}}class o{constructor(){this._documents=new Map}get(i,g){return this._documents.get(this.key(i,g))}add(i,g,r){const s=this.key(i,g.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${g.uri}`);const u=new h(g,r);return this._documents.set(s,u),u}delete(i,g){const r=this.key(i,g.uri);this._documents.delete(r)}key(i,g){return`${i}@@@${g}`}}var l;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(l||(l={}));class v{constructor(){this._providers=new Map}addTextProvider(i,g,r){return this.add(0,i,g,r)}addCustomProvider(i,g,r){return this.add(1,i,g,r)}get(i){return this._providers.get(i)}add(i,g,r,s){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(g))}}class S{constructor(i,g,r,s,u){this._extHostDocuments=g,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new v,this._documents=new o,this._proxy=i.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,g,r,s){const u=new E.DisposableStore;return _(r)?(u.add(this._editorProviders.addTextProvider(g,i,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),g,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(u.add(this._editorProviders.addCustomProvider(g,i,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(f=>{const p=this.getCustomDocumentEntry(g,f.document.uri);if(a(f)){const C=p.addEdit(f);this._proxy.$onDidEdit(f.document.uri,g,C,f.label)}else this._proxy.$onContentChange(f.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),g,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(u,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(i,g,r,s,u){const f=this._editorProviders.get(g);if(!f)throw new Error(`No provider found for '${g}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${g}'`);const p=k.URI.revive(i),C=await f.provider.openCustomDocument(p,{backupId:r,untitledDocumentData:s?.buffer},u);let P;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(g,C,P),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(i,g){const r=this._editorProviders.get(g);if(!r)throw new Error(`No provider found for '${g}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${g}'`);const s=k.URI.revive(i),{document:u}=this.getCustomDocumentEntry(g,s);this._documents.delete(g,u),u.dispose()}async $resolveWebviewEditor(i,g,r,s,u,f){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);const C=D.ViewColumn.to(u),P=this._extHostWebview.createNewWebview(g,s.webviewOptions,p.extension),m=this._extHostWebviewPanels.createNewWebviewPanel(g,r,s.title,C,s.panelOptions,P),I=k.URI.revive(i);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,I);return p.provider.resolveCustomEditor(F,m,f)}case 0:{const F=this._extHostDocuments.getDocument(I);return p.provider.resolveCustomTextEditor(F,m,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,g,r){this.getCustomDocumentEntry(g,i).disposeEdits(r)}async $onMoveCustomEditor(i,g,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(i);if(!u)throw new Error("No webview found");const f=k.URI.revive(g),p=this._extHostDocuments.getDocument(f);await s.provider.moveCustomTextEditor(p,u,d.CancellationToken.None)}async $undo(i,g,r,s){return this.getCustomDocumentEntry(g,i).undo(r,s)}async $redo(i,g,r,s){return this.getCustomDocumentEntry(g,i).redo(r,s)}async $revert(i,g,r){const s=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,g,r){const s=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,g,r,s){const u=this.getCustomDocumentEntry(g,i);return this.getCustomEditorProvider(g).saveCustomDocumentAs(u.document,k.URI.revive(r),s)}async $backup(i,g,r){const s=this.getCustomDocumentEntry(g,i),f=await this.getCustomEditorProvider(g).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(f),f.id}getCustomDocumentEntry(i,g){const r=this._documents.get(i,k.URI.revive(g));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function _(y){return typeof y.resolveCustomTextEditor=="function"}function a(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function c(y){const i=y.scheme===A.Schemas.file||y.scheme===A.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[210],Ee([0,1,3,6,2,36,8,50,5,7]),function(re,e,d,M,E,A,R,k,D,T){"use strict";var t,b,n,h,o,l,v,S,_,a,c,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class g extends M.Disposable{constructor(f,p,C,P,m,I,F){super();t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),h.set(this,void 0),o.set(this,void 0),l.set(this,void 0),v.set(this,void 0),S.set(this,void 0),_.set(this,!0),a.set(this,!0),c.set(this,!1),y.set(this,this._register(new d.Emitter)),this.onDidDispose=Fe(this,y,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,et(this,t,f,"f"),et(this,b,p,"f"),et(this,n,C,"f"),et(this,o,I,"f"),et(this,S,m,"f"),et(this,l,P,"f"),et(this,h,F,"f")}dispose(){Fe(this,c,"f")||(et(this,c,!0,"f"),Fe(this,y,"f").fire(),Fe(this,b,"f").$disposeWebview(Fe(this,t,"f")),Fe(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,h,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,n,"f")}get title(){return this.assertNotDisposed(),Fe(this,l,"f")}set title(f){this.assertNotDisposed(),Fe(this,l,"f")!==f&&(et(this,l,f,"f"),Fe(this,b,"f").$setTitle(Fe(this,t,"f"),f))}get iconPath(){return this.assertNotDisposed(),Fe(this,v,"f")}set iconPath(f){this.assertNotDisposed(),Fe(this,v,"f")!==f&&(et(this,v,f,"f"),Fe(this,b,"f").$setIconPath(Fe(this,t,"f"),E.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Fe(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,S,"f")=="number"&&Fe(this,S,"f")<0))return Fe(this,S,"f")}get active(){return this.assertNotDisposed(),Fe(this,a,"f")}get visible(){return this.assertNotDisposed(),Fe(this,_,"f")}_updateViewState(f){Fe(this,c,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(et(this,a,f.active,"f"),et(this,_,f.visible,"f"),et(this,S,f.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(f,p){this.assertNotDisposed(),Fe(this,b,"f").$reveal(Fe(this,t,"f"),{viewColumn:f?R.ViewColumn.from(f):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Fe(this,c,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,S=new WeakMap,_=new WeakMap,a=new WeakMap,c=new WeakMap,y=new WeakMap,i=new WeakMap;class r{constructor(f,p,C){this.webviews=p,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,p,C,P,m={}){const I=typeof P=="object"?P.viewColumn:P,F={viewColumn:R.ViewColumn.from(I),preserveFocus:typeof P=="object"&&!!P.preserveFocus},L=(0,k.shouldSerializeBuffersForPostMessage)(f),w=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(f),w,p,{title:C,panelOptions:s(m),webviewOptions:(0,k.serializeWebviewOptions)(f,this.workspace,m),serializeBuffersForPostMessage:L},F);const x=this.webviews.createNewWebview(w,m,f);return this.createNewWebviewPanel(w,p,C,I,m,x)}$onDidChangeWebviewPanelViewStates(f){const p=Object.keys(f);p.sort((C,P)=>{const m=f[C],I=f[P];return m.active?1:I.active?-1:+m.visible-+I.visible});for(const C of p){const P=this.getWebviewPanel(C);if(!P)continue;const m=f[C];P._updateViewState({active:m.active,visible:m.visible,viewColumn:R.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,p,C){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:C,extension:f}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(f)}),new T.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(f,p,C,P){const m=this._serializers.get(p);if(!m)throw new Error(`No serializer found for '${p}'`);const{serializer:I,extension:F}=m,L=this.webviews.createNewWebview(f,C.webviewOptions,F),w=this.createNewWebviewPanel(f,p,C.title,P,C.panelOptions,L);await I.deserializeWebviewPanel(w,C.state)}createNewWebviewPanel(f,p,C,P,m,I){const F=new g(f,this._proxy,p,C,P,m,I);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[211],Ee([0,1,3,6,50,5,7]),function(re,e,d,M,E,A,R){"use strict";var k,D,T,t,b,n,h,o,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends M.Disposable{constructor(c,y,i,g,r,s){super();k.set(this,void 0),D.set(this,void 0),T.set(this,void 0),t.set(this,void 0),b.set(this,!1),n.set(this,void 0),h.set(this,void 0),o.set(this,void 0),l.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Fe(this,l,"f").event,v.set(this,this._register(new d.Emitter)),this.onDidDispose=Fe(this,v,"f").event,et(this,T,i,"f"),et(this,h,g,"f"),et(this,k,c,"f"),et(this,D,y,"f"),et(this,t,r,"f"),et(this,n,s,"f")}dispose(){Fe(this,b,"f")||(et(this,b,!0,"f"),Fe(this,v,"f").fire(),Fe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,h,"f")}set title(c){this.assertNotDisposed(),Fe(this,h,"f")!==c&&(et(this,h,c,"f"),Fe(this,D,"f").$setWebviewViewTitle(Fe(this,k,"f"),c))}get description(){return this.assertNotDisposed(),Fe(this,o,"f")}set description(c){this.assertNotDisposed(),Fe(this,o,"f")!==c&&(et(this,o,c,"f"),Fe(this,D,"f").$setWebviewViewDescription(Fe(this,k,"f"),c))}get visible(){return Fe(this,n,"f")}get webview(){return Fe(this,t,"f")}get viewType(){return Fe(this,T,"f")}_setVisible(c){c===Fe(this,n,"f")||Fe(this,b,"f")||(et(this,n,c,"f"),Fe(this,l,"f").fire())}show(c){this.assertNotDisposed(),Fe(this,D,"f").$show(Fe(this,k,"f"),!!c)}assertNotDisposed(){if(Fe(this,b,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,T=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap;class _{constructor(c,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,y,i,g){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:c}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(c),y,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(c,y,i,g,r){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:u,extension:f}=s,p=this._extHostWebview.createNewWebview(c,{},f),C=new S(c,this._proxy,y,i,p,!0);this._webviewViews.set(c,C),await u.resolveWebviewView(C,{state:g},r)}async $onDidChangeWebviewViewVisibility(c,y){this.getWebviewView(c)._setVisible(y)}async $disposeWebviewView(c){const y=this.getWebviewView(c);this._webviewViews.delete(c),y.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const y=this._webviewViews.get(c);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=_}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ui{constructor(b){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=b.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,n){let h;if(typeof b=="string"){h=b;try{b=E.URI.parse(b)}catch(o){return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,h,n)}async asExternalUri(b,n){if((0,R.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(b,n);return E.URI.from(h)}};T.InitialState={focused:!0},T=$e([Ve(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends d.AbstractLogger{constructor(D,T){super();this._proxy=D.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(D,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(D,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(D,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(D,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(D,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};R=$e([Ve(0,A.IExtHostRpcService),Ve(1,E.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(be[213],Ee([0,1,14,22,21,16,3,6,109,180,38]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(m,I){try{return JSON.stringify(m,I)}catch(F){return"null"}}const h="$$ref$$",o={[h]:-1};class l{constructor(I,F){this.jsonString=I,this.referencedBuffers=F}}function v(m,I=null,F=!1){const L=[];return{jsonString:(F?n:JSON.stringify)(m,(x,W)=>{if(typeof W=="undefined")return o;if(typeof W=="object"){if(W instanceof M.VSBuffer){const B=L.push(W)-1;return{[h]:B}}if(I)return I(x,W)}return W}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=v;function S(m,I,F){return JSON.parse(m,(L,w)=>{if(w){const x=w[h];if(typeof x=="number")return I[x];if(F&&w.$mid===1)return F.transformIncoming(w)}return w})}e.parseJsonAndRestoreBufferRefs=S;function _(m,I){return JSON.stringify(m,I)}function a(m){return m?(I,F)=>F&&F.$mid===1?m.transformOutgoing(F):F:null}var c;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},g=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends k.Disposable{constructor(I,F=null,L=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=F,this._uriTransformer=L,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,x=t.ProxyIdentifier.count;w<x;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,D.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:F,sid:L}=I;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,L)),this._proxies[F]}_createProxy(I,F){let L={get:(w,x)=>(typeof x=="string"&&!w[x]&&x.charCodeAt(0)===36&&(w[x]=(...W)=>this._remoteCall(I,x,W)),x===r?F:w[x])};return new Proxy(Object.create(null),L)}set(I,F){return this._locals[I.nid]=F,F}assertRegistered(I){for(let F=0,L=I.length;F<L;F++){const w=I[F];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const F=I.byteLength,L=u.read(I,0),w=L.readUInt8(),x=L.readUInt32();switch(w){case 1:case 2:{let{rpcId:W,method:B,args:G}=p.deserializeRequestJSONArgs(L);this._uriTransformer&&(G=(0,D.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,x,W,B,G,w===2);break}case 3:case 4:{let{rpcId:W,method:B,args:G}=p.deserializeRequestMixedArgs(L);this._uriTransformer&&(G=(0,D.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,x,W,B,G,w===4);break}case 5:{this._logger&&this._logger.logIncoming(F,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(F,x);break}case 7:{this._receiveReply(F,x,void 0);break}case 9:{let W=p.deserializeReplyOKJSON(L);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(F,x,W);break}case 10:{const W=p.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(F,x,W);break}case 8:{let W=p.deserializeReplyOKVSBuffer(L);this._receiveReply(F,x,W);break}case 11:{let W=p.deserializeReplyErrError(L);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(F,x,W);break}case 12:{this._receiveReplyErr(F,x,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,F,L,w,x,W){this._logger&&this._logger.logIncoming(I,F,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${w}(`,x);const B=String(F);let G,H;if(W){const V=new E.CancellationTokenSource;x.push(V.token),G=this._invokeHandler(L,w,x),H=()=>V.cancel()}else G=this._invokeHandler(L,w,x),H=i;this._cancelInvokedHandlers[B]=H;const U=p.serializeAcknowledged(F);this._logger&&this._logger.logOutgoing(U.byteLength,F,1,"ack"),this._protocol.send(U),G.then(V=>{delete this._cancelInvokedHandlers[B];const Q=p.serializeReplyOK(F,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,F,1,"reply:",V),this._protocol.send(Q)},V=>{delete this._cancelInvokedHandlers[B];const Q=p.serializeReplyErr(F,V);this._logger&&this._logger.logOutgoing(Q.byteLength,F,1,"replyErr:",V),this._protocol.send(Q)})}_receiveCancel(I,F){this._logger&&this._logger.logIncoming(I,F,1,"receiveCancel");const L=String(F);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(I,F,L){this._logger&&this._logger.logIncoming(I,F,0,"receiveReply:",L);const w=String(F);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],x.resolveOk(L)}_receiveReplyErr(I,F,L){this._logger&&this._logger.logIncoming(I,F,0,"receiveReplyErr:",L);const w=String(F);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let W;L&&(L.$isError?(W=new Error,W.name=L.name,W.message=L.message,W.stack=L.stack):W=L),x.resolveErr(W)}_invokeHandler(I,F,L){try{return Promise.resolve(this._doInvokeHandler(I,F,L))}catch(w){return Promise.reject(w)}}_doInvokeHandler(I,F,L){const w=this._locals[I];if(!w)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(I));let x=w[F];if(typeof x!="function")throw new Error("Unknown method "+F+" on actor "+(0,t.getStringIdentifierForProxy)(I));return x.apply(w,L)}_remoteCall(I,F,L){if(this._isDisposed)return Promise.reject(A.canceled());let w=null;if(L.length>0&&E.CancellationToken.isCancellationToken(L[L.length-1])&&(w=L.pop()),w&&w.isCancellationRequested)return Promise.reject(A.canceled());const x=p.serializeRequestArguments(L,this._uriReplacer),W=++this._lastMessageId,B=String(W),G=new T.LazyPromise;w&&w.onCancellationRequested(()=>{const U=p.serializeCancel(W);this._logger&&this._logger.logOutgoing(U.byteLength,W,0,"cancel"),this._protocol.send(p.serializeCancel(W))}),this._pendingRPCReplies[B]=G,this._onWillSendRequest(W);const H=p.serializeRequest(W,I,F,x,!!w);return this._logger&&this._logger.logOutgoing(H.byteLength,W,0,`request: ${(0,t.getStringIdentifierForProxy)(I)}.${F}(`,L),this._protocol.send(H),G}}e.RPCProtocol=s,b=g,s.UNRESPONSIVE_TIME=3*1e3;class u{constructor(I,F){this._buff=I,this._offset=F}static alloc(I,F,L){let w=new u(M.VSBuffer.alloc(L+1+4),0);return w.writeUInt8(I),w.writeUInt32(F),w}static read(I,F){return new u(I,F)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,F}static sizeMixedArray(I){let F=0;F+=1;for(let L=0,w=I.length;L<w;L++){const x=I[L];switch(F+=1,x.type){case 1:F+=this.sizeLongString(x.value);break;case 2:F+=this.sizeVSBuffer(x.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(x.value);for(let W=0;W<x.buffers.length;++W)F+=this.sizeVSBuffer(x.buffers[W]);break;case 4:break}}return F}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let F=0,L=I.length;F<L;F++){const w=I[F];switch(w.type){case 1:this.writeUInt8(1),this.writeLongString(w.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(w.value);break;case 3:this.writeUInt8(3),this.writeUInt32(w.buffers.length),this.writeLongString(w.value);for(let x=0;x<w.buffers.length;++x)this.writeBuffer(w.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let F=new Array(I);for(let L=0;L<I;L++)switch(this.readUInt8()){case 1:F[L]=this.readLongString();break;case 2:F[L]=this.readVSBuffer();break;case 3:const x=this.readUInt32(),W=this.readLongString(),B=[];for(let G=0;G<x;++G)B.push(this.readVSBuffer());F[L]=new t.SerializableObjectWithBuffers(S(W,B,null));break;case 4:F[L]=void 0;break}return F}}u.sizeUInt32=4;var f;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(f||(f={}));class p{static _useMixedArgSerialization(I){for(let F=0,L=I.length;F<L;F++)if(I[F]instanceof M.VSBuffer||I[F]instanceof t.SerializableObjectWithBuffers||typeof I[F]=="undefined")return!0;return!1}static serializeRequestArguments(I,F){if(this._useMixedArgSerialization(I)){const L=[];for(let w=0,x=I.length;w<x;w++){const W=I[w];if(W instanceof M.VSBuffer)L[w]={type:2,value:W};else if(typeof W=="undefined")L[w]={type:4};else if(W instanceof t.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:G}=v(W.value,F);L[w]={type:3,value:M.VSBuffer.fromString(B),buffers:G}}else L[w]={type:1,value:M.VSBuffer.fromString(_(W,F))}}return{type:1,args:L}}return{type:0,args:_(I,F)}}static serializeRequest(I,F,L,w,x){switch(w.type){case 0:return this._requestJSONArgs(I,F,L,w.args,x);case 1:return this._requestMixedArgs(I,F,L,w.args,x)}}static _requestJSONArgs(I,F,L,w,x){const W=M.VSBuffer.fromString(L),B=M.VSBuffer.fromString(w);let G=0;G+=u.sizeUInt8(),G+=u.sizeShortString(W),G+=u.sizeLongString(B);let H=u.alloc(x?2:1,I,G);return H.writeUInt8(F),H.writeShortString(W),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(I){const F=I.readUInt8(),L=I.readShortString(),w=I.readLongString();return{rpcId:F,method:L,args:JSON.parse(w)}}static _requestMixedArgs(I,F,L,w,x){const W=M.VSBuffer.fromString(L);let B=0;B+=u.sizeUInt8(),B+=u.sizeShortString(W),B+=u.sizeMixedArray(w);let G=u.alloc(x?4:3,I,B);return G.writeUInt8(F),G.writeShortString(W),G.writeMixedArray(w),G.buffer}static deserializeRequestMixedArgs(I){const F=I.readUInt8(),L=I.readShortString(),w=I.readMixedArray(),x=new Array(w.length);for(let W=0,B=w.length;W<B;W++){const G=w[W];typeof G=="string"?x[W]=JSON.parse(G):x[W]=G}return{rpcId:F,method:L,args:x}}static serializeAcknowledged(I){return u.alloc(5,I,0).buffer}static serializeCancel(I){return u.alloc(6,I,0).buffer}static serializeReplyOK(I,F,L){if(typeof F=="undefined")return this._serializeReplyOKEmpty(I);if(F instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(I,F);if(F instanceof t.SerializableObjectWithBuffers){const{jsonString:w,referencedBuffers:x}=v(F.value,L,!0);return this._serializeReplyOKJSONWithBuffers(I,w,x)}else return this._serializeReplyOKJSON(I,n(F,L))}static _serializeReplyOKEmpty(I){return u.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,F){let L=0;L+=u.sizeVSBuffer(F);let w=u.alloc(8,I,L);return w.writeVSBuffer(F),w.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,F){const L=M.VSBuffer.fromString(F);let w=0;w+=u.sizeLongString(L);let x=u.alloc(9,I,w);return x.writeLongString(L),x.buffer}static _serializeReplyOKJSONWithBuffers(I,F,L){const w=M.VSBuffer.fromString(F);let x=0;x+=u.sizeUInt32,x+=u.sizeLongString(w);for(const B of L)x+=u.sizeVSBuffer(B);let W=u.alloc(10,I,x);W.writeUInt32(L.length),W.writeLongString(w);for(const B of L)W.writeBuffer(B);return W.buffer}static deserializeReplyOKJSON(I){const F=I.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(I,F){const L=I.readUInt32(),w=I.readLongString(),x=[];for(let W=0;W<L;++W)x.push(I.readVSBuffer());return new t.SerializableObjectWithBuffers(S(w,x,F))}static serializeReplyErr(I,F){return F?this._serializeReplyErrEror(I,F):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,F){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(F),null));let w=0;w+=u.sizeLongString(L);let x=u.alloc(11,I,w);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(I){const F=I.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(I){return u.alloc(12,I,0).buffer}}var C;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var P;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(P||(P={}))}),define(be[214],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const R=k=>{self.removeEventListener("message",R);const D=k.data;Object.defineProperties(self,{postMessage:{value(T,t){D.postMessage(T,t)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(A,R,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${d})('${R}'))`,T=new Blob([D],{type:"application/javascript"}),t=URL.createObjectURL(T),b=new MessageChannel,n=t,h={type:"_newWorker",id:n,port:b.port2,url:t,options:k};A(h,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};b.port1.postMessage(o),URL.revokeObjectURL(t),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(o){b.port1.onmessage=o}},onmessageerror:{get(){return b.port1.onmessageerror},set(o){b.port1.onmessageerror=o}}}),b.port1.addEventListener("messageerror",o=>{const l=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(l)}),b.port1.addEventListener("message",o=>{const l=new MessageEvent("message",{data:o.data});this.dispatchEvent(l)}),b.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,86,47,176,215]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let b=class $i{constructor(h,o,l,v){this.localUserHome=h,this.remoteAgentService=o,this.environmentService=l,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome||h})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,o){if(h.remoteAuthority)return d.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const v=o.getWorkspace().folders[0];if(v)return v.uri.scheme;const S=o.getWorkspace().configuration;return S?S.scheme:d.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?M.win32:M.posix)}async fileURI(h){let o="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(o=h.substring(2),h="/"):(o=h.substring(2,v),h=h.substring(v)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:o,path:h,query:"",fragment:""})}};b=$e([Ve(1,t.IRemoteAgentService),Ve(2,T.IWorkbenchEnvironmentService),Ve(3,D.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(R,k){this.line=R,this.character=k}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,k){return new d(0,0)}with(R){return new d(0,0)}}e.Position=d;class M{constructor(R,k,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(R,k),this.end=new d(D,T)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,13,27,23,43,9,4,17,16,98,10]),function(re,e,d,M,E,A,R,k,D,T,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",h=" characters skipped \u27EB",o=(n.length+h.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var l;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function S(U){return!!U.preview}e.resultIsMatch=S;function _(U){return!!U.resource}e.isFileMatch=_;function a(U){return!!U.message}e.isProgressMessage=a;var c;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=y;class i{constructor(V,Q,ne){this.ranges=Q;const ce=Array.isArray(Q)?Q:[Q];if(ne&&ne.matchLines===1&&g(ce)){V=(0,R.getNLines)(V,ne.matchLines);let Z="",oe=0,ve=0;const Ae=Math.floor(ne.charsPerLine/5),Se=[];for(const Ne of ce){const We=Math.max(Ne.startColumn-Ae,0),je=Ne.startColumn+ne.charsPerLine;if(We>ve+Ae+o){const qe=n+(We-ve)+h;Z+=qe+V.slice(We,je),oe+=We-(ve+qe.length)}else Z+=V.slice(ve,je);Se.push(new s(0,Ne.startColumn-oe,Ne.endColumn-oe)),ve=je}this.preview={text:Z,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const Z=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:V,matches:(0,d.mapArrayOrNot)(Q,oe=>new r(oe.startLineNumber-Z,oe.startColumn,oe.endLineNumber-Z,oe.endColumn))}}}}e.TextSearchMatch=i;function g(U){const V=U[0].startLineNumber;for(const Q of U)if(Q.startLineNumber!==V||Q.endLineNumber!==V)return!1;return!0}class r{constructor(V,Q,ne,ce){this.startLineNumber=V,this.startColumn=Q,this.endLineNumber=ne,this.endColumn=ce}}e.SearchRange=r;class s extends r{constructor(V,Q,ne){super(V,Q,V,ne)}}e.OneLineRange=s;var u;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function f(U,V=!0){const Q=U&&U.files&&U.files.exclude,ne=V&&U&&U.search&&U.search.exclude;if(!Q&&!ne)return;if(!Q||!ne)return Q||ne;let ce=Object.create(null);return ce=E.mixin(ce,E.deepClone(Q)),ce=E.mixin(ce,E.deepClone(ne),!0),ce}e.getExcludes=f;function p(U,V){return U.excludePattern&&M.match(U.excludePattern,V)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,V)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(Q=>{const ne=Q.folder.fsPath;if(A.isEqualOrParent(V,ne)){const ce=D.relative(ne,V);return!Q.includePattern||!!M.match(Q.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var C;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(C=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(V,Q){super(V);this.code=Q}}e.SearchError=P;function m(U){const V=U.message;if((0,T.isPromiseCanceledError)(U))return new P(V,C.canceled);try{const Q=JSON.parse(V);return new P(Q.message,Q.code)}catch(Q){return new P(V,C.other)}}e.deserializeSearchError=m;function I(U){const V={message:U.message,code:U.code};return new Error(JSON.stringify(V))}e.serializeSearchError=I;function F(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=F;function L(U){return U.type==="success"}e.isSerializedSearchSuccess=L;function w(U){return!!U.path}e.isSerializedFileMatch=w;function x(U,V){const Q=U.searchPath?U.searchPath:U.relativePath;return(0,R.fuzzyContains)(Q,V)}e.isFilePatternMatch=x;class W{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function B(U,V){const Q={...U||{},...V||{}};return Object.keys(Q).filter(ne=>{const ce=Q[ne];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=B;class G{constructor(V,Q){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ne=V.includePattern;Q.includePattern&&(ne?ne={...ne,...Q.includePattern}:ne=Q.includePattern),ne&&(this._parsedIncludeExpression=M.parse(ne))}matchesExcludesSync(V,Q,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,Q,ne))}includedInQuerySync(V,Q,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,Q,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,Q,ne))}includedInQuery(V,Q,ne){const ce=this._parsedExcludeExpression(V,Q,ne),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,Q,ne):!0;return(0,b.isPromise)(ce)?ce.then(oe=>oe?!1:Z()):Z()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=G;function H(U){for(const V in U)if(typeof U[V]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,12,7,41,5]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a,c,y,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(I,F,L){return new T.ExtUri(w=>p(w,L)).isEqual(I,F)}function s(I,F,L){return r(I.uri,F.uri,L)?0:(0,t.compare)(I.uri.toString(),F.uri.toString())}function u(I,F,L){return I.index!==F.index?I.index<F.index?-1:1:r(I.uri,F.uri,L)?(0,t.compare)(I.name,F.name):(0,t.compare)(I.uri.toString(),F.uri.toString())}function f(I,F,L,w){const x=I.slice(0).sort((B,G)=>L(B,G,w)),W=F.slice(0).sort((B,G)=>L(B,G,w));return(0,d.delta)(x,W,(B,G)=>L(B,G,w))}function p(I,F){const L=F.getCapabilities(I.scheme);return!(L&&L&1024)}class C extends S.Workspace{constructor(F,L,w,x,W,B,G){super(F,w.map(H=>new S.WorkspaceFolder(H)),x,W,G);this._name=L,this._isUntitled=B,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(G),w.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(F,L,w,x){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:B,folders:G,configuration:H,transient:U,isUntitled:V}=F,Q=[],ne=L;L?G.forEach((ve,Ae)=>{const Se=n.URI.revive(ve.uri),Ne=C._findFolder(w||L,Se,x);Ne?(Ne.name=ve.name,Ne.index=ve.index,Q.push(Ne)):Q.push({uri:Se,name:ve.name,index:Ae})}):Q.push(...G.map(({uri:ve,name:Ae,index:Se})=>({uri:n.URI.revive(ve),name:Ae,index:Se}))),Q.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const ce=new C(W,B,Q,!!U,H?n.URI.revive(H):null,!!V,ve=>p(ve,x)),{added:Z,removed:oe}=f(ne?ne.workspaceFolders:[],ce.workspaceFolders,s,x);return{workspace:ce,added:Z,removed:oe}}static _findFolder(F,L,w){for(let x=0;x<F.folders.length;x++){const W=F.workspaceFolders[x];if(r(W.uri,L,w))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,L){return L&&this._structure.get(F)&&(F=(0,T.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let P=class{constructor(F,L,w,x){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=w,this._requestIdProvider=new D.Counter,this._barrier=new M.Barrier,this._proxy=F.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(g.MainContext.MainThreadMessageService);const W=L.workspace;this._confirmedWorkspace=W?new C(W.id,W.name,[],!!W.transient,W.configuration?n.URI.revive(W.configuration):null,!!W.isUntitled,B=>p(B,w)):void 0}$initializeWorkspace(F,L){this._trusted=L,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:k.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,L,w,...x){const W=[];if(Array.isArray(x)&&x.forEach(V=>{n.URI.isUri(V.uri)&&!W.some(Q=>r(Q.uri,V.uri,this._extHostFileSystemInfo))&&W.push({uri:V.uri,name:V.name||(0,T.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[L,w].some(V=>typeof V!="number"||V<0)||w===0&&W.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+w>B.length)return!1;const G=B.slice(0);G.splice(L,w,...W.map(V=>({uri:V.uri,name:V.name||(0,T.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<G.length;V++){const Q=G[V];if(G.some((ne,ce)=>ce!==V&&r(Q.uri,ne.uri,this._extHostFileSystemInfo)))return!1}G.forEach((V,Q)=>V.index=Q);const{added:H,removed:U}=f(B,G,u,this._extHostFileSystemInfo);if(H.length===0&&U.length===0)return!1;if(this._proxy){const V=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(V,L,w,W).then(void 0,Q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,h.localize)(0,null,V,Q.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(F,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,L)}async getWorkspaceFolder2(F,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,L)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,L){let w,x="";if(typeof F=="string"?(w=n.URI.file(F),x=F):typeof F!="undefined"&&(w=F,x=F.fsPath),!w)return x;const W=this.getWorkspaceFolder(w,!0);if(!W)return x;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let B=(0,T.relativePath)(W.uri,w);return L&&W.name&&(B=`${W.name}/${B}`),B}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:L,added:w,removed:x}=C.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:w,removed:x}))}findFiles(F,L,w,x,W=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let B;if(L===null?B=!1:L&&(typeof L=="string"?B=L:B=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:H}=m(F);return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(G),(0,b.withUndefinedAsNull)(H),(0,b.withUndefinedAsNull)(B),(0,b.withUndefinedAsNull)(w),W).then(U=>Array.isArray(U)?U.map(V=>n.URI.revive(V)):[])}async findTextInFiles(F,L,w,x,W=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),G=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:U}=m(L.include),V=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Q={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:V},ne=!1;if(this._activeSearchCallbacks[B]=ce=>{if(ne)return;const Z=n.URI.revive(ce.resource);ce.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?w({uri:Z,preview:{text:oe.preview.text,matches:(0,d.mapArrayOrNot)(oe.preview.matches,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(oe.ranges,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):w({uri:Z,text:oe.text,lineNumber:oe.lineNumber})})},W.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(F,(0,b.withUndefinedAsNull)(U),Q,B,W);return delete this._activeSearchCallbacks[B],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[B],ce}}$handleTextSearchResult(F,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=$e([Ve(0,c.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,_.IExtHostFileSystemInfo),Ve(3,l.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function m(I){let F,L;return I&&(typeof I=="string"?F=I:(F=I.pattern,L=I.baseFolder||n.URI.file(I.base))),{includePattern:F,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,148,62,10,14,4,12,15,2]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(g,r){if(r){const s=r.split(".");let u=g;for(let f=0;u&&f<s.length;f++)u=u[s[f]];return u}}function v(g){return g instanceof o.URI}function S(g){return g&&g.uri instanceof o.URI&&g.languageId&&typeof g.languageId=="string"}function _(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function a(g){return g&&g.uri instanceof o.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function c(g){if(v(g))return{resource:g};if(S(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(_(g))return{overrideIdentifier:g.languageId};if(a(g))return{resource:g.uri};if(g===null)return{resource:null}}let y=class{constructor(r,s,u){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,s))}};y=$e([Ve(0,n.IExtHostRpcService),Ve(1,E.IExtHostWorkspace),Ve(2,h.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(r,s,u,f){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=s,this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(r,s,u){const f=c(s)||{},p=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,u?.identifier);function C(m){if(m==null)return null;if(typeof m=="boolean")return m?1:4;switch(m){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(m){return typeof l(p,m)!="undefined"},get:(m,I)=>{this._validateConfigurationAccess(r?`${r}.${m}`:m,f,u?.identifier);let F=l(p,m);if(typeof F=="undefined")F=I;else{let L;const w=(x,W)=>{let B;const G=()=>{L=L||(0,d.deepClone)(p),B=B||l(L,W)};return(0,T.isObject)(x)?new Proxy(x,{get:(H,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return G(),()=>B;if(L)return B=B||l(L,W),B[U];const V=H[U];return typeof U=="string"?w(V,`${W}.${U}`):V},set:(H,U,V)=>(G(),B&&(B[U]=V),!0),deleteProperty:(H,U)=>(G(),B&&delete B[U],!0),defineProperty:(H,U,V)=>(G(),B&&Object.defineProperty(B,U,V),!0)}):x};F=w(F,m)}return F},update:(m,I,F,L)=>{m=r?`${r}.${m}`:m;const w=C(F);return I!==void 0?this._proxy.$updateConfigurationOption(w,m,I,f,L):this._proxy.$removeConfigurationOption(w,m,f,L)},inspect:m=>{m=r?`${r}.${m}`:m;const I=(0,d.deepClone)(this._configuration.inspect(m,f,this._extHostWorkspace.workspace));if(I)return{key:m,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof p=="object"&&(0,d.mixin)(P,p,!1),Object.freeze(P)}_toReadonlyValue(r){const s=u=>(0,T.isObject)(u)?new Proxy(u,{get:(f,p)=>s(f[p]),set:(f,p,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(f,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(f,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(r)}_validateConfigurationAccess(r,s,u){const f=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),p=u?`[${u.value}] `:"";if(f===4){typeof s?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){s?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const u=new k.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,p)=>u.affectsConfiguration(f,c(p))})}_toMap(r){return r.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,40,12,29,4,11,25,15,69,166,16]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a,c){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var g;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(g=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(W){function B(U){if(U){const V=U;return V&&!!V.process}else return!1}W.is=B;function G(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=r.from(U.options)),V}W.from=G;function H(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}W.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(W){function B(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}W.is=B;function G(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=u.from(U.options)),V}W.from=G;function H(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}W.to=H})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(W){function B(U){if(U){let V=U;return V&&V.customExecution==="customExecution"}else return!1}W.is=B;function G(U){return{customExecution:"customExecution"}}W.from=G;function H(U,V){return V.get(U)}W.to=H})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(W){function B(G,H){let U;return G.scope!==void 0&&typeof G.scope!="number"?U=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===R.TaskScope.Workspace&&H&&H.workspaceFile?U=H.workspaceFile:U=a.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:U}}W.from=B})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var P;(function(W){function B(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}W.from=B})(P=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function(W){function B(U,V){if(U==null)return[];const Q=[];for(let ne of U){const ce=G(ne,V);ce&&Q.push(ce)}return Q}W.fromMany=B;function G(U,V){if(U==null)return;let Q;U.execution instanceof R.ProcessExecution?Q=s.from(U.execution):U.execution instanceof R.ShellExecution?Q=f.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(Q=p.from(U.execution));const ne=i.from(U.definition);let ce;return U.scope?typeof U.scope=="number"?ce=U.scope:ce=U.scope.uri:ce=R.TaskScope.Workspace,!ne||!ce?void 0:{_id:U._id,definition:ne,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:ce},execution:Q,isBackground:U.isBackground,group:P.from(U.group),presentationOptions:g.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=G;async function H(U,V,Q){if(U==null)return;let ne;s.is(U.execution)?ne=s.to(U.execution):f.is(U.execution)?ne=f.to(U.execution):p.is(U.execution)&&(ne=p.to(U._id,Q));const ce=i.to(U.definition);let Z;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Z=U.source.scope:Z=await V.resolveWorkspaceFolder(d.URI.revive(U.source.scope)):Z=R.TaskScope.Workspace),!ce||!Z)return;const oe=new R.Task(ce,Z,U.name,U.source.label,ne,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=R.TaskGroup.from(U.group._id),oe.group&&U.group.isDefault&&(oe.group=new R.TaskGroup(oe.group.id,oe.group.label),U.group.isDefault&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=g.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}W.to=H})(m=e.TaskDTO||(e.TaskDTO={}));var I;(function(W){function B(H){return H}W.from=B;function G(H){if(!!H)return Object.assign(Object.create(null),H)}W.to=G})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(B,G,H){this._id=G,this._task=H,y.set(this,void 0),et(this,y,B,"f")}get task(){return this._task}terminate(){Fe(this,y,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}y=new WeakMap;var L;(function(W){function B(G){return{id:G._id,task:void 0}}W.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let w=class{constructor(B,G,H,U,V,Q,ne,ce){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=U,this._configurationService=V,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ne,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,H){if(!H)return new R.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:G,provider:H,extension:B}),this._proxy.$registerTaskProvider(U,G),new R.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(I.from(B)).then(async G=>{const H=[];for(let U of G){const V=await m.to(U,this._workspaceProvider,this._providedCustomExecutions2);V&&H.push(V)}return H})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,H){const U=this._providedCustomExecutions2.get(B.id);if(U){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,U),this._terminalService.attachPtyToTerminal(G,await U.callback(H))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));const U=[],V=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,U,H,Q));return new Promise(Q=>{V.then(ne=>{Promise.all(U).then(()=>{Q(ne)})})})}async $resolveTask(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));if(G.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${H.type}].`);const U=await m.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await H.provider.resolveTask(U,t.CancellationToken.None);if(!V)return;this.checkDeprecation(V,H);const Q=m.from(V,H.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Q.execution)&&await this.addCustomExecution(Q,V,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,H){const U=await this._proxy.$createTaskId(B);!H&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const V=this._taskExecutionPromises.get(B);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let H=this._taskExecutionPromises.get(B.id);if(H)return H;const U=new Promise(async(V,Q)=>{const ne=G||await m.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);ne?V(new F(this,B.id,ne)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,U),U.then(V=>(this._taskExecutions.set(B.id,V),V),V=>Promise.reject(V))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let H=this._notProvidedCustomExecutions.values(),U=H.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=H.next()}};w=$e([Ve(0,n.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,k.IExtHostWorkspace),Ve(3,D.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,S.ILogService),Ve(7,_.IExtHostApiDeprecationService)],w),e.ExtHostTaskBase=w;let x=class extends w{constructor(B,G,H,U,V,Q,ne,ce){super(B,G,H,U,V,Q,ne,ce);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const H=m.from(G,B);if(H===void 0)throw new Error("Task is not valid");if(p.is(H.execution))await this.addCustomExecution(H,G,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),G);return this._proxy.$executeTask(H).catch(V=>{throw new Error(V)}),U}provideTasksInternal(B,G,H,U){const V=[];if(U)for(let Q of U){this.checkDeprecation(Q,H),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const ne=m.from(Q,H.extension);ne&&p.is(ne.execution)?(V.push(ne),G.push(this.addCustomExecution(ne,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:H.extension}}async resolveTaskInternal(B){if(p.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,H){}};x=$e([Ve(0,n.IExtHostRpcService),Ve(1,h.IExtHostInitDataService),Ve(2,k.IExtHostWorkspace),Ve(3,D.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,S.ILogService),Ve(7,_.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,216,41]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(C,P,m,I){this.configurationService=C,this.workspaceContextService=P,this.editorGroupsService=m,this.pathService=I}text(C,P,m={}){C=this.getContentPattern(C,m);const I=this.configurationService.getValue(),F=P&&P.some(w=>!this.configurationService.getValue({resource:w}).search.useRipgrep);return{...this.commonQuery(P?.map(v.toWorkspaceFolder),m),type:2,contentPattern:C,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles}}getContentPattern(C,P){const m=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const I={...C,wordSeparators:m.editor.wordSeparators};return this.isCaseSensitive(C,P)&&(I.isCaseSensitive=!0),this.isMultiline(C)&&(I.isMultiline=!0),I}file(C,P={}){return{...this.commonQuery(C,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(C,P){return C?(C=Array.isArray(C)?C.map(s):s(C),P?this.parseSearchPaths(C):{pattern:i(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],P={}){const m=this.handleIncludeExclude(P.includePattern,P.expandPatterns),I=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),F=C.length>1,L=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,P,I)):C.map(W=>this.getFolderQueryForRoot(W,P,I,F))).filter(W=>!!W),w={_reason:P._reason,folderQueries:L,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:I.pattern,includePattern:m.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const B=d.coalesce(d.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(U=>U.resource)))).filter(H=>(0,a.pathIncludedInQuery)(w,H.fsPath)),G=this.commonQueryFromFileList(B);return{...w,...G}}const x=P.extraFileResources&&P.extraFileResources.filter(W=>(0,a.pathIncludedInQuery)(w,W.fsPath));return w.extraFileResources=x&&x.length?x:void 0,w}commonQueryFromFileList(C){const P=[],m=new R.ResourceMap,I={};let F=!1;return C.forEach(L=>{if(L.scheme===k.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:D.dirname(L.fsPath)});let W=m.get(x);W||(F=!0,W={folder:x,includePattern:{}},P.push(W),m.set(x,W));const B=D.relative(x.fsPath,L.fsPath);(0,b.assertIsDefined)(W.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(F=!0,I[L.fsPath]=!0)}),{folderQueries:P,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(C,P){if(P.isSmartCase){if(C.isRegExp){if(t.containsUppercaseCharacter(C.pattern,!0))return!0}else if(t.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,h.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const P=G=>D.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),I=(Array.isArray(C)?C:g(C)).map(G=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(G,H.scheme===k.Schemas.file?H.fsPath:H.path):G}),F=M.groupBy(I,G=>P(G)?"searchPaths":"exprSegments"),L=(F.exprSegments||[]).map(G=>t.rtrim(G,"/")).map(G=>t.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),r(G))),w={},x=this.expandSearchPathPatterns(F.searchPaths||[]);x&&x.length&&(w.searchPaths=x);const W=d.flatten(L),B=i(...W);return B&&(w.pattern=B),w}getExcludesForFolder(C,P){return P.disregardExcludeSettings?void 0:(0,a.getExcludes)(C,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const P=d.flatten(C.map(I=>{let{pathPortion:F,globPortion:L}=y(I);L&&(L=u(L));const w=this.expandOneSearchPath(F);return d.flatten(w.map(x=>this.resolveOneSearchPathPattern(x,L)))})),m=new Map;return P.forEach(I=>{const F=I.searchPath.toString(),L=m.get(F);L?I.pattern&&(L.pattern=L.pattern||{},L.pattern[I.pattern]=!0):m.set(F,{searchPath:I.searchPath,pattern:I.pattern?i(I.pattern):void 0})}),Array.from(m.values())}expandOneSearchPath(C){if(D.isAbsolute(C)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==k.Schemas.file?[{searchPath:P[0].uri.with({path:C})}]:[{searchPath:n.URI.file(D.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=s(C),C.startsWith("../")||C===".."){const I=D.posix.resolve(P.path,C);return[{searchPath:P.with({path:I})}]}const m=u(C);return[{searchPath:P,pattern:m}]}else{if(C==="./"||C===".\\")return[];{const P=C.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(F=>{const L=P.match(new RegExp(`^${t.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return L?{match:L,folder:F}:null}).filter(b.isDefined);if(I.length)return I.map(F=>{const L=F.match[1];return{searchPath:F.folder.uri,pattern:L&&u(L)}});{const F=C.match(/\.[\/\\](.+)[\/\\]?/),L=F?F[1]:C,w=o.localize(0,null,L);throw new Error(w)}}}}resolveOneSearchPathPattern(C,P){const m=C.pattern&&P?`${C.pattern}/${P}`:C.pattern||P,I=[{searchPath:C.searchPath,pattern:m}];return m&&!m.endsWith("**")&&I.push({searchPath:C.searchPath,pattern:m+"/**"}),I}getFolderQueryForSearchPath(C,P,m){const I=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(C.searchPath),P,m,!1);return I?{...I,includePattern:C.pattern}:null}getFolderQueryForRoot(C,P,m,I){let F;const L=n.URI.isUri(C)?C:C.uri;if(m.searchPaths){const G=m.searchPaths.filter(H=>(0,T.isEqual)(H.searchPath,L))[0];if(G&&!G.pattern)return null;G&&(F=G.pattern)}const w=this.configurationService.getValue({resource:L}),W={...this.getExcludesForFolder(w,P)||{},...F||{}},B=n.URI.isUri(C)?(0,T.basename)(C):C.name;return{folder:L,folderName:I?B:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:w.files&&w.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!w.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!w.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!w.search.followSymlinks}}};c=$e([Ve(0,l.IConfigurationService),Ve(1,v.IWorkspaceContextService),Ve(2,S.IEditorGroupsService),Ve(3,_.IPathService)],c),e.QueryBuilder=c;function y(p){const C=p.match(/[\*\{\}\(\)\[\]\?]/);if(C){const P=C.index,m=p.substr(0,P).match(/[/|\\][^/\\]*$/);if(m){let I=p.substr(0,m.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:p.substr((m.index||0)+1)}}}return{pathPortion:p}}function i(...p){return p.length?p.reduce((C,P)=>(C[P]=!0,C),Object.create(null)):void 0}function g(p){return E.splitGlobAware(p,",").map(C=>C.trim()).filter(C=>!!C.length)}function r(p){return[`**/${p}/**`,`**/${p}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function u(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(p,C){p=d.distinct(p,I=>I.toString());const P=[],m=C.getWorkspace();return p&&p.forEach(I=>{let F;if(C.getWorkbenchState()===2)F=(0,T.relativePath)(m.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const L=C.getWorkspaceFolder(I);if(L){const w=L.name;if(m.folders.filter(W=>W.name===w).length===1){const W=(0,T.relativePath)(L.uri,I);W===""?F=`./${L.name}`:F=`./${L.name}/${W}`}else F=I.fsPath}}F&&P.push(F)}),P}e.resolveResourcesForSearchIncludes=f}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,47]),function(re,e,d,M,E,A,R,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function b(l,v){const S=v.activationEvents;if(!S)return Promise.resolve(void 0);const _=[],a=[];for(const s of S)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||l.forceUsingSearch?a.push(u):_.push(u)}if(_.length===0&&a.length===0)return Promise.resolve(void 0);let c;const y=new Promise((s,u)=>{c=s}),i=s=>c({activationEvent:s}),g=Promise.all(_.map(s=>n(l,s,i))).then(()=>{}),r=h(l,v.identifier,a,i);return Promise.all([g,r]).then(()=>{c(void 0)}),y}e.checkActivateWorkspaceContainsExtension=b;async function n(l,v,S){for(const _ of l.folders)if(await l.exists(d.joinPath(M.URI.revive(_),v))){S(`workspaceContains:${v}`);return}}async function h(l,v,S,_){if(S.length===0)return Promise.resolve(void 0);const a=new E.CancellationTokenSource,c=l.checkExists(l.folders,S,a.token),y=setTimeout(async()=>{a.cancel(),_(`workspaceContainsTimeout:${S.join(",")}`)},t);let i=!1;try{i=await c}catch(g){A.isPromiseCanceledError(g)||A.onUnexpectedError(g)}a.dispose(),clearTimeout(y),i&&_(`workspaceContains:${S.join(",")}`)}function o(l,v,S,_){const a=l.get(R.IInstantiationService),c=l.get(D.ISearchService),i=a.createInstance(k.QueryBuilder).file(v.map(g=>(0,T.toWorkspaceFolder)(M.URI.revive(g))),{_reason:"checkExists",includePattern:S,exists:!0});return c.fileSearch(i,_).then(g=>!!g.limitHit,g=>A.isPromiseCanceledError(g)?!1:Promise.reject(g))}e.checkGlobFileExists=o});var et=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Fe=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,179,72,31,30,177,16,26,22,153,7,85,4,29,73,12,61,64,40,3,218,68,155]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a,c,y,i,g,r,s,u,f,p,C,P,m,I,F,L){"use strict";var w,x,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let B=class Wi extends k.Disposable{constructor(V,Q,ne,ce,Z,oe,ve,Ae,Se,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new m.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=ne,this._initData=ve,this._extHostWorkspace=ce,this._extHostConfiguration=Z,this._logService=oe,this._extHostTunnelService=Se,this._extHostTerminalService=Ne,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=V.createChild(new p.ServiceCollection([o.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(je=>We.add(a.ExtensionIdentifier.toKey(je))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,qe,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,_.transformErrorForSerialization(qe),$)},actualActivateExtension:async(je,qe)=>{if(We.has(a.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,qe),new h.HostExtension;const $=this._registry.getExtensionDescription(je);return this._activateExtension($,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){_.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch(Q){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Q){return this._activator.activateByEvent(V,Q)}_activateById(V,Q){return this._activator.activateById(V,Q)}activateByIdWithErrors(V,Q){return this._activateById(V,Q).then(()=>{const ne=this._activator.getActivatedExtension(V);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const V=D.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(ce=>V.set(T.URI.file(ce).fsPath,ne))});this._extensionPathIndex=Promise.all(Q).then(()=>V)}return this._extensionPathIndex}_deactivate(V){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Q;const ne=this._activator.getActivatedExtension(V);if(!ne)return Q;try{typeof ne.module.deactivate=="function"&&(Q=Promise.resolve(ne.module.deactivate()).then(void 0,ce=>(this._logService.error(ce),Promise.resolve(void 0))))}catch(ce){this._logService.error(ce)}try{(0,k.dispose)(ne.subscriptions)}catch(ce){this._logService.error(ce)}return Q}async _activateExtension(V,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Q).then(ne=>{const ce=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,Q),this._logExtensionActivationTimes(V,Q,"success",ce),ne},ne=>{throw this._logExtensionActivationTimes(V,Q,"failure"),ne})}_logExtensionActivationTimes(V,Q,ne,ce){const Z=G(V,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ce||{},outcome:ne})}_doActivateExtension(V,Q){const ne=G(V,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const ce=this._getEntryPoint(V);if(!ce)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${V.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const Z=new h.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,ce),Z),this._loadExtensionContext(V)]).then(oe=>(E.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wi._callActivate(this._logService,V.identifier,oe[0],oe[1],Z))).then(oe=>(E.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),oe))}_loadExtensionContext(V){const Q=new y.ExtensionGlobalMemento(V,this._storage),ne=new y.ExtensionMemento(V.identifier.value,!1,this._storage),ce=new L.ExtensionSecrets(V,this._secretState),Z=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Q.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Ae;return Object.freeze({globalState:Q,workspaceState:ne,secrets:ce,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Se){return M.join(V.extensionLocation.fsPath,Se)},get storagePath(){return ve._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(V).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return T.URI.joinPath(ve._initData.logsLocation,V.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(V)},get globalStorageUri(){return ve._storagePath.globalValue(V)},get extensionMode(){return Z},get extension(){return Ae===void 0&&(Ae=new H(ve,V.identifier,V,oe)),Ae},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(V),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Q,ne,ce,Z){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Q,ne,ce,Z).then(oe=>new h.ActivatedExtension(!1,null,Z.build(),ne,oe,ce.subscriptions))}static _callActivateOptional(V,Q,ne,ce,Z){if(typeof ne.activate=="function")try{Z.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const oe=typeof global=="object"?global:self,ve=ne.activate.apply(oe,[ce]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(ve).then(Ae=>(Z.activateResolveStop(),Ae))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(ne)}_activateOneStartupFinished(V,Q){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Q}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Q of V.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(V,Q)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Q),ce=Promise.all([V,ne]).then(()=>{});return Promise.race([ce,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(V,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Q){if(this.isActivated(Q.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ce={folders:V.map(oe=>oe.uri),forceUsingSearch:ne,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,ve,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(oe,ve,Ae)},Z=await(0,I.checkActivateWorkspaceContainsExtension)(ce,Q);if(!!Z)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:Z.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Q}=this._initData.environment;if(!V||!Q)throw new Error(d.localize(0,null));const ne=await this._loadCommonJSModule(null,Q,new h.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(d.localize(1,null,Q.toString()));return new Promise((ce,Z)=>{const oe=(Se,Ne)=>{Se?Z(Se):ce(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(Q),Ae=ne.run(ve,oe);Ae&&Ae.then&&Ae.then(()=>{ce(0)}).catch(Se=>{Z(Se.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,Q){return this._resolvers[V]=Q,(0,k.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Q=V.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const ne=V.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(V,Q){const{authorityPrefix:ne,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)return{type:"error",error:{code:g.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ce)),E.mark(`code/extHost/willResolveAuthority/${ne}`);const Z=await ce.resolve(V,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const oe={authority:V,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},ve={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted};return{type:"ok",value:{authority:oe,options:ve,tunnelInformation:{environmentTunnels:Z.environmentTunnels}}}}catch(Z){if(E.mark(`code/extHost/didResolveAuthorityError/${ne}`),Z instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(V,Q){const{authorityPrefix:ne,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const Z=T.URI.revive(Q);if(typeof ce.getCanonicalURI=="undefined")return Z;const oe=await(0,R.asPromise)(()=>ce.getCanonicalURI(Z));return oe||Z}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Q){return Q===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(V,!1))}async $activate(V,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Q),!0):!1}async $deltaExtensions(V,Q){V.forEach(ce=>ce.extensionLocation=T.URI.revive(ce.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ce=>{const Z=this._registry.getExtensionDescription(ce);if(!Z)return;const oe=await this._hostUtils.realpath(Z.extensionLocation.fsPath);ne.delete(T.URI.file(oe).fsPath)})),await Promise.all(V.map(async ce=>{const Z=await this._hostUtils.realpath(ce.extensionLocation.fsPath);ne.set(T.URI.file(Z).fsPath,ce)})),this._registry.deltaExtensions(V,Q),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Q=c.VSBuffer.alloc(V),ne=Math.random()%256;for(let ce=0;ce<V;ce++)Q.writeUInt8(ne,ce);return Q}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};B=$e([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,f.IExtHostRpcService),Ve(3,l.IExtHostWorkspace),Ve(4,n.IExtHostConfiguration),Ve(5,t.ILogService),Ve(6,s.IExtHostInitDataService),Ve(7,u.IExtensionStoragePaths),Ve(8,C.IExtHostTunnelService),Ve(9,P.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function G(U,V){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class H{constructor(V,Q,ne,ce){w.set(this,void 0),x.set(this,void 0),W.set(this,void 0),et(this,w,V,"f"),et(this,x,Q,"f"),et(this,W,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ce}get isActive(){return Fe(this,w,"f").isActivated(Fe(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,w,"f").getExtensionExports(Fe(this,W,"f"))}activate(){return Fe(this,w,"f").activateByIdWithErrors(Fe(this,W,"f"),{startup:!1,extensionId:Fe(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=H,w=new WeakMap,x=new WeakMap,W=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,49,168,32,164,12,4,10,91,70]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let c=class{constructor(p,C,P,m,I,F){this._workspaceService=C,this._extensionService=P,this._editorsService=m,this._configurationService=I,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=p.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(w=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,C){const P=p;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let m=`debug:${encodeURIComponent(P.path||"")}`,I="?";return C&&(m+=`${I}session=${encodeURIComponent(C.id)}`,I="&"),m+=`${I}ref=${P.sourceReference}`,M.URI.parse(m)}else{if(P.path)return M.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const C=[];for(const P of p.getAllExtensionDescriptions())if(P.contributes){const m=P.contributes.debuggers;if(m&&m.length>0)for(const I of m)(0,o.isDebuggerMainContribution)(I)&&C.push(I.type)}this._debugServiceProxy.$registerDebugTypes(C)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(C=>p.push(C)),p}addBreakpoints(p){this.startBreakpoints();const C=p.filter(I=>{const F=I.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,I),!0)});this.fireBreakpointChanges(C,[],[]);const P=[],m=new Map;for(const I of C)if(I instanceof k.SourceBreakpoint){let F=m.get(I.location.uri.toString());F||(F={type:"sourceMulti",uri:I.location.uri,lines:[]},m.set(I.location.uri.toString(),F),P.push(F)),F.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof k.FunctionBreakpoint&&P.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(p){this.startBreakpoints();const C=p.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],C,[]);const P=C.filter(F=>F instanceof k.SourceBreakpoint).map(F=>F.id),m=C.filter(F=>F instanceof k.FunctionBreakpoint).map(F=>F.id),I=C.filter(F=>F instanceof k.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(P,m,I)}startDebugging(p,C,P){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,C,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI,suppressSaveBeforeStart:P.suppressSaveBeforeStart})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,C,P){if(!C)return new k.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:m,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,P,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,m),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(p,C,P){if(!P)return new k.Disposable(()=>{});if(!this.definesDebugType(p,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:m,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,m),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(p,C){if(!C)return new k.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:P,factory:C}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==C)})}async $runInTerminal(p,C){return Promise.resolve(void 0)}async $substituteVariables(p,C){if(!this._variableResolver){const[I,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,F)}let P;const m=await this.getFolder(p);return m&&(P={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,C)}createDebugAdapter(p,C){if(p.type==="implementation")return new s(p.implementation)}createSignService(){}async $startDASession(p,C){const P=this,m=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const F=this.convertToDto(I),L=this.createDebugAdapter(F,m);if(!L)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const w=L;return this._debugAdapters.set(p,w),this.getDebugAdapterTrackers(m).then(x=>(x&&this._debugAdaptersTrackers.set(p,x),w.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const B=W,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(B.arguments.value);G.body={signature:H},w.sendResponse(G)}else throw new Error("no signer")}catch(H){G.success=!1,G.message=H.message,w.sendResponse(G)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(W),W=(0,o.convertToVSCPaths)(W,!0),P._debugServiceProxy.$acceptDAMessage(p,W)}),w.onError(W=>{x&&x.onError&&x.onError(W),this._debugServiceProxy.$acceptDAError(p,W.name,W.message,W.stack)}),w.onExit(W=>{x&&x.onExit&&x.onExit((0,S.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,S.withNullAsUndefined)(W),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),w.startSession()))})}$sendDAMessage(p,C){C=(0,o.convertToDAPaths)(C,!1);const P=this._debugAdaptersTrackers.get(p);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(C);const m=this._debugAdapters.get(p);m&&m.sendMessage(C)}$stopDASession(p){const C=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),C&&C.onWillStopSession&&C.onWillStopSession();const P=this._debugAdapters.get(p);return this._debugAdapters.delete(p),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const C=[],P=[],m=[];if(p.added)for(const I of p.added){const F=I.id;if(F&&!this._breakpoints.has(F)){let L;if(I.type==="function")L=new k.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")L=new k.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const w=M.URI.revive(I.uri);L=new k.SourceBreakpoint(new k.Location(w,new k.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}L._id=F,this._breakpoints.set(F,L),C.push(L)}}if(p.removed)for(const I of p.removed){const F=this._breakpoints.get(I);F&&(this._breakpoints.delete(I),P.push(F))}if(p.changed){for(const I of p.changed)if(I.id){const F=this._breakpoints.get(I.id);if(F){if(F instanceof k.FunctionBreakpoint&&I.type==="function"){const L=F;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.functionName=I.functionName}else if(F instanceof k.SourceBreakpoint&&I.type==="source"){const L=F;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.location=new k.Location(M.URI.revive(I.uri),new k.Position(I.line,I.character))}m.push(F)}}}this.fireBreakpointChanges(C,P,m)}$provideDebugConfigurations(p,C,P){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(p);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(C);return m.provideDebugConfigurations(I,P)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(p,C,P,m){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(p);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(C);return I.resolveDebugConfiguration(F,P,m)})}$resolveDebugConfigurationWithSubstitutedVariables(p,C,P,m){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(p);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(C);return I.resolveDebugConfigurationWithSubstitutedVariables(F,P,m)})}async $provideDebugAdapter(p,C){const P=this.getAdapterDescriptorFactoryByHandle(p);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(C);return this.getAdapterDescriptor(P,m).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(p){const C=await this.getSession(p);this._onDidStartDebugSession.fire(C)}async $acceptDebugSessionTerminated(p){const C=await this.getSession(p);C&&(this._onDidTerminateDebugSession.fire(C),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,C){const P=await this.getSession(p);P&&P._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(p,C){const m={session:await this.getSession(p),event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(p){if(p instanceof k.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof k.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const C=this._adapterFactories.filter(P=>P.type===p);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(p){const C=this._adapterFactories.filter(P=>P.handle===p);if(C.length>0)return C[0].factory}getConfigProviderByHandle(p){const C=this._configProviders.filter(P=>P.handle===p);if(C.length>0)return C[0].provider}definesDebugType(p,C){if(p.contributes){const P=p.contributes.debuggers;if(P&&P.length>0){for(const m of P)if(m.label&&m.type&&m.type===C)return!0}}return!1}getDebugAdapterTrackers(p){const P=p.configuration.type,m=this._trackerFactories.filter(I=>I.type===P||I.type==="*").map(I=>(0,A.asPromise)(()=>I.factory.createDebugAdapterTracker(p)).then(F=>F,F=>null));return Promise.race([Promise.all(m).then(I=>{const F=I.filter(L=>!!L);if(F.length>0)return new r(F)}),new Promise((I,F)=>{const L=setTimeout(()=>{clearTimeout(L),F(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(p,C){const P=C.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new k.DebugAdapterServer(P));if(p){const I=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>p.createDebugAdapterDescriptor(C,this.daExecutableFromPackage(C,I))).then(F=>{if(F)return F})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,m))}daExecutableFromPackage(p,C){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,C,P){(p.length>0||C.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:C,changed:P}))}async getSession(p){if(p)if(typeof p=="string"){const C=this._debugSessions.get(p);if(C)return C}else{let C=this._debugSessions.get(p.id);if(!C){const P=await this.getFolder(p.folderUri),m=p.parent?this._debugSessions.get(p.parent):void 0;C=new y(this._debugServiceProxy,p.id,p.type,p.name,P,p.configuration,m),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(p){if(p){const C=M.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}};c=$e([Ve(0,l.IExtHostRpcService),Ve(1,T.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class y{constructor(p,C,P,m,I,F,L){this._debugServiceProxy=p,this._id=C,this._type=P,this._name=m,this._workspaceFolder=I,this._configuration=F,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,C){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,C)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=y;class i{constructor(p){this.value=Object.freeze({append(C){p.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=i;class g extends n.AbstractVariableResolverService{constructor(p,C,P,m,I){function F(){if(C){const L=C.activeEditor();if(L)return L.document.uri;const w=m.tabs.filter(x=>x.isActive);if(w.length>0){const x=w[0].resource;return x&&(x.primary||x.secondary)?x.primary??x.secondary:w[0].resource}}}super({getFolderUri:L=>{const w=p.filter(x=>x.name===L);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(L,w)=>P.getConfiguration(void 0,L).get(w),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=F();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const L=F();if(L){const w=I.getWorkspaceFolder(L);if(w)return d.normalize(w.uri.fsPath)}}},getSelectedText:()=>{if(C){const L=C.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(C){const L=C.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=g;class r{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(C=>C.onError?C.onError(p):void 0)}onExit(p,C){this.trackers.forEach(P=>P.onExit?P.onExit(p,C):void 0)}}class s extends D.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends c{constructor(p,C,P,m,I,F){super(p,C,P,m,I,F)}createVariableResolver(p,C,P){return new g(p,C,P,this._editorTabs)}};u=$e([Ve(0,l.IExtHostRpcService),Ve(1,T.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,h.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[219],Ee([0,1,74,2,5,32,30,26,12,29,4,33,91,15]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(a,c,y,i,g,r,s){this._apiFactory=a,this._extensionRegistry=c,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=g,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,c,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,c,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let c of a.nodeModuleName)this._factories.set(c,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(c=>a.alternativeModuleName(c))}};o=$e([Ve(2,t.IInstantiationService),Ve(3,A.IExtHostConfiguration),Ve(4,b.IExtHostExtensionService),Ve(5,T.IExtHostInitDataService),Ve(6,h.ILogService)],o),e.RequireInterceptor=o;class l{constructor(a,c,y,i,g){this._apiFactory=a,this._extensionPaths=c,this._extensionRegistry=y,this._configProvider=i,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,c){const y=this._extensionPaths.findSubstr(c.fsPath);if(y){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((g,r)=>i+=`	${r} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(a,c){this.nodeModuleName="keytar";const{environment:y}=c,i=a.getProxy(E.MainContext.MainThreadKeytar);if(y.appRoot){let g=y.appRoot.fsPath;n.platform==="win32"&&(g=g.replace(/\\/g,"/")),g[g.length-1]==="/"&&(g=g.substr(0,g.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${g}/node_modules.asar/keytar`),this.alternativeNames.add(`${g}/node_modules/keytar`)}this._impl={getPassword:(g,r)=>i.$getPassword(g,r),setPassword:(g,r,s)=>i.$setPassword(g,r,s),deletePassword:(g,r)=>i.$deletePassword(g,r),findPassword:g=>i.$findPassword(g),findCredentials(g){return i.$findCredentials(g)}}}load(a,c){return this._impl}alternativeModuleName(a){const c=a.length;if(c<=7||!this.alternativeNames)return;const y=c-7;if((a.charAt(y)==="/"||a.charAt(y)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};v=$e([Ve(0,D.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],v);let S=class{constructor(a,c,y){this._extensionPaths=a,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(E.MainContext.MainThreadTelemetry);const i=y.getProxy(E.MainContext.MainThreadWindow);this._impl=(g,r)=>{const s=M.URI.parse(g);return r?this.callOriginal(g,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,g,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,g,{}):this.callOriginal(g,r)}}load(a,c,y){const i=this._extensionPaths.findSubstr(c.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(a),this._impl}callOriginal(a,c){return this.sendNoForwardTelemetry(),this._original(a,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=$e([Ve(2,D.IExtHostRpcService)],S)}),define(be[220],Ee([0,1,14,16,74,6,2,5,213,15,57,61,29,144,12,65,33,40]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,y,i,g){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new D.RPCProtocol(c,null,g),y=_._transform(y,this._rpcProtocol);const r=new b.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(g)),r.set(v.IHostUtils,i);const s=new h.InstantiationService(r,!0),u=s.invokeFunction(P=>P.get(S.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(P=>P.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(P=>P.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(m,I)=>{let F="",L,w;for(const x of I)F+=`
	at ${x.toString()}`,w=x.getFileName(),!L&&w&&(L=P.findSubstr(w));return f.set(m,L),`${m.name||"Error"}: ${m.message||""}${F}`}});const p=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),C=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(P=>{const m=M.transformErrorForSerialization(P),I=f.get(P);I?p.$onExtensionRuntimeError(I.identifier,m):C.$onUnexpectedError(m)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(c,y){c.extensions.forEach(g=>g.extensionLocation=R.URI.revive(y.transformIncomingURIs(g.extensionLocation))),c.environment.appRoot=R.URI.revive(y.transformIncomingURIs(c.environment.appRoot));const i=c.environment.extensionDevelopmentLocationURI;return i&&(c.environment.extensionDevelopmentLocationURI=i.map(g=>R.URI.revive(y.transformIncomingURIs(g)))),c.environment.extensionTestsLocationURI=R.URI.revive(y.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=R.URI.revive(y.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=R.URI.revive(y.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=R.URI.revive(y.transformIncomingURIs(c.logsLocation)),c.logFile=R.URI.revive(y.transformIncomingURIs(c.logFile)),c.workspace=y.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(be[221],Ee([0,1,17,21,56,27,24,194,41]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,h,o){this.config=n,this.provider=h,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const h=this.config.folderQueries||[];return new Promise((o,l)=>{const v=S=>{this.resultCount++,n(S)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const _=S.toString(),a=d.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,a)||this.matchFile(v,{base:S,basename:a})}),Promise.all(h.map(S=>this.searchInFolder(S,v))).then(S=>{o({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{l(new Error((0,E.toErrorMessage)(S)))})})}async searchInFolder(n,h){const o=new M.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),S=new D.QueryGlobTester(this.config,n),_=!S.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(o),a=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,o.token),y=a.elapsed(),i=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(g=>{const r=d.posix.relative(n.folder.path,g.path);if(_){const s=d.basename(g.path);this.matchFile(h,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(v,n.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,S,h),{providerTime:y,postProcessTime:i.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,D.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},h,o,l){if(o===this.filePattern){const S=d.basename(this.filePattern);this.matchFile(l,{base:h,relativePath:this.filePattern,basename:S})}function v(S){const _=d.basename(S),a=d.dirname(S);let c=n[a];c||(c=n[a]=[],v(a)),c.push({base:h,relativePath:S,basename:_})}v(o)}matchDirectoryTree({rootEntries:n,pathToEntries:h},o,l){const v=this,S=this.filePattern;function _(a){const c=A.hasSiblingFn(()=>a.map(y=>y.basename));for(let y=0,i=a.length;y<i;y++){const g=a[y],{relativePath:r,basename:s}=g;if(o.matchesExcludesSync(r,s,S!==s?c:void 0))continue;const u=h[r];if(u)_(u);else{if(r===S)continue;v.matchFile(l,g)}if(v.isLimitHit)break}}_(n)}matchFile(n,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(h))}}class t{constructor(){this.sessions=new Map}fileSearch(n,h,o,l){const v=this.getSessionTokenSource(n.cacheKey),S=new T(n,h,v&&v.token);let _=0;const a=c=>{_+=c.length,o(c.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(S,t.BATCH_SIZE,a,l).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(n){const h=this.getSessionTokenSource(n);h&&h.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:R.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,h,o,l){l.onCancellationRequested(()=>{n.cancel()});const v=_=>{_&&(S.push(_),h>0&&S.length>=h&&(o(S),S=[]))};let S=[];return n.search(v).then(_=>(S.length&&o(S),_),_=>(S.length&&o(S),Promise.reject(_)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,56,27,11,17,24,10,2,41]),function(re,e,d,M,E,A,R,k,D,T,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(a,c,y,i){this.query=a,this.provider=c,this.fileUtils=y,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,c){const y=this.query.folderQueries||[],i=new M.CancellationTokenSource;return c.onCancellationRequested(()=>i.cancel()),new Promise((g,r)=>{this.collector=new o(a);let s=!1;const u=(f,p)=>{if(!s&&!this.isLimitHit){const C=this.resultSize(f);v(f)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const P=this.resultSize(f);this.resultCount+=P,(P>0||!v(f))&&this.collector.add(f,p)}};Promise.all(y.map((f,p)=>this.searchInFolder(f,C=>u(C,p),i.token))).then(f=>{i.dispose(),this.collector.flush();const p=f.some(C=>!!C&&!!C.limitHit);g({limitHit:this.isLimitHit||p,messages:(0,d.flatten)(f.map(C=>C?.message?(0,T.isArray)(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},f=>{i.dispose();const p=(0,E.toErrorMessage)(f);r(new Error(p))})})}resultSize(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,c){const y=Array.isArray(a.ranges)?a.ranges:[a.ranges],i=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:y.slice(0,c),preview:{matches:i.slice(0,c),text:a.preview.text},uri:a.uri}}async searchInFolder(a,c,y){const i=new b.QueryGlobTester(this.query,a),g=[],r={report:f=>{if(!this.validateProviderResult(f))return;const p=a.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(f.uri))):void 0,C=D.relativePath(a.folder,f.uri);if(C){const P=i.includedInQuery(C,k.basename(C),p);(0,T.isPromise)(P)?g.push(P.then(m=>{m&&c(f)})):P&&c(f)}}},s=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(h(this.query.contentPattern),s,r,y);return g.length&&await Promise.all(g),u}validateProviderResult(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const c=(0,b.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),y=(0,b.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),i={folder:t.URI.from(a.folder),excludes:y,includes:c,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function h(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,c=>this.sendItems(c))}add(a,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!D.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(l(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=o;function l(_){return v(_)?{preview:{matches:(0,d.mapArrayOrNot)(_.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:_.preview.text},ranges:(0,d.mapArrayOrNot)(_.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function v(_){return!!_.preview}e.extensionResultIsMatch=v;class S{constructor(a,c){this.maxBatchSize=a,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,c){!a||this.addItemToBatch(a,c)}addItems(a,c){!a||this.addItemsToBatch(a,c)}addItemToBatch(a,c){this.batch.push(a),this.batchSize+=c,this.onUpdate()}addItemsToBatch(a,c){this.batch=this.batch.concat(a),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,65,15,2,222]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let b=class{constructor(l,v,S){this.extHostRpc=l,this._uriTransformer=v,this._logService=S,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,v){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const S=this._handlePool++;return this._textSearchProvider.set(S,v),this._proxy.$registerTextSearchProvider(S,this._transformScheme(l)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(l,v){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const S=this._handlePool++;return this._fileSearchProvider.set(S,v),this._proxy.$registerFileSearchProvider(S,this._transformScheme(l)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(l,v,S,_){const a=n(S),c=this._fileSearchProvider.get(l);if(c)return this._fileSearchManager.fileSearch(a,c,y=>{this._proxy.$handleFileMatch(l,v,y.map(i=>i.resource))},_);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,v,S,_){const a=this._textSearchProvider.get(l);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const c=n(S);return this.createTextSearchManager(c,a).search(i=>this._proxy.$handleTextMatch(l,v,i),_)}$enableExtensionHostSearch(){}createTextSearchManager(l,v){return new t.TextSearchManager(l,v,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};b=$e([Ve(0,R.IExtHostRpcService),Ve(1,k.IURITransformerService),Ve(2,D.ILogService)],b),e.ExtHostSearch=b;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(h),extraFileResources:o.extraFileResources&&o.extraFileResources.map(l=>T.URI.revive(l))}}e.reviveQuery=n;function h(o){return{...o,folder:T.URI.revive(o.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,184,183,39,185,32,186,187,188,170,189,49,33,190,171,193,195,196,96,173,201,202,203,72,40,205,174,8,7,208,50,97,31,30,51,160,192,86,95,99,100,101,15,65,12,29,197,157,64,69,181,206,156,73,71,211,209,210,182,37,204,207,68,70,87,199,98,200,11,146,198,154,191]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a,c,y,i,g,r,s,u,f,p,C,P,m,I,F,L,w,x,W,B,G,H,U,V,Q,ne,ce,Z,oe,ve,Ae,Se,Ne,We,je,qe,$,K,ee,ae,q,se,he,Re,Be,ze,Qe,it,ke,Ze,j,J,me,He,Ye,st,ot,Et,mt,Dt,Pt,It,Xe,St,Te,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(te){const le=te.get(ee.IExtHostInitDataService),ge=te.get(me.IExtHostFileSystemInfo),fe=te.get(it.IExtHostConsumerFileSystem),Pe=te.get(r.IExtHostExtensionService),xe=te.get(ne.IExtHostWorkspace),Oe=te.get(Et.IExtHostTelemetry),Ke=te.get(S.IExtHostConfiguration),tt=te.get($.IURITransformerService),Le=te.get(K.IExtHostRpcService),de=te.get(w.IExtHostStorage),pe=te.get(Qe.IExtensionStoragePaths),Y=te.get(qe.ILogService),z=te.get(se.IExtHostTunnelService),we=te.get(he.IExtHostApiDeprecationService),Ie=te.get(Q.IExtHostWindow),Je=te.get(st.IExtHostSecretState),Ue=te.get(ot.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),Le.set(n.ExtHostContext.ExtHostLogService,Y),Le.set(n.ExtHostContext.ExtHostWorkspace,xe),Le.set(n.ExtHostContext.ExtHostConfiguration,Ke),Le.set(n.ExtHostContext.ExtHostExtensionService,Pe),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,Ie),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Oe),Le.set(n.ExtHostContext.ExtHostEditorTabs,Ue);const dt=Le.set(n.ExtHostContext.ExtHostDecorations,te.get(Se.IExtHostDecorations)),gt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,te.get(g.IExtHostDocumentsAndEditors)),lt=Le.set(n.ExtHostContext.ExtHostCommands,te.get(l.IExtHostCommands)),ft=Le.set(n.ExtHostContext.ExtHostTerminalService,te.get(x.IExtHostTerminalService)),ut=Le.set(n.ExtHostContext.ExtHostDebugService,te.get(We.IExtHostDebugService)),pt=Le.set(n.ExtHostContext.ExtHostSearch,te.get(je.IExtHostSearch)),bt=Le.set(n.ExtHostContext.ExtHostTask,te.get(Ne.IExtHostTask)),Ut=Le.set(n.ExtHostContext.ExtHostOutputService,te.get(P.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(Le)),yt=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,gt)),$t=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(Le,gt,Y)),ti=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(Y,yt,Le.getProxy(n.MainContext.MainThreadBulkEdits))),vt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,lt,gt,yt,pe)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(Y,vt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new St.ExtHostNotebookEditors(Y,Le,vt)),ii=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(Le,le,vt,lt,Y)),ni=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Pt.ExtHostNotebookRenderers(Le,vt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(Le,gt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),lt,Y)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,le)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(Le,Y,ge)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(Le,yt,lt.converter,tt)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Le,tt,yt,lt,Wt,Y,we)),ri=Le.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Le,ht)),Ot=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Le,Y,gt)),Nt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(Le,xe,lt)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Le,lt,Y)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(Le,lt,yt)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new m.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Le)),Xt=Le.set(n.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Le,lt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Le,{remote:le.remote},xe,Y,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new j.ExtHostWebviewPanels(Le,qt,xe)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new Ze.ExtHostCustomEditors(Le,yt,pe,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new ke.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Le,lt)),Zt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new Ye.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Le,vt,gt,lt));const Si=(0,Z.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new J.ExtHostBulkEdits(Le,gt),ai=new o.ExtHostClipboard(Le),li=new C.ExtHostMessageService(Le,Y),zt=new a.ExtHostDialogs(Le),Mt=new L.ExtHostStatusBar(Le,lt.converter);return h.ExtHostApiCommands.register(lt),function(Me,Rt,Kt){const wt=function(){let X=!Me.isUnderDevelopment;function ue(De){X||(Y.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function De(rt){if(Array.isArray(rt))rt.forEach(De);else if(typeof rt=="string")ue(rt);else{const _t=rt;typeof _t.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,ce.throwProposedApiError)(Me)}return rt}}(),Ci={getSession(X,ue,De){return De?.forceNewSession&&(0,ce.checkProposedApiEnabled)(Me),Xt.getSession(Me,X,ue,De)},async hasSession(X,ue){return(0,ce.checkProposedApiEnabled)(Me),!!await Xt.getSession(Me,X,ue,{solelyCheckExistence:!0})},get onDidChangeSessions(){return Xt.onDidChangeSessions},registerAuthenticationProvider(X,ue,De,rt){return Xt.registerAuthenticationProvider(X,ue,De,rt)}},ki={registerCommand(X,ue,De){return lt.registerCommand(!0,X,ue,De)},registerTextEditorCommand(X,ue,De){return lt.registerCommand(!0,X,(...rt)=>{const _t=Tt.getActiveTextEditor();if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}return _t.edit(kt=>{ue.apply(De,[_t,kt,...rt])}).then(kt=>{kt||Y.warn("Edits from command "+X+" were not applied.")},kt=>{Y.warn("An error occurred while running command "+X,kt)})})},registerDiffInformationCommand:(X,ue,De)=>((0,ce.checkProposedApiEnabled)(Me),lt.registerCommand(!0,X,async(...rt)=>{const _t=gt.activeEditor(!0);if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}const kt=await Tt.getDiffInformation(_t.id);ue.apply(De,[kt,...rt])})),executeCommand(X,...ue){return lt.executeCommand(X,...ue)},getCommands(X=!1){return lt.getCommands(X)}},mi={get machineId(){return le.telemetryInfo.machineId},get sessionId(){return le.telemetryInfo.sessionId},get language(){return le.environment.appLanguage},get appName(){return le.environment.appName},get appRoot(){return le.environment.appRoot?.fsPath??""},get appHost(){return le.environment.appHost},get uriScheme(){return le.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return Oe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Oe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ue){return Ie.openUri(X,{allowTunneling:!!le.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===le.environment.appUriScheme)return Vt.createAppUri(X);try{return await Ie.asExternalUri(X,{allowTunneling:!!le.remote.authority})}catch(ue){if((0,Xe.matchesScheme)(X,It.Schemas.http)||(0,Xe.matchesScheme)(X,It.Schemas.https))return X;throw ue}},get remoteName(){return(0,Ae.getRemoteName)(le.remote.authority)},get remoteAuthority(){return(0,ce.checkProposedApiEnabled)(Me),le.remote.authority},get uiKind(){return le.uiKind}};le.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=le.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(X,ue){return Gt.createTestController(X,ue)},createTestObserver(){return(0,ce.checkProposedApiEnabled)(Me),Gt.createTestObserver()},runTests(X){return(0,ce.checkProposedApiEnabled)(Me),Gt.runTests(X)},get onDidChangeTestResults(){return(0,ce.checkProposedApiEnabled)(Me),Gt.onResultsChanged},get testResults(){return(0,ce.checkProposedApiEnabled)(Me),Gt.results}},Pi={getExtension(X){const ue=Rt.getExtensionDescription(X);if(ue)return new r.Extension(Pe,Me.identifier,ue,gi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new r.Extension(Pe,Me.identifier,X,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,ue){return Ht.changeLanguage(X.uri,ue)},match(X,ue){return(0,t.score)(G.LanguageSelector.from(X),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(X,ue,De){return ht.registerCodeActionProvider(Me,wt(X),ue,De)},registerCodeLensProvider(X,ue){return ht.registerCodeLensProvider(Me,wt(X),ue)},registerDefinitionProvider(X,ue){return ht.registerDefinitionProvider(Me,wt(X),ue)},registerDeclarationProvider(X,ue){return ht.registerDeclarationProvider(Me,wt(X),ue)},registerImplementationProvider(X,ue){return ht.registerImplementationProvider(Me,wt(X),ue)},registerTypeDefinitionProvider(X,ue){return ht.registerTypeDefinitionProvider(Me,wt(X),ue)},registerHoverProvider(X,ue){return ht.registerHoverProvider(Me,wt(X),ue,Me.identifier)},registerEvaluatableExpressionProvider(X,ue){return ht.registerEvaluatableExpressionProvider(Me,wt(X),ue,Me.identifier)},registerInlineValuesProvider(X,ue){return ht.registerInlineValuesProvider(Me,wt(X),ue,Me.identifier)},registerDocumentHighlightProvider(X,ue){return ht.registerDocumentHighlightProvider(Me,wt(X),ue)},registerLinkedEditingRangeProvider(X,ue){return ht.registerLinkedEditingRangeProvider(Me,wt(X),ue)},registerReferenceProvider(X,ue){return ht.registerReferenceProvider(Me,wt(X),ue)},registerRenameProvider(X,ue){return ht.registerRenameProvider(Me,wt(X),ue)},registerDocumentSymbolProvider(X,ue,De){return ht.registerDocumentSymbolProvider(Me,wt(X),ue,De)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,ue){return ht.registerDocumentFormattingEditProvider(Me,wt(X),ue)},registerDocumentRangeFormattingEditProvider(X,ue){return ht.registerDocumentRangeFormattingEditProvider(Me,wt(X),ue)},registerOnTypeFormattingEditProvider(X,ue,De,...rt){return ht.registerOnTypeFormattingEditProvider(Me,wt(X),ue,[De].concat(rt))},registerDocumentSemanticTokensProvider(X,ue,De){return ht.registerDocumentSemanticTokensProvider(Me,wt(X),ue,De)},registerDocumentRangeSemanticTokensProvider(X,ue,De){return ht.registerDocumentRangeSemanticTokensProvider(Me,wt(X),ue,De)},registerSignatureHelpProvider(X,ue,De,...rt){return typeof De=="object"?ht.registerSignatureHelpProvider(Me,wt(X),ue,De):ht.registerSignatureHelpProvider(Me,wt(X),ue,typeof De=="undefined"?[]:[De,...rt])},registerCompletionItemProvider(X,ue,...De){return ht.registerCompletionItemProvider(Me,wt(X),ue,De)},registerInlineCompletionItemProvider(X,ue){return(0,ce.checkProposedApiEnabled)(Me),ht.registerInlineCompletionsProvider(Me,wt(X),ue)},registerDocumentLinkProvider(X,ue){return ht.registerDocumentLinkProvider(Me,wt(X),ue)},registerColorProvider(X,ue){return ht.registerColorProvider(Me,wt(X),ue)},registerFoldingRangeProvider(X,ue){return ht.registerFoldingRangeProvider(Me,wt(X),ue)},registerSelectionRangeProvider(X,ue){return ht.registerSelectionRangeProvider(Me,X,ue)},registerCallHierarchyProvider(X,ue){return ht.registerCallHierarchyProvider(Me,X,ue)},registerTypeHierarchyProvider(X,ue){return ht.registerTypeHierarchyProvider(Me,X,ue)},setLanguageConfiguration:(X,ue)=>ht.setLanguageConfiguration(Me,X,ue),getTokenInformationAtPosition(X,ue){return(0,ce.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(X,ue)},registerInlayHintsProvider(X,ue){return(0,ce.checkProposedApiEnabled)(Me),ht.registerInlayHintsProvider(Me,X,ue)},createLanguageStatusItem(X,ue){return(0,ce.checkProposedApiEnabled)(Me),Ht.createLanguageStatusItem(Me,X,ue)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,ue,De){const rt=await(R.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(rt,ue,De)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,ue,De){return Tt.onDidChangeActiveTextEditor(X,ue,De)},onDidChangeVisibleTextEditors(X,ue,De){return Tt.onDidChangeVisibleTextEditors(X,ue,De)},onDidChangeTextEditorSelection(X,ue,De){return Tt.onDidChangeTextEditorSelection(X,ue,De)},onDidChangeTextEditorOptions(X,ue,De){return Tt.onDidChangeTextEditorOptions(X,ue,De)},onDidChangeTextEditorVisibleRanges(X,ue,De){return Tt.onDidChangeTextEditorVisibleRanges(X,ue,De)},onDidChangeTextEditorViewColumn(X,ue,De){return Tt.onDidChangeTextEditorViewColumn(X,ue,De)},onDidCloseTerminal(X,ue,De){return ft.onDidCloseTerminal(X,ue,De)},onDidOpenTerminal(X,ue,De){return ft.onDidOpenTerminal(X,ue,De)},onDidChangeActiveTerminal(X,ue,De){return ft.onDidChangeActiveTerminal(X,ue,De)},onDidChangeTerminalDimensions(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(X,ue,De)},onDidChangeTerminalState(X,ue,De){return ft.onDidChangeTerminalState(X,ue,De)},onDidWriteTerminalData(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(X,ue,De)},get state(){return Ie.state},onDidChangeWindowState(X,ue,De){return Ie.onDidChangeWindowState(X,ue,De)},showInformationMessage(X,...ue){return li.showMessage(Me,A.default.Info,X,ue[0],ue.slice(1))},showWarningMessage(X,...ue){return li.showMessage(Me,A.default.Warning,X,ue[0],ue.slice(1))},showErrorMessage(X,...ue){return li.showMessage(Me,A.default.Error,X,ue[0],ue.slice(1))},showQuickPick(X,ue,De){return Nt.showQuickPick(X,!!Me.enableProposedApi,ue,De)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,ue){return Nt.showInput(X,ue)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,ue,De){let rt,_t,kt;return typeof X=="string"?(rt=X,_t=ue,kt=De):(_t=X,kt=ue),Mt.createStatusBarEntry(Me,rt,_t,kt)},setStatusBarMessage(X,ue){return Mt.setStatusBarMessage(X,ue)},withScmProgress(X){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hi.withProgress(Me,{location:H.ProgressLocation.SourceControl},(ue,De)=>X({report(rt){}}))},withProgress(X,ue){return hi.withProgress(Me,X,ue)},createOutputChannel(X){return Ut.createOutputChannel(X,Me)},createWebviewPanel(X,ue,De,rt){return oi.createWebviewPanel(Me,X,ue,De,rt)},createWebviewTextEditorInset(X,ue,De,rt){return(0,ce.checkProposedApiEnabled)(Me),wi.createWebviewEditorInset(X,ue,De,rt,Me)},createTerminal(X,ue,De){return typeof X=="object"?("location"in X&&(0,ce.checkProposedApiEnabled)(Me),"pty"in X?ft.createExtensionTerminal(X):ft.createTerminalFromOptions(X)):ft.createTerminal(X,ue,De)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTerminalProfileProvider(X,ue){return ft.registerProfileProvider(Me,X,ue)},registerTreeDataProvider(X,ue){return Yt.registerTreeDataProvider(X,ue,Me)},createTreeView(X,ue){return Yt.createTreeView(X,ue,Me)},registerWebviewPanelSerializer:(X,ue)=>oi.registerWebviewPanelSerializer(Me,X,ue),registerCustomEditorProvider:(X,ue,De={})=>_i.registerCustomEditorProvider(Me,X,ue,De),registerFileDecorationProvider(X){return dt.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Vt.registerUriHandler(Me.identifier,X)},createQuickPick(){return Nt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Nt.createInputBox(Me.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,ue,De){return fi.onDidChangeActiveColorTheme(X,ue,De)},registerWebviewViewProvider(X,ue,De){return yi.registerWebviewViewProvider(Me,X,ue,De?.webviewOptions)},get activeNotebookEditor(){return(0,ce.checkProposedApiEnabled)(Me),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeActiveNotebookEditor(X,ue,De)},get visibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Me),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorSelection(X,ue,De)},onDidChangeNotebookEditorVisibleRanges(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorVisibleRanges(X,ue,De)},showNotebookDocument(X,ue){return(0,ce.checkProposedApiEnabled)(Me),vt.showNotebookDocument(X,ue)},registerExternalUriOpener(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),Zt.registerExternalUriOpener(Me.identifier,X,ue,De)},get tabs(){return(0,ce.checkProposedApiEnabled)(Me),Ue.tabs},get activeTab(){return(0,ce.checkProposedApiEnabled)(Me),Ue.activeTab},get onDidChangeTabs(){return(0,ce.checkProposedApiEnabled)(Me),Ue.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ce.checkProposedApiEnabled)(Me),Ue.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ce.checkProposedApiEnabled)(Me),f.InlineCompletionController.get(X)}},pi={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,ue,...De)=>xe.updateWorkspaceFolders(Me,X,ue||0,...De),onDidChangeWorkspaceFolders:function(X,ue,De){return xe.onDidChangeWorkspace(X,ue,De)},asRelativePath:(X,ue)=>xe.getRelativePath(X,ue),findFiles:(X,ue,De,rt)=>xe.findFiles(G.GlobPattern.from(X),G.GlobPattern.from(ue),De,Me.identifier,rt),findTextInFiles:(X,ue,De,rt)=>{let _t,kt;return typeof ue=="object"?(_t=ue,kt=De):(_t={},kt=ue,rt=De),xe.findTextInFiles(X,_t||{},kt,Me.identifier,rt)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ue,De,rt)=>Ot.createFileSystemWatcher(G.GlobPattern.from(X),ue,De,rt),get textDocuments(){return yt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let ue;const De=X;if(typeof X=="string")ue=Promise.resolve(R.URI.file(X));else if(R.URI.isUri(X))ue=Promise.resolve(X);else if(!De||typeof De=="object")ue=yt.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>yt.ensureDocumentData(rt).then(_t=>_t.document))},onDidOpenTextDocument:(X,ue,De)=>yt.onDidAddDocument(X,ue,De),onDidCloseTextDocument:(X,ue,De)=>yt.onDidRemoveDocument(X,ue,De),onDidChangeTextDocument:(X,ue,De)=>yt.onDidChangeDocument(X,ue,De),onDidSaveTextDocument:(X,ue,De)=>yt.onDidSaveDocument(X,ue,De),onWillSaveTextDocument:(X,ue,De)=>ti.getOnWillSaveTextDocumentEvent(Me)(X,ue,De),get notebookDocuments(){return vt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ue){let De;if(R.URI.isUri(X))De=X,await vt.openNotebookDocument(X);else if(typeof X=="string")De=R.URI.revive(await vt.createNotebookDocument({viewType:X,content:ue}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(X,ue,De,rt){return vt.registerNotebookSerializer(Me,X,ue,De,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,ue,De,rt)=>((0,ce.checkProposedApiEnabled)(Me),vt.registerNotebookContentProvider(Me,X,ue,De,Me.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,ue,De)=>Kt.onDidChangeConfiguration(X,ue,De),getConfiguration(X,ue){return ue=arguments.length===1?void 0:ue,Kt.getConfiguration(X,ue,Me)},registerTextDocumentContentProvider(X,ue){return $t.registerTextDocumentContentProvider(X,ue)},registerTaskProvider:(X,ue)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Me,X,ue)),registerFileSystemProvider(X,ue,De){return ri.registerFileSystemProvider(Me.identifier,X,ue,De)},get fs(){return fe.value},registerFileSearchProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),pt.registerFileSearchProvider(X,ue)),registerTextSearchProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),pt.registerTextSearchProvider(X,ue)),registerRemoteAuthorityResolver:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),Pe.registerRemoteAuthorityResolver(X,ue)),registerResourceLabelFormatter:X=>((0,ce.checkProposedApiEnabled)(Me),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ue,De)=>Ot.onDidCreateFile(X,ue,De),onDidDeleteFiles:(X,ue,De)=>Ot.onDidDeleteFile(X,ue,De),onDidRenameFiles:(X,ue,De)=>Ot.onDidRenameFile(X,ue,De),onWillCreateFiles:(X,ue,De)=>Ot.getOnWillCreateFileEvent(Me)(X,ue,De),onWillDeleteFiles:(X,ue,De)=>Ot.getOnWillDeleteFileEvent(Me)(X,ue,De),onWillRenameFiles:(X,ue,De)=>Ot.getOnWillRenameFileEvent(Me)(X,ue,De),openTunnel:X=>((0,ce.checkProposedApiEnabled)(Me),z.openTunnel(Me,X).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,ce.checkProposedApiEnabled)(Me),z.getTunnels()},onDidChangeTunnels:(X,ue,De)=>((0,ce.checkProposedApiEnabled)(Me),z.onDidChangeTunnels(X,ue,De)),registerPortAttributesProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),z.registerPortsAttributesProvider(X,ue)),registerTimelineProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),si.registerTimelineProvider(X,ue,Me.identifier,lt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,ce.checkProposedApiEnabled)(Me),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ue,De)=>xe.onDidGrantWorkspaceTrust(X,ue,De)},Ai={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(X,ue,De){return Jt.createSourceControl(Me,X,ue,De)}},Ri={createCommentController(X,ue){return bi.createCommentController(Me,X,ue)}},Fi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(X,ue,De){return ut.onDidStartDebugSession(X,ue,De)},onDidTerminateDebugSession(X,ue,De){return ut.onDidTerminateDebugSession(X,ue,De)},onDidChangeActiveDebugSession(X,ue,De){return ut.onDidChangeActiveDebugSession(X,ue,De)},onDidReceiveDebugSessionCustomEvent(X,ue,De){return ut.onDidReceiveDebugSessionCustomEvent(X,ue,De)},onDidChangeBreakpoints(X,ue,De){return ut.onDidChangeBreakpoints(X,ue,De)},registerDebugConfigurationProvider(X,ue,De){return ut.registerDebugConfigurationProvider(X,ue,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ue){return ut.registerDebugAdapterDescriptorFactory(Me,X,ue)},registerDebugAdapterTrackerFactory(X,ue){return ut.registerDebugAdapterTrackerFactory(X,ue)},startDebugging(X,ue,De){return!De||typeof De=="object"&&"configuration"in De?ut.startDebugging(X,ue,{parentSession:De}):ut.startDebugging(X,ue,De||{})},stopDebugging(X){return ut.stopDebugging(X)},addBreakpoints(X){return ut.addBreakpoints(X)},removeBreakpoints(X){return ut.removeBreakpoints(X)},asDebugSourceUri(X,ue){return ut.asDebugSourceUri(X,ue)}},Mi={registerTaskProvider:(X,ue)=>bt.registerTaskProvider(Me,X,ue),fetchTasks:X=>bt.fetchTasks(X),executeTask:X=>bt.executeTask(Me,X),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(X,ue,De)=>bt.onDidStartTask(X,ue,De),onDidEndTask:(X,ue,De)=>bt.onDidEndTask(X,ue,De),onDidStartTaskProcess:(X,ue,De)=>bt.onDidStartTaskProcess(X,ue,De),onDidEndTaskProcess:(X,ue,De)=>bt.onDidEndTaskProcess(X,ue,De)},Li={createNotebookController(X,ue,De,rt,_t){return ii.createNotebookController(Me,X,ue,De,rt,Me.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(X,ue)=>vt.registerNotebookCellStatusBarItemProvider(Me,X,ue),get onDidSaveNotebookDocument(){return(0,ce.checkProposedApiEnabled)(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ce.checkProposedApiEnabled)(Me),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ni.createRendererMessaging(Me,X)},onDidChangeNotebookDocumentMetadata(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),Qt.onDidChangeNotebookDocumentMetadata(X,ue,De)},onDidChangeNotebookCells(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCells(X,ue,De)},onDidChangeNotebookCellExecutionState(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCellExecutionState(X,ue,De)},onDidChangeCellOutputs(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeCellOutputs(X,ue,De)},onDidChangeCellMetadata(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeCellMetadata(X,ue,De)},createConcatTextDocument(X,ue){return(0,ce.checkProposedApiEnabled)(Me),new ze.ExtHostNotebookConcatDocument(vt,yt,X,ue)}};return{version:le.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:T.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:R.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,69,97,71,37,68,87,70]),function(re,e,d,M,E,A,R,k,D,T,t,b,n,h,o,l,v,S,_,a,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,d.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,d.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,d.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,d.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,d.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(re,e,d,M,E,A,R,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(o){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(S,..._)=>{_.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const a=_.slice(0,-1).join(","),c=_.pop().toString();return`(function anonymous(${a}) {${c}
})`}});function v(...S){return l?self.eval(l.createScript("",...S)):new Function(...S)}o.create=v})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,v){for(let S of this._alternatives){let _=S(l);if(_){l=_;break}}if(this._factories.has(l))return this._factories.get(l).load(l,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class b extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);h(l,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,v,S){v=v.with({path:n(v.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const _=await fetch(D.FileAccess.asBrowserUri(v).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),_.status!==200)throw new Error(_.statusText);const a=await _.text(),c=`${v.toString(!0)}#vscode-extension`,y=`${a}
//# sourceURL=${c}`;let i;try{i=T.create(b._ttpExtensionScripts?.createScript("module")??"module",b._ttpExtensionScripts?.createScript("exports")??"exports",b._ttpExtensionScripts?.createScript("require")??"require",b._ttpExtensionScripts?.createScript(y)??y)}catch(u){throw console.error(l?`Loading code for extension ${l.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${v.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const g={},r={exports:g},s=u=>{const f=this._fakeModules.getModule(u,v);if(f===void 0)throw new Error(`Cannot load module '${u}'`);return f};try{return S.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(r,g,s),r.exports!==g?r.exports:g}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),S.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+l;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=b,b._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,l){return o.endsWith(l)?o:o+l}function h(o,l){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(a,c){const y=console[a];console[a]=function(){o.$logExtensionHostMessage({type:"__$console",severity:c,arguments:_(arguments)}),l&&y.apply(console,arguments)}}const S=1e5;function _(a){const c=[],y=[];if(a.length)for(let i=0;i<a.length;i++){if(typeof a[i]=="undefined")a[i]="undefined";else if(a[i]instanceof Error){const g=a[i];g.stack?a[i]=g.stack:a[i]=g.toString()}y.push(a[i])}try{const i=JSON.stringify(y,function(g,r){if(r&&typeof r=="object"){if(c.indexOf(r)!==-1)return"[Circular]";c.push(r)}return r});return i.length>S?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,73,225,212]),function(re,e,d,M,E,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,R.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,k.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,74,11,2,224,226]),function(re,e,d,M,E,A,R,k,D,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(a,c){return a instanceof Request||/^file:/i.test(String(a))&&(a=T.FileAccess.asBrowserUri(t.URI.parse(String(a))).toString(!0)),h(a,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,c,y,i,g){return/^file:/i.test(c.toString())&&(c=T.FileAccess.asBrowserUri(t.URI.parse(c.toString())).toString(!0)),super.open(a,c,y??!0,i,g)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),c=self.Worker;Worker=function(y,i){/^file:/i.test(y.toString())&&(y=T.FileAccess.asBrowserUri(t.URI.parse(y.toString())).toString(!0));const r=`(${function(p){function C(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const P=fetch.bind(self);self.fetch=function(F,L){return F instanceof Request?P(F,L):P(C(F),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,L,w,x,W){return super.open(F,C(L),w??!0,x,W)}};const m=importScripts.bind(self);self.importScripts=(...F)=>{m(...F.map(C))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:F=>F}):void 0;m(I?I.createScriptURL(p):p)}.toString()}('${y}'))`;i=i||{},i.name=i.name||k.basename(y.toString());const s=new Blob([r],{type:"application/javascript"}),u=URL.createObjectURL(s);return new c(a?a.createScriptURL(u):u,i)}}else self.Worker=class extends R.NestedWorker{constructor(a,c){super(n,a,{name:k.basename(a.toString()),...c})}};const o=new class{exit(a){b()}async exists(a){return!0}async realpath(a){return a}};class l{constructor(){const c=new MessageChannel,y=new M.Emitter;let i=!1;n(c.port2,[c.port2]),c.port1.onmessage=g=>{const{data:r}=g;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=d.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(s,2)){i=!0,S("received terminate message from renderer");return}y.fire(s)},this.protocol={onMessage:y.event,send:g=>{if(!i){const r=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);c.port1.postMessage(r,[r])}}}}}function v(a){return new Promise(c=>{const y=a.onMessage(i=>{y.dispose();const g=JSON.parse(i.toString());a.send((0,E.createMessageOfType)(0)),c({protocol:a,initData:g})});a.send((0,E.createMessageOfType)(1))})}let S=a=>b();function _(){const a=new l;D.mark("code/extHost/willConnectToRenderer"),v(a.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const y=new A.ExtensionHostMain(c.protocol,c.initData,o,null);S=i=>y.terminate(i)})}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6cba118ac49a1b88332f312a8f67186f7f3c1643/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
